/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * The following files were originally developed by Netscape Communications
 * Corporation
 */
/*
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "NPL"); you may not use this file except in
 * compliance with the NPL.  You may obtain a copy of the NPL at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the NPL is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the NPL
 * for the specific language governing rights and limitations under the
 * NPL.
 *
 * The Initial Developer of this code under the NPL is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.  All Rights
 * Reserved.
 */
/*
 *  Copyright (c) 1990 Regents of the University of Michigan.
 *  All rights reserved.
 */
/*
 * The contents of these files are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use these files except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is freevalues.c
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation. Copyright (C) 1998. All Rights Reserved
 */
/*
 * Portions created by NetApp, Inc. are Copyright (c) 2001.  All Rights
 * Reserved.
 */
/*
 *  freevalues.c
 */

#include "ldap-int.h"
#include <sk/sk_domain.h>

SK_DOMAIN_EXPORT(ldap_value_free, SK_REASON_MPSAFE);
void
LDAP_CALL
ldap_value_free( char **vals )
{
	int	i;

	if ( vals == NULL ) {
		return;
	}
	for ( i = 0; vals[i] != NULL; i++ ) {
		NSLDAPI_FREE( vals[i] );
	}
	NSLDAPI_FREE( (char *) vals );
}

SK_DOMAIN_EXPORT(ldap_value_free_len, SK_REASON_MPSAFE);
void
LDAP_CALL
ldap_value_free_len( struct berval **vals )
{
	int	i;

	if ( vals == NULL ) {
		return;
	}
	for ( i = 0; vals[i] != NULL; i++ ) {
		NSLDAPI_FREE( vals[i]->bv_val );
		NSLDAPI_FREE( vals[i] );
	}
	NSLDAPI_FREE( (char *) vals );
}
