/*
 *
 * Copyright (c) 2008 Network Appliance, Inc.
 * All rights reserved.
 */

/*
 *  Template MIB group interface - ipv6
 *
 */

#include <sys/types.h>
#include <sys/param.h>
#include <net7g/sys/sk_socket.h>
#include <net7g/sys/sk_socketvar.h>
#include <net7g/sys/sk_sockio.h>
//#include <sys/ioctl.h>
#include <legacy/sys/syslog.h>


#include <net7g/net/sk_if.h>
#include <net7g/net/sk_if_dl.h>
#include <net7g/net/sk_route.h>

#include <net7g/netinet/sk_in.h>
#include <net7g/netinet/sk_ip6.h>
#include <net7g/netinet/sk_ip.h>
#include <net7g/netinet/sk_ip_var.h>
#include <net7g/netinet/sk_in_pcb.h>
#include <net7g/netinet/sk_udp_var.h>
#include <net7g/netinet/sk_if_ether.h>

#include <net7g/netinet6/sk_in6_var.h>
#include <net7g/netinet6/sk_ip6_var.h>
#include <net7g/netinet6/sk_in6_pcb.h>
#include <net7g/netinet6/sk_tcp6_var.h>
#include <net7g/netinet6/sk_nd6.h>
#include <net7g/netinet6/sk_in6_ifattach.h>

#include <tcp/tcp.h>
#include <tcp/tcp_timer.h>
#include <tcp/tcp_var.h>
#include <tcp/tcp_fsm.h>

#include <cmds/ndp.h>

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <agent/mibgroup/util_funcs.h>
#include "interfaces.h"
#include <psm/psm.h>

#ifndef _MIBGROUP_IP_ICMP_IPV6_H
#define _MIBGROUP_IP_ICMP_IPV6_H

extern void init_ipv6(void);

#define IPV6IFINDEX 1
#define IPV6IFDESC 2
#define IPV6IFLOWERLAYER 3
#define IPV6IFEFFECTIVEMTU 4
#define IPV6IFREASMMAXSIZE 5
#define IPV6IFIDENTIFIER 6
#define IPV6IFIDENTIFIERLENGTH 7
#define IPV6IFPHYSICALADDRESS 8
#define IPV6IFADMINSTATUS 9
#define IPV6IFOPERSTATUS 10
#define IPV6IFLASTCHANGE 11

#define IPV6IFSTATSINRECEIVES 1
#define IPV6IFSTATSINHDRERRORS 2
#define IPV6IFSTATSINTOOBIGERRORS 3
#define IPV6IFSTATSINNOROUTES 4
#define IPV6IFSTATSINADDRERRORS 5
#define IPV6IFSTATSINUNKNOWNPROTOS 6
#define IPV6IFSTATSINTRUNCATEDPKTS 7
#define IPV6IFSTATSINDISCARDS 8
#define IPV6IFSTATSINDELIVERS 9
#define IPV6IFSTATSOUTFORWDATAGRAMS 10
#define IPV6IFSTATSOUTREQUESTS 11
#define IPV6IFSTATSOUTDISCARDS 12
#define IPV6IFSTATSOUTFRAGOKS 13
#define IPV6IFSTATSOUTFRAGFAILS 14
#define IPV6IFSTATSOUTFRAGCREATES 15
#define IPV6IFSTATSREASMREQDS 16
#define IPV6IFSTATSREASMOKS 17
#define IPV6IFSTATSREASMFAILS 18
#define IPV6IFSTATSINMCASTPKTS 19
#define IPV6IFSTATSOUTMCASTPKTS 20

#define IPV6ADDRPREFIX 1
#define IPV6ADDRPREFIXLENGTH 2
#define IPV6ADDRPREFIXONLINKFLAG 3
#define IPV6ADDRPREFIXAUTONOMOUSFLAG 4
#define IPV6ADDRPREFIXADVPREFERREDLIFETIME 5
#define IPV6ADDRPREFIXADVVALIDLIFETIME 6

#define IPV6ADDRADDRESS 1
#define IPV6ADDRPFXLENGTH 2
#define IPV6ADDRTYPE 3
#define IPV6ADDRANYCASTFLAG 4
#define IPV6ADDRSTATUS 5

#define IPV6ROUTEDEST 1
#define IPV6ROUTEPFXLENGTH 2
#define IPV6ROUTEINDEX 3
#define IPV6ROUTEIFINDEX 4
#define IPV6ROUTENEXTHOP 5
#define IPV6ROUTETYPE 6
#define IPV6ROUTEPROTOCOL 7
#define IPV6ROUTEPOLICY 8
#define IPV6ROUTEAGE 9
#define IPV6ROUTENEXTHOPRDI 10
#define IPV6ROUTEMETRIC 11
#define IPV6ROUTEWEIGHT 12
#define IPV6ROUTEINFO 13
#define IPV6ROUTEVALID 14

#define IPV6NETTOMEDIANETADDRESS 1
#define IPV6NETTOMEDIAPHYSADDRESS 2
#define IPV6NETTOMEDIATYPE 3
#define IPV6IFNETTOMEDIASTATE 4
#define IPV6IFNETTOMEDIALASTUPDATED 5
#define  IPV6NETTOMEDIAVALID 6

#define IPV6FORWARDING 1
#define IPV6DEFAULTHOPLIMIT 2
#define IPV6INTERFACES 3
#define IPV6IFTABLELASTCHANGE 4
#define IPV6ROUTENUMBER 9
#define IPV6DISCARDEDROUTES 10

#endif


