/*
 *
 * Copyright (c) 1992-2006 Network Appliance, Inc.
 * All rights reserved.
 */

#ifndef __ISCSI_VARS_H__
#define __ISCSI_VARS_H__


/*
 * Inet Address type
 */
#define ISCSI_SNMP_INET_ADDRESS_IPv4		1
#define ISCSI_SNMP_INET_ADDRESS_IPv6		2
#define ISCSI_SNMP_INET_ADDRESS_IPv4z		3
#define ISCSI_SNMP_INET_ADDRESS_IPv6z		4

/*
 * The OID of the  counter object that  was incremented when the
 * last session failed.
 *
 */
#define ISCSI_SNMP_SSN_OTHER_ERROR_OID       "0.0"
#define ISCSI_SNMP_SSN_DIGEST_ERROR_OID      "1.3.6.1.3.9999.1.2.2.1.1.1"

/*
 * The type of most recent failure of a login attempt to 
 * this target needs to be represnted as a OID of the counter object.
 *
 */
#define ISCSI_SNMP_LOGIN_OTHER_FAILURE_OID   "1.3.6.1.3.9999.1.7.2.1.2"
#define ISCSI_SNMP_LOGIN_AUTH_FAILURE_OID    "1.3.6.1.3.9999.1.7.2.1.5"
#define ISCSI_SNMP_LOGIN_NO_FAILURE_OID    	"0.0"

#define ISCSI_SNMP_NODE_TYPE			0 

/*
 * The digest values are as follows
 * none :1 other:2 noDigest:3 crc32c:4
 */
#define ISCSI_SNMP_DEFAULT_DIGEST		3 
#define ISCSI_SNMP_ALTERNATE_DIGEST		4 
#define ISCSI_SNMP_MARKER_SUPPORT		2 
#define ISCSI_SNMP_INBOUND_SESSION		1

#define ISCSI_SNMP_VENDOR_ID			"Network Appliance"
#define ISCSI_SNMP_VENDOR_VERSION		"0"
#define ISCSI_SNMP_NODE_ALIAS			""	

/*
 * An octet string. When only a single instance is present
 * this object may be set to a zero length string.
 */
#define ISCSI_SNMP_INST_DESCR			""

/*
 * We support only one node. 
 */
#define ISCSI_SNMP_NODE_NUMBER		1

/*
 * Portal Types
 */
#define ISCSI_SNMP_TARGET_TYPE_PORTAL		"01" 
#define ISCSI_SNMP_INITIATOR_TYPE_PORTAL	"10" 

/*
 * Row in the IPS-AUTH MIB that identifies the
 * authentication method
 */
#define ISCSI_SNMP_IPS_AUTH_IDENTITY		"0"

/*
 * This should be a pointer to the corresponding scsiTrnspt object
 * in the SCSI MIB.
 */
#define ISCSI_SNMP_NODE_TRANSPORT_TYPE	0

/*
 * Refer http://www.iana.org/assignments/protocol-numbers
 * for the list of protocol numbers.
 */

#define ISCSI_SNMP_TRANSPORT_PROTOCOL_TCP	6

#define ISCSI_SNMP_STATUS_ACTIVE		1
#define ISCSI_SNMP_STATUS_NOTINSERVICE	2
#define ISCSI_SNMP_STATUS_NOTREADY		3


#define ISCSI_SNMP_OTHER_FAILURE		1 
#define ISCSI_SNMP_AUTH_FAILURE			2 
#define ISCSI_SNMP_SSN_OTHER_ERROR		3
#define ISCSI_SNMP_SSN_DIGEST_ERROR		4

/*
 * SessionType
 */
#define ISCSI_SNMP_SESSION_TYPE_NORMAL 1
#define ISCSI_SNMP_SESSION_TYPE_DISCOVERY 2

/*
 * Digests
 */
#define ISCSI_SNMP_DIGEST_VALUE_NO_DIGEST 3
#define ISCSI_SNMP_DIGEST_VALUE_CRC32C 4

/*
 * Connection states
 */
#define ISCSI_SNMP_CONN_STATE_LOGIN	1
#define ISCSI_SNMP_CONN_STATE_FFP	2
#define ISCSI_SNMP_CONN_STATE_LOGOUT	3


/*
 *   TruthValue
 */

typedef enum {
	SnmpTrue  = 1,
	SnmpFalse = 2
} snmpv2_TruthValue_t;


#endif /* __ISCSI_VARS_H__ */
