/*
 *
 * Copyright (c) 1992-2010 NetApp, Inc.
 * All rights reserved.
 */
/*
 * snmpd.h
 */

#ifndef _SNMPV3_SNMPD_H_
#define _SNMPV3_SNMPD_H_ 1

#include <sk/sk_mutex.h>
#include <sk/sk_param.h>


#define MASTER_AGENT 0
#define SUB_AGENT    1
#define SNMP_AUTHENTICATED_TRAPS_ENABLED 1
#define SNMP_AUTHENTICATED_TRAPS_DISABLED 2

/*
 * Each host will have 2 sockets if IPv6 enabled.
 */
#define NUM_SOCKETS (ONTAP_NHOSTS * 2)

/*
 * Index of primary and secondary IPv4 and IPv6 SNMP sockets in the acceptors
 * array is defined here.
 */
typedef enum {
        SNMP_PRI_IPV6_SOCK,
        SNMP_PRI_SOCK,
        SNMP_SEC_IPV6_SOCK,
        SNMP_SEC_SOCK,
} snmp_enum_sock;

extern int      agent_role;

extern int      snmp_dump_packet;
extern int      verbose;
extern int      (*sd_handlers[]) (int);
extern int      smux_listen_sd;

extern int      snmp_read_packet(int);

/*
 * config file parsing routines 
 */
void            agentBoots_conf(char *, char *);

extern void     snmpd_init(void *dummy);
extern void     snmpd_prerc(int host);
extern void     shutdown_snmpd(void);
extern int	init_partner_agent(void);

extern void	snmp_enable_change_to(int newvalue);
extern int	snmp_enable(int host);
extern int	snmp_disable(int host);
extern int      is_snmp_enabled(void);
extern void	snmp_give_useradmin_rouser(void);


#ifdef SNMP_TRANSPORT_UDPIPV6_DOMAIN
/*
 * Need one additional entry for IPv6 for each host to hold
 * agent handlers.
 * IPv6 agent handler is stored at offset 'host+2' , where
 * 'host' is SK_HOST_LOCAL or SK_HOST_PARTNER.
 */
extern int	SnmpAgentHandle[ONTAP_NHOSTS*2];
#else
extern int	SnmpAgentHandle[ONTAP_NHOSTS];
#endif

extern void snmp_autosupport(const char *);
extern sk_mutex_t snmp_sess_mutex[ONTAP_NHOSTS];

#endif /* ifndef _SNMPV3_SNMPD_H_ */
