/*
 *
 * Copyright (c) 1992-2006 Network Appliance, Inc.
 * All rights reserved.
 */
/*
 * keytools.h
 */

#ifndef _KEYTOOLS_H
#define _KEYTOOLS_H

#ifdef __cplusplus
extern          "C" {
#endif


#define USM_LENGTH_EXPANDED_PASSPHRASE	(1024 * 1024)   /* 1Meg. */

#define USM_LENGTH_KU_HASHBLOCK		64      /* In bytes. */

#define USM_LENGTH_P_MIN		8       /* In characters. */
    /*
     * Recommended practice given in <draft-ietf-snmpv3-usm-v2-02.txt>,
     * * Section 11.2 "Defining Users".  Move into cmdline app argument
     * * parsing, and out of the internal routine?  XXX
     */

    /*
     * Prototypes.h
     */
    int             generate_Ku(const oid * hashtype, uint32_t hashtype_len,
                                uint8_t * P, size_t pplen,
                                uint8_t * Ku, size_t * kulen);

    int             generate_kul(const oid * hashtype, uint32_t hashtype_len,
                                 uint8_t * engineID, size_t engineID_len,
                                 uint8_t * Ku, size_t ku_len,
                                 uint8_t * Kul, size_t * kul_len);

    int             encode_keychange(const oid * hashtype,
                                     uint32_t hashtype_len, uint8_t * oldkey,
                                     size_t oldkey_len, uint8_t * newkey,
                                     size_t newkey_len, uint8_t * kcstring,
                                     size_t * kcstring_len);

    int             decode_keychange(const oid * hashtype,
                                     uint32_t hashtype_len, uint8_t * oldkey,
                                     size_t oldkey_len, uint8_t * kcstring,
                                     size_t kcstring_len, uint8_t * newkey,
                                     size_t * newkey_len);


    /*
     * All functions devolve to the following block if we can't do cryptography
     */
#define	_KEYTOOLS_NOT_AVAILABLE			\
{						\
	return SNMPERR_KT_NOT_AVAILABLE;	\
}

#ifdef __cplusplus
}
#endif
#endif                          /* _KEYTOOLS_H */
