/*
 *
 * Copyright (c) 1992-2010 NetApp, Inc.
 * All rights reserved.
 */
#ifndef _SNMPUDPIPV6DOMAIN_H
#define _SNMPUDPIPV6DOMAIN_H

#ifdef __cplusplus
extern          "C" {
#endif

#include <net-snmp/library/snmp_transport.h>
#include <net-snmp/library/asn1.h>

extern oid      netsnmp_UDPIPv6Domain[]; /* = { ENTERPRISE_MIB, 3, 3, 4 }; */

netsnmp_transport *snmp_udp6_transport(struct sockaddr_in6 *addr,
                                       int local);

netsnmp_transport *netsnmp_udp6_transport(struct sockaddr_in6 *addr,
                                       int local);

/*
 * Convert a "traditional" peername into a sockaddr_in6 structure which is
 * written to *addr.  Returns 1 if the conversion was successful, or 0 if it
 * failed.  
 */

int             netsnmp_sockaddr_in6(struct sockaddr_in6 *addr,
                                     const char *peername,
                                     int remote_port);

void            netsnmp_udp6_agent_config_tokens_register(void);
void            netsnmp_udp6_parse_security(const char *token,
                                            char *param);

int             netsnmp_udp6_getSecName(void *opaque, int olength,
                                        const char *community,
                                        int community_len, char **secname);

/*
 * "Constructor" for transport domain object.  
 */

void            netsnmp_udp6_ctor(void);

int             inet_make_mask_addr(int pf, void *dst, int masklength);
int             inet_addr_complement(int pf, void *src, void *dst);
int             inet_addr_and(int pf, void *src1, void *src2, void *dst);
int             inet_addrs_consistence(int pf, void *net, void *mask);
void            netsnmp_udp6_com2Sec6List_free(void);
netsnmp_transport * netsnmp_udp6_create_tstring(const char *str, int local);
netsnmp_transport * netsnmp_udp6_create_ostring(const uint8_t * o, 
					size_t o_len, int local);
#ifdef __cplusplus
}
#endif
#endif/*_SNMPUDPIPV6DOMAIN_H*/
