/*
 * Copyright (c) 1992-2013 NetApp, Inc.
 * All rights reserved.
 */

#include <sk/sk_stats.h>
#include <sk/ha_host.h>


#include <sk/sk_host.h>

#include <sk/sk_param.h>

#include <sk/sk_types.h>

#include <net7g/sys/sk_socket.h>
#include <net7g/netinet/sk_in.h>
#include <sys/endian.h>
#include <net7g/net/sk_route.h>
#include <sk/sk_synch.h>
#include <net7g/netinet/sk_in_var.h>
#include <net7g/netinet/sk_if_ether.h>
#include <net7g/netinet/sk_ip.h>
#include <net7g/netinet/sk_in_pcb.h>
#include <net7g/netinet/sk_ip_var.h>	/* struct ipstat */
#include <lib/rsrc_mgr.h>
#include <converged/getops.h>
#include <cmds/nfsstat_private.h>
#include <nfsd/nfsd_vfiler.h>
#include <ftpd/admin.h>
#include <httpd/httpd_cmd.h>        /* For listener port number */
#include <httpd/httpd_stat.h>	/* httpstats */
#include <driver/envstatus/envstatus.h>
#include <driver/lcd/lcd.h>	/* lcd_printf */
#include <driver/nvram/nvram.h> /* nvram_check_batteries */
SK_DOMAIN_IMPORT(ha_names, SK_REASON_READONLY);
SK_DOMAIN_IMPORT(raid_takeover, SK_REASON_READONLY);
#include <smb/smbsave.h>
#include <smb/smbstat.h>
#include <cmds/ifconfig.h>
#include <cmds/enable.h>
#include <license_v2/license_v2_misc.h>
#include <managed_feature/managed_feature.h>
#include <cmds/volcmd_util.h>
#include <cmds/volcmd.h>
#include <cmds/dense.h>
#include <converged/converged_common.h>
#include <sys/instrument.h>
#include <wafl/proto_ext.h>
#include <wafl/consist_pnt.h>
#include <wafl/vdb.h>
#include <wafl/volume.h>
#include <wafl/vol_ext.h>
#include <wafl/wafl_stats.h>
#include <wafl/qtree.h>
#include <wafl/denseops.h>
#include <wafl/guardrail.h>
#include <registry/reg.h>
#include <idump/interface.h>
#include <idump/replicate.h>
#include <idump/rpl_status.h>
#include <idump/rpl_log.h>
#include <idump/sv.h>
#include <backup/bkp_rcv_common.h>
#include <dump/proto.h>
#include <dense/admin.h>
#include <sk/sk_msgs.h>
#include <driver/scsi/aha.h>	/* ha_names */
#include <driver/disk/disk.h> 
#include <driver/raid/disk_enclosure_ext.h> /* disk shelf status */
#include <driver/raid/enclosure_snmp.h> /* disk shelf snmp */
#include <driver/raid/rfd_ext.h> /* disk shelf status */
#include <driver/scsitarget/scsi_tgt_vfiler.h>
#include <cmds/setup.h>		/* WSW_VERSION */

#include <autosupport/autosupport.h>
#include "net-snmp/net-snmp-config.h"
#include "net-snmp/net-snmp-includes.h"
#include "net-snmp/agent/snmp_vars.h"
#include "netapp_vars.h"
#include "net-snmp/library/snmp.h"
#include <fio/fio.h>
#include <cmds/ext.h>		/* percent */
#include <raidv2/config_iter.h>
#include <raidv2/disk_iter.h>
#include <raidv2/disk_subr.h>
#include <raidv2/pool_obj.h>
#include <raidv2/util_export.h>
#include <raidv2/vol_obj.h>
#include <raidv2/vol_subr.h>
#include <raidv2/external.h>
#include <raidv2/raid_fm.h>
#include <cmds/disk.h>
#include "ha/fm.h"
#include <psm/psm.h>
#include <wafl/wafl_raid.h>
#include <rpc/sunrpc_vfiler.h>
#include <driver/fabric/fabric_mgmtapi.h>
#include <driver/fabric/fabric_man.h>
#include <legacy/vfiler.h>
#include <net7g/netinet/sk_ipspace.h>    /* struct ipspace  */
#include <ontap/ems/link_ems.h>
#include <ontap/ems/snmp_vars_ems.h>
#include <ha/fmmisc.h>
#include <vdisk/attr.h>
#include <vdisk/vdisk.h>
#include <sk/typedefs.h>
#include <driver/scsi/wwn.h>
#include <driver/scsitarget/tha.h>
#include <driver/scsitarget/scsi_tgt_private.h>
#include <driver/scsitarget/scsi_tgt_proto.h>
#include <driver/scsitarget/scsi_tgt_throttle.h>
#include <driver/cmds/fcp_cmd.h>
#include <driver/sanown/sanown_public.h>
#include <wafl/quota.h>
#include <sparse/voltypes.h>
#include <sk/proto.h>
#include <wafl/vvols.h>
#include <wafl/vv_proto.h>

#include <nis/client.h>
#include <nis/nis_vfiler.h>
#include <ndm/ndm.h>
#include <sk/sk_vers.h>

#include "agent/mibgroup/mibparser_defines.h"
#include "agent/mibgroup/mibparser_structs.h"
#include "agent/mibgroup/mibII/interfaces.h"
#include "net-snmp/agent/snmp_vars.h"
#include "agent/mibgroup/util_funcs.h"
#include <ndmpd/ndmpd_dblade_mgmt.h>
#include <ndmpd/ndmpd_vfiler.h>

#include "adminapi/na.h"

#include <wafl/ext_cache/ext_cache.h>
#include <lib/strncpy_safe.h>

#include <driver/dsa/include/dsa.h>
#include <driver/dsa/api/dsa_ext.h>
#include <driver/dsa/apps/ui/dsa_apps_common.h>


/*
 * Malloc tags definitions
 */
MALLOC_DEFINE(M_SNMPV3, "snmpv3", "snmpv3 anonymous memory");
SK_DOMAIN_EXPORT(M_SNMPV3, SK_REASON_MPSAFE);


extern void nfs_aggregate_cpu_stats(nfs_Stats *stats, oldBool bSyncDomain);

extern int          handle_pdu(netsnmp_agent_session *asp);

SK_DOMAIN_IMPORT(is_service_licensed, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(is_nfs_allowed, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(is_snapmirror_allowed, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(zapi_license_info, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(disk_failure_reason_string, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(raid_disk_iterator_including_uninit, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_iterator_init, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(raid_disk_id_name, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(get_disk_attributes, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_id_is_in_labelmaint, SK_REASON_SWITCH_DOMAIN);
C_IMPORT_MPSAFE(gXL);

extern struct spa spa;
#define	HIGH32(x)	((uint32_t)((x)>>32))
#define	LOW32(x)	((uint32_t)(x))
#define GETWAFLSTAT(stat) wafl_stats_get_counter(&wafl_stats->stat)
#define VAULT_MAGIC(a) (-a)


#ifndef	MAXPATHLEN
#define	MAXPATHLEN	1024
#endif

#define MAX_VAL_LENGTH 1024

uint8_t          return_buf[MAX_VAL_LENGTH];
uint32_t         unsigned_return;

/* 
 * long_return is only accessed by one thread at a time  
 * behind the snmpstatlock mutex, making it MPSAFE.
 */
int32_t          long_return;

struct counter64 counter64_return;
uint32_t         unsigned_return;
uint64_t         big_return;
oid nullOid[] = { 0, 0 };
int nullOidLen = sizeof(nullOid);

static pclnt_nfs_Stats pcs, tpcs;

#define FILER_GUI_URL_PATH "/na_admin"
#define FILER_API_URL_PATH "/servlets/netapp.servlets.admin.XMLrequest_filer"

#define	SNMP_GLOBAL_STATUS_MESSAGE_LEN	256
#define	SNMP_FS_STATUS_MESSAGE_LEN	256
#define	SNMP_DISK_FAILED_MESSAGE_LEN	256

static char	snmp_vars_no_failed_disks_message[] =
		{ "There are no failed disks." };

static char	snmp_vars_no_failed_fans_message[] =
		{ "There are no failed fans." };

static char	snmp_vars_no_failed_power_supply_message[] =
		{ "There are no failed power supplies." };

/*
 * Currently a static string. At some point we will want to make
 * this dynamic so it will return the value of the last trap. (burt 148136)
 */
static char snmp_trap_var[] = "Trap variable currrently unused.";

static char spare_str[] = "spare";
static char broken_str[] = "failed";
static char na_str[]    = "N/A";

/*
 *  Number of seconds that the cached disk status information is
 *  valid.  The number should be large enough to allow a management
 *  station to ask for all of the summary stats, but short enough
 *  not to give out stale disk information.
 */
#define SNMP_DISK_CACHE_SECS 2

/*
 * These disk counts are shared by several routines below.
 * update_disk_counts() updates them.
 */
static struct snmp_vars_disk_counts {
    long		totalCount;
    long		activeCount;
    long		reconstructingCount;
    long		reconstructingParityCount;
    long		verifyingParityCount;
    long		scrubbingCount;
    long		failedCount;
    long		spareCount;
    long		addingSpareCount;
    long		adminRemovedOrFailedCount;
    long		prefailedCount;

    char		failedMessage[ SNMP_DISK_FAILED_MESSAGE_LEN ];
} counts[ONTAP_NHOSTS];

extern struct ifnet *ifnet;
extern int arptab_size;
/* FIXME: NOT NEEDED? extern struct arptab arptab[]; */

SK_DOMAIN_IMPORT(nfs_per_cpu_data_areas, SK_DOMAIN_NETWORK);
extern nfs_Stats nfs_last[2];

static boolean_t update_disk_counts(int host);
STATIC void init_send_link_traps(void);

/* nfsstat rw stats 			*/
static void var_getrwstats(void);
static void var_gettrwstats(void);

/* Vfiler related functions             */
static vfiler *vfGetVFByIndex(int index);
static int vfGetStoragePathNbrs(vfiler *vfp);


/*
 * per interface flag to ensure that two successive traps of
 * the same type are not sent
 *	snmp_ltrap[0]:		unused
 *	MAX_IF entries for physical interfaces
 *	additional two entries for the loopback and the vh interfaces
 */
#define SNMP_MAX_IF	(1 + MAX_IF + 2)
static int snmp_ltrap[ SNMP_MAX_IF ];

STATIC FindVarMethod _var_nfs;
STATIC FindVarMethod _var_tnfs;
STATIC FindVarMethod _var_pclEntry;
STATIC FindVarMethod _var_nfsCacheOptions;
STATIC FindVarMethod _var_nfsCacheStats;

STATIC uint8_t * _var_mirrorvaultCommon (SNMP_FM_ARGS, rpl_type       rtype);
STATIC uint8_t *_var_mirrorvaultStatusEntryCommon(SNMP_FM_ARGS, rpl_type       rtype);

static int snmp_get_out_of_date_disk_count(void);

SK_DOMAIN_IMPORT(in_auxpcblist, SK_REASON_SWITCH_DOMAIN);

SK_DOMAIN_IMPORT(raid_disk_id_type, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_config_iterator_create, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(raid_config_iterator_next, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(raid_config_iterator_destroy, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(raid_disk_iterator, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_iterator_from_id, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_iterator_is_parity_disk, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_iterator_recons_in_progress,
		SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_iterator_scrub_in_progress, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_iterator_verify_in_progress,
		SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_owner, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_spare_disks, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_zeroing_in_progress, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(raid_disk_id_to_diskindex, SK_REASON_SWITCH_DOMAIN);
SK_DOMAIN_IMPORT(disk_rpm_string, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(disk_type_string, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(disk_pool_string, SK_REASON_MPSAFE);

SK_DOMAIN_IMPORT(aggrcmd_util_get_opt_list, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(aggrcmd_util_get_status_string, SK_REASON_MPSAFE);
SK_DOMAIN_IMPORT(sanown_enabled, SK_REASON_READONLY);
SK_DOMAIN_IMPORT(sanown_count_unowned_disks, SK_REASON_SWITCH_DOMAIN);

/*
 *  Format an OID into a character buffer of specified size,
 *  and return a pointer to it.
 */
char *
sprintoidto(oid *name, int len, char *buf, int buflen) {
        int ctr;
        char * bptr;
        int l;

        buf[0] = 0;
        for (bptr = buf, ctr = 0 ; ctr< len ; ctr++) {
                l = snprintf(bptr, buflen, ".%d", name[ctr]);
                buflen -= l;
                bptr += l;
        }
        return buf;
}

/*
 *  Get an integer value from the registry.  If it doesn't exist,
 *  return a default value.
 */
static int
snmp_get_registry_int(char *key, int defval, int saveit)
{
	char	buf[32];

	if (registry_get(rootCred, key, buf, sizeof buf)) {
		return strtol(buf, NULL, 10);
	}
	else {
		if (saveit) {
			snprintf(buf, sizeof buf, "%d", defval);
			(void) registry_set(rootCred, key, buf);
			(void) registry_commit(rootCred, NULL);
		}
		return defval;
	}
}

/*
 * Given 2 OID return:
 * 0 if equal
 * -1 if name1 is numerically less than name2 or is a substring of name2
 * 1  if name1 is numerically greater than name2 or name2 is a substring of name1
 */
SK_DOMAIN_EXPORT(compare, SK_REASON_MPSAFE);
int
compare(oid *name1, int len1, oid *name2, int len2)
{
	return snmp_oid_compare(name1, len1, name2, len2);
}

/*
 * send appropriate linkup/down trap for each interface at init
 */
SK_DOMAIN_EXPORT(init_send_link_traps, SK_DOMAIN_NETWORK);
void
init_send_link_traps(void)
{
	int interface;
	struct ifnet *ifp;
	struct in_ifaddr *ia;

	ASSERT(sk_in_domain(sk_domain_network) || 
	       sk_in_domain(sk_domain_nwk_exclusive));

	SK_DOMAIN_REFERENCE(ifnet, SK_DOMAIN_NETWORK);
	for (interface = 1, ifp = ifnet; ifp; ifp = ifp->if_next,
		interface++) {

		VERIFY( interface < SNMP_MAX_IF );

		ia = ifnet_inaddr(ifp, sk_gethost(), AF_INET);
		if (ia == NULL)
			continue;

		if(ifp->if_flags & IFF_UP) {
			EMS_snmp_link_up(interface);
			snmp_ltrap[interface] = SNMP_TRAP_LINKUP;
		} else {
			EMS_snmp_link_down(interface);
			snmp_ltrap[interface] = SNMP_TRAP_LINKDOWN;
		}
	}
}

/*
 * send linkup/down trap at any time on being called by interface routines
 * don't send more than one trap for each condition.
 */
SK_DOMAIN_EXPORT(snmp_send_link_trap, SK_DOMAIN_NETWORK);
void
snmp_send_link_trap(struct ifnet *ifp_in, int trap)
{
	int interface;
	struct ifnet	*ifp;

	ASSERT(sk_in_domain(sk_domain_network) || 
	       sk_in_domain(sk_domain_nwk_exclusive));

	SK_DOMAIN_REFERENCE(ifnet, SK_DOMAIN_NETWORK);

	for (interface = 1, ifp = ifnet; ifp; ifp = ifp->if_next,
		interface++) {
		ASSERT( interface < SNMP_MAX_IF );
		if(interface >= SNMP_MAX_IF)
			return;
		if(ifp == ifp_in && (snmp_ltrap[interface] != trap)) {
			snmp_ltrap[interface] = trap;
			VERIFY((trap==SNMP_TRAP_LINKUP) || (trap==SNMP_TRAP_LINKDOWN));
			if ( trap == SNMP_TRAP_LINKUP )
				EMS_snmp_link_up(interface);
			else
				EMS_snmp_link_down(interface);
		}
	}
}

void
snmp_init_sendtraps(void)
{
	D(snmp, 10, ("snmp: snmp_init_sendtraps() is sending traps\n") );

	/*
	 * If the LCD manager isn't running, we're probably running from
	 * "/etc/rc"; display a message indicating what we're doing.
	 */
	if (!lcd_manager_running)
		lcd_printf("Reporting SNMP traps");

	send_easy_trap(SNMP_TRAP_COLDSTART, 0);

	/* send link related traps here since the interfaces
	 * own traps will have failed prior to this.
	 */
	sk_domain_switch_end(sk_domain_network);
	init_send_link_traps();
	sk_domain_switch_end(sk_domain_kahuna);
}

/* format is .1.3.6.1.4.1.789.1.22.1.magic.0  */
uint8_t *
var_netInterfaces(SNMP_FM_ARGS)
{
	HEADER_GENERIC;
	switch (vp->magic) {
	case NETIFNUMBER:
		*var_len = sizeof(long_return);
		long_return = Interface_Scan_Get_Count(AF_INET);
		return (uint8_t *) & long_return;
	default:
		ERROR("var_system");
	}
	return NULL;
}

/* **********     -- Vfiler  starts ******************************** */

static int getVfilerNbr(void)
{
	vfiler * vfp = NULL;
	void * cookie = NULL;
	int n = 0;

	while((vfp = vfiler_iterator( & cookie, VFILER_ITER_ACTIVE)) != NULL)
	{
		n++;
	}
	return n;
}

/* format is .1.3.6.1.4.1.789.1.16.magic.0  */
uint8_t *
var_vfiler(SNMP_FM_ARGS)
{
	HEADER_GENERIC;
	switch (vp->magic) {

        case VFILERISLICENSED:
		*var_len = sizeof(long_return);
                long_return = is_service_licensed(LICENSE_VFILER) ? 2 : 1;
                return (uint8_t *) & long_return;

	case VFFILERS:
		*var_len = sizeof(long_return);
		long_return = getVfilerNbr();   // HH_n_vfiler;
		return (uint8_t *) & long_return;

	default:
		ERROR("var_system");
	}
	return NULL;
}
 
#define ITER_WAY       VFILER_ITER_ACTIVE

static vfiler *vfGetVFByIndex(int index)
{
        vfiler *vfp = NULL;
        int i = 1;
	void	*cookie = NULL;

        if( (index > HH_n_vfiler) || (index < 1))
        {
		ERROR("vfGetVFByIndex: index 1");
              	return NULL;
        }
	i = 1;

	while(( vfp = vfiler_iterator( &cookie, ITER_WAY)) && (i < index))
	{
		i++;
	}
        if( !vfp || (i != index))
        {
	        return NULL;	/* no vfiler found */
        }

        return vfp;
}

static int vfGetIPNbrs(vfiler *vfp)
{
        if(!vfp)
	{
		ERROR("vfGetIPNbrs: index 1");
		return 0;
	}
	return vfiler_get_addrs(vfp, NULL);
}

static int32_t vfGetIPByIndex(vfiler *vfp, int index)
{
        if(!vfp) 
	{
		ERROR("vfGetIPByIndex: index 1");	
		return 0;
	}
	return vfiler_get_addr(vfp, index - 1);
}


static int vfGetStoragePathNbrs(vfiler *vfp)
{
        int nbr_stg = 0;
        vfstore *pvfs = NULL;
	uint64_t cookie = 0;

        if(!vfp)
	{
		ERROR("vfGetStoragePathNbrs: index 1");	
		return 0;
	}
	while( (pvfs = vfstore_iterator( vfp, &cookie)) != NULL)
	{
                if( vfp != pvfs->owningvf) 
			continue;		/* the storage owning vfiler doesn't match the given vfiler */
	        if( pvfs->path[0] != '\0') nbr_stg++;

        }
        return nbr_stg;
}


static char *vfGetStoragePathByIndex(vfiler *vfp, int index)
{
        int  i = 0;
        vfstore *pvfs = NULL;
	uint64_t	cookie = 0;

        if(!vfp) 
	{
		ERROR("vfGetStoragePathByIndex: index 1");
		return NULL;
	}
	while((pvfs = vfstore_iterator( vfp, &cookie)) != NULL)
	{
                if( vfp != pvfs->owningvf) 
			continue;		/*the storage owning vfiler doesn't match the given vfiler */
	        if( pvfs->path[0] == '\0')
			continue;
	        i++;
                if( i==index)
                {
                        return pvfs->path;
        	}
        }
	return NULL;
}

SK_DOMAIN_IMPORT(get_ipspace_name, SK_REASON_SWITCH_DOMAIN);

/* format is .1.3.6.1.4.1.789.1.16.3.1.magic.index */
uint8_t *
var_vfEntry(SNMP_FM_ARGS)
{
         int             result;
         static char     Name[MAX_VAL_LENGTH];
         char           *cp;
	 vfiler         *vfp=NULL;

	 if (HH_n_vfiler == 0) {
		 return NULL;
	 }

	 HEADER_SIMPLE_TABLE(HH_n_vfiler);

	vfp = vfGetVFByIndex(NAME_INDEX);
	if(!vfp)
	{
		ERROR("var_vfEntry: index 1 ");
		return NULL;
	}
        
	switch (vp->magic) {
	case VFINDEX:
	        *var_len = sizeof(long_return);
	        long_return = NAME_INDEX;
		return (uint8_t *) & long_return;
	case VFNAME:
	        strcpy(Name, vfp->name);
	        cp = Name;
		*var_len = strlen(cp);
	        return (uint8_t *) cp;
        case VFUUID:
		vfiler_strcpy_uuid(return_buf, sizeof(return_buf), &vfp->uuid);
		*var_len = strlen(return_buf);
		return return_buf;

        case VFIPADDRESSES:
		/* total number of ip addresses in vfindex indexed vfiler */
		long_return = vfGetIPNbrs( vfp);
        	if( !long_return)
		        {                  
	                    ERROR("var_vfEntry: vfNbrIPAddr 1");
		            return NULL; 
	                 } 
	         *var_len = sizeof(long_return);
	         return (uint8_t *) & long_return;
   
	case VFSTORAGEPATHS:
		/* total number of storage paths in vfindex indexed vfiler */
            	long_return = vfGetStoragePathNbrs( vfp); 
	        if( !long_return) 
	        {                       
	        	ERROR("var_vfEntry: vfNbrPath 1");
	                return NULL; 
	         } 
	         *var_len = sizeof(long_return);
	         return (uint8_t *) & long_return;

	case VFIPSPACE:

		cp = Name;
		get_ipspace_name( vfp->ipsid, cp);
		*var_len = strlen( cp);
		return (uint8_t *)cp;

	case VFALLOWEDPROTOCOLS:
		result = 0;
		if( !vfp->cifs_disabled) result++;
		if( !vfp->nfs_disabled)  result++;
		if( !vfp->rsh_disabled)  result++;
		if( !vfp->iscsi_disabled)  result++;
		long_return = result;
		*var_len = sizeof(long_return);
		return (uint8_t *)&long_return;
		
	case VFDISALLOWEDPROTOCOLS:
		result = 0;
		if( vfp->cifs_disabled) result++;
		if( vfp->nfs_disabled)  result++;
		if( vfp->rsh_disabled)  result++;
		if( vfp->iscsi_disabled)  result++;
		long_return = result;
		*var_len = sizeof(long_return);
		return (uint8_t *)&long_return;

	case VFSTATE:
		if (vfp->vfstate == VF_RUNNING)
			result = 2;
		else //If it's not running, then it's stopped.
			result = 1; 
		long_return = result;
		*var_len = sizeof(long_return);
		return (uint8_t *)&long_return;
		
        default:
               ERROR("var_system");
        }
        return NULL;
}

/* format is .1.3.6.1.4.1.789.1.16.4.1.magic.vfindex.ipindex
 *            0 1 2 3 4 5 6   7 8  9 10 11   12      13       
 */
uint8_t *
var_vfIpEntry(SNMP_FM_ARGS)

{
        oid     newname[SNMP_OID_MAX];
        int     result;
        int     vf_index, ip_index=0;
        int     vfno;
        int     ip_nbr = 0;
        vfiler  *vfp=NULL;
        int32_t    vf_ipaddr;
        int     done = 0;

	if (HH_n_vfiler == 0) {
		return NULL;
	}
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(HH_n_vfiler);
	}

	bcopy( (char *)vp->name, (char *)newname, (int)vp->namelen * sizeof(oid));

        if(*length >= 13 ) {
                vfno = name[12];
        } else {
                newname[12] = vfno = 1;
        }

        if( vfno > HH_n_vfiler)
        {
	        ERROR("var_vfIpEntry: index 1");
                return NULL;
	}

       for ( vf_index = 0; ((!done) &&(vf_index < vfno)); )
	{
		vf_index++;
                vfp = vfGetVFByIndex( vf_index);

                if( !vfp) {
                        ERROR("var_vfIpEntry: index 2");
                        return NULL;
                }
                if( vf_index < vfno) continue;
                ip_nbr = vfGetIPNbrs( vfp);
		newname[12] = vf_index;

                for(ip_index = 0; !done && (ip_index < ip_nbr); )
                {
                         ip_index++;
                         newname[13] = (oid) ip_index;
                         result = compare(name, *length, newname, 14);
                         done = ((exact && (result == 0)) || (!exact && (result < 0)));
                 }
                 if( !done && !exact)
                 {
		 	vfno++;
			if( vfno > HH_n_vfiler)
			{
				ERROR("var_vfIpEntry: index 1");
				return NULL;
			}       
			name[12] = 0;
                 }
         }
	
        if(!done || (ip_index == 0)) return NULL;

        *length = 14;
	*var_len = sizeof(long_return);
        bcopy( (char *)newname, (char *)name, (int)(*length) *sizeof(oid));
	
	switch (vp->magic) {
        case VFFIINDEX:		/* which vfiler */
		long_return = vf_index;
	        return (uint8_t *) & long_return;
       	
	case VFIPINDEX:		/* which ip in vffindex indexed vfiler */

                long_return = ip_index;
		return (uint8_t *) & long_return;

	case VFIPADDR:
        
                vf_ipaddr = vfGetIPByIndex(vfp, ip_index);
	        if( !vf_ipaddr)
	        {
                        ERROR("var_vfIpEntry: vfIPAddr 1");
			return NULL;
		}

                long_return = vf_ipaddr;
	        return (uint8_t *) & long_return;
	default:
	               ERROR("var_system");
	}
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.15.5.1.magic.vfindex.spindex
 *            0 1 2 3 4 5 6   7 8  9 10 11   12      13     
 */
uint8_t *
var_vfSpEntry(SNMP_FM_ARGS)
{
        oid     newname[SNMP_OID_MAX];
        int     result;
        static char     Name[MAX_VAL_LENGTH];
        int     vf_index, sp_index=0;
        int     vfno;
        int     sp_nbr = 0;
        vfiler         *vfp=NULL;

        char           *cp;
        int             done = 0;

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}
	bcopy( (char *)vp->name, (char *)newname, (int)vp->namelen* sizeof(oid));

        if(*length >= 13) {
                vfno = name[12];
        } else {
                newname[12] = vfno = 1;
        }

        if( vfno > HH_n_vfiler)
        {
                ERROR("var_vfSpEntry: index 1");
                return NULL;
        }

        for ( vf_index = 0; ((!done) &&(vf_index < vfno)); )
	{
		vf_index++;
                vfp = vfGetVFByIndex( vf_index);

                if( !vfp) return NULL;
                if( vf_index < vfno) continue;

                sp_nbr = vfGetStoragePathNbrs( vfp);
		newname[12] = vf_index;

                for(sp_index = 0; !done && (sp_index < sp_nbr); )
                {
                        sp_index++;
                        newname[13] = (oid) sp_index;
                        result = compare(name, *length, newname, 14);
                        done = ((exact && (result == 0)) || (!exact && (result < 0)));
                }
                if( !done && !exact)
                {
                        vfno++;
			if( vfno > HH_n_vfiler)
			{
				ERROR("var_vfSpEntry: index 1");
				return NULL;
			}       

                        name[12] = 0;
                }
        }
        if(!done || (sp_index == 0) ) return NULL;
        if( !vfp )
        {
                ERROR("var_vfSpEntry: index 2");
	        return NULL;
	}

        *length = 14;
        bcopy( (char *)newname, (char *)name, (int)(*length) *sizeof(oid));

        switch (vp->magic) {
        case VFFSINDEX:		/* which vfiler */
               long_return = vf_index;
	       *var_len = sizeof(long_return);
	       return (uint8_t *) & long_return;

        case VFSPINDEX:		/* which storage name in vffsindex indexed vfiler */

		long_return = sp_index;
		*var_len = sizeof(long_return);
		return (uint8_t *) & long_return;

        case VFSPNAME:
        
		cp = vfGetStoragePathByIndex(vfp, sp_index);
	        if( !cp) 
	        {                      
			ERROR("var_vfSpEntry: StoragePath 1"); 
			return NULL; 
  		} 
		ASSERT(strlen(cp) < sizeof(Name));
		strlcpy(Name, cp, sizeof(Name));
   	        cp = Name;
  		*var_len = strlen(cp);
		return (uint8_t *) cp;


	default:
              ERROR("var_system");
	}
	return NULL;
}

#define VFILER_PROTOCOL_COUNT   4
#define CIFS_INDX				1
#define NFS_INDX				2
#define RSH_INDX				3
#define ISCSI_INDX				4
char	*vf_pro_names[VFILER_PROTOCOL_COUNT] =
{"CIFS", "NFS", "RSH", "ISCSI"};

COMPILE_TIME_ASSERT(sizeof(vf_pro_names) / sizeof(vf_pro_names[0])  ==
			VFILER_PROTOCOL_COUNT);

/* format is .1.3.6.1.4.1.789.1.15.6.1.magic.vfindex.proindex
 *            0 1 2 3 4 5 6   7 8  9 10 11   12      13 
 */
uint8_t *
var_vfProEntry(SNMP_FM_ARGS)
{
        oid     newname[SNMP_OID_MAX];
        int     result;
	static char     Name[MAX_VAL_LENGTH];
        int     vf_index, pro_index=0;
        int     vfno;
        int     pro_nbr = VFILER_PROTOCOL_COUNT;
        vfiler         *vfp=NULL;

        char           *cp;
        int             done = 0;
        
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}
	bcopy( (char *)vp->name, (char *)newname, (int)vp->namelen* sizeof(oid));

        if(*length >= 13) {
                vfno = name[12];
        } else {
                vfno = name[12] = 1;
        }

        if( vfno > HH_n_vfiler) {
                ERROR("var_vfProEntry: index 1");
                return NULL;
        }

        for ( vf_index = 0; ((!done) &&(vf_index < vfno)); )
	{
		vf_index++;
        	vfp = vfGetVFByIndex( vf_index);

	        if( !vfp) return NULL;
	        if( vf_index < vfno) continue;
		
		newname[12] = vf_index;

	        for(pro_index = 0; !done && (pro_index < pro_nbr); )
                {
			pro_index++;
	                newname[13] = (oid) pro_index;
		        result = compare(name, *length, newname, 14);
		        done = ((exact && (result == 0)) || (!exact && (result < 0)));
		}
	        if( !done && !exact)
	        {
			vfno++;
			if( vfno > HH_n_vfiler)
			{
				ERROR("var_vfProEntry: index 1");
				return NULL;
			}       
			name[12] = 0;
		}
	}
	
	if(!done || (pro_index == 0) ) return NULL;
	if( !vfp )
	{
	          ERROR("var_vfProEntry: index 2");
	        return NULL;
	}

        *length = 14;
        bcopy( (char *)newname, (char *)name, (int)(*length) *sizeof(oid));
	*write_method = 0;
	*var_len = sizeof(int32_t);

        switch (vp->magic) {
        case VFFPINDEX:         /* which vfiler */
               long_return = vf_index;
               *var_len = sizeof(long_return);
               return (uint8_t *) & long_return;

        case VFPROINDEX:         /* which protocol name in vffsindex indexed vfiler */

	      	long_return = pro_index;
      		*var_len = sizeof(long_return);
		return (uint8_t *) & long_return;

	case VFPRONAME:

		ASSERT(strlen(vf_pro_names[pro_index-1]) < sizeof(Name));
		strlcpy(Name, vf_pro_names[pro_index-1], sizeof(Name));
	   	cp = Name;
		*var_len = strlen(cp);   
		return (uint8_t *) cp;

	case VFPROSTATUS:
      		switch(pro_index)
	       	{
		case CIFS_INDX:
			long_return = vfp->cifs_disabled? 1:2;
			break;

		case NFS_INDX:
			long_return = vfp->nfs_disabled? 1:2;
			break;

		case RSH_INDX:
			long_return = vfp->rsh_disabled? 1:2;
			break;

		case ISCSI_INDX:
			long_return = vfp->iscsi_disabled? 1:2;
			break;

		default:
			long_return = 1;
		}
		*var_len = sizeof(long_return);
		return (uint8_t *) & long_return;

	
	default:
		ERROR("var_vfProEntry");
	}

        return NULL;


}

/*
 * Netapp-specific additions to the network OID's found in mibII/interfaces.c
 */
/* format is .1.3.6.1.4.1.789.1.22.1.2.1.2.1.magic.index */
#define MIBIFNAMSIZ 2*IFNAMSIZ
uint8_t *
var_netifEntry(SNMP_FM_ARGS)
{
	int             count;
	struct ifnet   *ifp;
	static char     Name[MIBIFNAMSIZ];
	char *Name_ptr = Name;
	int		host = sk_gethost();
	uint64_t	counter64;

	count = (int)Interface_Scan_Get_Count(AF_INET);
	if (count == 0) {
		return NULL;
	}
	HEADER_SIMPLE_TABLE(count);

	ifp = Interface_Scan_By_Index(NAME_INDEX);
	if (ifp == NULL) {
		return NULL;
	}

	switch (vp->magic) {
	case NETIFINDEX:
		long_return = NAME_INDEX;
		return (uint8_t *) & long_return;
	case NETIFDESCR:
		/*
		 * We have to play this gross little game of getting
		 * the correct interface name based on whether we are
		 * in local or takeover mode.
		 */
                if (ifp->if_flags2 & IFF2_MGMT_PORTS){
                        strlcpy(Name_ptr, "MGMT_PORT_ONLY ", IFNAMSIZ);
                        Name_ptr += strlen(Name_ptr);
                }

		if (host == SK_HOST_LOCAL) {
			strlcpy(Name_ptr, ifp->if_fullname, IFNAMSIZ);
		} else {
			ifconfig_map_t *im =
				ifconfig_getPartner(ifp->if_fullname);
			SK_DOMAIN_REFERENCE(ifconfig_getPartner, SK_REASON_SWITCH_DOMAIN);
			if (!im)
				return NULL;
			strlcpy(Name_ptr, im->im_partner, IFNAMSIZ);
		}
		*var_len = strlen(Name);
		return (uint8_t *) Name;
	case IFHIGHINOCTETS:
		long_return = HIGH32(ifp->if_ibytes);
		return (uint8_t *) & long_return;
	case IFLOWINOCTETS:
		long_return = LOW32(ifp->if_ibytes);
		return (uint8_t *) & long_return;
	case IF64INOCTETS:
		counter64_return.high = HIGH32(ifp->if_ibytes);
		counter64_return.low  = LOW32(ifp->if_ibytes);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) &counter64_return;

	case IFHIGHINUCASTPKTS:
		counter64 = (uint64_t)(ifp->if_ipackets - ifp->if_imcasts);
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWINUCASTPKTS:
		long_return = LOW32(ifp->if_ipackets - ifp->if_imcasts);
		return (uint8_t *) & long_return;
	case IF64INUCASTPKTS:
		counter64 = (uint64_t)(ifp->if_ipackets - ifp->if_imcasts);
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHINNUCASTPKTS:
		counter64 = (uint64_t)ifp->if_imcasts;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWINNUCASTPKTS:
		long_return = LOW32(ifp->if_imcasts);
		return (uint8_t *) & long_return;
	case IF64INNUCASTPKTS:
		counter64 = (uint64_t)ifp->if_imcasts;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHINDISCARDS:
		counter64 = (uint64_t)ifp->if_iqdrops;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWINDISCARDS:
		long_return = LOW32(ifp->if_iqdrops);
		return (uint8_t *) & long_return;
	case IF64INDISCARDS:
		counter64 = (uint64_t)ifp->if_iqdrops;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

      	case IFHIGHINERRORS:
		counter64 = (uint64_t)ifp->if_ierrors;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWINERRORS:
		long_return = LOW32(ifp->if_ierrors);
		return (uint8_t *) & long_return;
      	case IF64INERRORS:
		counter64 = (uint64_t)ifp->if_ierrors;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHINUNKNOWNPROTOS:
		counter64 = (uint64_t)ifp->if_noproto;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWINUNKNOWNPROTOS:
		long_return = LOW32(ifp->if_noproto);
		return (uint8_t *) & long_return;
	case IF64INUNKNOWNPROTOS:
		counter64 = (uint64_t)ifp->if_noproto;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHOUTOCTETS:
		long_return = HIGH32(ifp->if_obytes);
		return (uint8_t *) & long_return;
	case IFLOWOUTOCTETS:
		long_return = LOW32(ifp->if_obytes);
		return (uint8_t *) & long_return;
	case IF64OUTOCTETS:
		long_return = HIGH32(ifp->if_obytes);
		counter64_return.high = HIGH32(ifp->if_obytes);
		counter64_return.low  = LOW32(ifp->if_obytes);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHOUTUCASTPKTS:
		counter64 = (uint64_t)(ifp->if_opackets - ifp->if_omcasts);
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWOUTUCASTPKTS:
		long_return = LOW32(ifp->if_opackets - ifp->if_omcasts);
		return (uint8_t *) & long_return;
	case IF64OUTUCASTPKTS:
		counter64 = (uint64_t)(ifp->if_opackets - ifp->if_omcasts);
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHOUTNUCASTPKTS:
		counter64 = (uint64_t)ifp->if_omcasts;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWOUTNUCASTPKTS:
		long_return = LOW32(ifp->if_omcasts);
		return (uint8_t *) & long_return;
	case IF64OUTNUCASTPKTS:
		counter64 = (uint64_t)ifp->if_omcasts;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;


	case IFHIGHOUTDISCARDS:
		counter64 = (uint64_t)ifp->if_snd.ifq_drops;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWOUTDISCARDS:
		long_return = LOW32(ifp->if_snd.ifq_drops);
		return (uint8_t *) & long_return;
	case IF64OUTDISCARDS:
		counter64 = (uint64_t)ifp->if_snd.ifq_drops;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case IFHIGHOUTERRORS:
		counter64 = (uint64_t)ifp->if_oerrors;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	case IFLOWOUTERRORS:
		long_return = LOW32(ifp->if_oerrors);
		return (uint8_t *) & long_return;
	case IF64OUTERRORS:
		counter64 = (uint64_t)ifp->if_oerrors;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	default:
		DEBUGMSGTL(("snmpd", "unknown sub-id %d in var_netifEntry\n",
			    vp->magic));
	}
	return NULL;
}

SK_DOMAIN_EXPORT(snmp_fillname, SK_REASON_MPSAFE);
void
snmp_fillname(oid *name, size_t *namelen, oid fill, int len) 
{
	while (*namelen < len) {
		*namelen = *namelen +1;
		name[*namelen-1] = fill;
	}
}

/*
 * Fill in return_buf (a global string used for returning SNMP values)
 * with the URL value for a given protocol/port/path.
 * For the network address, we use whatever interface gets used for DHCP.
 */
static boolean_t
create_admin_url(int port, char * path)
{
	char *p = NULL;
	int sz;
	char *q;
	char *proto = "http";
	char key[64];	/* enough for status.if.{interfacename}.addr */
	char *temp_sslport = NULL;
	char return_str[6];

	snprintf(key,sizeof(key),"status.if.%s.addr",psm_get_dhcp_if());
	if ( registry_get_realloc(rootCred,key,&p,&sz,SKMA_SLEEP) == false ) {
		return false;
	}
	if ( registry_get_boolean("options.httpd.admin.ssl.enable",false) ) {
		proto = "https";
		if ((temp_sslport = httpd_get_sslport(NULL, return_str, 6))) {
			port = atoi(temp_sslport);
		}
	}
	/*
	 * The values from status.if.*.addr are actually triples -
	 * {address},{netmask},{broadcast} - so we only want the first.
	 */
	if ( (q=strchr(p,',')) != NULL )
		*q = '\0';
	snprintf(return_buf, sizeof(return_buf), "%s://%s:%d%s",
		proto, p, port, path);
	sk_kmem_free(p);
	return true;
}

/* format is .1.3.6.1.4.1.789.1.1.magic.0 */
uint8_t         *
var_product(SNMP_FM_ARGS)
{
	static char     Name[MAX_VAL_LENGTH];
	int host = sk_gethost();
	int ret_status = 0;

	HEADER_GENERIC;

	switch (vp->magic) {
	/* ---------------------------------------------- */
	case PRODUCTTYPE:
		if (ddi_get_system_bus() == PCI_BUS) {
			long_return = (int32_t) PRODTYPE_PCI;
		} else {
			long_return = (int32_t) PRODTYPE_EISA;
		}
		return (uint8_t *) & long_return;
	/* ---------------------------------------------- */
	case PRODUCTVERSION:
		*var_len = strlen(ontap_version.version);
		return (uint8_t *) ontap_version.version;
	/* ---------------------------------------------- */
	case PRODUCTID:
		if (host == SK_HOST_LOCAL)
			*var_len = snprintf(Name, sizeof Name, "%s", nvram_serialno);
		else
			*var_len = snprintf(Name, sizeof Name, "%s", fm_partner_serialno());
		return (uint8_t *) Name;
	/* ---------------------------------------------- */
	case PRODUCTVENDOR:
		/*
		 * The value of vendor_id is 0-based, but the
		 * MIB value should be 1-based.
		 */
		long_return = (int32_t) ( vendor_info_id + 1 );
		return (uint8_t *) & long_return;
	/* ---------------------------------------------- */
	case PRODUCTMODEL: {
		const char * model = psm_get_public_modelstr();

		/*
		 *  Do this just like sysconfig.
		 */
		if (NULL == model) {
			model = "unknown";
		}
		*var_len = snprintf(Name, sizeof Name, "%s", model);
		return (uint8_t *) Name;
	}
	/* ---------------------------------------------- */
	case PRODUCTFIRMWAREVERSION: {
		const char * ofw_release_str = psm_get_firmware_release();

		/*
		 *  Do this just like sysconfig.
		 */
		if (NULL == ofw_release_str) {
			ofw_release_str = "unknown";
		}
		*var_len = snprintf(Name, sizeof Name, "%s", ofw_release_str);
		return (uint8_t *) Name;
	}
	/* ---------------------------------------------- */
	case PRODUCTGUIURL:
		if ( create_admin_url(httpd_GetAdminPort(),
			FILER_GUI_URL_PATH) == false ) {
			return NULL;
		}
		*var_len = strlen((char *) return_buf);
		return return_buf;
	/* ---------------------------------------------- */
	case PRODUCTAPIURL:
		if ( create_admin_url(httpd_GetAdminPort(),
			FILER_API_URL_PATH) == false ) {
			return NULL;
		}
		*var_len = strlen((char *) return_buf);
		return return_buf;
	/* ---------------------------------------------- */
	case PRODUCTSERIALNUM: 
		if (host == SK_HOST_LOCAL) 
			ret_status = get_serialnum(Name, sizeof Name);
		else 
			ret_status = get_partner_serialnum(Name, sizeof Name);
		
		if (ret_status) 
			*var_len = strlen(Name);
		else  
			*var_len = snprintf(Name, sizeof Name, "unknown");
		
		return (uint8_t *) Name;
	
	/* ---------------------------------------------- */
	case PRODUCTPARTNERSERIALNUM: 
		if (fm_cf_configuration()) { 
			if (host == SK_HOST_LOCAL) {
				ret_status = get_partner_serialnum(Name, 
						sizeof Name);
			} else { 
				ret_status = get_serialnum(Name, sizeof Name);
			}
			
			if (ret_status) {
				*var_len = strlen(Name);
			} else {
				*var_len = snprintf(Name, sizeof Name, 
						"unknown");
			}
		} else {
			*var_len = snprintf(Name, sizeof Name, 
					"not applicable");
		}
		return (uint8_t *) Name;
	/* ---------------------------------------------- */
	case PRODUCTCPUARCH:
		long_return = (int32_t) psm_arch();
		return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case PRODUCTTRAPDATA: 
		
		*var_len = strlen(snmp_trap_var);
		return (uint8_t *) snmp_trap_var;
	
	/* ---------------------------------------------- */
	case PRODUCTMACHINETYPE: {
		const char * model = psm_get_mtmstr();

		/*
		 *  Do this just like sysconfig.
		 */
		if (NULL == model) {
			model = "unknown";
		}
		*var_len = snprintf(Name, sizeof Name, "%s", model);
		return (uint8_t *) Name;
	}
	default:
		ERROR("var_prod");
	/* ---------------------------------------------- */
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.1.14.1.magic.index */
uint8_t         *
var_productLicenseEntry(SNMP_FM_ARGS)
{
	/*
	 * This MIB table has been marked deprecated for License V2.
	 * See the new licenseTable and var_licenseEntry() function for
	 * the new license V2 handling.
	 * 
	 * Don't return any values here.
	 */
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.25.4.1.magic.index */
uint8_t * var_licenseEntry(SNMP_FM_ARGS)
{
	//cmd_printf("[DEBUG]: var_licenseEntry, BEFORE HEADER, exact: %d, *length: %d, vp->namelen: %d, NAME_INDEX: %d\n", (int) exact, (int) *length, (int) vp->namelen, (int) NAME_INDEX);

	/* 
	 * Don't use HEADER_SIMPLE_TABLE all the time. Because we have a string as index before the
	 * package number, the macro doesn't support table with more than one index. But since we
	 * don't really care about the serial-number index in 7mode we can treat it as a single
	 * index table and make use of the macro with some tweaking:
	 * 1) for exact matches it gets a MATCH FAILED (because the string does not match anything)
	 * 2) for non exact matches, instead of incrementing the INDEX to the next one, it starts from the beginning (1) for snmp getnext operations.
	 */

	/* Here's a way to get the INDEX right.*/
	if (exact && *length < 14) {
		/* not complete match, return not found */
		return NULL;
	}

	if (!exact) {
		/*
		 * If the length is complete, skip the HEADER_SIMPLE_TABLE call because it'll
		 * change the INDEX back to 1. If the length is incomplete then use the macro
		 * which will return the next possible INDEX value.
		 */
		if (*length < 14) {
			/* no index provided, search for the next available index */
			HEADER_SIMPLE_TABLE(LICENSE_PACKAGE_MAX_7MODE);
		} else {
			/* else use the next index */
			NAME_INDEX++;
		}
	}

	//cmd_printf("[DEBUG]: var_licenseEntry, AFTER HEADER, exact: %d, *length: %d, vp->namelen: %d, NAME_INDEX: %d\n", (int) exact, (int) *length, (int) vp->namelen, (int) NAME_INDEX);


	/*
	 * If we reached here we have an INDEX to use. Get the
	 * value of the INDEX from the database
	 */
	na_elem_t *license_list = 0;
	na_elem_t *license_info =0;

	license_list = na_elem_new("licenses");

	DateAndTime expiration;
	bzero(&expiration, sizeof(expiration));

	if (exact) {
		/* 
		 * Exact match requested. So just look in the database
		 * for the value of the INDEX, if any.
		 */
		if (snmp_license_get(NAME_INDEX, license_list, &expiration) != 0) {
			na_elem_free(license_list);
			return NULL;
		}

		license_info = na_child_get(license_list, "license-v2-info");
		if (!license_info) {
			na_elem_free(license_list);
			return NULL;
		}

	} else {

		/*
		 * Not an exact match request, so we should skip holes until we find the
		 * next INDEX that has a valid value.
		 *
		 * If the INDEX requested is less than the minimum LicensedPackage value
		 * set it to the minimum
		 */
		if (NAME_INDEX < LICENSE_PACKAGE_MIN_7MODE) {
			NAME_INDEX = LICENSE_PACKAGE_MIN_7MODE;
		}

		/* Keep looking until we reached the end max Licensed Package value */
		while(license_info == NULL && NAME_INDEX < LICENSE_PACKAGE_MAX_7MODE) {
			if (snmp_license_get(NAME_INDEX, license_list, &expiration) != 0) {
				NAME_INDEX++;
			} else {
				license_info = na_child_get(license_list, "license-v2-info");
			}
		}

		/* If no values are found, we are done. */
		if (!license_info) {
			na_elem_free(license_list);
			return NULL;
		}
	}
	

	/*
	 * If we reached here, an INDEX and it's vlaue has been found in 
	 * the databse. Now extract the requested data from the value.
	 */
	const char *displaystring;

	switch(vp->magic) {
	case LICENSESERIALNUMBER:
		displaystring = na_child_get_string(license_info, "serial-number");
		if (displaystring == NULL) {
			break;
		}

		strlcpy((char*) return_buf, displaystring, sizeof(return_buf));
		*var_len = strlen((char*) return_buf);
		na_elem_free(license_list);
		return return_buf;

	case LICENSEPACKAGE:
		long_return = NAME_INDEX;
		break;

	case LICENSEOWNER:
		displaystring = na_child_get_string(license_info, "owner");
		if (displaystring == NULL) {
			break;
		}

		strlcpy((char*) return_buf, displaystring, sizeof(return_buf));
		*var_len = strlen((char*) return_buf);
		na_elem_free(license_list);
		return return_buf;

	case LICENSEDESCRIPTION:
		displaystring = na_child_get_string(license_info, "description");
		if (displaystring == NULL) {
			break;
		}

		strlcpy((char*) return_buf, displaystring, sizeof(return_buf));
		*var_len = strlen((char*) return_buf);
		na_elem_free(license_list);
		return return_buf;

	case LICENSETYPE:
		displaystring = na_child_get_string(license_info, "type");
		if (strcmp(displaystring, "license")==0) {
			long_return = 2;
		} else if (strcmp(displaystring, "site")==0) {
			long_return = 3;
		} else if (strcmp(displaystring, "demo")==0) {
			long_return = 4;
		} else {
			long_return =0;
		}
		break;

	case LICENSEEXPIRATION:
		memcpy(return_buf, &expiration, sizeof(expiration));
		*var_len = sizeof(expiration);
		na_elem_free(license_list);
		return return_buf;

	case LICENSELEGACY:
		displaystring = na_child_get_string(license_info, "legacy");
		if (strcmp(displaystring, "true")==0) {
			long_return = 1;
		}
		else {
			long_return = 2;
		}
		break;

	case LICENSECUSTOMERID:
		displaystring = na_child_get_string(license_info, "customer-id");

		if (displaystring == NULL) {
			break;
		}

		strlcpy((char*) return_buf, displaystring, sizeof(return_buf));
		*var_len = strlen((char*) return_buf);
		na_elem_free(license_list);
		return return_buf;

	default:
		ERROR("var_licenseEntry");
		na_elem_free(license_list);
		return NULL;
	}

	na_elem_free(license_list);
	*var_len = sizeof(long_return);
	return (uint8_t *)&long_return;
}

/*
 * The following function is commented out for SN.0 
 * because the SNMP support for managed-feature is
 * postoned after SN.0 release. There is currently no
 * feature requiring this interface, and therefore
 * having it in the MIB was deemed not necessary at
 * this point. The following MIB entry was pulled out
 * of netapp.mib. See burt644450 for more info. Commenting
 * this out because it may still be needed in SN.1 or FS
 * release.
 *

    	-- managedFeatureTable
        managedFeatureTable		OBJECT-TYPE
	SYNTAX      			SEQUENCE OF ManagedFeatureEntry
	MAX-ACCESS  			not-accessible
	STATUS      			current
	DESCRIPTION
		"Managed Feature"
	::= { cluster 5 }

	managedFeatureEntry	 	OBJECT-TYPE
	SYNTAX      			ManagedFeatureEntry
	MAX-ACCESS  			not-accessible
	STATUS      			current
	DESCRIPTION
		"Details about each managed feature."
	INDEX { managedFeatureID }
	::= { managedFeatureTable 1 }

	ManagedFeatureEntry ::=
            SEQUENCE {
		managedFeatureID              Integer32,
		managedFeatureName	      DisplayString,
		managedFeatureStatus          Integer32,
		managedFeatureNotes           DisplayString
	    }

	managedFeatureID 		OBJECT-TYPE
	SYNTAX      			Integer32 (1..2147483647)
	MAX-ACCESS  			read-only
	STATUS      			current
	DESCRIPTION
		"Managed Feature ID"
	::= { managedFeatureEntry 1 }

	managedFeatureName	 	OBJECT-TYPE
	SYNTAX      			DisplayString
	MAX-ACCESS  			read-only
	STATUS      			current
	DESCRIPTION
		"Name of Managed Feature"
	::= { managedFeatureEntry 2 }

	managedFeatureStatus	 	OBJECT-TYPE
	SYNTAX      			INTEGER {
	                                    on(0),
					    running(1),
					    off(2),
					    not-available(3)
					}
	MAX-ACCESS  			read-only
	STATUS      			current
	DESCRIPTION
		"Managed Feature Status (on/running/off/not-available)"
	::= { managedFeatureEntry 3 }

	managedFeatureNotes	 	OBJECT-TYPE
	SYNTAX      			DisplayString
	MAX-ACCESS  			read-only
	STATUS      			current
	DESCRIPTION
		"Managed Feature Notes"
	::= { managedFeatureEntry 4 }
 *
 *
 *
 *
 *
*/

/* format is .1.3.6.1.4.1.789.1.25.5.1.magic.index */

/* uint8_t * var_managedFeatureEntry(SNMP_FM_ARGS) */
/* { */
/* 	ManagedFeatureStatus mf_status; */
/* 	char notes[MF_MAX_STR_SIZE]; */

/* 	HEADER_SIMPLE_TABLE(MANAGED_FEATURE_MAX); */

/* 	if (exact) { */
/* 		/\* */
/* 		 * The exact match case, try to get the enum matching the */
/* 		 * NAME_INDEX */
/* 		 *\/ */
/* 		if (managed_feature_get_status((ManagedFeature) NAME_INDEX, */
/* 					       &mf_status, notes) != true) { */
/* 			return NULL; */
/* 		} */
/* 	} else { */
/* 		/\*  */
/* 		 * The non-exact match case: */
/* 		 * Loop in case there is a hole in the enum definition. Currently */
/* 		 * there isn't. Find the next match. */
/* 		 *\/ */
/* 		while (managed_feature_get_status((ManagedFeature) NAME_INDEX, */
/* 						  &mf_status, notes) != true) { */

/* 			/\* */
/* 			 * Reached the END of the enum definition, return NULL */
/* 			 * because nothing is found. */
/* 			 *\/ */
/* 			if (NAME_INDEX >= MANAGED_FEATURE_MAX) { */
/* 				return NULL; */
/* 			} */

/* 			NAME_INDEX++; */
/* 		} */
/* 	} */

/* 	switch (vp->magic) { */
/* 	case MANAGEDFEATUREID: */
/* 		long_return = NAME_INDEX; */
/* 		break; */

/* 	case MANAGEDFEATURENAME: */

/* 		/\* sizeof(return_buf) is much larger than feature name length *\/ */

/* 		if(managed_feature_tostring((ManagedFeature) NAME_INDEX, */
/* 					    return_buf)) { */
/* 			*var_len = strlen(return_buf); */
/* 			return return_buf; */
/* 		} else { */
/* 			return NULL; */
/* 		}					        */

/* 	case MANAGEDFEATURESTATUS: */
/* 		long_return = mf_status; */
/* 		break; */

/* 	case MANAGEDFEATURENOTES: */
/* 		strlcpy(return_buf, notes, sizeof(return_buf)); */
/* 		*var_len = strlen(return_buf); */
/* 		return return_buf; */

/* 	default: */
/* 		ERROR("var_managedFeatureEntry"); */
/* 		return NULL; */

/* 	} */

/* 	return (uint8_t *)&long_return; */
/* } */

/* format is .1.3.6.1.4.1.789.1.2.1.magic.0 */
uint8_t *
var_cpu(SNMP_FM_ARGS)
{
	uint64_t total_tics, busy_tics, cp_rupt_busy_tics, noncp_rupt_busy_tics;
	
        uint64_t total_cycles, busy_cycles, cp_rupt_busy_cycles, 
	      noncp_rupt_busy_cycles;
	sk_system_stats_t sys_stats;

        #define CYCLES_TO_TICS(field) (sk_cycles_to_usec(field)/(1000*SK_MSEC_PER_TIC))

	/*
	 *  We keep track of what the total and busy counts
	 *  were the last time anyone asked SNMP for either
	 *  the cpuBusyTimePercent or cpuIdleTimePercent,
	 *  so that we can report the busy or idle time
	 *  *since the last request*.
	 *
	 *  This isn't perfect -- two pollers necessarily
	 *  interfere with each other -- but it's much better
	 *  than the nearly-useless behavior of reporting
	 *  percentages since boot.
	 *
	 *  We keep the last_busy and last_idle stats separately
	 *  so that a request for the busy percent doesn't
	 *  immediately reset the idle percent.  We don't keep
	 *  these as per-host values, though, because the CPU
	 *  usage isn't allocated to a particular host.
	 */
	static sk_system_stats_t last_busy_percent_stats = {0};
	static sk_system_stats_t last_idle_percent_stats = {0};

        HEADER_GENERIC;

	sk_system_getstats(SK_STATS_TOTAL, &sys_stats);
      
	total_cycles = sys_stats.ss_real_cycles;
        busy_cycles =  sys_stats.ss_cpu_summary_cycles;
	cp_rupt_busy_cycles = sys_stats.ss_cp_rupt_cycles;
	noncp_rupt_busy_cycles = sys_stats.ss_noncp_rupt_cycles;

	
	total_tics = CYCLES_TO_TICS(total_cycles) ;
	busy_tics =  CYCLES_TO_TICS(busy_cycles) ;
	cp_rupt_busy_tics = CYCLES_TO_TICS(cp_rupt_busy_cycles) ;
	noncp_rupt_busy_tics = CYCLES_TO_TICS(noncp_rupt_busy_cycles) ;

	switch (vp->magic) {
	/* --------------------------------------------- */
	case CPUUPTIME:
	    /* return uptime in hundredths of seconds */
	    long_return = (int32_t) (total_tics);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPUBUSYTIME:
	    /* return busy time in hundredths of seconds */
	    long_return = (int32_t) (busy_tics);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPUBUSYTIMEPERCENT: {

	  /*
	     * CPU Utilization:
	     *  Being reported as, 
	     *  The percent of time one or more CPUs were busy (PLEVEL1).
	     *  Therefore, plevel1 cycles are being used.
	     *  Note that it's *not* being reported as  the average amount 
	     *  of busy time for all system processors (i.e. busy_cycles).
	     */


	    /* New local variables added to hold values in cycles too */
	    uint64_t       delta_total_cycles;
	    uint64_t       delta_busy_cycles;

	    /* Using cycles in place of usecs */
           
	    delta_total_cycles = total_cycles - 
	                         last_busy_percent_stats.ss_real_cycles;
	    delta_busy_cycles = busy_cycles - 
	                          last_busy_percent_stats.ss_cpu_summary_cycles;
	
	    /*
	     *  We're doing our math with uint64_t, so wraparound isn't
	     *  a concern -- the tic counter will wrap around in
	     *  approximately 5 billion years.
	     *
	     *  Since polling intervals are set in terms of seconds, we 
	     *  round anything under a second down to zero.  burt 85905.
	     */

	   
	    if (delta_total_cycles < 
		  (sk_usec_to_cycles(100*SK_MSEC_PER_TIC*1000)) && 
		     delta_busy_cycles >= delta_total_cycles) {
		    long_return = 0;
	    } else {
	     
	      /* Returning CPU busy % as defined in Burt 159087 */
	      long_return = (int32_t) percent(delta_busy_cycles,
					   delta_total_cycles);
	      
	      bcopy(&sys_stats, &last_busy_percent_stats, 
			  sizeof(sk_system_stats_t));
	    }

	    return (uint8_t *) & long_return;
	}
	/* --------------------------------------------- */
	case CPUIDLETIME:
	    
	  /* 
	   * Idle Time conforming to definition of busy time in Burt 159087
	   */

	    long_return = (int32_t) (CYCLES_TO_TICS((total_cycles - busy_cycles)));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPUIDLETIMEPERCENT: {
	   
	    /* new variables to hold values in cycles */
	    uint64_t       delta_total_cycles;
	    uint64_t       delta_busy_cycles;
	    
	    /* Store values in cycles */

	    delta_total_cycles = total_cycles - 
	                         last_idle_percent_stats.ss_real_cycles;
	    delta_busy_cycles = busy_cycles - 
                                   last_idle_percent_stats.ss_cpu_summary_cycles;
	   
	    /*
	     *  We're doing our math with uint64_t, so wraparound isn't
	     *  a concern -- the tic counter will wrap around in
	     *  approximately 5 billion years.
	     *
	     *  Since polling intervals are set in terms of seconds, we 
	     *  round anything under a second down to zero.  burt 85905.
	     */

	    if (delta_total_cycles < (sk_usec_to_cycles(100*SK_MSEC_PER_TIC*
	       1000)) && delta_busy_cycles >= delta_total_cycles) {
		    long_return = 100;
	    } else {

	      /*
	       * Idle % conforming to definition of busy time in Burt 159087
	       */
	      
	       long_return = delta_total_cycles ?
			    ((int32_t) (100 - percent(delta_busy_cycles,
						   delta_total_cycles )))
						   : 100;
		    bcopy(&sys_stats, &last_idle_percent_stats, 
			  sizeof(sk_system_stats_t));
	    }

	    return (uint8_t *) & long_return;
	}
	/* --------------------------------------------- */
	case CPUCOUNT:
	    long_return = psm_active_processor_count();
	    return (uint8_t *) & long_return;
	/* ---------------------------------------------- */
	case CPUSWITCHINVOCATIONS:
	    long_return = (int32_t) (sys_stats.ss_switch_count);
            return (uint8_t *) & long_return;	
        
	/* --------------------------------------------- */
	case CPUCONTEXTSWITCHES:
	    long_return = (int32_t) (sys_stats.ss_hard_switch_count);
            return (uint8_t *) & long_return;	

	/* --------------------------------------------- */
	case CPUINTERRUPTS:
	    long_return = (int32_t) (sys_stats.ss_cp_rupts);
            return (uint8_t *) & long_return;	
	/* --------------------------------------------- */
        case CPUNONCPINTERRUPTS:
	    long_return = (int32_t) (sys_stats.ss_noncp_rupts);
            return (uint8_t *) & long_return;	
	
	/* --------------------------------------------- */
        case CPUCPINTERRUPTPERCENT: {
            	
	    
	    
	    uint64_t       last_total_cycles;
            uint64_t       last_busy_cycles;

          
	    last_total_cycles = last_busy_percent_stats.ss_real_cycles;
	    last_busy_cycles =  last_busy_percent_stats.ss_cp_rupt_cycles;

	  

            /*
             *  We're doing our math with uint64_t, so wraparound isn't
             *  a concern -- the tic counter will wrap around in
             *  approximately 5 billion years.
             */
	    
	    long_return = (total_cycles - last_total_cycles) ? 
	                    ((int32_t) percent( cp_rupt_busy_cycles - 
			     last_busy_cycles, total_cycles - 
					     last_total_cycles)): 0;


            bcopy(&sys_stats, &last_busy_percent_stats, 
		  sizeof(sk_system_stats_t));
            return (uint8_t *) & long_return;
        }

	/* --------------------------------------------- */
	case CPUNONCPINTERRUPTPERCENT: {
	   
	   
	     /* new variables to hold values in cycles */

	    uint64_t       last_total_cycles;
            uint64_t       last_busy_cycles;
	    
	    last_total_cycles = last_busy_percent_stats.ss_real_cycles;
	    last_busy_cycles =  last_busy_percent_stats.ss_noncp_rupt_cycles;
	    
            /*
             *  We're doing our math with uint64_t, so wraparound isn't
             *  a concern -- the tic counter will wrap around in
             *  approximately 5 billion years.
             */
	    
	   
	    long_return = (total_cycles - last_total_cycles) ?
                        ((int32_t) percent( noncp_rupt_busy_cycles - 
			last_busy_cycles,total_cycles - last_total_cycles))
					 : 0;
            bcopy(&sys_stats, &last_busy_percent_stats, 
		  sizeof(sk_system_stats_t));
            return (uint8_t *) & long_return;
        }
	
	/* --------------------------------------------- */
	case CPUTOTALDOMAINSWITCHES:
	    long_return = ((int32_t) (sys_stats.ss_dswitch_total));
            return (uint8_t *) & long_return;	
	/* --------------------------------------------- */
	default:
		ERROR("var_cpu");
	/* --------------------------------------------- */
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.2.6.magic.0 */
uint8_t *
var_cp(SNMP_FM_ARGS)
{
	uint64_t	cp_usecs;
	HEADER_GENERIC;

	switch (vp->magic) {
	/* --------------------------------------------- */
	case CPTIME:
	    /* return cptime in hundredths of seconds */
	    cp_usecs = sk_cp_gettime();
	    /* convert return value from microseconds to hundredths */
	    cp_usecs /= 10000;
	    long_return = (int32_t) (cp_usecs);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMTIMEROPS:
	    /* return count of consistency points caused by timer */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_TIMER]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMSNAPSHOTOPS:
	    /* return count of cp calculations caused by snapshot */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_SNAPSHOT]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMLOWWATEROPS:
	    /* return count of consistency points caused by low water mark */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_LOW_WATER]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMHIGHWATEROPS:
	    /* return count of consistency points caused by high water mark */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_HIGH_WATER]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMLOGFULLOPS:
	    /* return count of consistency points caused by nv log full */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_LOG_FULL]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMCPOPS:
	    /* return count of back to back consistency points */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_CP]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPTOTALOPS:
	    /* return count of all consistency points */
	    long_return = (int32_t) GETWAFLSTAT(cp_stats.cps);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMFLUSHOPS:
	    /* return count of consistency points to flush async writes */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_FLUSH]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMSYNCOPS:
	    /* return count of consistency points to sync WAFL */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_SYNC]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMLOWVBUFOPS:
	    /* return count of consistency points caused by low vbuf ops */
	    long_return = (int32_t) 0;
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMCPDEFERREDOPS:
	    /* return count of deferred back-to-back cps */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_CP_DEFERRED]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case CPFROMLOWDATAVECSOPS:
	    /* return count of consistency points caused by low datavecs */
	    long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_LOW_DATAVECS]));
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
        case CPFROMLOWMBUFOPS:
         /* return count of consistency points caused by low mbuf ops*/
            long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_LOW_MBUFS]));
            return (uint8_t *) & long_return;
        /* --------------------------------------------- */
        case CPFROMNVLOGREPLAYTAKEOVERTIME:
            /* return count of nvlog heuristic CP */
            long_return = (int32_t) (GETWAFLSTAT(cp_stats.cp_count[CP_FROM_NVLOG_REPLAY_TAKEOVER_TIME]));
            return (uint8_t *) & long_return;
        /* --------------------------------------------- */
        default:
            ERROR("var_cp");
	/* --------------------------------------------- */
	}

	return NULL;
}
static char	report[ENV_STATUS_MSG_LEN];	/* for fan and power supply reports */

/*
 *  Check to see how busy the CPU is.
 *
 *  The laststats should contain the statistics gathered last
 *  time; this routine will update the contents after calculating
 *  how busy the CPU was since the last stats were gathered.
 *
 *  This routine uses the same
 *
 *	msgcnt = snprintf(*msgptr, *msgsz, 
 *		*msgptr += msgcnt;
 *		*msgsz -= msgcnt;
 *
 *  code structure as the other status generators (see 
 *  snmp_check_for_full_volumes() for example), in case the
 *  code gets cut-and-pasted later.
 */
snmp_cpu_status_t
snmp_check_cpu_status(sk_system_stats_t * laststats,
		char ** msgptr, int * msgsz)
{
	int	busyThreshold;
	snmp_cpu_status_t	status = CpuOk;
	int	msgcnt;
        sk_system_stats_t sys_stats;
        uint64_t	diff_cycles;
	uint64_t	diff_busy_cycles;
	

	int	busy_percent;

	VERIFY(laststats != NULL);

	busyThreshold = snmp_get_registry_int(
		"options.thresholds.cpuBusy", 90, true);

        sk_system_getstats(SK_STATS_TOTAL, &sys_stats);
	
	
	diff_cycles = sys_stats.ss_real_cycles - laststats->ss_real_cycles;
	diff_busy_cycles = sys_stats.ss_busy_cycles - laststats->ss_busy_cycles;
	
	busy_percent = (int) PERCENT_RND(diff_busy_cycles, diff_cycles);

	if (NULL != msgptr && NULL != *msgptr) {
		msgcnt = snprintf(*msgptr, *msgsz, 
					"The CPU is %d%% busy.",
					busy_percent);
		*msgptr += msgcnt;
		*msgsz -= msgcnt;
	}

	if (busy_percent > busyThreshold) {
		status = CpuBusy; 
	}

	bcopy(&sys_stats, laststats, sizeof(sys_stats));

	return status;
}


/*
 * EPS BURT # 474467, fixing 255752, 326786.
 */

/*
 * format full volume message for a single volume. Optionally call out to
 * add_to_fv_volumes when a volume storage data pointer is provided.
 */

static int
make_full_volume_message(
	fv_volumes *full_volumes_info,
	char **msgptr, int *msgsz,
	bool is_aggregate,
	char *path,
	snmp_volume_status_t onestatus,
	int percent_full_blocks,
	int percent_full_inodes)
{
	int msgcnt;

	if (full_volumes_info) {
		/* 
		 * The full volume info is saved for later formatting
		 * of a message. And so, msgptr and msgsz are not updated.
		 */
		monitor_add_to_fv_volumes(full_volumes_info,
					  path,
					  is_aggregate, /* is an aggregate? */
					  percent_full_blocks,
					  percent_full_inodes,
					  onestatus);
	} else {
		/* The default style behavior */
		msgcnt = snprintf(*msgptr, *msgsz,
				  "%s is %s (using or reserving %d%% of space and %d%% of inodes).\n",
				  path,
				  (onestatus == VolumeNearlyFull) ?
				  "nearly full" : "full",
				  percent_full_blocks,
				  percent_full_inodes);
		/*
		 *  Adjust the message pointers so that we can keep on
		 *  appending.
		 */
		*msgptr += msgcnt;
		*msgsz -= msgcnt;
	}
	return *msgsz;
}

static int
snmp_get_threshold_value(char *str_option, wafl_Volume *vol, int def_threshold)
{
#define opt_size 356
	char registry_option[opt_size];
	snprintf(registry_option, opt_size, "options.thresholds.%s.%s", 
		 WVOL_NAME(vol),
		 str_option);
	return snmp_get_registry_int(registry_option, def_threshold, false);
}


static int get_percent_full(uint64_t tot, uint64_t avail)
{
	if (tot < avail) {
		return 0;
	}
	return percent(tot - avail, tot);
}


/*
 * Fixing BURT # 487811
 * This function is used to identify a fullness status for a specific value
 * by comparing to its thresholds. It is called for space used, used and
 * inodes used. The thresholds for space used and inodes used are
 * fsNearlyFull/fsFull. 'level' is used to indicate the minimum status level
 * for reporting. E.g. if nearlyFull is passed all volumes that are nearlyFull
 * or Full are reported but if Full is passed only full volumes are
 * reported.
 *
 * It returns a fullness status for each value given. Later, the two
 * status values are compared and the "most full" status is user for
 * reporting the volume's fullness condition.
 */

static snmp_volume_status_t
snmp_get_fullness_level(int pct_value,
	int nearly_full_threshold,
	int full_threshold,
	snmp_volume_status_t level)
{
	ASSERT(level != VolumeOk);

	if (full_threshold <= pct_value) {
		return VolumeFull;
	}
	if (level == VolumeFull) {
		return VolumeOk;
	}
	if (nearly_full_threshold <= pct_value) {
		return VolumeNearlyFull;
	}
	return VolumeOk;
}


/*
 *  Check to see if any volumes are at or above their thresholds
 *
 *  The "level" is the lowest non-OK level we're interested in.
 *  For example, if the caller doesn't care about nearly-full
 *  conditions, pass in VolumeFull as the "level".
 *
 *  If the blocksp and/or inodesp pointers are non-NULL, we fill
 *  in the locations pointed to with the block usage and inodes
 *  usage for the volumes which are most full with respect to
 *  blocks and inodes.
 *
 *  If the return value is not VolumeOk, also fill in the msgbuf.
 *  
 *  Note this is *not* applicable to snapmirror destination volumes
 *  burt36513. 
 */
snmp_volume_status_t
snmp_check_for_full_volumes(snmp_volume_status_t level,
	int host, char **msgptr, int *msgsz, int *blocksp, int *inodesp,
	int *numFullp, int *numNearlyFullp,
        fv_volumes *full_volumes_info)
{
	int	fullThreshold;
	int	nearlyFullThreshold;
	bool	do_aggregate;
	int	how_iterated = WIT_HOST | WIT_FS;

	/* status accumulation for all volumes */
	snmp_volume_status_t	status = VolumeOk;
	/* Status for a single volume */
	snmp_volume_status_t	onestatus;
	snmp_volume_status_t	space_status;
	snmp_volume_status_t	inodes_status;

	void *	cookie;
	wafl_Volume *vol;
	char path[MAXPATHLEN];
	wafl_Fs_attr f_attr;
	int	percent_full_blocks = 0;
	int	percent_full_inodes = 0;
	wafl_Volref *vref;

	/*
	 * Loop through all volumes and count number that are full.
	 */
	nearlyFullThreshold = snmp_get_registry_int(
		"options.thresholds.fsNearlyFull", 
		DEFAULT_VOLUME_NEARLY_FULL_THRESHOLD, true);
	fullThreshold = snmp_get_registry_int(
		"options.thresholds.fsFull", 
		DEFAULT_VOLUME_FULL_THRESHOLD, true);

	do_aggregate =
		(registry_get_boolean(MONITOR_AGGREGATES_FULL, false) &&
		 registry_get_boolean(MONITOR_EACH_VOLUME_CHANGE, false));
	if (do_aggregate ) {
		how_iterated |= WIT_BASE;
	}

	if (numNearlyFullp != 0) {
		*numNearlyFullp = 0;
	}
	if (numFullp != 0) {
		*numFullp = 0;
	}
	/*
	 * Code below assumes that the full threshold is >=
	 * the nearly-full threshold.  So we enforce that here.
	 */
	if (nearlyFullThreshold > fullThreshold) {
		nearlyFullThreshold = fullThreshold;
	}

	if (0 != blocksp) {
		*blocksp = 0;
	}
	if (0 != inodesp) {
		*inodesp = 0;
	}

	cookie = NULL;
	/* VVOL_NEEDS_CHANGES - which volumes? */
	
	/*
	 * The custom fields below now allow us to have custom
	 * thresholds for every volume. If a volume specific
	 * option is set in the registry it takes precedence 
	 * over the global options options.thresholds.fsFull
	 * and options.thresholds.fsNearlyFull.
	 * The custom options possible in order:
	 * options.thresholds.vol-name.fsFull
	 * options.thresholds.vol-name.fsNearlyFull
	 */
	while ( (vol=wafl_volume_iterator(&cookie, how_iterated)) ) {
		int customnearlyFullThreshold = -1;
		int customFullThreshold = -1;

		vref = wafl_volref_create(vol, "snmp check for full volumes");
		if (!vref)
			continue;

		/*
		 * Find if there are volume specific thresholds set
		 */
		/*Full*/
		customFullThreshold =
			snmp_get_threshold_value("fsFull",
					   vol,
					   fullThreshold);
		/*Nearlyfull*/
		customnearlyFullThreshold =
			MIN(customFullThreshold,
			    snmp_get_threshold_value("fsNearlyFull",
						     vol,
						     nearlyFullThreshold));
		/* 
		 * No need to print warnings for snapmirror destination
		 * volumes, burt36513
		 */
		if (wafl_get_option(vol, WAFL_FSOPTIONS_REPLICA)) {
			wafl_volref_destroy(vref);
			continue;
		}

		/*
		 * XXX
		 * WAFL_STATFS on a PFS sparse volume will go to the origin 
		 * to get its filesystem information. I don't think
		 * we want to be printing warnings about the origin's
		 * filesystem being full on a caching filer, but do
		 * we need to have a check for our local filesystem?
		 */
		if (WAFL_SPARSE_VOL_LOADED(vol) &&
		    (SPARSE_CHECK_PROP(vol, SVOL_RECLAIM_SPACE))) {
			wafl_volref_destroy(vref);
			continue;
		}

		/* BURT # 326786 -- add ability to scan for full aggregates */
		if (do_aggregate && (WAFL_AGGR(vol) == vol)) {
			/* do an aggregate report */
			wafl_File_handle  fh ;
			snprintf(path, sizeof(path), "%s", WVOL_NAME(vol));
			fh = fio_getfh_root(WIT_RAID, WVOL_NAME(vol));
			if (fhzero(fh)) {
				wafl_volref_destroy(vref);
				continue;
			}
			f_attr = fio_statfs_fh(fh, true);
		} else {
			/* do a volume report */
			snprintf(path, sizeof(path), "/vol/%s", WVOL_NAME(vol));
			f_attr = fio_statfs(path, true);
		}
		if (f_attr.blocks == (blks_t)-1) {
			wafl_volref_destroy(vref);
			continue;
		}
		/*
		 *  Do the check both for blocks and for inodes.
		 */
		space_status = VolumeOk;
		inodes_status = VolumeOk;
		if (f_attr.blocks != 0) {
			percent_full_blocks =
				get_percent_full(f_attr.blocks,
						 f_attr.bavail);
			space_status =
				snmp_get_fullness_level(percent_full_blocks,
					customnearlyFullThreshold,
					customFullThreshold,
					level);

			if (0 != blocksp && percent_full_blocks > *blocksp) {
				*blocksp = percent_full_blocks;
			}
		} else {
			percent_full_blocks = 0;
		}

		if ( f_attr.inodes!=0 && f_attr.inodes!=(unsigned)-1 ) {
			percent_full_inodes =
				get_percent_full(f_attr.inodes,
						 f_attr.ifree);
			inodes_status =
				snmp_get_fullness_level(percent_full_inodes,
					customnearlyFullThreshold,
					customFullThreshold,
					level);
			if (0 != inodesp && percent_full_inodes > *inodesp) {
				*inodesp = percent_full_inodes;
			}
		} else {
			percent_full_inodes = 0;
		}

		onestatus = MAX(space_status, inodes_status);
		if (VolumeOk != onestatus) {
			if (NULL != msgptr && NULL != *msgptr) {
				/*
				 * Format the message
				 * (or save the full vol info)
				 */
				make_full_volume_message(full_volumes_info,
					msgptr, msgsz,
					(WAFL_AGGR(vol) == vol),
					path,
				        onestatus,
					percent_full_blocks,
					percent_full_inodes);

				if (numNearlyFullp != NULL &&
				    onestatus == VolumeNearlyFull) {
					*numNearlyFullp = *numNearlyFullp + 1;
				}
				if (numFullp != NULL && 
				    onestatus == VolumeFull) {
					*numFullp = *numFullp + 1;
				}
			}
			if (onestatus > status) {
				status = onestatus;
			}
		}
		wafl_volref_destroy(vref);
	}

	return status;
}

/*
 * EPS BURT # 474467, fixing 255752, 326786.
 */


#define CFSTATE_DEAD 1
#define CFSTATE_CANTAKEOVER 2
#define CFSTATE_CANNOTTAKEOVER 3
#define CFSTATE_TAKEOVER 4

/*
 * Calculate the current MIB value for cluster state.
 */
static int32_t
snmp_calculate_cfstate(int host, const fm_status_t  * status)
{
	int32_t r;

	if (host == SK_HOST_PARTNER) {
		r = CFSTATE_DEAD;
	}
	else {
		/*
		 * As per RFC 1155, the value 0 is not allowed
		 * in an enumerated INTEGER. Map it to
		 * acceptable values.
		 */
		switch(FailoverMonitor.fm_state) {
		    case DEAD:
			r = CFSTATE_DEAD;
			break;
		    case UP:
			if (!status->s_takeoverOfPartnerStatus) {
				r = CFSTATE_CANTAKEOVER;
			} else {
				r = CFSTATE_CANNOTTAKEOVER;
			}
			break;
		    case TAKEOVER:
			r = CFSTATE_TAKEOVER;
			break;
		    default:
			r = CFSTATE_DEAD;
			break;
		}
	}
	return r;
}

#define CFCANNOTTAKEOVERCAUSE_OK 1
#define CFCANNOTTAKEOVERCAUSE_UNKNOWN 2
#define CFCANNOTTAKEOVERCAUSE_DISABLED_BY_OPERATOR 3
#define CFCANNOTTAKEOVERCAUSE_INTERCONNECT_IS_DOWN 4
#define CFCANNOTTAKEOVERCAUSE_DISABLED_BY_PARTNER 5
#define CFCANNOTTAKEOVERCAUSE_TAKEOVER_FAILED 6
#define CFCANNOTTAKEOVERCAUSE_MB_DEGRADED 7
#define CFCANNOTTAKEOVERCAUSE_MB_UNINIT 8
#define CFCANNOTTAKEOVERCAUSE_MB_VER_MISMATCH 9
#define CFCANNOTTAKEOVERCAUSE_NVRAM_SIZE_MISMATCH 10
#define CFCANNOTTAKEOVERCAUSE_KERNEL_VER_MISMATCH 11
#define CFCANNOTTAKEOVERCAUSE_PTNR_IS_BOOTING 12 
#define CFCANNOTTAKEOVERCAUSE_PTNR_IS_REVERTING 13
#define CFCANNOTTAKEOVERCAUSE_REVERTING 14
#define CFCANNOTTAKEOVERCAUSE_SAME_TIME_PARTNER_TRYING_TO_TAKEOVER 15
#define CFCANNOTTAKEOVERCAUSE_ALREADY_IN_TAKEOVER 16
#define CFCANNOTTAKEOVERCAUSE_NVRAM_LOG_UNSYNC 17
#define CFCANNOTTAKEOVERCAUSE_BACKUP_MB_DOUBTFUL 18

static int32_t
snmp_cannottakeover_reason(int host, const fm_status_t  *status)
{
	/* 
	 * XXX Add the state disabledByPartner(5).
	 */
	int temp;

	if (host == SK_HOST_PARTNER) { /* in takeover mode */
		return -1; /* SNMP_ERR_NOSUCHNAME */
	}
	if (FailoverMonitor.fm_state == TAKEOVER)
		return CFCANNOTTAKEOVERCAUSE_OK;

	/*
	 * If running normally, return OK.
	 */
	if (FailoverMonitor.fm_state == UP
		&& snmp_calculate_cfstate(host, status)==CFSTATE_CANTAKEOVER)
		return CFCANNOTTAKEOVERCAUSE_OK;



	 if ((status->s_state == UP) &&
			(status->s_takeoverOfPartnerStatus != TO_ALLOWED)) {
    		switch (status->s_takeoverOfPartnerStatus) {
			
		case TO_DISABLED:
			temp=CFCANNOTTAKEOVERCAUSE_DISABLED_BY_OPERATOR;
			break;
		case TO_IC_ERROR:   
			temp=CFCANNOTTAKEOVERCAUSE_INTERCONNECT_IS_DOWN;
			break;
		case TO_OPERATOR_DENY:
			temp=CFCANNOTTAKEOVERCAUSE_DISABLED_BY_OPERATOR;
			break;
		case TO_DEGRADED:
			temp=CFCANNOTTAKEOVERCAUSE_MB_DEGRADED;
			break;
		case TO_MBX_UNKNOWN:
			temp=CFCANNOTTAKEOVERCAUSE_MB_UNINIT;
			break;
		case TO_FM_VERSION:
			temp=CFCANNOTTAKEOVERCAUSE_MB_VER_MISMATCH;
			break;
		case TO_NVRAM_MISMATCH:
			temp=CFCANNOTTAKEOVERCAUSE_NVRAM_SIZE_MISMATCH;
			break;
		case TO_VERSION:
			temp=CFCANNOTTAKEOVERCAUSE_KERNEL_VER_MISMATCH;
			break;
		case TO_BOOTING:
			temp=CFCANNOTTAKEOVERCAUSE_PTNR_IS_BOOTING;
			break;
		case TO_PARTNER_REVERT_IN_PROGRESS:
			temp=CFCANNOTTAKEOVERCAUSE_PTNR_IS_REVERTING;
			break;
		case TO_LOCAL_REVERT_IN_PROGRESS:
			temp=CFCANNOTTAKEOVERCAUSE_REVERTING;
			break;
		case TO_PARTNER_TAKEOVER:
			temp=CFCANNOTTAKEOVERCAUSE_SAME_TIME_PARTNER_TRYING_TO_TAKEOVER;
			break;
		case TO_LOCAL_TAKEOVER:
			temp=CFCANNOTTAKEOVERCAUSE_ALREADY_IN_TAKEOVER;
			break;
		case TO_LOG_UNSYNC:
			temp=CFCANNOTTAKEOVERCAUSE_NVRAM_LOG_UNSYNC;
			break;
		case TO_MBX_UNCERTAIN:	
			temp= CFCANNOTTAKEOVERCAUSE_BACKUP_MB_DOUBTFUL;
			break;
		default:
			temp=CFCANNOTTAKEOVERCAUSE_UNKNOWN;
		}
		return temp;
	 }


	if (FailoverMonitor.fm_takeoverState == FT_TAKEOVER_DONE_FAILED)
		return CFCANNOTTAKEOVERCAUSE_TAKEOVER_FAILED;

	return CFCANNOTTAKEOVERCAUSE_UNKNOWN;
}

/*
 * Convert the return value of snmp_cannottakeover_reason
 * to a string.  Does not return NULL.

static char *
snmp_cannottakeover_reason_string(int32_t v)
{
	switch (v) {
	case CFCANNOTTAKEOVERCAUSE_OK:
		return "takeover status is normal";
	case CFCANNOTTAKEOVERCAUSE_UNKNOWN:
		return "unknown reason";
	case CFCANNOTTAKEOVERCAUSE_DISABLED_BY_OPERATOR:
		return "disabled by operator";
	case CFCANNOTTAKEOVERCAUSE_INTERCONNECT_IS_DOWN:
		return "interconnect is down";
	case CFCANNOTTAKEOVERCAUSE_DISABLED_BY_PARTNER:
		return "disabled by partner";
	case CFCANNOTTAKEOVERCAUSE_TAKEOVER_FAILED:
		return "takeover failed";
	}
	return "reason value is invalid";
}
*/

/*
 *  Calculate the system's "global health", taking into account
 *  a variety of possible problems.  Return a constant indicating
 *  the worst of the problems found.  Fill in the msgbuf string
 *  with a description of all of the unusual conditions.
 *
 *  Update the *msgbufsz to reflect the new characters we wrote
 *  into the buffer.
 */

/*
 * EPS BURT # 474467, fixing 255752, 326786.
 * Add alternate entry point in order to support callback routine to
 * report on full volumes by the caller as the volumes are iterated.
 */

int
snmp_calculate_global_health(int host, char * msgbuf, int * msgbufsz,
			     int *isRemoved, char *spare_low_msg,
			     int spare_low_msg_size,
			     fv_volumes *full_volumes_info)
{
#define	WORST_OF(oldstatus,newstatus)	\
		(((newstatus) > (oldstatus)) ? (newstatus) : (oldstatus))
	int	retval;
	int	msgsz;
	int	msgcnt;
	char *	msgptr;
	int	temperature_ret;

	if (0 == msgbufsz || *msgbufsz <= 0) {
		msgptr = ""; /*  Never used, but can't be NULL.  */
		msgsz = 0;
	}
	else {
		msgsz = *msgbufsz;
		msgptr = msgbuf;
		msgbuf[0] = 0;
	}

	retval = MISCGLOBALSTATUS_OK;
	/*
	 * NOTE: The algorithm here is subject to change
	 * in future releases.
	 *
	 * Status is critical
	 *     if there are any failed fans, or
	 *     if temperature is over threshold, or
	 *     if there are any failed power supplies.
	 *     if cluster status is dead, cannotTakeover, or takeover
	 *
	 * Status is nonCritical
	 *     if there are any failed disks, or
	 *     if there are no spares, or 
	 *     if any volumes are more than a certain percentage full, or
	 *     if the real time clock battery is dead.
	 * 
	 * Message buffer range checking is built into snprintf()
	 */

	if (fm_cf_configuration() && fm_is_HAmode()) {
		fm_status_t	status;
		int32_t	cfstate;
		char	partnername[DEFAULT_NAMELEN+1];

		/* Fill-in the FM status */
		fm_lastStatus(&status);
		cfstate = snmp_calculate_cfstate(host,&status);
		if ( cfstate == CFSTATE_DEAD ) {
			sk_getpartnername(partnername,sizeof(partnername));
			msgcnt = snprintf(msgptr,msgsz,
				"%s has taken over this node. ", partnername);
			msgptr += msgcnt;
			msgsz -= msgcnt;
			retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
		}
		if ( cfstate == CFSTATE_TAKEOVER ) {
			sk_getpartnername(partnername,sizeof(partnername));
			if (!fm_takeoverdone()) {
				msgcnt = snprintf(msgptr, msgsz,
					"This node is attempting to takeover %s. ", partnername);
			}
			else {
				msgcnt = snprintf(msgptr, msgsz,
					"This node has taken over %s. ", partnername);
			}
			msgptr += msgcnt;
			msgsz -= msgcnt;
			retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
		}
		if ( cfstate == CFSTATE_CANNOTTAKEOVER ) {
			sk_getpartnername(partnername,sizeof(partnername));
			if (strlen(partnername) == 0) {
				msgcnt = snprintf(msgptr, msgsz,
					"Controller failover partner unknown. Controller failover "
					"not possible.");
				msgptr += msgcnt;
				msgsz -= msgcnt;
			} else {
				SK_DOMAIN_REFERENCE(ses_fw_update_in_progress, SK_REASON_READONLY); 
				if (ses_fw_update_in_progress()) {
					msgcnt = snprintf(msgptr, msgsz,
						"Controller failover of %s is not possible: downloading shelf firmware",
						partnername
						);
					msgptr += msgcnt;
					msgsz -= msgcnt;
				} else {
					msgcnt = snprintf(msgptr, msgsz,
						"Controller failover of %s is not possible: %s. ",
						partnername,
						fmmisc_takeoverPartnerStatus(
							status.s_takeoverOfPartnerStatus));
					msgptr += msgcnt;
					msgsz -= msgcnt;
				}

			}
			retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
		}
	}

	if ( ic_get_link_state() == ICS_PARTIAL ) {
		msgcnt = snprintf(msgptr, msgsz, "One of the two interconnect links has failed"); 
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_NONCRITICAL);
	}

	if (!update_disk_counts(host))
		return 0;

	if ( counts[host].failedCount != 0 ) {
		/*
		 * if disk was failed or removed by administrator
		 * set isRemoved 
		 */
		if (isRemoved) { 
			if (counts[host].failedCount == 
				counts[host].adminRemovedOrFailedCount) {
				*isRemoved = true;
			}
		}

		msgcnt = snprintf(msgptr, msgsz, "%s ", 
			counts[host].failedMessage);
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_NONCRITICAL);
	}

	// This method is called every minute. We DO NOT want to call raid_check_spares_low
	// that often. So we'll call it every 5 minutes.
	//
	static	uint32_t	cnt=0;
	static bool spare_low_detected = false;
	static char msg_sparelow[256];
	char * msg_spare = "There are not enough spare disks. ";
	char * msg_unowned_disk = "Assign unowned disks.";

	if( !cnt ) {
	    spare_low_detected = false;
	    if ( raid_check_spares_low(spare_low_msg, spare_low_msg_size) ) { 
		if (spare_low_msg) {
			strlcpy(msg_sparelow, msg_spare, strlen(msg_spare) + 1);
			strlcat(msg_sparelow, spare_low_msg, sizeof(msg_sparelow));
		} else {
			strlcpy(msg_sparelow, msg_spare, strlen(msg_spare) + 1);
		}
		if (sanown_enabled()) {
			if (sanown_count_unowned_disks() > 0) {
				strlcat(msg_sparelow, msg_unowned_disk,
					sizeof(msg_sparelow));
			}
		}
		retval = WORST_OF(retval, MISCGLOBALSTATUS_NONCRITICAL);
		spare_low_detected = true;

		msgcnt = snprintf(msgptr, msgsz, "%s ",
				msg_sparelow);
		msgptr += msgcnt;
		msgsz -= msgcnt;
	    }
	    cnt=5;
	} else {
	    cnt--;
	    if (spare_low_detected == true) {
		retval = WORST_OF(retval, MISCGLOBALSTATUS_NONCRITICAL);

		msgcnt = snprintf(msgptr, msgsz, "%s ",
				msg_sparelow);
		msgptr += msgcnt;
		msgsz -= msgcnt;
	    }
        }

	/*
	 * Starting in SN, the spcd (wafl/space_daemon.c) monitors volumes
	 * for fullness in C-mode (aka cluster mode).
	 *
	 * Note: this code path may be entered due to snmp walks. In C-mode,
	 * this function won't generate snmp traps in response to an snmp
	 * query, as we skip the if clause below, where the volume fullness
	 * gets checked. This is a change in behavior wrt legacy, 7-mode
	 * behavior.
	 */
	if (!is_cluster_capable()) {
		/*
		 * EPS BURT # 474467, fixing 255752, 326786.
		 */

		if (full_volumes_info != NULL) {
			/*
			 * Burt474467 requires us to send one EMS per each
			 * full or nearly full volume. But we still want a list
			 * of all full volumes when global health check runs.
			 */
			msgcnt = monitor_enumerate_full_volumes(
				full_volumes_info, msgptr, msgsz);
			msgptr += msgcnt;
			msgsz -= msgcnt;
			if (0 < msgcnt) {
				retval = WORST_OF(
					retval, MISCGLOBALSTATUS_NONCRITICAL);
			}
		} else if (VolumeFull == snmp_check_for_full_volumes(
				   VolumeFull, host, &msgptr, &msgsz, 0, 0,
				   0, 0, NULL))
		{
			retval = WORST_OF(retval, MISCGLOBALSTATUS_NONCRITICAL);
		}
	}

	if ( is_low_rtc() == environ_rtc_battery_status_needs_replacement) {
		msgcnt = snprintf(msgptr, msgsz, "%s ", 
				  "The Real Time Clock battery needs replacement.");
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_NONCRITICAL);
	}	
	if ( check_fan_status(report) > 0 ) {
		msgcnt = snprintf(msgptr, msgsz, "%s ", report);
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
	}
	if ( is_low_power(report) != 0 ) {
		msgcnt = snprintf(msgptr, msgsz, "%s ", report);
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
	}
	temperature_ret = check_temperature_status();
	if ( temperature_ret ) {
		msgcnt = snprintf(msgptr, msgsz, "Chassis temperature is too %s ", 
			(temperature_ret == 1)? "low." : "high.");
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
	}


	if(!dsa_sesv2_init_done()) {
	    SK_DOMAIN_REFERENCE(rfd_shelf_fault, SK_REASON_SWITCH_DOMAIN);
	    if ( rfd_shelf_fault() ) {
		msgcnt = snprintf(msgptr, msgsz, "%s ",
			"Disk shelf fault.");
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
	    }
	} else {
	    if ( dsa_api_get_shelf_fault() ) {
		msgcnt = snprintf(msgptr, msgsz, "%s ",
			"Disk shelf fault.");
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
	    }
	}

	SK_DOMAIN_REFERENCE(rfd_shelf_cfg_error, SK_REASON_SWITCH_DOMAIN);
	if ( rfd_shelf_cfg_error() ) {
		msgcnt = snprintf(msgptr, msgsz, "%s ",
			"Disk shelf configuration error.");
		msgptr += msgcnt;
		msgsz -= msgcnt;
		retval = WORST_OF(retval, MISCGLOBALSTATUS_CRITICAL);
	}

	if ( MISCGLOBALSTATUS_OK == retval ) {
		msgcnt = snprintf(msgptr, msgsz, "%s ", 
			"The system's global status is normal.");
		msgptr += msgcnt;
		msgsz -= msgcnt;
	}
	if (0 != msgbufsz) {
		*msgbufsz -= msgsz;
	}
	return retval;
#undef	WORST_OF
}

/* format is .1.3.6.1.4.1.789.1.2.2.magic.0 */
uint8_t *
var_misc(SNMP_FM_ARGS)
{
	uint64_t        counter64;
	uint64_t	recvcnt;
	uint64_t	sendcnt;

	HEADER_GENERIC;

	switch (vp->magic) {
	/* --------------------------------------------- */
	case MISCNFSOPS:
	    long_return = (int32_t) nfs_getops();
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case MISCNETRCVDKB:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    long_return = (int32_t) (recvcnt / 1024);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case MISCNETSENTKB:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    long_return = (int32_t) (sendcnt / 1024);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case MISCGLOBALSTATUS:
	    long_return = (int32_t) snmp_calculate_global_health(
				sk_gethost(), 0, 0, 0, NULL, 0, NULL);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------- */
	case MISCHIGHNFSOPS:
	    counter64 = (uint64_t) nfs_getops();
	    long_return = HIGH32(counter64);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCLOWNFSOPS:
	    counter64 = (uint64_t) nfs_getops();
	    long_return = LOW32(counter64);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISC64NFSOPS:
	    counter64 = (uint64_t) nfs_getops();
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;

	/* --------------------------------------------- */
	case MISCHIGHCIFSOPS:
	    counter64 = SMB_GetOps();
	    long_return = HIGH32(counter64);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCLOWCIFSOPS:
	    counter64 = SMB_GetOps();
	    long_return = LOW32(counter64);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISC64CIFSOPS:
	    counter64 = SMB_GetOps();
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;

	/* --------------------------------------------- */
	case MISCHIGHHTTPOPS:
	    counter64 = httpd_getops();
	    long_return = HIGH32(counter64);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCLOWHTTPOPS:
	    counter64 = httpd_getops();
	    long_return = LOW32(counter64);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISC64HTTPOPS:
	    counter64 = httpd_getops();
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;

	/* --------------------------------------------- */
	case MISCHIGHNETRCVDBYTES:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    long_return = HIGH32(recvcnt);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCLOWNETRCVDBYTES:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    long_return = LOW32(recvcnt);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISC64NETRCVDBYTES:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    counter64_return.high = HIGH32(recvcnt);
	    counter64_return.low  = LOW32(recvcnt);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;

	/* --------------------------------------------- */
	case MISCHIGHNETSENTBYTES:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    long_return = HIGH32(sendcnt);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCLOWNETSENTBYTES:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    long_return = LOW32(sendcnt);
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISC64NETSENTBYTES:
	    SK_DOMAIN_REFERENCE(if_stat, SK_REASON_SWITCH_DOMAIN);
	    if_stat(&recvcnt, &sendcnt);
	    counter64_return.high = HIGH32(sendcnt);
	    counter64_return.low  = LOW32(sendcnt);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;

	/* --------------------------------------------- */
	case MISCHIGHDISKREADBYTES:
	case MISCLOWDISKREADBYTES:
	case MISC64DISKREADBYTES:
	case MISCHIGHDISKWRITEBYTES:
	case MISCLOWDISKWRITEBYTES:
	case MISC64DISKWRITEBYTES:
	    {
	    uint64_t	readblks;
	    uint64_t	readblks2;
	    uint64_t	writeblks;
	    uint64_t	readcnt = 0;
	    uint64_t	writecnt = 0;

	    SK_DOMAIN_REFERENCE(disk_stat, SK_REASON_SWITCH_DOMAIN);
	    disk_stat(&readblks, &readblks2, &writeblks);

	    readcnt = (readblks + readblks2) * BLOCK_SIZE;
	    writecnt = writeblks * BLOCK_SIZE;
		switch (vp->magic) {
			case MISCHIGHDISKREADBYTES:
				long_return = HIGH32(readcnt);
				break;
			case MISCLOWDISKREADBYTES:
				long_return = LOW32(readcnt);
				break;
			case MISC64DISKREADBYTES:
				counter64_return.high = HIGH32(readcnt);
				counter64_return.low  = LOW32(readcnt);
				*var_len = sizeof(counter64_return);
				return (uint8_t *) & counter64_return;
			case MISCHIGHDISKWRITEBYTES:
				long_return = HIGH32(writecnt);
				break;
			case MISCLOWDISKWRITEBYTES:
				long_return = LOW32(writecnt);
				break;
			case MISC64DISKWRITEBYTES:
				counter64_return.high = HIGH32(writecnt);
				counter64_return.low  = LOW32(writecnt);
				*var_len = sizeof(counter64_return);
				return (uint8_t *) & counter64_return;
		}
	
	    return (uint8_t *) & long_return;
	    }
	/* --------------------------------------------- */
	case MISCHIGHTAPEREADBYTES:
	case MISCLOWTAPEREADBYTES:
	case MISC64TAPEREADBYTES:
	case MISCHIGHTAPEWRITEBYTES:
	case MISCLOWTAPEWRITEBYTES:
	case MISC64TAPEWRITEBYTES:
	    {
	    uint64_t	readcnt = 0;
	    uint64_t	writecnt = 0;

	    SK_DOMAIN_REFERENCE(tape_stat, SK_REASON_SWITCH_DOMAIN);
	    tape_stat(&readcnt, &writecnt);

		switch (vp->magic) {
			case MISCHIGHTAPEREADBYTES:
				long_return = HIGH32(readcnt);
				break;
			case MISCLOWTAPEREADBYTES:
				long_return = LOW32(readcnt);
				break;
			case MISC64TAPEREADBYTES:
				counter64_return.high = HIGH32(readcnt);
				counter64_return.low  = LOW32(readcnt);
				*var_len = sizeof(counter64_return);
				return (uint8_t *) & counter64_return;
			case MISCHIGHTAPEWRITEBYTES:
				long_return = HIGH32(writecnt);
				break;
			case MISCLOWTAPEWRITEBYTES:
				long_return = LOW32(writecnt);
				break;
			case MISC64TAPEWRITEBYTES:
				counter64_return.high = HIGH32(writecnt);
				counter64_return.low  = LOW32(writecnt);
				*var_len = sizeof(counter64_return);
				return (uint8_t *) & counter64_return;
		}
	
	    return (uint8_t *) & long_return;
	    }
	/* --------------------------------------------- */
	case MISCGLOBALSTATUSMESSAGE: {
	    static char global_status[ SNMP_GLOBAL_STATUS_MESSAGE_LEN ];
	    int len = SNMP_GLOBAL_STATUS_MESSAGE_LEN;
	    char spare_low_msg[256];

	    spare_low_msg[0] = '\0';
	    snmp_calculate_global_health(sk_gethost(), global_status, & len, 0,
					 spare_low_msg, sizeof(spare_low_msg), NULL);
	    *var_len = strlen(global_status);

	    return (uint8_t *) global_status;
	}

	/* --------------------------------------------- */
	case MISCCACHEAGE:
	    long_return = wafl_buf_eject_age() / 60;
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCCORRECTEDMACHINECHECKS:
	    long_return = psm_get_corr_err_count();
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	case MISCWINDOWSSETUPWIZARDVERSION:
	    long_return = WSW_VERSION;
	    return (uint8_t *) & long_return;

	/* --------------------------------------------- */
	default:
		ERROR("var_miscstat");
	/* --------------------------------------------- */
	}

	return NULL;

}

/* format is .1.3.6.1.4.1.789.1.2.3.magic.0 */
uint8_t *
var_cf(SNMP_FM_ARGS)
{
	int host;
	fm_status_t status;
	ic_state state;	/* ICS_UP, ICS_DOWN, etc. */

	HEADER_GENERIC;

	host = sk_gethost();
	/*
	 * If cluster is not licensed or cluster is disabled don't expose
	 * any CF objects except cfSettings.
	 */
	if (vp->magic != CFSETTINGS) {
		/*
		 * If cluster is not licensed or cluster is disabled return
		 * NOSUCHNAME error.
		 */
		if (!fm_is_HAmode()) {
			return NULL;
		}
	}
	/* Fill-in the FM status */
	fm_lastStatus(&status);
	switch (vp->magic) {
	    case CFSETTINGS:
		if (host == SK_HOST_PARTNER) { /* in takeover mode */
			long_return = 5; /* thisNodeDead */
			return (uint8_t *) & long_return;
		}
		if (!fm_is_HAmode()) {
			long_return = 1; /* notConfigured */
		}
		else if (!status.s_clusterTakeover) {
			long_return = 3; /* Controller Failover disabled */
		}
		else if (NOTKOVER_REASONS(FailoverMonitor.fm_primaryCtx.cl_info)) {
			/* XXXSMC this needs to be masked appropriately */
			long_return = 4; /* takeoverByPartnerDisabled */
		}
		else {
			long_return = 2; /* Controller Failover enabled */
		}
		return (uint8_t *) & long_return;
	    case CFSTATE:
		long_return = snmp_calculate_cfstate(host,&status);
		return (uint8_t *) & long_return;
	    case CFCANNOTTAKEOVERCAUSE:
		long_return = snmp_cannottakeover_reason(host,&status);
		if ( long_return <= 0 )
			return NULL; /* SNMP_ERR_NOSUCHNAME */
		return (uint8_t *) & long_return;
	    case CFPARTNERSTATUS:
		if (host == SK_HOST_PARTNER) {
			return NULL; /* SNMP_ERR_NOSUCHNAME */
		}
		else if (host == SK_HOST_LOCAL) {
			if (FailoverMonitor.fm_state == TAKEOVER) {
				long_return = 3; /* parter is dead */
			}
			else if (status.s_partnerConnected) { /* up/down */
				long_return = 2; /* ok */
			}
			else {
				long_return = 1; /* maybe down */
			}
		}
		return (uint8_t *) & long_return;
	    case CFPARTNERLASTSTATUSUPDATE:
		if (host == SK_HOST_PARTNER) { /* in takeover mode */
			return NULL; /* SNMP_ERR_NOSUCHNAME */
		}
		long_return = status.s_lastPartnerUpdateAbstime;
		return (uint8_t *) & long_return;
	    case CFPARTNERNAME:
		sk_getpartnername((char *) return_buf, sizeof(return_buf));
		*var_len = strlen((char *) return_buf);
		return return_buf;
	    case CFPARTNERSYSID:
		if (host == SK_HOST_PARTNER) { /* in takeover mode */
			long_return = nvram_system_id;
		}
		else {
			long_return = FailoverMonitor.fm_partnerSysid;
		}
		return (uint8_t *) & long_return;
	    case CFINTERCONNECTSTATUS:
		if (host == SK_HOST_PARTNER) { /* in takeover mode */
			return NULL; /* SNMP_ERR_NOSUCHNAME */
		}

		state = ic_get_link_state();
		switch (state) {
			case ICS_UP:
				long_return = 4; /* Interconnect is up. */
				break;
			case ICS_DOWN:
				long_return = 2; /* Interconnect is down. */
				break;
			case ICS_PARTIAL:
				long_return = 3; /* Partial failure. */
				break;
			default:
				long_return = 1; /* Interconnect not present. */
		}
		return (uint8_t *) & long_return;
	    default:
			ERROR("var_fm");
	}

	return NULL;
}

/*
 *  Retrieve disk id.
 */

static int
snmp_get_raid_disk_diskid( config_attr_disk_t *cad )
{
	return cad->cad_id;
}

/*
 *  Retrieve scsi id.
 */

static int
snmp_get_raid_disk_scsiid( config_attr_disk_t *cad )
{
	int i;
	disk_handle_t disk_handle;
	int ha_id = -1;
	int scsi_id = -1;

	i = raid_disk_id_to_diskindex(cad->cad_id);
	
	if (!disk_open_id(i, &disk_handle)) {
		ERROR("scsi_id: bad handle");
		return scsi_id;
	}
	SK_DOMAIN_REFERENCE(disk_get_device,SK_REASON_SWITCH_DOMAIN);
	
	disk_get_device(disk_handle, &ha_id, &scsi_id);

	disk_close_handle(disk_handle);

	return scsi_id;
}

/*
 * Returns the sdc target disk name and progress percentage
 */

static int
snmp_get_sdc_target_disk_name_and_copy_percentage(config_attr_disk_t *cad,
		char *sdc_target_disk_name, int len, int *percent_copy_done)
{
	if ((cad->cad_sick || cad->cad_replacing) && 
	     (cad->cad_sdc_replacement_id > 0)) {
		config_attr_obj_t cao;
		if (raid_config_get_attributes_by_id(&cao, 
			cad->cad_sdc_replacement_id, RAIDTYPE_DISK)) {

			if (sdc_target_disk_name && (len > 0)) {
				snprintf(sdc_target_disk_name, len, "%s",
					 cao.cao_raid_name);
			}

			if (percent_copy_done) {
				config_attr_disk_t *cao_cad = &cao.cao_disk;
				*percent_copy_done = 
					(cao_cad->cad_sdc_progress >= 0) ?
					 cao_cad->cad_sdc_progress : 0 ;
			}
			return true;
		}
	}

	return false;
}

/*
 *  Retrieve various raid operation completion percentage
 */

static int
snmp_get_raid_disk_completion_percent( config_attr_disk_t *cad, config_attr_group_t *cag )
{
	int percent = 0;

	/*
	 * Completion percent is "zeroing", "reconstruction",
	 * "reparity", or "scrub" or sick disk copy percentage.
	 * NOTE: These activities are assumed to be mutually exclusive,
	 *       so there is no need to check status to see which one
	 *       is happening.
	 */
	if (cad->cad_zero >= 0 && cad->cad_zero <= 100) {
		percent = cad->cad_zero;
	}
	else if (cag->cag_recons >= 0 && cag->cag_recons <= 100) {
		percent = cag->cag_recons;
	}
	else if (cag->cag_reparity >= 0 && cag->cag_reparity <= 100) {
		percent = cag->cag_reparity;
	}
	else if (cag->cag_scrub >= 0 && cag->cag_scrub <= 100) {
		percent = cag->cag_scrub;
	} else if (cad->cad_sick || cad->cad_replacing) { 
		snmp_get_sdc_target_disk_name_and_copy_percentage(cad,
			NULL, 0, &percent);
	}

	return percent;
}

/*
 *  Retrieve disk port.
 */

static int
snmp_get_raid_disk_diskport( config_attr_disk_t *cad )
{
	int port = 0;
	int i;
	disk_handle_t disk_handle;
	DiskInfo di;

	i = raid_disk_id_to_diskindex(cad->cad_id);
	
	if (!disk_open_id(i, &disk_handle)) {
		ERROR("diskport: bad handle");
		return port;
	}
	SK_DOMAIN_REFERENCE(disk_get_phys_info,SK_REASON_SWITCH_DOMAIN);
	
	if (disk_get_phys_info(disk_handle, &di) == E_NO_ERROR) {
		port = disk_get_port_info(&di,true);	/* TRUE means primary */
	}
	else {
		ERROR("diskport: bad info");
	}

	disk_close_handle(disk_handle);

	return port;
}

/*
 *  Retrieve secondary disk port.
 */

static int
snmp_get_raid_disk_secondarydiskport( config_attr_disk_t *cad )
{
	int port = 0;
	int i;
	disk_handle_t disk_handle;
	DiskInfo di;

	i = raid_disk_id_to_diskindex(cad->cad_id);
	
	if (!disk_open_id(i, &disk_handle)) {
		ERROR("secondarydiskport: bad handle");
		return port;
	}
	SK_DOMAIN_REFERENCE(disk_get_phys_info,SK_REASON_SWITCH_DOMAIN);
	
	if (disk_get_phys_info(disk_handle, &di) == E_NO_ERROR) {
		port = disk_get_port_info(&di,false);	/* TRUE means primary */
	}
	else {
		ERROR("secondarydiskport: bad info");
	}

	disk_close_handle(disk_handle);

	return port;
}

/*
 *  Retrieve number of raid groups in the specified volume .
 */

static int
snmp_get_raid_disk_groups_in_volume( raidobj_id_t vol_id )
{
	raid_config_iter_t *plexIter;
	raid_config_iter_t *raidIter;
	config_attr_obj_t  *caPlex;
	config_attr_obj_t  *caRaid;
	int groups = 0;

	/*
	 * Walking down into plexes and raidgroups
	 */
	if (!raid_config_iterator_create(&plexIter, RAIDTYPE_PLEX)) {
		ERROR("groups_in_volume: plexIter");
		return 0;
	}

	while ((caPlex = raid_config_iterator_next(plexIter)) != NULL) {
		/*
		 * Skip if current volume not this plex's parent
		 */
		if (caPlex->cao_parent_obj_id != vol_id)
			continue;

		/*
		 * create iterator for raid groups
		 */
		if (!raid_config_iterator_create(&raidIter, RAIDTYPE_GROUP)) {
			raid_config_iterator_destroy(plexIter);
			ERROR("groups_in_volume: raidIter");
			return 0;
		}

		/*
		 * walk all raid groups (in the plex)
		 */
		groups = 0;

		while ((caRaid = raid_config_iterator_next(raidIter)) != NULL) {
			/*
			 * Skip if current plex not this group's parent
			 */
			if (caRaid->cao_parent_obj_id != caPlex->cao_id.cai_obj_id)
				continue;

			groups++;
		}
		raid_config_iterator_destroy(raidIter);
	}
	raid_config_iterator_destroy(plexIter);

	return groups;
}

/*
 *  Retrieve number of raid groups in the specified plex.
 */

static int
snmp_get_raid_disk_groups_in_plex( raidobj_id_t plex_id )
{
	raid_config_iter_t *raidIter;
	config_attr_obj_t *caRaid;
	int groups = 0;

	/*
	 * create iterator for raid groups
	 */
	if (!raid_config_iterator_create(&raidIter, RAIDTYPE_GROUP)) {
		ERROR("groups_in_plex: raidIter");
		return groups;
	}
	
	/*
	 * walk all raid groups (in the plex)
	 */
	groups = 0;
	
	while ((caRaid = raid_config_iterator_next(raidIter)) != NULL) {
		/*
		 * Skip if current plex not this group's parent
		 */
		if (caRaid->cao_parent_obj_id != plex_id)
			continue;
	
		groups++;
	}
	raid_config_iterator_destroy(raidIter);

	return groups;
}

/*
 *  Retrieve number of disks in the specified raid group.
 */

static int
snmp_get_raid_disk_disks_in_group( raidobj_id_t group_id )
{
	raid_config_iter_t *diskIter;
	config_attr_obj_t  *caDisk;
	int disks = 0;

	/*
	 * create iterator for raid group disks
	 */
	if (!raid_config_iterator_create(&diskIter, RAIDTYPE_DISK)) {
		ERROR("disks_in_group: diskIter");
		return disks;
	}
	
	/*
	 * walk all disks (in the raid group)
	 */
	disks = 0;
	
	while ((caDisk = raid_config_iterator_next(diskIter)) != NULL) {
		/*
		 * Skip if current raid group not this disk's parent
		 */
		if (caDisk->cao_parent_obj_id != group_id)
			continue;
	
		disks++;
	}
	raid_config_iterator_destroy(diskIter);

	return disks;
}

/*
 *  Retrieve disk pool.
 */

static int
snmp_get_raid_disk_pool( config_attr_obj_t *cao, char *poolbuf, int bufsize )
{
	int retcode;

	/*
	 * Parent pool.  If the disk is a spare, this can be
	 * derived from the parent info. (see registry/impl_disks.c) 
	 */ 
	if (cao != NULL && cao->cao_disk.cad_spare) { 
		/*
		 * In case pool name has a POOL: prefix, we 
		 * want to skip over that 
		 */
		char *p;
		char pool[MAX_DISKPOOL_NAMELEN+1];

		snprintf(pool,sizeof(pool),
			"%s",cao->cao_tree);

		p = pool;
		if ((p = strchr(pool,':')) != NULL)  
			p++;

		snprintf(poolbuf,bufsize,
			"%s",p);
		retcode = 1;
	}
	else {
		/*
		 * Pool is not available
		 */
		snprintf(poolbuf,bufsize,
			"%s",na_str);
		retcode = 0;
	}
	return retcode;
}


/*
 *  Return true if this disk is "bypassed".
 *  (see raidv2/dmgr.c - dmgr_print_bypassed_info() for corresponding
 *   sysconfig -r logic)
 */

static boolean_t
snmp_get_raid_disk_bypassed( config_attr_disk_t *cad )
{
	return false; // XXX burt29232
}


/*
 *  Interpret a raid config structure to figure out which of the SNMP disk status
 *  values most appropriately represents the disk.
 */

static int
snmp_get_raid_disk_status ( config_attr_disk_t *cad, config_attr_group_t *cag )
{
	int raid_status = 0;

	if (cad == NULL) {
		ERROR("snmp_get_raid_disk_status: cad NULL");
		return 0;
	}

	if (cad->cad_broken) {
		raid_status = RAIDSTFAILED;
	} else if (cad->cad_offline) {
		raid_status = RAIDSTOFFLINE;
	} else if (cad->cad_reconstructing)	{
		raid_status = (cad->cad_parity_disk ? RAIDSTPARRECON : RAIDSTRECON);
	} else if (cag != NULL && cag->cag_scrub >= 0) {
		raid_status = RAIDSTSCRUB;
	} else if (cag != NULL && cag->cag_reparity >= 0) {
		raid_status = RAIDSTPARVERIF;
	} else if (cad->cad_sick || cad->cad_replacing) {
		raid_status = RAIDSTPREFAILED;
	/*
	 * BURT 341319: Treat both "reconstruct pending" and "disk add pending"  
	 * as instances of "adding spares".
	 */
	} else if (cad->cad_pending) {
		raid_status = RAIDSTADDSPARE;
	} else if (cad->cad_spare) {
		raid_status = RAIDSTSPARE;
	} else {
		raid_status = RAIDSTACTIVE;
	}
    
	return raid_status;
}

static boolean_t
update_disk_counts(int host)
{
	static time32_t	lastreadtime[ONTAP_NHOSTS] = {0,0};
	time32_t now;
	char ha_name[MAX_DISK_NAME];
	raid_disk_iterator_t it;
	DiskInfo di;
	int i;
	disk_handle_t disk_handle;
	struct snmp_vars_disk_counts disk_counts;
	int raid_status;
	char * failedMessagePtr = disk_counts.failedMessage;
	int failedMessageLen = SNMP_DISK_FAILED_MESSAGE_LEN;
	
	raid_config_iter_t		*rci;
	config_attr_obj_t		*caoDisk;
	config_attr_disk_t		*cad;
	config_attr_group_t		*cag;
	config_attr_group_t		cagKeep;

	now = ontap_time();

	/*
	 * Only need to scan the disks for status if the cache hasn't been 
	 * updated within the last 2 seconds. If it has, just exit. On first 
	 * run, lastreadtime is 0 and now > 2, so the data is guaranteed to 
	 * be updated.
	 */

	if (now - lastreadtime[host] <= SNMP_DISK_CACHE_SECS ) 
		return true;
	
	bzero((char *)&disk_counts, sizeof(disk_counts));

	if (!raid_config_iterator_create(&rci, RAIDTYPE_DISK)) {
		EMS_snmp_raid_iterator_failure();
		return true;
	}
	while ( (caoDisk = raid_config_iterator_next(rci)) != NULL ) {
		cad = &caoDisk->cao_disk;
		if ( cad->cad_host != host ) {
			continue;
		}
		i = raid_disk_id_to_diskindex(cad->cad_id);
		if (!disk_open_id(i, &disk_handle)) 
			continue;
		
		if (fm_takingover() || fm_givingback()) {
			raid_config_iterator_destroy(rci);
			disk_close_handle(disk_handle);
			return false;
		}
		disk_counts.totalCount ++;
		raid_disk_iterator_from_id(&it, cad->cad_id);

		/*
		 * If parent is a RAIDTYPE_GROUP, then we will search 
		 * for the parent in order to pass it to 
		 * snmp_get_raid_disk_status().  If we can't find
		 * it, cag will remain NULL. 
		 */
		cag = NULL;
		if (caoDisk->cao_parent_obj_type == RAIDTYPE_GROUP) { 

			config_attr_obj_t *caoGroup;
			raid_config_iter_t *rgIter;

			/*
			 * Create raid iterator to search for parent group
			 */
			if (!raid_config_iterator_create(&rgIter,RAIDTYPE_GROUP)) {
				raid_config_iterator_destroy(rci);
				disk_close_handle(disk_handle);
				EMS_snmp_raid_iterator_failure();
				return true;
			} 

			/*
			 * Search for parent group 
			 */
			while ((caoGroup = raid_config_iterator_next(rgIter)) 
						!= NULL) {
				if (caoDisk->cao_parent_obj_id == 
						caoGroup->cao_id.cai_obj_id) { 
					bcopy(
						&(caoGroup->cao_group),
						&cagKeep,
						sizeof(cagKeep));
					cag = &cagKeep;
					break;
				}
			} 
	    		raid_config_iterator_destroy(rgIter);
		} 

		raid_status = snmp_get_raid_disk_status(cad,cag);

		/*
		 * XXX Note that the cases here are mutually exclusive (no
		 *     overlap of cases), meaning a disk is either active
		 *     OR reconstructing, for example.  That is not 100% 
		 *     clear in the MIB descriptions. 
		 */
		switch (raid_status) {
		    case RAIDSTACTIVE:
			    disk_counts.activeCount++; break;
		    case RAIDSTRECON:	
			    disk_counts.reconstructingCount++; break;
		    case RAIDSTPARRECON:	
			    disk_counts.reconstructingParityCount++; 
			    disk_counts.reconstructingCount++;
			    break;
		    case RAIDSTPARVERIF:	
			    disk_counts.verifyingParityCount++; break;
		    case RAIDSTSCRUB:
			    /*
			     * for scrub case, a disk is active while 
			     * being scrubbed
			     */
			    disk_counts.activeCount++;
			    disk_counts.scrubbingCount++; break;
		    case RAIDSTFAILED: {
			    size_t	len;
			    const char *failed_reason = broken_str;

				if (cad->cad_maintenance)
					/* skip "maintenance disks" */
					break;
				
			    disk_counts.failedCount++;

			    if (cad->cad_failure_reason == CADFR_ADMIN_FAILED ||
			       cad->cad_failure_reason == CADFR_ADMIN_REMOVED){
				    disk_counts.adminRemovedOrFailedCount++;
			    }
				failed_reason =
					disk_failure_reason_string(cad->cad_outage_reason);

			    SK_DOMAIN_REFERENCE(disk_get_phys_info,
						SK_REASON_SWITCH_DOMAIN);
			    if (disk_get_phys_info(disk_handle, &di) != E_NO_ERROR) {
			    	snprintf(failedMessagePtr,
				    failedMessageLen,
				    "%s disk in volume %s%s, RAID group %d, %s. ",
				    cad->cad_raid_type, 
				    raid_owner_string(it.rdi_owner),
				    caoDisk->cao_tree,
				    cad->cad_group_id,
				    failed_reason);
			    } else if ((di.Shelf == UNSPECIFIED) || 
				       (di.Slot == UNSPECIFIED)) {
				DiskType dt = di.TypeDisk;
				SK_DOMAIN_REFERENCE(disk_get_ha_name, 
					SK_REASON_SWITCH_DOMAIN);
				disk_get_ha_name(disk_handle, ha_name);

				/*
				 * gFilers don't have shelves and slots
				 * see burt 134628.
				 */
				snprintf(failedMessagePtr, failedMessageLen, 
					"Disk on adapter %s %s%s. ",
					ha_name,
					((dt == OPR_DISK) ? ""
						: ("unknown shelf and slot ")),
					failed_reason);
			    } else {
				SK_DOMAIN_REFERENCE(disk_get_ha_name, 
					SK_REASON_SWITCH_DOMAIN);
				disk_get_ha_name(disk_handle, ha_name);

			    	snprintf(failedMessagePtr, failedMessageLen,
				    "Disk on adapter %s, shelf %d, bay %d, %s. ",
				    ha_name,
				    di.Shelf,
				    di.Slot,
				    failed_reason);
			    }

			
			    len = strlen(failedMessagePtr);
			    failedMessagePtr += len;
			    *failedMessagePtr = 0;
			    failedMessageLen -= len;
			    ASSERT(failedMessageLen >= 0);

			    break;
		    }
		    case RAIDSTSPARE:
			    disk_counts.spareCount++; break;
		    case RAIDSTADDSPARE:
			    disk_counts.addingSpareCount++; break;
		    case RAIDSTPREFAILED:
			    disk_counts.prefailedCount++; break;
		    case RAIDSTOFFLINE:
			   if (cad->cad_spare) {
				disk_counts.spareCount++;
			   } else if (cad->cad_sick || cad->cad_replacing) {
				disk_counts.prefailedCount++;
			   }
			   break;
		    default:
			    dbg_printf("Disk %d returned unexpected status %d.",
					i, raid_status);
			    break;
		}
		disk_close_handle(disk_handle);
	}
	raid_config_iterator_destroy(rci);
	
	if (0 == disk_counts.failedCount) {
		strcpy(disk_counts.failedMessage,
		       snmp_vars_no_failed_disks_message);
	}
	
	bcopy((char *) &disk_counts, (char *) &counts[host], 
	      sizeof(counts[host]));
	lastreadtime[host] = now;

	return true;
}

/*
 *  Handle getting disk summary information -- sums of the number
 *  of disks in each of the possible states.
 *
 *  We keep the counts cached so that callers who are asking
 *  for all of the values in sequence don't require us to walk
 *  the lists of disks each time.
 */
/* format is .1.3.6.1.4.1.789.1.6.4.magic.0 */
uint8_t *
var_diskSummary(SNMP_FM_ARGS)
{
	int			host;

	HEADER_GENERIC;
	host = sk_gethost();
	if (!update_disk_counts(host))
		return NULL;

	/*
	 *  The counts structure holds all the recent values; return the right one.
	 */

	switch (vp->magic) {
	/* ---------------------------------------------- */
	case DISKTOTALCOUNT:
	    long_return = counts[host].totalCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKACTIVECOUNT:
	    long_return = counts[host].activeCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKRECONSTRUCTINGCOUNT:
	    long_return = counts[host].reconstructingCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKRECONSTRUCTINGPARITYCOUNT:
	    long_return = counts[host].reconstructingParityCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKVERIFYINGPARITYCOUNT:
	    long_return = counts[host].verifyingParityCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKSCRUBBINGCOUNT:
	    long_return = counts[host].scrubbingCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKFAILEDCOUNT:
	    long_return = counts[host].failedCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKFAILEDMESSAGE:
	    *var_len = strlen(counts[host].failedMessage);
	    return (uint8_t *) (counts[host].failedMessage);

	/* ---------------------------------------------- */
	case DISKSPARECOUNT:
	    long_return = counts[host].spareCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKADDINGSPARECOUNT:
	    long_return = counts[host].addingSpareCount;
	    return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	case DISKPREFAILEDCOUNT:
		long_return = counts[host].prefailedCount;
		return (uint8_t *) & long_return;

	/* ---------------------------------------------- */
	default:
	    ERROR("var_diskSummary");
	}

	return NULL;
}

/*
 *  Handle getting the environmental variables -- temperature,
 *  fan status, power supply status.
 */
/* format is .1.3.6.1.4.1.789.1.2.4.magic.0 */
uint8_t *
var_environment(SNMP_FM_ARGS)
{

	HEADER_GENERIC;

	report[0] = 0;

	switch (vp->magic) {
	/* ---------------------------------------------- */
	case ENVOVERTEMPERATURE:
	    /*
	     *  The SNMP values have to be 1 (no) or 2 (yes).
	     *  check_temperature_status() returns 2 for hi-temp,
	     *  1 for low-temp, 0 for normal temp
	     */

	    long_return = ( (check_temperature_status() == 0) ? 1 : 2 );
	    return (uint8_t *) & long_return;
	    
	/* ---------------------------------------------- */
	case ENVFAILEDFANCOUNT:
	    long_return = check_fan_status(report);
	    return (uint8_t *) & long_return;
	    
	/* ---------------------------------------------- */
	case ENVFAILEDFANMESSAGE:
	    long_return = check_fan_status(report);
	    if ( 0 == long_return ) {
		    strlcpy( report, snmp_vars_no_failed_fans_message,
			     sizeof( report )/ sizeof( char ) );
	    }
	    *var_len = strlen( report );
	    return (uint8_t *) report;
	
	/* ---------------------------------------------- */
	case ENVFAILEDPOWERSUPPLYCOUNT:
	    /*
	     * XXX - is_low_power() returns TRUE/FALSE, so the only
	     * values we're currently capable of returning are 0 and 1.
	     */
	    long_return = is_low_power(report);
	    return (uint8_t *) & long_return;
	    
	/* ---------------------------------------------- */
	case ENVFAILEDPOWERSUPPLYMESSAGE:
	    long_return = is_low_power(report);
	    if ( 0 == long_return ) {
		strlcpy( report, snmp_vars_no_failed_power_supply_message,
			sizeof( report ) / sizeof( char ) );
	    }
	    *var_len = strlen( report );
	    return (uint8_t *) report;
	    
	/* ---------------------------------------------- */
	default:
	    ERROR("var_environment");
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.2.5.magic.0 */
uint8_t *
var_nvram(SNMP_FM_ARGS)
{
	HEADER_GENERIC;

	switch (vp->magic) {
	/* ---------------------------------------------- */
	case NVRAMBATTERYSTATUS:
	    /*
	     *  We depend on the nvram_battery_status_t values from
	     *  <driver/nvram/nvram.h> mapping exactly to the possible
	     *  values for this variable as defined in the MIB.
	     */
	    long_return = nvram_check_batteries();

	    return (uint8_t *) & long_return;
	    
	/* ---------------------------------------------- */
	default:
	    ERROR("var_nvram");
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.2.7.magic.0 */
uint8_t *
var_autosupport(SNMP_FM_ARGS)
{
	uint8_t *return_ptr = NULL;

	HEADER_GENERIC;
	switch (vp->magic) {
	/* ---------------------------------------------- */
	case AUTOSUPPORTSTATUS:
		long_return = asup_status_get();
		return_ptr = (uint8_t *) & long_return;
		break;
	    
	/* ---------------------------------------------- */
	case AUTOSUPPORTSTATUSMESSAGE:
		long_return = asup_status_message_get(return_buf, sizeof(return_buf)-1);
		*var_len = strlen(return_buf);
		return_ptr = return_buf;
		break;
	
	/* ---------------------------------------------- */
	case AUTOSUPPORTSUCCESSFULSENDS:
		long_return = asup_success_count_get();
		return_ptr = (uint8_t *) & long_return;
		break;
	    
	/* ---------------------------------------------- */
	case AUTOSUPPORTFAILEDSENDS:
		long_return =  asup_failure_count_get();
		return_ptr = (uint8_t *) & long_return;
		break;
	    
	/* ---------------------------------------------- */
	default:
		ERROR("var_autosupport");
		*var_len = 0;
		return_ptr = NULL;
		break;
	}
	
	return return_ptr;
}

SK_DOMAIN_EXPORT(var_nfsvx, SK_DOMAIN_NETWORK);
uint8_t  *var_nfsvx( oid vpn, int index )
{	
	nfs_Stats st;
	nfs_Stats *stl = &nfs_last[sk_gethost()];

	nfs_aggregate_cpu_stats(&st, false);

	switch( vpn )
	{
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxTOTALCALLS:
		long_return = ( st.srvrpccnt[ index ] -
			       stl->srvrpccnt[ index ]);
		return (uint8_t *) & long_return;
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxTOTALPERCENT:
	    {
		uint64_t total = get_deltaOps();

		long_return = total ? percent(
	          ( st.srvrpccnt[ index ] -
		   stl->srvrpccnt[ index ]), total ) : 0;
		return (uint8_t *) & long_return;
	    }
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxCACHEDCALLS:
		long_return = ( st.nonblock_req[ index ] -
			       stl->nonblock_req[ index ]);
		return (uint8_t *) & long_return;
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxCACHEDPERCENT:
	    {
		uint64_t total = ( st.srvrpccnt[ index ] -
			     stl->srvrpccnt[ index ]);

		long_return = total ? percent(
	          ( st.nonblock_req[ index ] -
		   stl->nonblock_req[ index ]), total ) : 0;
		return (uint8_t *) & long_return;
	    }
	    /* ++++++++++++++++++++++++++++++ */
	    default:
		ERROR("var_nfsvx");
		return( NULL );
	    /* ++++++++++++++++++++++++++++++ */
	}
}

#define NFS_NEXT_OFFSET 12

/* handles many formats:
 * format is .1.3.6.1.4.1.789.1.3.1.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.2.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.3.1.magic.0 
 * format is .1.3.6.1.4.1.789.1.3.1.2.3.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.3.3.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.3.4.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.4.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.4.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.4.3.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.4.4.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.5.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.6.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.6.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.6.3.magic.0
 * format is .1.3.6.1.4.1.789.1.3.1.2.6.4.magic.0
 */
uint8_t *
_var_nfs(SNMP_FM_ARGS)
{
	nfs_Stats st;
	nfs_Stats *stl = &nfs_last[sk_gethost()];
	HEADER_GENERIC;

	nfs_aggregate_cpu_stats(&st, false);
	SK_DOMAIN_REFERENCE(nfs_last, SK_DOMAIN_NETWORK);

	switch( vp->name[ 10 ] ) {
	case NFSRPC:
	    /* curNfs:oid:1.3.6.1.4.1.789.1.3.1.1.X */
	    switch ( vp->magic ) {
	    /* ------------------------------------- */
	    case RPCCALLS:
		long_return = (int32_t)((st.rpc_calls_co - stl->rpc_calls_co)
		                   + (st.rpc_calls_cl - stl->rpc_calls_cl));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCBADCALLS:
		long_return = (int32_t)((st.rpc_badlen_co - stl->rpc_badlen_co)
		                   + (st.rpc_badlen_cl - stl->rpc_badlen_cl)
		                   + (st.rpc_badhdr_co - stl->rpc_badhdr_co)
		                   + (st.rpc_badhdr_cl - stl->rpc_badhdr_cl));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCNULLRECVS:
		long_return = (int32_t)((st.rpc_badproc_co - stl->rpc_badproc_co)
		                   + (st.rpc_badproc_cl - stl->rpc_badproc_cl));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCBADLENS:
		long_return = (int32_t)((st.rpc_badlen_co - stl->rpc_badlen_co)
		                   + (st.rpc_badlen_cl - stl->rpc_badlen_cl));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCSERVXDRCALLS:
		long_return = (int32_t)((st.rpc_badhdr_co - stl->rpc_badhdr_co)
		                   + (st.rpc_badhdr_cl - stl->rpc_badhdr_cl));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPCALLS:
		long_return = (int32_t)(st.rpc_calls_co - stl->rpc_calls_co);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPBADCALLS:
		long_return = (int32_t)((st.rpc_badlen_co - stl->rpc_badlen_co)
		                   + (st.rpc_badhdr_co - stl->rpc_badhdr_co));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPNULLRECVS:
		long_return = (int32_t)(st.rpc_badproc_co - stl->rpc_badproc_co);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPBADLENS:
		long_return = (int32_t)(st.rpc_badlen_co - stl->rpc_badlen_co);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPSERVXDRCALLS:
		long_return = (int32_t)(st.rpc_badhdr_co - stl->rpc_badhdr_co);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPCALLS:
		long_return = (int32_t)(st.rpc_calls_cl - stl->rpc_calls_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPBADCALLS:
		long_return = (int32_t)((st.rpc_badlen_cl - stl->rpc_badlen_cl)
		                   + (st.rpc_badhdr_cl - stl->rpc_badhdr_cl));
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPNULLRECVS:
		long_return = (int32_t)(st.rpc_badproc_cl - stl->rpc_badproc_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPBADLENS:
		long_return = (int32_t)(st.rpc_badlen_cl - stl->rpc_badlen_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPSERVXDRCALLS:
		long_return = (int32_t)(st.rpc_badhdr_cl - stl->rpc_badhdr_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    default:
		ERROR("var_nfs: NFSRPC 1");
	    /* ------------------------------------- */
	    }
	    break;
	/* ======================================================= */
	case NFSNFS:
	    {
		/* curNfs:oid:1.3.6.1.4.1.789.1.3.1.2.X */
		oid vpn_nfs = vp->name[ 11 ];

		switch ( vpn_nfs ) {
		/* ------------------------------------- */
		case NFSCALLS:
		    if ( vp->magic == vpn_nfs ) {
			SK_DOMAIN_REFERENCE(get_deltaOps, SK_DOMAIN_NETWORK);
			long_return = (int32_t) get_deltaOps();
			return (uint8_t *) & long_return;
		    }
		    else {
			ERROR("var_nfs: NFSNFS NFSCALLS 2");
			return( NULL );
		    }
		/* ------------------------------------- */
		case NFSSERVBADCALLS:
		    if ( vp->magic == vpn_nfs ) {
			long_return = (int32_t)(st.srv_errs - stl->srv_errs);
			return (uint8_t *) & long_return;
		    }
		    else {
			ERROR("var_nfs: NFSNFS NFSSERVBADCALLS 3");
			return( NULL );
		    }
		/* ------------------------------------- */
		case NFSV2:
		    if ( (vp->magic >= NFSV2STARTOID) ||
			 (vp->magic <= NFSV2ENDOID  ) )
		    {
			return( var_nfsvx( vp->name[ NFS_NEXT_OFFSET ],
					   (vp->magic - 1) ) );
		    }
		    else
		    {
			ERROR("var_nfs: NFSNFS NFSV2 4");
			return(NULL);
		    }
		/* ------------------------------------- */
		case NFSV3:
		    if ( (vp->magic >= NFSV3STARTOID) ||
			 (vp->magic <= NFSV3ENDOID  ) )
		    {
			return( var_nfsvx( vp->name[ NFS_NEXT_OFFSET ],
					   (vp->magic
					    + (NFSV2_NPROCS -1)) ) );
		    }
		    else
		    {
			ERROR("var_nfs: NFSNFS NFSV3 5");
			return(NULL);
		    }
		/* ------------------------------------- */
		case NFSREPLYCACHE:
		    switch ( vp->magic ) {
		    /* +++++++++++++++++++++++++++ */
		    case RCINPROGRESSHITS:
			long_return = (int32_t)(( st.srvcache_inproghits_co -
					      stl->srvcache_inproghits_co)
			                   + ( st.srvcache_inproghits_cl -
					      stl->srvcache_inproghits_cl));
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCDELAYHITS:
			long_return = 0;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCMISSES:
			long_return = (int32_t)(( st.srvcache_misses_co -
					      stl->srvcache_misses_co)
			                   + ( st.srvcache_misses_cl -
					      stl->srvcache_misses_cl));
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCNONIDEMDONEHITS:
			long_return = (int32_t)(( st.srvcache_idemdonehits_co -
			                      stl->srvcache_idemdonehits_co)
			                   + ( st.srvcache_idemdonehits_cl -
			                      stl->srvcache_idemdonehits_cl));
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCNONIDEMNOTDONEHITS:
			long_return = (int32_t)(( st.srvcache_nonidemdonehits_co -
			                      stl->srvcache_nonidemdonehits_co)
			                   + ( st.srvcache_nonidemdonehits_cl -
			                      stl->srvcache_nonidemdonehits_cl));
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCTCPINPROGRESSHITS:
			long_return = (int32_t)( st.srvcache_inproghits_co -
					      stl->srvcache_inproghits_co);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCTCPDELAYHITS:
			long_return = 0;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCTCPMISSES:
			long_return = (int32_t)( st.srvcache_misses_co -
					      stl->srvcache_misses_co);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCTCPNONIDEMDONEHITS:
			long_return = (int32_t)( st.srvcache_idemdonehits_co -
			                      stl->srvcache_idemdonehits_co);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCTCPNONIDEMNOTDONEHITS:
			long_return = (int32_t)(st.srvcache_nonidemdonehits_co -
			                     stl->srvcache_nonidemdonehits_co);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCUDPINPROGRESSHITS:
			long_return = (int32_t)( st.srvcache_inproghits_cl -
					      stl->srvcache_inproghits_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCUDPDELAYHITS:
			long_return = 0;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCUDPMISSES:
			long_return = (int32_t)( st.srvcache_misses_cl -
					      stl->srvcache_misses_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCUDPNONIDEMDONEHITS:
			long_return = (int32_t)( st.srvcache_idemdonehits_cl -
			                      stl->srvcache_idemdonehits_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case RCUDPNONIDEMNOTDONEHITS:
			long_return = (int32_t)( st.srvcache_nonidemdonehits_cl -
			                      stl->srvcache_nonidemdonehits_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    default:
			ERROR("var_nfs: NFSNFS NFSREPLYCACHE 6");
			return( NULL );
		    /* +++++++++++++++++++++++++++ */
		    }
		/* ------------------------------------- */
		case TNFSRWSTATS:

			switch ( vp->name[ NFS_NEXT_OFFSET ] ) {
                        /* +++++++++++++++++++++++++++ */
                        case TV2READSTATS:
                                if ((vp->magic >= TV2READ512CALLS) &&
                                        (vp->magic <= TV2READ128KCALLS)) {
                                        long_return = (int32_t)
                                        (pcs.statreadv2.bucket[vp->magic - TV2READ512CALLS]);
                                }
                                break;

                        /* +++++++++++++++++++++++++++ */

			case TV2WRITESTATS:
                                if ((vp->magic >= TV2WRITE512CALLS) &&
                                        (vp->magic <= TV2WRITE128KCALLS)) {
                                        long_return = (int32_t)
                                        (pcs.statwritev2.bucket[vp->magic - TV2WRITE512CALLS]);
                                }
                                break;

                        /* +++++++++++++++++++++++++++ */
                        case TV3READSTATS:
                                if ((vp->magic >= TV3READ512CALLS) &&
                                        (vp->magic <= TV3READ128KCALLS)) {
                                        long_return = (int32_t)
                                        (pcs.statreadv3.bucket[vp->magic - TV3READ512CALLS]);
                                }
                                break;

                        /* +++++++++++++++++++++++++++ */
                        case TV3WRITESTATS:
                                if ((vp->magic >= TV3WRITE512CALLS) &&
                                        (vp->magic <= TV3WRITE128KCALLS)) {
                                        long_return = (int32_t)
                                        (pcs.statwritev3.bucket[vp->magic - TV3WRITE512CALLS]);
                                }
                                break;

                        /* +++++++++++++++++++++++++++ */
                        default:
                                ERROR("var_tnfs: NFSNFS NFSRWSTATS 7");
                                return( NULL );
                        }
                        return (uint8_t *) & long_return;
                        /* ------------------------------------- */
		default:
		    ERROR("var_nfs: NFSNFS 8");
		    return( NULL );
		}
		break;
	    }
	/* ======================================================= */
	default:
	    ERROR("var_nfs 8");
	    return( NULL );
	/* ======================================================= */
	}

	return( NULL );
}

/*
 * Not used for any particular table. This function is strictly used to forward 
 * requests from other handlers to _var_nfs.
 */
SK_DOMAIN_EXPORT(var_nfs, SK_REASON_SWITCH_DOMAIN);
uint8_t *
var_nfs(SNMP_FM_ARGS)
{
	DOMAIN_SWITCH_NEST(sk_domain_network, _var_nfs,
			   (vp, name, length, exact, var_len, write_method)); 
}

/*
 * Not used for any particular table. This function should be static.
 */
/* Looks like the formats are the following, though this is really
 * convoluted code.
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.3.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.4.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.5.magic.0
 */
SK_DOMAIN_EXPORT(var_tnfsvx, SK_DOMAIN_NETWORK);
uint8_t *
var_tnfsvx( oid vpn, int index )
{
	nfs_Stats stat;

	nfs_aggregate_cpu_stats(&stat, false);

	switch( vpn )
	{
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxTOTALCALLS:
		long_return = stat.srvrpccnt[ index ];
		return (uint8_t *) & long_return;
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxTOTALPERCENT:
	    {
		uint64_t total = nfs_getops();

		long_return = total ? percent(
	          stat.srvrpccnt[ index ], total ) : 0;
		return (uint8_t *) & long_return;
	    }
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxCACHEDCALLS:
		long_return = stat.nonblock_req[ index ];
		return (uint8_t *) & long_return;
	    /* ++++++++++++++++++++++++++++++ */
	    case NFSvxCACHEDPERCENT:
	    {
		uint64_t total = stat.srvrpccnt[ index ];

		long_return = total ? percent(
	          stat.nonblock_req[ index ], total ) : 0;
		return (uint8_t *) & long_return;
	    }
	    /* ++++++++++++++++++++++++++++++ */
	    default:
		ERROR("var_tnfsvx");
		return( NULL );
	    /* ++++++++++++++++++++++++++++++ */
	}
}

/* handles many formats:
 * format is .1.3.6.1.4.1.789.1.3.2.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.3.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.3.4.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.5.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.6.1.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.6.2.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.6.3.magic.0
 * format is .1.3.6.1.4.1.789.1.3.2.2.6.4.magic.0
 */
uint8_t *
_var_tnfs(SNMP_FM_ARGS)
{
	nfs_Stats stat;
	nfs_aggregate_cpu_stats(&stat, false);

	HEADER_GENERIC;

	/*
	 * totNFS.X:oid:1.3.6.1.4.1.789.1.3.2.x
	 */
	switch( vp->name[ 10 ] ) {
	/* ======================================================= */
	case NFSRPC:
	    switch ( vp->magic ) {
	    /* ------------------------------------- */
	    case RPCCALLS:
		long_return = (int32_t)(stat.rpc_calls_co + stat.rpc_calls_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCBADCALLS:
		long_return = (int32_t)(stat.rpc_badlen_co + stat.rpc_badhdr_co
		                   + stat.rpc_badlen_cl + stat.rpc_badhdr_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCNULLRECVS:
		long_return = (int32_t)(stat.rpc_badproc_co + stat.rpc_badproc_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCBADLENS:
		long_return = (int32_t)(stat.rpc_badlen_co + stat.rpc_badlen_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCSERVXDRCALLS:
		long_return = (int32_t)(stat.rpc_badhdr_co + stat.rpc_badhdr_cl);
	    /* ------------------------------------- */
	    case RCPTCPCALLS:
		long_return = (int32_t)stat.rpc_calls_co;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPBADCALLS:
		long_return = (int32_t)(stat.rpc_badlen_co + stat.rpc_badhdr_co);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPNULLRECVS:
		long_return = (int32_t)stat.rpc_badproc_co;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPBADLENS:
		long_return = (int32_t)stat.rpc_badlen_co;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RCPTCPSERVXDRCALLS:
		long_return = (int32_t)stat.rpc_badhdr_co;
	    /* ------------------------------------- */
	    case RPCUDPCALLS:
		long_return = (int32_t)stat.rpc_calls_cl;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPBADCALLS:
		long_return = (int32_t)(stat.rpc_badlen_cl + stat.rpc_badhdr_cl);
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPNULLRECVS:
		long_return = (int32_t)stat.rpc_badproc_cl;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPBADLENS:
		long_return = (int32_t)stat.rpc_badlen_cl;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    case RPCUDPSERVXDRCALLS:
		long_return = (int32_t)stat.rpc_badhdr_cl;
		return (uint8_t *) & long_return;
	    /* ------------------------------------- */
	    default:
		ERROR("var_tnfs: NFSRPC 1");
	    /* ------------------------------------- */
	    }
	    break;
	/* ======================================================= */
	case NFSNFS:
	    {
		/* curNfs:oid:1.3.6.1.4.1.789.1.3.2.2.X */
		oid vpn_nfs = vp->name[ 11 ];

		switch ( vpn_nfs ) {
		/* ------------------------------------- */
		case NFSCALLS:
		    if ( vp->magic == vpn_nfs ) {
			long_return = (int32_t) nfs_getops();
			return (uint8_t *) & long_return;
		    }
		    else {
			ERROR("var_tnfs: NFSNFS NFSCALLS 2");
			return( NULL );
		    }
		/* ------------------------------------- */
		case NFSSERVBADCALLS:
		    if ( vp->magic == vpn_nfs ) {
			long_return = (int32_t)stat.srv_errs;
			return (uint8_t *) & long_return;
		    }
		    else {
			ERROR("var_tnfs: NFSNFS NFSSERVBADCALLS 3");
			return( NULL );
		    }
		/* ------------------------------------- */
		case NFSV2:
		    if ( (vp->magic >= NFSV2STARTOID) ||
			 (vp->magic <= NFSV2ENDOID  ) )
		    {
			return( var_tnfsvx( vp->name[ NFS_NEXT_OFFSET ],
					   (vp->magic - 1) ) );
		    }
		    else
		    {
			ERROR("var_tnfs: NFSNFS NFSV2 4");
			return(NULL);
		    }
		/* ------------------------------------- */
		case NFSV3:
		    if ( (vp->magic >= NFSV3STARTOID) ||
			 (vp->magic <= NFSV3ENDOID  ) )
		    {
			return( var_tnfsvx( vp->name[ NFS_NEXT_OFFSET ],
					   (vp->magic
					    + (NFSV2_NPROCS -1)) ) );
		    }
		    else
		    {
			ERROR("var_tnfs: NFSNFS NFSV3 5");
			return(NULL);
		    }
		/* ------------------------------------- */
		case NFSREPLYCACHE:
		    switch ( vp->magic ) {
		    /* +++++++++++++++++++++++++++ */
		    case TRCINPROGRESSHITS:
			long_return = (int32_t)(stat.srvcache_inproghits_co
			                   + stat.srvcache_inproghits_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCDELAYHITS:
			long_return = 0;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCMISSES:
			long_return = (int32_t)(stat.srvcache_misses_co
			                   + stat.srvcache_misses_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCNONIDEMDONEHITS:
			long_return = (int32_t)(stat.srvcache_idemdonehits_co
			                   + stat.srvcache_idemdonehits_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCNONIDEMNOTDONEHITS:
			long_return = (int32_t)(stat.srvcache_nonidemdonehits_co
			                   + stat.srvcache_nonidemdonehits_cl);
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCTCPINPROGRESSHITS:
			long_return = (int32_t)stat.srvcache_inproghits_co;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCTCPDELAYHITS:
			long_return = 0;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCTCPMISSES:
			long_return = (int32_t)stat.srvcache_misses_co;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCTCPNONIDEMDONEHITS:
			long_return = (int32_t)stat.srvcache_idemdonehits_co;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCTCPNONIDEMNOTDONEHITS:
			long_return = (int32_t)stat.srvcache_nonidemdonehits_co;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCUDPINPROGRESSHITS:
			long_return = (int32_t)stat.srvcache_inproghits_cl;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCUDPDELAYHITS:
			long_return = 0;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCUDPMISSES:
			long_return = (int32_t)stat.srvcache_misses_cl;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCUDPNONIDEMDONEHITS:
			long_return = (int32_t)stat.srvcache_idemdonehits_cl;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    case TRCUDPNONIDEMNOTDONEHITS:
			long_return = (int32_t)stat.srvcache_nonidemdonehits_cl;
			return (uint8_t *) & long_return;
		    /* +++++++++++++++++++++++++++ */
		    default:
			ERROR("var_tnfs: NFSNFS NFSREPLYCACHE 6");
			return( NULL );
		    /* +++++++++++++++++++++++++++ */
		    }
		/* ------------------------------------- */
		case TNFSRWSTATS:  

                	switch ( vp->name[ NFS_NEXT_OFFSET ] ) {
                        /* +++++++++++++++++++++++++++ */
			case TV2READSTATS:
				if ((vp->magic >= TV2READ512CALLS) &&
					(vp->magic <= TV2READ128KCALLS)) {
					long_return = (int32_t)
					(tpcs.statreadv2.bucket[vp->magic - TV2READ512CALLS]);
				}
				break;
		
			/* +++++++++++++++++++++++++++ */
			case TV2WRITESTATS:
				if ((vp->magic >= TV2WRITE512CALLS) &&
                               		(vp->magic <= TV2WRITE128KCALLS)) {
                                	long_return = (int32_t)
					(tpcs.statwritev2.bucket[vp->magic - TV2WRITE512CALLS]);   
				}
				break;

			/* +++++++++++++++++++++++++++ */
			case TV3READSTATS:
                                if ((vp->magic >= TV3READ512CALLS) &&
                                        (vp->magic <= TV3READ128KCALLS)) {
                                        long_return = (int32_t)
					(tpcs.statreadv3.bucket[vp->magic - TV3READ512CALLS]);
                                }
				break;

			/* +++++++++++++++++++++++++++ */
			case TV3WRITESTATS:
                                if ((vp->magic >= TV3WRITE512CALLS) &&
                                        (vp->magic <= TV3WRITE128KCALLS)) {
                                        long_return = (int32_t)
					(tpcs.statwritev3.bucket[vp->magic - TV3WRITE512CALLS]);
				}
				break;

			/* +++++++++++++++++++++++++++ */
			default:
				ERROR("var_tnfs: NFSNFS TNFSRWSTATS 7");
                        	return( NULL );
			}
			return (uint8_t *) & long_return;
			/* ------------------------------------- */
		default:
		    ERROR("var_tnfs: NFSNFS 8");
		    return( NULL );
		}
		break;
	    }
	/* ======================================================= */
	default:
	    ERROR("var_tnfs: 9");
	    return( NULL );
	/* ======================================================= */
	}

	return( NULL );
}

/*
 * Not used for any particular table. This function is strictly used to forward 
 * requests from other handlers to _var_nfs.
 */
SK_DOMAIN_EXPORT(var_tnfs, SK_REASON_SWITCH_DOMAIN);
uint8_t *
var_tnfs(SNMP_FM_ARGS)
{
	DOMAIN_SWITCH_NEST(sk_domain_network, _var_tnfs,
			   (vp, name, length, exact, var_len, write_method)); 
}

/* format is .1.3.6.1.4.1.789.1.3.3.1.0 */
uint8_t *
var_nfsOptions(SNMP_FM_ARGS)
{
	int		displayNFSvars;
	
	HEADER_GENERIC;

	SK_DOMAIN_IMPORT(registry_get_boolean, SK_REASON_MPSAFE);
	switch (vp->magic) {
	case NFSISLICENSED:
		displayNFSvars = is_nfs_allowed() ||
			registry_get_boolean(OPTION_VLD_ENABLE, false);
		long_return = displayNFSvars ? 2 : 1;
		return (uint8_t*)&long_return;
	default:
		ERROR("var_nfsOptions");
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.4.magic.0 */
uint8_t         *
var_quota(SNMP_FM_ARGS)
{
	wafl_Volume *vol = wafl_root_volume();	
	                         /* for deprecated oids here */
	uint8_t *rval = NULL;

	wafl_quota_stats_inc_calls(WQS_CALLS_VAR_QUOTA);
	HEADER_GENERIC;

	switch ( vp->magic ) {
	/* ----------------------------- */
	case QUOTASTATE:
	    switch (vol->wvq_vqowner->wvqi_quota_state) {
	    /* ========= */
	    case WAFL_QUOTA_ON:
		long_return = QUOTASTATEON;
		break;
	    /* ========= */
	    case WAFL_QUOTA_OFF:
		long_return = QUOTASTATEOFF;
		break;
	    /* ========= */
	    case WAFL_QUOTA_INIT:
		long_return = QUOTASTATEINIT;
		break;
	    /* ========= */
	    default:
		ERROR("var_quota: QUOTASTATE 1");
		return rval;
	    /* ========= */
	    }
	    rval = (uint8_t *) & long_return;
	    break;
	/* ----------------------------- */
	case QUOTAINITPERCENT:
		long_return =
			(vol->wvq_vqowner->wvqi_quota_state == WAFL_QUOTA_INIT) ?
			 percent(QUOTA_INIT_TOTAL_PROCESSED(vol->wvq_vqowner,
			                                    vol),
		                 WAFL_VOL_INOS_TOTAL(vol))
			: 0;
	    rval = (uint8_t *) & long_return;
	    break;
	/* ----------------------------- */
	default:
	    ERROR("var_quota 2");
	    break;
	/* ----------------------------- */
	}
	return( rval );
}

/*
 * A cached copy of wafl_Quota information, to speed up SNMP.
 */
typedef struct snmp_Quota {
	/*
	 * These values are used to determine whether the cached
	 * values can be used.
	 */
	int	volno;
	int	index;
	int32_t	secs;  /* time at which data was obtained */	
	oldBool	found;
	/*
	 * The rest of the values are copied from wafl_Quota, but only
	 * the ones we actually use.
	 */
	uint32_t	id;
	uint32_t	tid;
	enum wafl_Quota_type	type;
	uint64_t	block_limit;
	uint64_t	block_limit_soft;
	uint64_t	block_threshold;
	uint32_t	file_limit;
	uint32_t	file_limit_soft;
	uint64_t	blocks_used;
	uint64_t	nosync_blocks_used;
	uint32_t	files_used;
	uint32_t	flags;
	char    path[MAX_VAL_LENGTH];	/* a copy of the value */
	char    tree[MAX_VAL_LENGTH];	/* a copy of the value */
	char    sid[MAX_VAL_LENGTH];	/* a copy of the value */
} snmp_Quota;

/*
 * The code below manages a cache for quota information of a given vol/quota.
 * After 5 seconds, we re-request quota information.  Assumption is
 * that a walk of the quota entries for a given vol/quota will be faster
 * than that..
 */

static snmp_Quota snmp_qcache = { 0 };	/* all values start as 0 */
static snmp_Quota snmp_qcache_local = { 0 }; 


#define SNMP_QUOTA_STALENESS 5
#define SNMP_QUOTA_ALL_VOLUMES  (0)

/*
 * Converts the wafl_Quota to a snmp_Quota by
 * copying the wafl_Quota data into snmp_Quota and converting the
 * pathname, qtreename and sid to strings based on 'type'. 
 * If  type is -1 pathname, qtreename and sid are 
 * all converted to strings
 */

static oldBool
snmp_convert_quota(wafl_Quota *qp_copy, snmp_Quota* snmp_quota,
			wafl_Volume *vol, int type)
{
	WCHAR upath[MAX_VAL_LENGTH];
	len_c rlen;
	uint32_t tree_name_id;

	ASSERT(vol != NULL);
	ASSERT(qp_copy != NULL);
	ASSERT(snmp_quota != NULL);
	
	/*
	 * Save copies of numeric quota info.
	 */
	snmp_quota->id = qp_copy->disk_record->id;
	snmp_quota->tid = qp_copy->disk_record->tid;
	snmp_quota->type = qp_copy->disk_record->type;
	snmp_quota->block_limit = qp_copy->disk_record->u.quota_acct_info.block_limit;
	snmp_quota->block_limit_soft = qp_copy->disk_record->u.quota_acct_info.block_limit_soft;
	snmp_quota->block_threshold = qp_copy->disk_record->u.quota_acct_info.block_threshold;
	snmp_quota->file_limit = qp_copy->disk_record->u.quota_acct_info.file_limit;
	snmp_quota->file_limit_soft = qp_copy->disk_record->u.quota_acct_info.file_limit_soft;
	snmp_quota->blocks_used = qp_copy->disk_record->u.quota_acct_info.blocks_used;
	snmp_quota->nosync_blocks_used = qp_copy->nosync_blocks_used;
	snmp_quota->files_used = qp_copy->disk_record->u.quota_acct_info.files_used;
	snmp_quota->flags = qp_copy->disk_record->flags;

	/*
	 * Compute the path string and save a copy in snmp_quota->path
	 */
	if (type == -1 || type == QRV2PATHNAME) {
		if (qp_copy->path != NULL) {
			struct XL_TRANS_OBJ *obj;  
			/* utf8 -> ucode ->nfs char set */
			utf2szUnicode((UTF8 *)qp_copy->path, upath, 1024, &rlen);
			C_LOCK(&gXL.XLlock[sk_gethost()]);
			obj = gXL.NFS_obj[sk_gethost()];
			if (!(obj->Uc2enc)(obj, upath, rlen, snmp_quota->path, sizeof(snmp_quota->path))) {
				snmp_quota->path[0] = '\0';
			} 
			C_UNLOCK(&gXL.XLlock[sk_gethost()]);
		} else {
			snmp_quota->path[0] = '\0';
		}
	}

	/*
	 * Compute the tree name string and save a copy in snmp_quota->tree
	 */
	snmp_quota->tree[0] = 0;
	if (type == -1 || type == QRV2TREE) {
		if (qp_copy->disk_record->type == WAFL_QTYPE_TREE) {
			tree_name_id = qp_copy->disk_record->id;
		} else {
			tree_name_id = qp_copy->disk_record->tid;
		}

		if (tree_name_id) {
			wafl_Volref *vref;

			/*
			 * Try to get a volref, if we can't they we are
			 * in the process of offlining the volume and the
			 * the quota entry that we found will soon be gone.
			 * So we treat things as if we didn't find the 
			 * entry.
			 */
			vref = wafl_volref_create(vol, "get quota tree names");
			if (vref == NULL) {
				return false;
			}

			if (!wafl_qtree_get_name(vol, 0, tree_name_id, 
				snmp_quota->tree, sizeof(snmp_quota->tree))) {
				/* Make sure it's empty */
				snmp_quota->tree[0] = 0;
			}

			wafl_volref_destroy(vref);
		}
	}

	/*
	 * Compute the sid string and save a copy in snmp_quota->sid
	 *
	 * If multi user base record or ID is a SID,
	 * handle it specially, otherwise, just produce an empty string.
	 */
	if(type == -1 || type == QRV2SID) {
		if (qp_copy->disk_record->type == WAFL_QTYPE_MULTI_USER_BASE) {
			wafl_quota_handle_multi_names(qp_copy,
				snmp_quota->sid, sizeof(snmp_quota->sid));
		} else if (qp_copy->disk_record->flags & QUOTA_SID) {
			DWORD tlen = sizeof(snmp_quota->sid);
			GetTextualSid((SID *) qp_copy->usersid, snmp_quota->sid, &tlen);
		} else {
			snmp_quota->sid[0] = 0;
		}
	}

	return true;

}

/* This is now deprecated, to be replaced by snmp_get_quota_at_index() */
/*
 * This manages the snmp_Quota cache.  If the cache contains data for
 * the given volno and index, the data is returned in snmp_Quota without
 * calling wafl_get_quota_by_index.  Note, the "vol" value should
 * not be saved in the cache - because it may not be valid later.
 *
 * It is possible (when called from var_qrEntry) for the value of
 * volno to be 0, but index will always be 1 or more.  This is
 * important, because the initial value of snmp_qcache is all zeros,
 * and that must be an invalid cache entry that always gets filled.
 */
static snmp_Quota *
snmp_get_quota_by_index(int volno, int index, wafl_Volume *vol)
{
	wafl_Quota	*qp_copy;
	time32_t		now;

	now = ontap_time();

	if (snmp_qcache.volno == volno && snmp_qcache.index == index
		&& (now - snmp_qcache.secs) < SNMP_QUOTA_STALENESS) {

		D(snmp,1,("snmp: using cache for quota vol=%d index=%d\n",volno,index));

		/*
		 * Cache is okay, use it.  It's possible that
		 * the cached value is "not found".
		 */
		if (!snmp_qcache.found)
			return NULL;
		else
			return &snmp_qcache;
	}
	/*
	 *  SNMP indexes starting at 1; WAFL starts at 0.
	 *
	 *  SNMP_QUOTA_ALL_VOLUMES is a special sentinel value (zero) to
	 *  indicate that "index" is a global index across all volumes rather
	 *  than for a single volume. This is to support the deprecated
	 *  var_qrEntry interface.
	 */
	qp_copy = wafl_get_quota_copy_by_index(
		volno == SNMP_QUOTA_ALL_VOLUMES ? NULL : vol, index-1);

	if (qp_copy == NULL)
		return NULL;

	/*
	 * No matter what, record the time and whether or not
	 * the quota was found.
	 */
	snmp_qcache.secs = now;
	snmp_qcache.found = (qp_copy !=NULL);
	snmp_qcache.volno = volno;
	snmp_qcache.index = index;

	if (!snmp_qcache.found) {
		wafl_free_quota_copy(qp_copy);
		return NULL;
	}

	if (!snmp_convert_quota(qp_copy, &snmp_qcache, vol, -1)) {
		wafl_free_quota_copy(qp_copy);
		return NULL;
	}

	wafl_free_quota_copy(qp_copy);
	return &snmp_qcache;
}

/*
 * This interface is used by the var_qrV2Enty to obtain
 * quota information at a given index from wafl.
 *
 * type - specifies the SNMP "magic".
 * indexp - refers to the index of the requested index.
 * if the quota_record_status_t is "skip" the indexp will
 * get updated to quota index for the next valid record that is being returned.
 *
 * This function returns one of the following 
 *   QUOTA_RECORD_ERROR - error obtaining the requested record.
 *	 QUOTA_RECORD_OK - everything is fine.
 *	 QUOTA_RECORD_SKIP - record at given index is not valid, but a valid
 *	 record has been found at a later index.
 *	 QUOTA_RECORD_EOF - There are no more quota entries in the DB.
 */


static quota_record_status_t
snmp_get_quota_record_at_index(int type, 
			       wafl_Volume *vol, 
			       snmp_Quota **qpp, 
			       int *indexp)
{
	wafl_Quota	*qp_copy = NULL;
	time32_t		now;
	quota_record_status_t status = 0;
	int qp_index = -1;

	now = ontap_time();
	*qpp = NULL;

	/*
	 *  SNMP indexes starting at 1; WAFL starts at 0.
	 *
	 */
	status = wafl_get_quota_record_at_index(vol, (*indexp)-1, 
				&qp_index, &qp_copy);
	if ((status != QUOTA_RECORD_OK) &&
	    (status != QUOTA_RECORD_SKIP)) {
		return status;
	}	    

	/*
	 * No matter what, record the time and whether or not
	 * the quota was found.
	 */
	bzero(&snmp_qcache_local, sizeof(snmp_qcache_local));
	snmp_qcache_local.secs = now;
	snmp_qcache_local.found = true;
	snmp_qcache_local.index = qp_index + 1;

	if (!snmp_convert_quota(qp_copy, &snmp_qcache_local, vol, type)) {
		wafl_free_quota_copy(qp_copy);
		return QUOTA_RECORD_ERROR;
	}

	wafl_free_quota_copy(qp_copy);
	*qpp = &snmp_qcache_local;
	*indexp = snmp_qcache_local.index;
	return status;
}

/* var_qrVEntry should be used instead. */
/* format is .1.3.6.1.4.1.789.1.4.3.1.magic.index */
uint8_t *
var_qrEntry(SNMP_FM_ARGS)
{
        snmp_Quota     *qp;
        char           *cp;
	int             count;

	wafl_quota_stats_inc_calls(WQS_CALLS_VAR_QRENTRY);
        wafl_Volume *vol = wafl_root_volume();  /* XXX */

        if (vol->wvq_vqowner->wvqi_quota_state != WAFL_QUOTA_ON ) {
            ERROR("var_qrEntry: quota_state 1");
            return ( NULL );
        }
	count = wafl_quota_total();
	if (count == 0) {
		return NULL;
	}
	HEADER_SIMPLE_TABLE(count);

	qp = snmp_get_quota_by_index(SNMP_QUOTA_ALL_VOLUMES, NAME_INDEX, vol);
        if (qp == NULL) {
            return ( NULL );
	}

        switch (vp->magic) {
        /* ------------------------------------ */
        case QRINDEX:
                long_return = NAME_INDEX;
                return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRTYPE:
                switch( qp->type ) {
                /* ============================ */
                case WAFL_QTYPE_USER:
		case WAFL_QTYPE_MULTI_USER_BASE:
                        long_return = QRTYPEUSER;
                        break;
                /* ============================ */
                case WAFL_QTYPE_GROUP:
                        long_return = QRTYPEGROUP;
                        break;
                /* ============================ */
                case WAFL_QTYPE_TREE:
                        long_return = QRTYPETREE;
                        break;
                /* ============================ */
                default:
                        long_return = QRTYPEUNK;
                        break;
                /* ============================ */
                }
                return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRID:
		/*
		 * If multi user base record, or the id is a SID,
		 * return a -1 as the user id.
		 */
		if (qp->type == WAFL_QTYPE_MULTI_USER_BASE ||
		    qp->flags & QUOTA_SID) {
			long_return = -1;
		} else {
			long_return = qp->id;
		}
                return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRKBYTESUSED:
                long_return = ((qp->blocks_used + qp->nosync_blocks_used) *
				KB_PER_BLK);
                return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRKBYTESLIMIT:
		if (qp->flags & QUOTA_BLOCKS_UNLIMITED)
			long_return = -1;
		else
			long_return = (qp->block_limit * KB_PER_BLK);
                return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRFILESUSED:
                long_return = qp->files_used;
                return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRFILELIMIT:
		if (qp->flags & QUOTA_FILES_UNLIMITED)
			long_return = -1;
		else
			long_return = qp->file_limit;
		return (uint8_t *) & long_return;
        /* ------------------------------------ */
        case QRPATHNAME:
		cp = qp->path;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
        /* ------------------------------------ */
        default:
                ERROR("var_qrEntry: magic 3");
        /* ------------------------------------ */
        }
        return ( NULL );
}

/* 
 * var_qrV2Entry should be used instead.
 * If you modify any of the entries below you will
 * need to modify the corresponding var_qrV2Entry 
 */
/* format is .1.3.6.1.4.1.789.1.4.5.1.magic.volume.index */
uint8_t *
var_qrVEntry(SNMP_FM_ARGS)
{
	oid             newname[SNMP_OID_MAX];
	int		index=0;
	int             result;
	snmp_Quota     *qp;
	char	       *cp;
	wafl_Volume    *vol = NULL;
	int             done = 0;
	void           *cookie;
	int             volno = 0, volctr;

	wafl_quota_stats_inc_calls(WQS_CALLS_VAR_QRVENTRY);
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	if (vp->namelen > (sizeof(newname) / sizeof(newname[0]))) {
		// We're passing in an OID which is way too long
		// for the data we have.
		ASSERT(vp->namelen <= (sizeof(newname) / sizeof(newname[0])));
		return NULL;
	}

	memmove(newname, vp->name, vp->namelen * sizeof(oid));

	if (*length >= 14) {
		volno = name[12];
	} else
		newname[12] = volno = 1;

	cookie = NULL;
	for ( volctr = 1; ((!done) && (volctr<=volno)) ; volctr++ ) {
		int	count;

		vol = wafl_volume_iterator(&cookie, 
					   WIT_MOUNTED | WIT_HOST | WIT_FS);
		if (!vol) return NULL;
		if (volctr < volno) continue;
		
		/* Skip Primordial volumes */
	        if (WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
		        continue;
		}

		newname[12] = (oid) volctr;
		/*
		 * if quotas aren't in an acceptable state, we shouldn't
		 * display them for that volume.
		 */
		if (vol->wvq_vqowner->wvqi_quota_state != WAFL_QUOTA_ON) {
			volno++;
			name[13] = 0;
			continue;
		}

		count = wafl_quota_volume(vol);
		for (index = 0;
		     !done && index < count; ) {
			index++;
			newname[13] = (oid) index;
			result = compare(name, *length, 
					 newname, 14);
			done = ((exact && result == 0) || 
				(!exact && result < 0));
		}
		if ((!done) && (!exact)) {
			volno++;
			name[13] = 0;
		}
	}

	if (!done) return NULL;
	if (index < 1) {
		return NULL;
	}

	qp = snmp_get_quota_by_index(volno, index, vol);
	if (qp == NULL)
		return NULL;

	*length = 14;
	bcopy((char *) newname, (char *) name, (int) *length * sizeof(oid));
	*write_method = 0;
	*var_len = sizeof(int32_t);

	switch (vp->magic) {
	/* ------------------------------------ */
	case QRVINDEX:
		long_return = index;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVTYPE:
		switch( qp->type ) {
		/* ============================ */
		case WAFL_QTYPE_USER:
		case WAFL_QTYPE_MULTI_USER_BASE:
			long_return = QRVTYPEUSER;
			break;
		/* ============================ */
		case WAFL_QTYPE_GROUP:
			long_return = QRVTYPEGROUP;
			break;
		/* ============================ */
		case WAFL_QTYPE_TREE:
			long_return = QRVTYPETREE;
			break;
		/* ============================ */
		case WAFL_QTYPE_USER_DEFAULT:
			long_return = QRVTYPEUSERDEFAULT;
			break;
		/* ============================ */
		case WAFL_QTYPE_GROUP_DEFAULT:
			long_return = QRVTYPEGROUPDEFAULT;
			break;
		/* ============================ */
		default:
			long_return = QRVTYPEUNK;
			break;
		/* ============================ */
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVID:
		/*
		 * If multi user base record, or the id is a SID,
		 * return a -1 as the user id.
		 */
		if (qp->type == WAFL_QTYPE_MULTI_USER_BASE ||
		    qp->flags & QUOTA_SID) {
			long_return = -1;
		} else {
			long_return = qp->id;
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVKBYTESUSED:
		long_return = ((qp->blocks_used + qp->nosync_blocks_used) *
				KB_PER_BLK);
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVKBYTESLIMIT:
		if (qp->flags & QUOTA_BLOCKS_UNLIMITED)
			long_return = -1;
		else
			long_return = (qp->block_limit * KB_PER_BLK);
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVFILESUSED:
		long_return = qp->files_used;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVFILELIMIT:
		if (qp->flags & QUOTA_FILES_UNLIMITED)
			long_return = -1;
		else
			long_return = qp->file_limit;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVPATHNAME:
		cp = qp->path;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRVVOLUME:
		long_return = volno;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVTREE:
		cp = qp->tree;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRVIDTYPE:
		/*
		 * If multi user base record, or the id is a SID,
		 * indicate the QRVSID field contains the text form
		 * of the ID(s). Otherwise the QRVID field contains
		 * the numeric user ID or group ID.
		 */
		if (qp->type == WAFL_QTYPE_MULTI_USER_BASE ||
		    qp->flags & QUOTA_SID) {
			long_return = QRVSIDVALID;
		} else {
			long_return = QRVIDVALID;
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVSID:
		cp = qp->sid;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRVKBYTESTHRESHOLD:
		if (qp->flags & QUOTA_BLOCKS_NO_THRESHOLD)
			long_return = -1;
		else
			long_return = (qp->block_threshold * KB_PER_BLK);

		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVKBYTESLIMITSOFT:
		if (qp->flags & QUOTA_SOFT_BLOCKS_UNLIMITED)
			long_return = -1;
		else
			long_return = (qp->block_limit_soft * KB_PER_BLK);

		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRVFILELIMITSOFT:
		if (qp->flags & QUOTA_SOFT_FILES_UNLIMITED)
			long_return = -1;
		else
			long_return = qp->file_limit_soft;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	default:
		ERROR("var_qrVEntry: magic 1");
	/* ------------------------------------ */
	}
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.4.6.1.magic.volume.index */
uint8_t *
var_qrV2Entry(SNMP_FM_ARGS)
{
	oid             newname[SNMP_OID_MAX];
	int		index;
	int             result;
	snmp_Quota     *qp;
	char	       *cp;
	wafl_Volume    *vol = NULL;
	quota_record_status_t quotaStatus = QUOTA_RECORD_ERROR;
	void           *cookie = NULL;
	int             volno;
	int             volctr;
	uint64_t        counter64 = 0;
	static char     Name[MAX_VAL_LENGTH];

	wafl_quota_stats_inc_calls(WQS_CALLS_VAR_QRV2ENTRY);
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	if (*length >= 13 && name[12] != 0)  {
		volno = name[12];
	} else
		volno = name[12] = 1;

	if (*length >= 14) {
		index = name[13];
	} else
		index = name[13] = 0;

	if (exact) {
		if (index <= 0)
			return NULL;
		for (volctr = 1; volctr <= volno; volctr++) {
			vol = wafl_volume_iterator (&cookie, WIT_MOUNTED | WIT_HOST | WIT_FS);
			if (!vol)
				return NULL;
		}
		
		/* Skip Primordial volumes */
	        if (WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
		        return NULL;
		}

		if (vol->wvq_vqowner->wvqi_quota_state != WAFL_QUOTA_ON) 
			return NULL;
		
		qp = NULL;
		quotaStatus = snmp_get_quota_record_at_index(vp->magic, vol, 
							     &qp, 
							     &index);
		/* 
		 * snmp_get_quota_record_at_index finds the first available
		 * quota at or after a specific index. Since this is exact,
		 * expect that index still equals name[13].
		 */
		
		if (quotaStatus != QUOTA_RECORD_OK || index != name[13]) {
			return NULL;
		}

		goto magic;
	}
	
	/*
	 * Entering the getnext code. Start looking at current volume, but
	 * quota after the current one.
	 */
	if (vp->namelen > (sizeof(newname) / sizeof(newname[0]))) {
		// We're passing in an OID which is way too long
		// for the data we have.
		ASSERT(vp->namelen <= (sizeof(newname) / sizeof(newname[0])));
		return NULL;
	}
	memmove(newname, vp->name, *length * sizeof(oid));

	/*
	 * check whether we have wrapped around on the index. If the index has
	 * wrapped around, it means we have reached the theoretical last value
	 * for index. So, time to move onto the next volume.
	 */
	index++;
	if (index <= 0) {
		volno++;
		index = 1;
	}
	for (volctr = 1; volctr <= volno; volctr++) {
		vol = wafl_volume_iterator(&cookie, WIT_MOUNTED | WIT_HOST | WIT_FS);
		if (!vol) 
			return NULL;
	
		if (volctr < volno)
			continue;

		/* Skip Primordial volumes */
	        if (WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
		        continue;
		}

		if (vol->wvq_vqowner->wvqi_quota_state != WAFL_QUOTA_ON) {
			volno++;
			index = 1;
			continue;
		}
		
		newname[12] = (oid) volctr;
		newname[13] = (oid) index;
		result = compare(name, *length, newname, 14);

		ASSERT (result < 0); 
		if (result >= 0)
			return NULL;

		qp = NULL;
		quotaStatus = snmp_get_quota_record_at_index(vp->magic, vol, &qp, 
							&index);

		if (quotaStatus == QUOTA_RECORD_OK) {
			break;
		} else if (quotaStatus == QUOTA_RECORD_SKIP && index > 0) {
			newname[13] = (oid) index;
			break;
		} else if (quotaStatus == QUOTA_RECORD_EOF) {
			volno++;
			index = 1;
		} else { /* (quotaStatus == QUOTA_RECORD_ERROR || index <= 0)*/
			return NULL;
		}
	}

	if (volctr > volno)
		return NULL;

	*length = 14;
	bcopy((char *) newname, (char *) name, (int) *length * sizeof(oid));

  magic:
	ASSERT(qp != NULL);
	if (qp == NULL)
		return NULL;

	*write_method = 0;
	*var_len = sizeof(int32_t);

	switch (vp->magic) {
	/* ------------------------------------ */
	case QRV2INDEX:
		long_return = index;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2TYPE:
		switch( qp->type ) {
		/* ============================ */
		case WAFL_QTYPE_USER:
		case WAFL_QTYPE_MULTI_USER_BASE:
			long_return = QRVTYPEUSER;
			break;
		/* ============================ */
		case WAFL_QTYPE_GROUP:
			long_return = QRVTYPEGROUP;
			break;
		/* ============================ */
		case WAFL_QTYPE_TREE:
			long_return = QRVTYPETREE;
			break;
		/* ============================ */
		case WAFL_QTYPE_USER_DEFAULT:
			long_return = QRVTYPEUSERDEFAULT;
			break;
		/* ============================ */
		case WAFL_QTYPE_GROUP_DEFAULT:
			long_return = QRVTYPEGROUPDEFAULT;
			break;
		/* ============================ */
		case WAFL_QTYPE_TREE_DEFAULT:
			long_return = QRVTYPETREEDEFAULT;
			break;
		/* ============================ */
		default:
			long_return = QRVTYPEUNK;
			break;
		/* ============================ */
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2ID:
		/*
		 * If multi user base record, or the id is a SID,
		 * return a -1 as the user id.
		 */
		if (qp->type == WAFL_QTYPE_MULTI_USER_BASE ||
		    qp->flags & QUOTA_SID) {
			long_return = -1;
		} else {
			long_return = qp->id;
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2HIGHKBYTESUSED:
		counter64 = ((uint64_t)qp->blocks_used + 
			      (uint64_t)qp->nosync_blocks_used) *
				(uint64_t)KB_PER_BLK;
		long_return = HIGH32(counter64);
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2LOWKBYTESUSED:
		counter64 = ((uint64_t)qp->blocks_used + 
			      (uint64_t)qp->nosync_blocks_used) *
				(uint64_t)KB_PER_BLK;
		long_return = LOW32(counter64);
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV264KBYTESUSED:
		counter64 = ((uint64_t)qp->blocks_used + 
			      (uint64_t)qp->nosync_blocks_used) *
				(uint64_t)KB_PER_BLK;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	/* ------------------------------------ */
	case QRV2QUOTAUNLIMITED:
		if (qp->flags & QUOTA_BLOCKS_UNLIMITED)
			long_return = 2;
		else
			long_return = 1;
		return (uint8_t *) & long_return;
		
	/* ------------------------------------ */
	case QRV2HIGHKBYTESLIMIT:
		if (qp->flags & QUOTA_BLOCKS_UNLIMITED) {
			long_return = 0;
		} else {
			
			counter64 = ((uint64_t)qp->block_limit * 
				     (uint64_t)KB_PER_BLK);
			long_return = HIGH32(counter64);
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2LOWKBYTESLIMIT:
		if (qp->flags & QUOTA_BLOCKS_UNLIMITED) {
			long_return = 0;
		} else {
			counter64 = ((uint64_t)qp->block_limit * 
				     (uint64_t)KB_PER_BLK);
			long_return = LOW32(counter64);
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV264KBYTESLIMIT:
		if (!(qp->flags & QUOTA_BLOCKS_UNLIMITED)) {
			counter64 = ((uint64_t)qp->block_limit * 
				     (uint64_t)KB_PER_BLK);
		}
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	/* ------------------------------------ */
	case QRV2FILESUSED:
		long_return = qp->files_used;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2FILEQUOTAUNLIMITED:
		if (qp->flags & QUOTA_FILES_UNLIMITED)
			long_return = 2;
		else
			long_return = 1;
		return (uint8_t *) & long_return;
		
	/* ------------------------------------ */
	case QRV2FILELIMIT:
		if (qp->flags & QUOTA_FILES_UNLIMITED)
			long_return = 0;
		else
			long_return = qp->file_limit;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2PATHNAME:
		cp = qp->path;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRV2VOLUME:
		long_return = volno;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2TREE:
		cp = qp->tree;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRV2IDTYPE:
		/*
		 * If multi user base record, or the id is a SID,
		 * indicate the QRVSID field contains the text form
		 * of the ID(s). Otherwise the QRVID field contains
		 * the numeric user ID or group ID.
		 */
		if (qp->type == WAFL_QTYPE_MULTI_USER_BASE ||
		    qp->flags & QUOTA_SID) {
			long_return = QRVSIDVALID;
		} else {
			long_return = QRVIDVALID;
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2SID:
		cp = qp->sid;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRV2THRESHOLDUNLIMITED:
		if (qp->flags & QUOTA_BLOCKS_NO_THRESHOLD)
			long_return = 2;
		else
			long_return = 1;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2HIGHKBYTESTHRESHOLD:
		if (qp->flags & QUOTA_BLOCKS_NO_THRESHOLD) {
			long_return = 0;
		} else {
			counter64 = ((uint64_t)qp->block_threshold * 
				     (uint64_t)KB_PER_BLK);
			long_return = HIGH32(counter64);
		}

		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2LOWKBYTESTHRESHOLD:
		if (qp->flags & QUOTA_BLOCKS_NO_THRESHOLD) {
			long_return = 0;
		} else {
			counter64 = ((uint64_t)qp->block_threshold * 
				     (uint64_t)KB_PER_BLK);
			long_return = LOW32(counter64);
		}

		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV264KBYTESTHRESHOLD:
		if (!(qp->flags & QUOTA_BLOCKS_NO_THRESHOLD)) {
			counter64 = ((uint64_t)qp->block_threshold * 
				     (uint64_t)KB_PER_BLK);
		}
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	/* ------------------------------------ */
	case QRV2SOFTQUOTAUNLIMITED:
		if (qp->flags & QUOTA_SOFT_BLOCKS_UNLIMITED)
			long_return = 2;
		else
			long_return = 1;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2HIGHKBYTESSOFTLIMIT:
		if (qp->flags & QUOTA_SOFT_BLOCKS_UNLIMITED) {
			long_return = 0;
		} else {
			counter64 = ((uint64_t)qp->block_limit_soft * 
				     (uint64_t)KB_PER_BLK);
			long_return = HIGH32(counter64);
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2LOWKBYTESSOFTLIMIT:
		if (qp->flags & QUOTA_SOFT_BLOCKS_UNLIMITED) {
			long_return = 0;
		} else {
			counter64 = ((uint64_t)qp->block_limit_soft * 
				     (uint64_t)KB_PER_BLK);
			long_return = LOW32(counter64);
		}
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV264KBYTESSOFTLIMIT:
		if (!(qp->flags & QUOTA_SOFT_BLOCKS_UNLIMITED)) {
			counter64 = ((uint64_t)qp->block_limit_soft * 
				     (uint64_t)KB_PER_BLK);
		}
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	/* ------------------------------------ */
	case QRV2SOFTFILEQUOTAUNLIMITED:
		if (qp->flags & QUOTA_SOFT_FILES_UNLIMITED)
			long_return = 2;
		else
			long_return = 1;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2SOFTFILELIMIT:
		if (qp->flags & QUOTA_SOFT_FILES_UNLIMITED)
			long_return = 0;
		else
			long_return = qp->file_limit_soft;
		return (uint8_t *) & long_return;
	/* ------------------------------------ */
	case QRV2VOLUMENAME:
		strncpy_safe(Name, WVOL_NAME(vol), MAX_VAL_LENGTH);
		cp = Name;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	case QRV2VSERVER:
		if (WAFL_VOL_10_MODE(vol)) {
			char printable_uuid[VVOL_UUID_STRING_CHARS];
			uuid_to_string_noalloc(
				&(vol->wvvv_info->vvi_raid->
					vvrd_owning_vserver_uuid),
				printable_uuid, 
				sizeof(printable_uuid));
			snprintf(Name, MAX_VAL_LENGTH, "%s", printable_uuid);
		} else {
			strncpy_safe(Name, "N/A", MAX_VAL_LENGTH);
		}
		cp = Name;      
                *var_len = strlen(cp);
		return (uint8_t *) cp;
	/* ------------------------------------ */
	default:
		ERROR("var_qrV2Entry: magic 1");
	/* ------------------------------------ */
	}
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.4.4.1.magic.index */
uint8_t *
var_qvStateEntry(SNMP_FM_ARGS)
{
	int		index;
	static char     Name[MAX_VAL_LENGTH];
	char	       *cp;
	wafl_Volume    *vol;
	void           *cookie = NULL;
	uint8_t	       *rval = NULL;
	int             count = wafl_host_volume_cnt();

	wafl_quota_stats_inc_calls(WQS_CALLS_VAR_QVSTATEENTRY);
	if (count == 0) {
		return NULL;
	}
	HEADER_SIMPLE_TABLE(count);

	index = 1;
	while ((vol = wafl_volume_iterator(&cookie,
					   WIT_MOUNTED | WIT_HOST | WIT_FS)) 
			!= NULL){
		if (index == NAME_INDEX) {
			break;
		}
		index ++;
	}

	if (!vol) {
		return NULL;
	}

	switch (vp->magic) {
	/* ------------------------------------ */
	case QVSTATEVOLUME:
		long_return = index;
		rval = (uint8_t *) & long_return;
		break;
	/* ------------------------------------ */
	case QVSTATENAME:
		strcpy(Name, WVOL_NAME(vol));
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *) cp;
		break;
	/* ------------------------------------ */
	case QVSTATEVSERVER:
		if (WAFL_VOL_10_MODE(vol)) {
			char printable_uuid[VVOL_UUID_STRING_CHARS];
			uuid_to_string_noalloc(
				&(vol->wvvv_info->vvi_raid->
					vvrd_owning_vserver_uuid),
				printable_uuid,
				sizeof(printable_uuid));
			snprintf(Name, MAX_VAL_LENGTH, "%s", printable_uuid);
		} else {
			strncpy_safe(Name, "N/A", MAX_VAL_LENGTH);
		}

		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *) cp;
		break;
	/* ------------------------------------ */
	case QVSTATESTAT:
	    if (VOL_QUOTA_IS_CORRUPT(vol->wvq_vqowner)) {
	    	long_return = QUOTASTATECORRUPT;
	    } else {
    	        switch (vol->wvq_vqowner->wvqi_quota_state) {
    	        /* ========= */
	        case WAFL_QUOTA_ON:
		    long_return = QUOTASTATEON;
		    break;
		    /* ========= */
  	        case WAFL_QUOTA_OFF:
		    long_return = QUOTASTATEOFF;
		    break;
	    	    /* ========= */
	    	case WAFL_QUOTA_INIT:
		    long_return = QUOTASTATEINIT;
    		    break;
	    	    /* ========= */
	        default:
		    ERROR("var_quota: QVSTATESTATE 1");
	    	    return NULL;
	        /* ========= */
		}
	    }
	    rval = (uint8_t *) & long_return;
	    break;
	/* ----------------------------- */
	case QVSTATEINITPERCENT:
	    long_return =
		(vol->wvq_vqowner->wvqi_quota_state == WAFL_QUOTA_INIT) ?
		      (percent(QUOTA_INIT_TOTAL_PROCESSED(vol->wvq_vqowner, vol),
		                  WAFL_VOL_INOS_TOTAL(vol))) : 0;
	    rval = (uint8_t *) & long_return;
	/* ----------------------------- */
	default:
		ERROR("var_qvStateEntry: magic 3");
	/* ------------------------------------ */
	}
	return rval;
}

/*
 *  Count all aggregates, including offline and partner
 *  aggregates.  This must use the same algorithm as
 *  var_aggrEntry().
 */
static int
snmp_aggregate_cnt(void)
{
	int			count = 0;
	config_attr_obj_t *	vol;
	raid_config_iter_t *	volIter;

	if (!raid_config_iterator_create(&volIter, RAIDTYPE_VOL)) {
		return 0;
	}

	while ((vol = raid_config_iterator_next(volIter)) != NULL) {
		count++;
	}
	raid_config_iterator_destroy(volIter);
	return count;
}

/*
 *  Count all volumes, including offline and partner
 *  volumes.  This must use the same algorithm as
 *  var_volEntry().
 */
static int
snmp_volume_cnt(void)
{
	int count = 0;
	vdb_iter_t vdb_cookie;
	vdb_handle_t vdb;

	for (vdb = vdb_iter_first(&vdb_cookie, VDB_ITER_TYPE_FS);
	     !vdb_is_null(vdb);
	     vdb = vdb_iter_next(&vdb_cookie)) {
		count++;
	}
	vdb_iter_done(&vdb_cookie);
	return count;
}

/* Count all the online aggregates and volumes on the system. */
static int
snmp_host_online_vol_aggr_cnt(void)
{
        int count = 0;
        void    *cookie = NULL;
        while (wafl_volume_iterator(&cookie, WIT_HOST) != NULL) {
                count++;
        }
        return count;
}

/* format is .1.3.6.1.4.1.789.1.5.magic.0 */
uint8_t *
var_filesys(SNMP_FM_ARGS)
{
	wafl_Volume *vol = wafl_root_volume();	
	/* for deprecated oids here */
	
	HEADER_GENERIC;

	switch ( vp->magic ) {
	/* ----------------------------- */
	case FILESYSMAXFILESAVAIL:
	    long_return = wafl_get_inofile_counts(vol, WAFL_INODE_PUBLIC,
	                                          INOFILE_CUR_COUNT);
	    return (uint8_t *) & long_return;
	/* ----------------------------- */
	case FILESYSMAXFILESUSED:
	    long_return = wafl_get_inofile_counts(vol, WAFL_INODE_PUBLIC,
	                                          INOFILE_USED);
	    return (uint8_t *) & long_return;
	/* ----------------------------- */
	case FILESYSMAXFILESPOSSIBLE:
	    long_return = wafl_get_inofile_counts(vol, WAFL_INODE_PUBLIC,
	                                          INOFILE_MAX_COUNT);
	    return (uint8_t *) & long_return;
	/* ----------------------------- */
	case DFNUMBER:
	    /*
	     *  There's a dfEntry for each volume, plus one for each
	     *  volume's snapshot area, so we multiply by 2.
	     */
	    long_return = snmp_host_online_vol_aggr_cnt() * 2;
	    return (uint8_t *) & long_return;

	/* ----------------------------- */
	case VOLNUMBER:
		long_return = snmp_volume_cnt();
		return (uint8_t *) & long_return;
		break;
	/* ----------------------------- */
	case AGGRNUMBER:
		long_return = snmp_aggregate_cnt();
		return (uint8_t *) & long_return;
		break;
	/* ----------------------------- */
	default:
	    ERROR("var_fs");
	    break;
	/* ----------------------------- */
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.5.7.magic.0 */
uint8_t *
var_fsStatus(SNMP_FM_ARGS)
{
	static char	fs_status[ SNMP_FS_STATUS_MESSAGE_LEN ];
	char *		fs_status_ptr = fs_status;
	int		fs_status_len = SNMP_FS_STATUS_MESSAGE_LEN;

	snmp_volume_status_t status;

	HEADER_GENERIC;

	switch ( vp->magic ) {
	/* ----------------------------- */
	case FSOVERALLSTATUS: {
	    status = snmp_check_for_full_volumes(VolumeNearlyFull,
			sk_gethost(), 0, 0, 0, 0, 0, 0, NULL);

	    /*
	     *  We assume the volume status values will match
	     *  the MIB.  See snmp_vars.h.
	     */
	    long_return = status;
	    return (uint8_t *) & long_return;
	}
	/* ----------------------------- */
	case FSSTATUSMESSAGE: {
	    fs_status[0] = 0;
	    status = snmp_check_for_full_volumes(VolumeNearlyFull,
			sk_gethost(), & fs_status_ptr, &fs_status_len, 0, 0, 0, 0, NULL);

	    if (VolumeOk == status) {
		    *var_len = snprintf(fs_status, fs_status_len,
			"All volumes have adequate space.\n");
	    }
	    else {
		    *var_len = strlen(fs_status);
	    }
	    return (uint8_t *) fs_status;
	}
	/* ----------------------------- */
	case FSMAXUSEDBYTESPERCENT:
	    (void) snmp_check_for_full_volumes(VolumeNearlyFull,
			sk_gethost(), 0, 0, & long_return, 0, 0, 0, NULL);
	    return (uint8_t *) & long_return;
	/* ----------------------------- */
	case FSMAXUSEDINODESPERCENT:
	    (void) snmp_check_for_full_volumes(VolumeNearlyFull,
			sk_gethost(), 0, 0, 0, & long_return, 0, 0, NULL);
	    return (uint8_t *) & long_return;
	/* ----------------------------- */
	default:
	    ERROR("var_fsStatus");
	    break;
	/* ----------------------------- */
	}

	return( NULL );
}

/*
 * Get a RAIDv2 volume by name
 */
static int
get_vol(const char *volname,config_attr_obj_t *caoOut)
{
	raid_config_iter_t *rci;
	config_attr_obj_t *cao;
	int result = false;
	int host;

	if (!raid_config_iterator_create(&rci, RAIDTYPE_VOL)) {
		return false;
	}

	host = sk_gethost();
	while ((cao = raid_config_iterator_next(rci)) != NULL) {
		if ((host == cao->cao_vol.cav_host) &&
		    (strcmp(cao->cao_vol.cav_name,volname) == 0)) {
			memcpy(caoOut,cao,sizeof(config_attr_obj_t));
			result = true;
			break;
		}
	}

	raid_config_iterator_destroy(rci);
	return result;
}


/*
 *  If we can report the given vol, fill in file handle and attributes, and
 *  return a volref. If not, return NULL, and *fh_out and *f_attr_out are
 *  unreliable. If snapshot is true, get the volref/handle/attributes of
 *  the snapshot rather than the vol.
 */
static wafl_Volref*
check_vol(wafl_Volume *vol, 
	wafl_File_handle *fh_out, 
	wafl_Fs_attr *f_attr_out, 
	oldBool snapshot)
{
	wafl_Volref *vref = wafl_volref_quiesced(vol, "snmp var_df");
	char pn[sizeof("/vol//.snapshot") + MAX_VOLNAME_LEN + 1];
	
	if (!vref) {
		return NULL;
	}

	snprintf(pn, sizeof(pn), "/vol/%s/.snapshot", WVOL_NAME(vol));
	*fh_out = fio_getfh_snap_quiesced_vol(WAFL_VOL_BASE(vol) ? 
				WIT_RAID : WIT_FS, pn, NULL, false);
	if (fhzero(*fh_out)) {
		goto fail;
	}

	if (!snapshot) {
		*fh_out = fio_getfh_root_for_quiesced_vol(WAFL_VOL_BASE(vol) ? WIT_RAID : WIT_FS, 
					WVOL_NAME(vol));
		if (fhzero(*fh_out)) {
			goto fail;
		}
	}

	*f_attr_out = fio_statfs_fh_for_quiesced_vol(*fh_out, true);
	if (f_attr_out->blocks == -1) {
		goto fail;
	}

	/* Success. */
	return vref;

fail:
	wafl_volref_destroy(vref);
	return NULL;
}


/* format is .1.3.6.1.4.1.789.1.5.4.1.magic.index */
uint8_t *
var_dfEntry(SNMP_FM_ARGS)
{
	int		index;
	static char     Name[MAX_VAL_LENGTH];
	char            path[MAXPATHLEN];
	wafl_Fs_attr    f_attr;
	wafl_eff_stats sis_stats;
	wafl_Share_stats *s_stats;
	blks_t		bused;
	char	       *cp;
	void           *cookie = NULL;
	wafl_Volume    *vol = NULL;
	int64_t		counter64;
	wafl_Volref    *vref;
	uint8_t	       *rval;
	bool            snapshot_line = false;
	bool            sis_valid = false;
	wafl_File_handle fh;

	HEADER_SIMPLE_TABLE(20000);

	/*
	 * Note: var_plexEntry() uses wafl_volume_iterator() to determine
	 * volume indices.  If this routine uses a different iterator, 
	 * var_plexEntry() should be updated too (see PLEXVOL). 
	 *
	 * Each volume gets two arcs under dfFileSys: one for the volume and
	 * one for the snapshot directory. The volume's arc is always an
	 * odd number, and the corresponding snapshot arc is larger by one.
	 *
	 * We assign the arcs, starting with 1, in whatever order our iterator
	 * returns the volumes. If we cannot get a filehandle on the snapshot,
	 * we skip the volume and snapshot, and leave the possible OID's 
	 * unassigned (burt 254058).
	 *
	 * XXX: The OIDs of volumes are unstable.
	 */

	index = 0;
	while ((vol = wafl_volume_iterator(&cookie, WIT_HOST)) != NULL) {

		index = (index + 1) | 1;    /* Next odd number. */

		if (index + 1 < NAME_INDEX) {
			continue;
		}

		if (index >= NAME_INDEX)
		{
			/* Report the volume. */
			vref = check_vol(vol, &fh, &f_attr, false);
		} else {
			/* Report the snapshot. */
			++index;
			vref = check_vol(vol, &fh, &f_attr, true);
		}

		if (vref) {
			break;
		} else if (exact) {
			return NULL;
		}
	}
	if (vol == NULL) {
		return NULL;
	}

	ASSERT(vref && (!exact || index == NAME_INDEX));
	NAME_INDEX = index;

	wafl_efficiency_stats(vol, &sis_stats, false);
	s_stats = &sis_stats.share_stats;

	/* Volume or aggregate ? */
	if (WAFL_VOL_BASE(vol)) {
		/* flexible or traditional volume */
		sprintf(path, "%s", WVOL_NAME(vol));
	} else {
		/* aggregate */
		sprintf(path, "/vol/%s/", WVOL_NAME(vol));
	}
	if (!(index % 2)) {
		if (WAFL_VOL_BASE(vol))
			strcat(path, "/");
		strcat(path, wafl_get_option(vol, WAFL_FSOPTIONS_NO_SNAPDIR) ?
		       ".." : ".snapshot");
		snapshot_line = true;
	}
	sis_valid = WAFL_VOL_FLEX(vol) && !snapshot_line;

	/*
	 * XXX - I'm not sure if it's possible for the fio_statfs above
	 * to fail (given that the path is constructed from a valid volume),
	 * but if it is, the code below should check for f_attr.blocks == -1.
	 */

	rval = (uint8_t *) & long_return;
	switch (vp->magic) {
	/* ---------------------------------------------------- */
	case DFINDEX:
	    long_return = index;
	    break;
	/* ---------------------------------------------------- */
	case DFKBYTESTOTAL:
	    long_return = f_attr.blocks * (f_attr.bsize / 1024);
	    break;
	/* ---------------------------------------------------- */
	case DFKBYTESUSED:
	    long_return = (f_attr.blocks - f_attr.bavail) *
			    (f_attr.bsize / 1024);
	    break;
	/* ---------------------------------------------------- */
	case DFKBYTESAVAIL:
	    long_return = (f_attr.bavail <= 0) ? 0 :
			   f_attr.bavail * (f_attr.bsize / 1024);
	    break;
	/* ---------------------------------------------------- */
	case DFPERCENTKBYTESCAPACITY:
	    long_return = (f_attr.blocks) ?
	    	( percent(
		    (f_attr.blocks - f_attr.bavail),
		     f_attr.blocks ) )
		: 0;
	    break;
	/* ---------------------------------------------------- */
	case DFINODESUSED:
	    long_return = (f_attr.inodes && !snapshot_line) ?
				(f_attr.inodes - f_attr.ifree) : 0;
	    break;
	/* ---------------------------------------------------- */
	case DFINODESFREE:
	    long_return = (f_attr.inodes && !snapshot_line) ?
				(f_attr.ifree) : 0;
	    break;
	/* ---------------------------------------------------- */
	case DFPERCENTINODECAPACITY:
	    long_return = (f_attr.inodes && !snapshot_line) ?
		( percent((f_attr.inodes - f_attr.ifree),
				f_attr.inodes) )
		: 0;
	    break;
	/* ---------------------------------------------------- */
	case DFFILESYS:
	case DFMOUNTEDON:
	    strcpy(Name, path);
	    cp = Name;
	    *var_len = strlen(cp);
	    rval = (uint8_t *) cp;
	    break;
	/* ---------------------------------------- */
	case DFMAXFILESAVAIL:
	    long_return = (!snapshot_line) ?
		wafl_get_inofile_counts(vol, WAFL_INODE_PUBLIC,
					INOFILE_CUR_COUNT)
		: 0;
	    break;
	/* ----------------------------- */
	case DFMAXFILESUSED:
	    long_return = (!snapshot_line) ?
	    	wafl_get_inofile_counts(vol, WAFL_INODE_PUBLIC,
					INOFILE_USED)
		: 0;
	    break;
	/* ----------------------------- */
	case DFMAXFILESPOSSIBLE:
	    long_return = (!snapshot_line) ?
	    	wafl_get_inofile_counts(vol, WAFL_INODE_PUBLIC,
					INOFILE_MAX_COUNT)
		: 0;
	    break;
	/* ----------------------------- */
	case DFHIGHTOTALKBYTES:
	    counter64 = (int64_t)f_attr.blocks * (f_attr.bsize / 1024);
	    long_return = HIGH32(counter64);
	    break;
	/* ----------------------------- */
	case DFLOWTOTALKBYTES:
	    counter64 = (int64_t)f_attr.blocks * (f_attr.bsize / 1024);
	    long_return = LOW32(counter64);
	    break;
	/* ----------------------------- */
	case DFHIGHUSEDKBYTES:
	    counter64 = (int64_t)(f_attr.blocks - f_attr.bvfree) *
			    (f_attr.bsize / 1024);
	    long_return = HIGH32(counter64);
	    break;
	/* ----------------------------- */
	case DFLOWUSEDKBYTES:
	    counter64 = (int64_t)(f_attr.blocks - f_attr.bvfree) *
			    (f_attr.bsize / 1024);
	    long_return = LOW32(counter64);
	    break;
	/* ----------------------------- */
	case DFHIGHAVAILKBYTES:
	    counter64 = (f_attr.bavail <= 0) ? 0 : 
			f_attr.bavail * (f_attr.bsize / 1024);
	    long_return = HIGH32(counter64);
	    break;
	/* ----------------------------- */
	case DFLOWAVAILKBYTES:
	    counter64 = (f_attr.bavail <= 0) ? 0 :
			f_attr.bavail * (f_attr.bsize / 1024);
	    long_return = LOW32(counter64);
	    break;
	/* ----------------------------- */
	case DFSTATUS:
	    /*
	     * See wafl_Mount_state in wafl/typedefs.h
		 * 
		 * Note that MIB enumerations must start at 1:
		 * see RFC 1155: 3.2.1.1.  Guidelines for Enumerated INTEGERs
	     */
	    long_return = vol->wv_mstate + 1;
	    break;
	/* ----------------------------- */
	case DFMIRRORSTATUS:
	    /*
	     * Get the RAIDv2 volume by name and display mirror status
	     *  
	     * See mirror_state_t in raidv2/mirror_fsm.h
		 * 
		 * Note that MIB enumerations must start at 1.
		 */
	    { 
		config_attr_obj_t cao;
		long_return = 1;
		if (get_vol(WVOL_NAME(vol),&cao)) { 
			long_return = cao.cao_vol.cav_mirror_state + 1; 
		} 
	    } 
	    break;
	/* ----------------------------- */
	case DFPLEXCOUNT:
	    /*
	     * Get the RAIDv2 volume by name and display the plex count 
	     */
	    { 
		config_attr_obj_t cao;
		long_return = 0;
		if (get_vol(WVOL_NAME(vol),&cao)) { 
			long_return = cao.cao_vol.cav_plex_count; 
		} 
	    } 
	    break;
	case DFTYPE:
	    /*
	     * Is this an aggregate or a volume.
	     */

	    long_return = WAFL_VOL_TRAD(vol) ? 1 : (WAFL_VOL_FLEX(vol) ? 2 : 3);
				
	    break;
	/* ----------------------------- */
	case DFHIGHSISSHAREDKBYTES:
	    if (sis_valid) {
		counter64 = (int64_t)s_stats->wss_shared_blocks *
					(f_attr.bsize / 1024);
		long_return = HIGH32(counter64);
	    } else {
		long_return = 0;
	    }
	    break;
	/* ----------------------------- */
	case DFLOWSISSHAREDKBYTES:
	    if (sis_valid) {
		counter64 = (int64_t)s_stats->wss_shared_blocks *
					(f_attr.bsize / 1024);
		long_return = LOW32(counter64);
	    } else {
		long_return = 0;
	    }
	    break;
	/* ----------------------------- */
	case DFHIGHSISSAVEDKBYTES:
	    if (sis_valid) {
		    /*TODO why is this cast to int64 */
		counter64 = (int64_t)sis_stats.blks_sis_saved *
					(f_attr.bsize / 1024);
		long_return = HIGH32(counter64);
	    } else {
		long_return = 0;
	    }
	    break;
	/* ----------------------------- */
	case DFLOWSISSAVEDKBYTES:
	    if (sis_valid) {
		counter64 = (int64_t)sis_stats.blks_sis_saved *
					(f_attr.bsize / 1024);
		long_return = LOW32(counter64);
	    } else {
		long_return = 0;
	    }
	    break;
	/* ----------------------------- */
	case DFPERCENTSAVED:
	    if (sis_valid) {
		bused = f_attr.blocks - f_attr.bvfree;
		long_return = ((uint64_t)bused + sis_stats.blks_sis_saved) ?
	    			percent(sis_stats.blks_sis_saved,
				        (uint64_t)bused + sis_stats.blks_sis_saved)
				: 0;
	    } else {
		long_return = 0;
	    }
	    break;
	/* ----------------------------- */
	case DF64TOTALKBYTES:
	    counter64 = (int64_t)f_attr.blocks * (f_attr.bsize / 1024);

	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DF64USEDKBYTES:
	    counter64 = (int64_t)(f_attr.blocks - f_attr.bvfree) *
			    (f_attr.bsize / 1024);

	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DF64AVAILKBYTES:
	    counter64 = (f_attr.bavail <= 0) ? 0 :
                        f_attr.bavail * (f_attr.bsize / 1024);

	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DF64SISSHAREDKBYTES:
	    if (sis_valid) {
		counter64 = (int64_t)s_stats->wss_shared_blocks *
					(f_attr.bsize / 1024);
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
	    } else {
		counter64_return.high = 0;
		counter64_return.low  = 0;
	    }
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DF64SISSAVEDKBYTES:
	    if (sis_valid) {
		counter64 = (int64_t)sis_stats.blks_sis_saved *
					(f_attr.bsize / 1024);
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
	    } else {
		counter64_return.high = 0;
		counter64_return.low  = 0;
	    }
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DF64COMPRESSSAVED:
	    if (sis_valid) {
		counter64 = (int64_t)f_attr.compress_saved_blks * KB_PER_BLK;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
	    } else {
		counter64_return.high = 0;
		counter64_return.low  = 0;
	    }
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DFCOMPRESSSAVEDPERCENT:
	    if (sis_valid) {
		bused = f_attr.blocks - f_attr.bvfree;
		if (bused > 0) {
			long_return = percent(f_attr.compress_saved_blks, 
					f_attr.compress_saved_blks + bused);
		} else {
			long_return = 0;
		}
	    } else {
		long_return = 0;
	    }
	    rval = (uint8_t *)&long_return;
	    break;
	/* ----------------------------- */
	case DF64DEDUPESAVED:
	    if (sis_valid) {
		counter64 = (int64_t)sis_stats.blks_sis_saved * KB_PER_BLK;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
	    } else {
		counter64_return.high = 0;
		counter64_return.low  = 0;
	    }
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DFDEDUPESAVEDPERCENT:
	    if (sis_valid) {
		bused = f_attr.blocks - f_attr.bvfree;
		if (bused > 0) {
			long_return = percent(sis_stats.blks_sis_saved, 
					sis_stats.blks_sis_saved + bused);
		} else {
			long_return = 0;
		}
	    } else {
		long_return = 0;
	    }
	    rval = (uint8_t *)&long_return;
	    break;
	/* ----------------------------- */
	case DF64TOTALSAVED:
	    if (sis_valid) {
		counter64 = (int64_t) ((sis_stats.blks_sis_saved + 
				      f_attr.compress_saved_blks) * KB_PER_BLK);
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
	    } else {
		counter64_return.high = 0;
		counter64_return.low  = 0;
	    }
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	case DFTOTALSAVEDPERCENT:
	    if (sis_valid) {
		bused = f_attr.blocks - f_attr.bvfree;
		if (bused > 0) {
			long_return = percent(sis_stats.blks_sis_saved + 
					f_attr.compress_saved_blks, 
					sis_stats.blks_sis_saved + 
					f_attr.compress_saved_blks + bused);
		} else {
			long_return = 0;
		}
	    } else {
		long_return = 0;
	    }
	    rval = (uint8_t *)&long_return;
	    break;
	/* ----------------------------- */
	case DF64TOTALRESERVEDKBYTES:
	    counter64 = (int64_t)f_attr.breserved * (f_attr.bsize / 1024);

	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    rval = (uint8_t *)&counter64_return;
	    break;
	/* ----------------------------- */
	default:
		ERROR("var_dfEntry: magic 2");
		rval = NULL;
		break;
	/* ---------------------------------------- */
	}
	wafl_volref_destroy(vref);
	return rval;
}

/* format is .1.3.6.1.4.1.789.1.23.magic.0 */
uint8_t *
var_sis(SNMP_FM_ARGS)
{
	HEADER_GENERIC;

	switch (vp->magic) {
	/* ------------------------------*/
	case SISISLICENSED:
		long_return = is_service_licensed(LICENSE_A_SIS) ? 2 : 1;
		break;
	/* ------------------------------*/
	default:
		ERROR("var_sis");
		return NULL;
	}

	return (uint8_t *)&long_return;
}

/*
 * Converts status values returned from
 * dense subsystem to corresponding SNMP
 * values.
 * The integers returned are from ontap/files/netapp.mib
 */ 
static int32_t denseStatus2SNMPStatus(int dense_status)
{
	int32_t ret=1;
	switch (dense_status) {
	case DENSE_STATUS_IDLE:
		ret = 1;
		break;
	case DENSE_STATUS_ACTIVE:
		ret = 2;
		break;
	case DENSE_STATUS_REVERTING:
		ret = 3;
		break;
	case DENSE_STATUS_PENDING:
		ret = 4;
		break;
	case DENSE_STATUS_INITIALIZING:
		ret = 5;
		break;
	case DENSE_STATUS_DOWNGRADING:
		ret = 6;
		break;
	case DENSE_STATUS_DISABLED:
		ret = 7;
		break;
	default:
		/* We should never get here */
		ret = 1;
		ASSERT(false);
		break;
	}
	return ret;
}

/* format is 1.3.6.1.4.1.789.1.23.2.1.magic.index */
uint8_t *
var_sisEntry(SNMP_FM_ARGS)
{
	int		 index;
	int64_t		 counter64;
	char *		 *path = NULL;
	dense_status_ext *status = NULL;
	dense_msg_data_t dmd;
	dense_error_t	 err;

	HEADER_SIMPLE_TABLE(10000);

	bzero(&dmd, sizeof(dense_msg_data_t));
	DENSE_MSG_SET_VFILER(&dmd);
	dmd.flags = DENSE_CMDOPT_LONG_FORMAT;
	dmd.arg = &path;
	err = dense_send_msg(DENSE_MSG_STATUS, &dmd, (void **)&status);
	if (err != DENSE_OK) {
		ERROR("var_sisEntry: err != DENSE_OK");
		return NULL;
	}

	index = 0;
	while (status[index].path[0] != '\0') {
		if (index+1 == NAME_INDEX) {
			break;
		}
		index++;
	}

	if (status[index].path[0] == '\0') {
		ERROR("var_sisEntry: status path = 0");
		sk_kmem_free(status);
		return NULL;
	}

	return_buf[0] = '\0';

	switch (vp->magic) {
	/* ------------------------------------------- */
	case SISINDEX:
		long_return = index + 1;
		break;
	/* ------------------------------------------- */
	case SISPATH:
		strlcpy(return_buf, status[index].path, sizeof(return_buf));
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISSTATE:
		long_return = status[index].status.state + 1;
		break;
	/* ------------------------------------------- */
	case SISSTATUS:
		long_return = denseStatus2SNMPStatus(status[index].status.op);
		break;
	/* ------------------------------------------- */
	case SISPROGRESS:
		ASSERT(MAX_VAL_LENGTH >= MAX_PROGRESS_LEN);
		dense_get_progress(&status[index], return_buf, false);
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISTYPE:
		long_return = status[index].status.type + 1;
		break;
	/* ------------------------------------------- */
	case SISSCHEDULE:
		strlcpy(return_buf, status[index].config.schedstr,
			sizeof(return_buf));
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISLASTOPSTATE:
		ASSERT(MAX_VAL_LENGTH > LAST_OP_STATE_BUFFER_LEN);
		get_last_op_state(status, return_buf);
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISLASTSUCCESSFULOPBEGINTIME:
		rpl_get_ctime_str(status[index].status.pstatus.
				last_success_start_time, return_buf);
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISLASTSUCCESSFULOPENDTIME:
		rpl_get_ctime_str(status[index].status.pstatus.
				last_success_end_time, return_buf);
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISLASTOPBEGINTIME:
		rpl_get_ctime_str(status[index].status.pstatus.last_start_time,
			return_buf);
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISLASTOPENDTIME:
		rpl_get_ctime_str(status[index].status.pstatus.last_end_time,
			return_buf);
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISHIGHLASTOPSIZE:
		counter64 = BLKS2KB(status[index].status.pstatus.last_blk_cnt);
		long_return = HIGH32(counter64);
		break;
	/* ------------------------------------------- */
	case SISLOWLASTOPSIZE:
		counter64 = BLKS2KB(status[index].status.pstatus.last_blk_cnt);
		long_return = LOW32(counter64);
		break;
	/* ------------------------------------------- */
	case SIS64LASTOPSIZE:
		counter64 = BLKS2KB(status[index].status.pstatus.last_blk_cnt);
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		sk_kmem_free(status);
		return (uint8_t *)&counter64_return;

	/* ------------------------------------------- */
	case SISLASTOPERROR:
		strlcpy(return_buf,
			status[index].status.current_error_id == DENSE_OK ? "-" :
				dense_error_str(status->status.current_error_id),
			sizeof(return_buf));
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* --------------------------------------------*/
	case SISISCOMPRESSIONENABLED:
		if (IS_OFFLINE_COMPRESSION_ENABLED(&status[index])) {
				long_return = 1;
		} else {
				long_return = 0;
		}
		break;
	/* --------------------------------------------*/
	case SISISINLINEENABLED:
		if (EXT_STATUS_ISINLINE_COMP_ENABLED(&status[index])) {
				long_return = 1;
		} else {
				long_return = 0;
		}
		break;
	/* ------------------------------------------- */
	case SISMINBLOCKSSHARED:
		long_return = status[index].status.pstatus.min_block_share;
		break;
	/* ------------------------------------------- */
	case SISBLOCKSSKIPPEDSHARING:
		long_return = status[index].status.shared_blks_less_than_min;
		break;
	/* ------------------------------------------- */
	case SISCHANGELOGUSEDPERCENT:
		long_return = status[index].status.clog_percent_full;
		break;
	/* ------------------------------------------- */
	case SISROWAVAILABLE:
		/*
		 * This is available only for cluster interfaces. Handling this
		 * so that it does not appear like we are missing something.
		 */
		sk_kmem_free(status);
		return NULL;
	/* ------------------------------------------- */
	case SISPOLICY:
		/*
		 * This is available only for cluster interfaces. Handling this
		 * so that it does not appear like we are missing something.
		 */
		sk_kmem_free(status);
		return NULL;
	/* ------------------------------------------- */
	case SISVSERVER:
		/*
		 * This is available only for cluster interfaces. Handling this
		 * so that it does not appear like we are missing something.
		 */
		sk_kmem_free(status);
		return NULL;
	/* ------------------------------------------- */
	case SISLOGICALSIZE:
		long_return = status[index].dedupe_limit.logical_data_used;
		break;
	/* ------------------------------------------- */
	case SISLOGICALLIMIT:
		long_return = status[index].dedupe_limit.logical_limit;
		break;
	/* ------------------------------------------- */
	case SISQUEUEDJOB:
		strlcpy(return_buf,
			(!status[index].status.pending_optype? "" :
			 dense_optype_str[status[index].status.pending_optype]),
			sizeof(return_buf));
		*var_len = strlen(return_buf);
		sk_kmem_free(status);
		return return_buf;
	/* ------------------------------------------- */
	case SISSTALEFPPERCENTAGE:
		long_return = status[index].status.stale_fp_percent;
		break;
	/* --------------------------------------------*/
	case SISISIDDENABLED:
		if (IS_COMPRESSION_IDD_ENABLED(&status[index])) {
				long_return = 1;
		} else {
				long_return = 0;
		}
		break;
	/* --------------------------------------------*/
	case SISQUICKCHECKFSIZE:
		counter64_return.high =
			HIGH32(status[index].status.pstatus.qcheck_fsize);
		counter64_return.low =
			LOW32(status[index].status.pstatus.qcheck_fsize);
		*var_len = sizeof(counter64_return);
		sk_kmem_free(status);
		return (uint8_t *)&counter64_return;

	/* ------------------------------------------- */
	default:
		ERROR("var_sisEntry: magic");
		sk_kmem_free(status);
		return NULL;
	/* ------------------------------------------- */
	}

	sk_kmem_free(status);

	return (uint8_t *)&long_return;
}


/* format is .1.3.6.1.4.1.789.1.24.magic.0 */
uint8_t *
var_compress(SNMP_FM_ARGS)
{
	int		licenced;

	HEADER_GENERIC;

	switch (vp->magic) {
	/* ------------------------------*/
	case COMPRESSISLICENSED:
	        licenced = is_service_licensed(LICENSE_COMPRESSION);
		long_return = licenced ? 2 : 1;
		break;
	/* ------------------------------*/
	default:
		ERROR("var_compression");
		return NULL;
	}

	return (uint8_t *)&long_return;
}

/* extcache stats */

/* format is .1.3.6.1.4.1.789.1.26.magic.0 */
uint8_t *
var_extcache(SNMP_FM_ARGS)
{
	ext_cache_stats_t stats;
	ext_cache_cache_stats_t *cache;
	ext_cache_stat_t cache_stats;
	ext_cache_obj_type_t type = 0;
	char *str;
	uint64_t counter64 = 0;
        static char options[MAX_VAL_LENGTH];
	double double_temp;

	ext_cache_get_stats(&stats);
	cache = &stats.cache[0];

	if (stats.cache_count == 0) { /* EC not enabled */
		memset (cache, 0, sizeof(stats.cache[0]));
		memset (&cache_stats, 0, sizeof(cache_stats));
		cache->stats = &cache_stats;
	}

	HEADER_GENERIC;

	switch (vp->magic) {
	/* ------------------------------*/
	case EXTCACHETYPE:
		if (stats.cache_count != 0) { /* EC enabled */
			type = cache->type;
		}
		str = ext_cache_type_to_string(type);
		strlcpy(return_buf, str, sizeof(return_buf));
		*var_len = strlen(return_buf);
		return return_buf;

	case EXTCACHESUBTYPE:
		str = ext_cache_sub_type_to_string (cache->type);
		strlcpy(return_buf, str, sizeof(return_buf));
		*var_len = strlen(return_buf);
		return return_buf;

	case EXTCACHE64UPTIME:
		if (cache->epoch) {
			counter64 = (uint64_t) sk_msecs - cache->epoch;
		}
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;
	
	case EXTCACHE64SIZE:
		counter64 = (uint64_t) cache->blocks * BLOCK_SIZE;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64USEDSIZE:
		if (cache->blocks > 0) {
			counter64 = (uint64_t) cache->stats->blocks_used * 4096;
		} else {
			counter64 = 0;
		}
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

 	case EXTCACHE64TOTALBUFFERS:
		counter64 = cache->entries;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHEOPTIONS:
		ext_cache_get_options(options, sizeof(options));
		*var_len = strlen(options);
		return (uint8_t *) options;

	case EXTCACHE64HITS:
		counter64 = (uint64_t) cache->stats->async_lookup.hits;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64MISSES:
		counter64 = (uint64_t) cache->stats->async_lookup.misses;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64INSERTS:
		counter64 = (uint64_t) cache->stats->insert.inserts;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64EVICTS:
		counter64 = (uint64_t) cache->stats->evicts;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64INVALIDATES:
		counter64 = (uint64_t) cache->stats->invalidates;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64BLOCKSREF0:
		counter64 = (uint64_t) cache->stats->blocks_ref[0];
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64HITNORMALL0:
		counter64 = (uint64_t) cache->stats->async_lookup.normal_lev0_hits;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64METADATA:
		counter64 = (uint64_t) cache->stats->async_lookup.metadata_file_hits;
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64READLATENCY:
		counter64 = histogram_bucketSum(&(cache->stats->readio.io_latency));
		if (cache->stats->readio.chains) {
			double_temp = (double) counter64 / cache->stats->readio.chains;
		} else {
			double_temp = 0;
		}
		counter64 = double_temp + 0.5; /* Round to nearest integer */
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64WRITELATENCY:
		counter64 = histogram_bucketSum(&(cache->stats->writeio.io_latency));
		if (cache->stats->writeio.chains) {
			double_temp = (double) counter64 / cache->stats->writeio.chains;
		} else {
			double_temp = 0;
		}
		counter64 = double_temp + 0.5; /* Round to nearest integer */
		counter64_return.high = HIGH32(counter64);
		counter64_return.low = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case EXTCACHE64RCLENGTH:
	    if (cache->stats->readio.chains) {
		    double_temp = (double) cache->stats->readio.blocks / cache->stats->readio.chains;
		    counter64 = double_temp + 0.5;
	    }
	    else {
		    counter64 = 0;
	    }
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;

	case EXTCACHE64WCLENGTH:
	    if (cache->stats->writeio.chains) {
		    double_temp = (double) cache->stats->writeio.blocks / cache->stats->writeio.chains;
		    counter64 = double_temp + 0.5;
	    }
	    else {
		    counter64 = 0;
	    }
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *) & counter64_return;
	
	 case EXTCACHEISFLEXSHAREON:
		long_return = guardrail_is_available() ? 2 : 1;
		return (uint8_t *)&long_return;


	/* ------------------------------*/
	default:
		ERROR("var_extcache");
	}

	return NULL;
}


/* format is .1.3.6.1.4.1.789.1.24.2.1.magic.index */
uint8_t *
var_compressEntry(SNMP_FM_ARGS)
{
        int		   index;
	static char        Name[MAX_VAL_LENGTH];
	char               path[MAXPATHLEN];
	wafl_Fs_attr       f_attr;
	int64_t  	   used;
	char	           *cp;
	void               *cookie = NULL;
	wafl_Volume        *vol = NULL;
      	uint64_t	   counter64;
	uint8_t	           *rval;
	wafl_File_handle   fh;

	HEADER_SIMPLE_TABLE(10000);
	
	/* Print statistics for volumes only */	

	index = 1;
	while ((vol = wafl_volume_iterator(&cookie, WIT_HOST)) != NULL) {
	     if ( !WAFL_VOL_BASE(vol) ) {
		if (index == NAME_INDEX){
			break;
		}
	
		index ++;
	     }	
	}

	if (vol == NULL) {
		return NULL;
	}

	fh = fio_getfh_root(WIT_FS, WVOL_NAME(vol));
	
	if (fhzero(fh)) {
		return NULL;
	}

	f_attr = fio_statfs_fh(fh, true);

        sprintf(path, "/vol/%s/", WVOL_NAME(vol));
	   
	rval = (uint8_t *) &long_return;
	switch (vp->magic) {
	/* ---------------------------------------------------- */
	case COMPRESSINDEX:
	    long_return = index;
	    break;
	/* ----------------------------- */
	case COMPRESSFILESYS:
	    strcpy(Name, path);
	    cp = Name;
	    *var_len = strlen(cp);
	    rval = (uint8_t *) cp;
	    break;
	/* ----------------------------- */
	case COMPRESSHIGHUSEDKBYTES:
	    counter64 = (uint64_t)(f_attr.blocks - f_attr.bvfree) *
			          (f_attr.bsize / 1024);
            long_return = HIGH32(counter64);
	    break;
	/* ----------------------------- */
	case COMPRESSLOWUSEDKBYTES:
	    counter64 = (uint64_t)(f_attr.blocks - f_attr.bvfree) *
			          (f_attr.bsize / 1024);
            long_return = LOW32(counter64);
	    break;
	/* ----------------------------- */
	case COMPRESS64USEDKBYTES:
	    counter64 = (uint64_t)(f_attr.blocks - f_attr.bvfree) *
	                          (f_attr.bsize / 1024);
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *)&counter64_return;	    
	/* ----------------------------- */
	case COMPRESSHIGHSAVEDKBYTES:
	    counter64 = (uint64_t)(f_attr.compress_saved_blks) *
	    	(f_attr.bsize / 1024);
            long_return = HIGH32(counter64);
	    break;
	/* ----------------------------- */
	case COMPRESSLOWSAVEDKBYTES:
	    counter64 = (uint64_t)(f_attr.compress_saved_blks) *
	    	(f_attr.bsize / 1024);
	    long_return = LOW32(counter64);
	    break;	    
	/* ----------------------------- */
	case COMPRESS64SAVEDKBYTES:
	    counter64 = (uint64_t)(f_attr.compress_saved_blks) *
	    	(f_attr.bsize / 1024);
	    counter64_return.high = HIGH32(counter64);
	    counter64_return.low  = LOW32(counter64);
	    *var_len = sizeof(counter64_return);
	    return (uint8_t *)&counter64_return;
	/* ----------------------------- */
	case COMPRESSPERCENTSAVED:
 
            used = f_attr.blocks - f_attr.bvfree;
	    long_return = used > 0 ? 
	                     percent(f_attr.compress_saved_blks, 
				     used + f_attr.compress_saved_blks)
	                     : 0;
	    break;
	/* ----------------------------- */
	default:
		ERROR("var_compressEntry: magic 2");
		rval = NULL;
		break;
	/* ---------------------------------------- */
	}
	return rval;
}



/* use var_slVEntry instead */
/* format is .1.3.6.1.4.1.789.1.5.5.1.1.magic.index */
uint8_t *
var_slEntry(SNMP_FM_ARGS)
{
        int             index, real_index;
        static char     Name[MAX_VAL_LENGTH];
        char           *cp;
        blks_t            blks_used;
        wafl_Volume    *vol = wafl_root_volume();  /* XXX */
                /* Need to change MIB to let people ask about particular
                   volumes?  Or change it to dump all volumes? */
                /* This function is deprecated for this reason, to be 
		   replaced by var_slVEntry eventually */

        Snap_stats      *sn_stats;
        char            snapname[SNAPSHOT_NAMELEN];
        int             namelen = 0;
        struct tm      *tm_ptr;
	struct tm	tm_buf;

        HEADER_SIMPLE_TABLE(10000);

	sn_stats = sk_kmem_zalloc(sizeof(Snap_stats), M_SNMPV3, SKMA_SLEEP);

        wafl_get_snap_list( vol, sn_stats );

        for ( index = 1, real_index = 0 ;
              real_index < sn_stats->snapcnt ; real_index++ ) {
		/*
		 * Get the name of this snapshot.
		 */
		namelen = wafl_get_snap_name(vol,
		    sn_stats->snaps[real_index].snapid,
		    snapname,
		    sizeof (snapname));
		if ( namelen == 0 ) {
		    continue;
		}
		if (index == NAME_INDEX) {
			break;
		}
                index++;
        }
        if ( real_index >= sn_stats->snapcnt ) {
                ERROR("var_slEntry: real_index 1");
		sk_kmem_free(sn_stats);
		return NULL;
	}

	tm_ptr = ontap_localtime_r(sn_stats->snaps[real_index].atime.tv_sec, &tm_buf);

        blks_used = vol->wv_fsinfo.blks.used_by_plane0;

	SAFE_FREE(sn_stats);

        switch (vp->magic) {
        /* ------------------------------------------- */
        case  SLINDEX:
            long_return = index;
	    break;
        /* ------------------------------------------- */
        case  SLMONTH:
            long_return = 1 + (tm_ptr->tm_mon);
	    break;
        /* ------------------------------------------- */
        case  SLDAY:
            long_return = tm_ptr->tm_mday;
	    break;
        /* ------------------------------------------- */
        case  SLHOUR:
            long_return = tm_ptr->tm_hour;
	    break;
        /* ------------------------------------------- */
        case  SLMINUTES:
            long_return = tm_ptr->tm_min;
	    break;
        /* ------------------------------------------- */
        case  SLNAME:
            *var_len = namelen;
            strlcpy(Name, snapname, sizeof(Name) );
            cp = Name;
            return (uint8_t *) cp;
        /* ------------------------------------------- */
        default:
            ERROR("var_slEntry: magic 2");
	    return(NULL);
        /* ------------------------------------------- */
        }

        return (uint8_t *) & long_return;
}

/* format is .1.3.6.1.4.1.789.1.5.5.2.1.magic.volume.index */
uint8_t *
var_slVEntry(SNMP_FM_ARGS)
{
	oid             newname[SNMP_OID_MAX];
	int		index=1, real_index=0;
	static char     Name[MAX_VAL_LENGTH];
	char	       *cp;
	blks_t            blks_used;
	wafl_Volume    *vol = NULL;
	int             volctr = 0;
	void           *cookie;
	int             volno;

        Snap_stats      *sn_stats;
        char            snapname[SNAPSHOT_NAMELEN];
        int             namelen = 0;
	int32_t		snapcnt;
        struct tm      *tm_ptr;
	struct tm	tm_buf;
	wafl_Volref	*vref;
	int             done = 0;
	int             result;

	snapname[0] = '\0';

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(WAFL_SNAP_CNT);
	}
	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen * sizeof(oid));
	
	sn_stats = sk_kmem_zalloc(sizeof(Snap_stats), M_SNMPV3, SKMA_SLEEP);
	
	cookie = NULL;
	if (*length >= 14 && name[13] != 0) 
		volno = name[13];
	else
		volno = name[13] = 1;

	if (*length >= 15) {
		index = name[14];
	} else {
		index = name[14] = 0;
	}

	while ( (! done) && (vol = wafl_volume_iterator(&cookie, WIT_HOST))) { 
		/* if volume is being created, wafl_snmp_snap_list will
		   panic the filer.  Check to make sure vol is mounted. */
	        vref = wafl_volref_create(vol, "snmp snapshot info");
		if (vref == NULL)
			continue;

		volctr++;
		newname[13] = volctr;
		result = (volno - volctr);
		if (result > 0) /* skip ahead to queried volume */
			goto skip_vol;
		else if (exact && (result < 0)) {
			done = 1;
			vol = NULL;
			goto skip_vol;
		}
		wafl_get_snap_list( vol, sn_stats );

		for ( index = 1, real_index = 0 ;
		      real_index < sn_stats->snapcnt ; real_index++ ) {
			/*
			 * Get the name of this snapshot.
			 */
			namelen = wafl_get_snap_name(vol,
			    sn_stats->snaps[real_index].snapid,
			    snapname, sizeof (snapname));
			if ( namelen == 0 ) {
				continue;
			}
			newname[14] = (oid) index;
			result = compare(name, *length, newname, 15);
			if ((exact && (result == 0)) || 
			    (!exact && (result < 0))) {
				done = 1;
				break;
			}
			index++;
		}
skip_vol:
		wafl_volref_destroy(vref);
	}

	if ( (! vol) || (real_index >= sn_stats->snapcnt) ) {
		ERROR("var_slVEntry: real_index 1");
		sk_kmem_free(sn_stats);
		return NULL;
	}

	tm_ptr = ontap_localtime_r(sn_stats->snaps[real_index].atime.tv_sec, &tm_buf);

	*var_len = sizeof(int32_t);
	*length = 15;
	bcopy((char *) newname, (char *) name, (int) *length* sizeof(oid));

	blks_used = vol->wv_fsinfo.blks.used_by_plane0;

	snapcnt = sn_stats->snapcnt;

	SAFE_FREE(sn_stats);

	switch (vp->magic) {
	/* ------------------------------------------- */
	case  SLVINDEX:
	    long_return = index;
	    break;
	/* ------------------------------------------- */
	case  SLVMONTH:
	    long_return = 1 + (tm_ptr->tm_mon);
	    break;
	/* ------------------------------------------- */
	case  SLVDAY:
	    long_return = tm_ptr->tm_mday;
	    break;
	/* ------------------------------------------- */
	case  SLVHOUR:
	    long_return = tm_ptr->tm_hour;
	    break;
	/* ------------------------------------------- */
	case  SLVMINUTES:
	    long_return = tm_ptr->tm_min;
	    break;
	/* ------------------------------------------- */
	case  SLVNAME:
	    *var_len = namelen;
	    strlcpy(Name, snapname, sizeof(Name) );
	    cp = Name;
	    return  (uint8_t *) cp;
	/* ------------------------------------------- */
	case SLVVOLUME:
	    long_return = volctr;
	    break;
	/* ------------------------------------------- */
	case SLVNUMBER:
	    long_return = snapcnt;
	    break;
	/* ------------------------------------------- */
	case SLVVOLUMENAME:
	    strcpy(Name, WVOL_NAME(vol));
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case SLVTYPE:
	    long_return = WAFL_VOL_TRAD(vol) ? 1 : (WAFL_VOL_FLEX(vol) ? 2 : 3);
	    break;
	/* ------------------------------------------- */    
	default:
	    ERROR("var_slVEntry: invalid magic");
	    return NULL;
	/* ------------------------------------------- */
	}

	return (uint8_t *) & long_return;
}

/* format is .1.3.6.1.4.1.789.1.5.5.3.1.magic.volume.qtree.index */
uint8_t *
var_slQEntry(SNMP_FM_ARGS)
{
	oid             newname[SNMP_OID_MAX];
	int		index=1, real_index=0;
	int             result;
	static char     Name[MAX_VAL_LENGTH];
	char	       *cp;
	blks_t            blks_used;
	wafl_Volume    *vol = NULL;
	int             volctr = 0;
	int             qtreectr = 0;
	void           *cookie;
	int             done = 0;
	int             tid = 0;

	wafl_File_handle fh;
        Snap_stats      *sn_stats;
	Snap_stat1     *ss;
        char            snapname[SNAPSHOT_NAMELEN];
	char            volname[MAX_VOLNAME_LEN + 1];
        int             namelen = 0;
	wafl_Volref	*vref;
	char            qtname[MAXNAMLEN + 1];

	rpl_contents contents;
	uint32_t tv_sec, tv_sec2;
	char source[ONTAP_MAXHOSTNAMELEN + NFS_MAXPATHLEN + 2];
	int volno, qtreeno;

	snapname[0] = '\0';
	qtname[0] = '\0';
	source[0] = '\0';

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
					sizeof(oid));

	sn_stats = sk_kmem_zalloc(sizeof(Snap_stats), M_SNMPV3, SKMA_SLEEP);

	cookie = NULL;
	volno = (*length >= 14) ? name[13] : 1;
	qtreeno = (*length >= 15) ? name[14] : 1;
	while ( (! done) && (vol = wafl_volume_iterator(&cookie, WIT_HOST))) {
	        
	        /* Skip Primordial volumes */
	        if (WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
		        continue;
		}

		/* if volume is being created, wafl_snmp_snap_list will
		   panic the filer.  Check to make sure vol is mounted. */
	        vref = wafl_volref_create(vol, "var_slQEntry info");
		if (vref == NULL) {
			continue;
		}
		
		strcpy(volname, WVOL_NAME(vol));
		volctr++;
		newname[13] = volctr;
		result = (volno - volctr);
		if (result > 0) /* skip ahead to queried volume */
			goto skip_vol;
		else if (exact && (result < 0)) {
			done = 1;
			vol = NULL;
			goto skip_vol;
		}
		qtreectr = 0;

		for (tid = 1; tid < QUOTA_TID_LIM; tid++) {
			if (fm_takingover() || fm_givingback()) {
				wafl_volref_destroy(vref);
				goto error;
			}

			/* try and and get a file handle */
			if (!wafl_qtree_get_root_fh(vol, 0, tid, &fh)) {
				continue;
			}

			if (!wafl_qtree_get_name(vol, 0, tid, qtname, 
						 MAXNAMLEN+1)) {
				continue;
			}
			
			qtreectr++;
			newname[14] = qtreectr;
			result = (qtreeno - qtreectr);
			if (result > 0) /* skip ahead to queried qtree */
				continue;
			else if (exact && (result < 0)) {
				done = 1;
				vol = NULL;
				break;
			}
			
			wafl_get_snap_list( vol, sn_stats );

			for ( index = 1, real_index = 0 ;
			      real_index < sn_stats->snapcnt ; real_index++ ) {

				/* Get the name of this snapshot. */
				namelen = wafl_get_snap_name(vol,
					    sn_stats->snaps[real_index].snapid,
					    snapname,
					    sizeof (snapname));
				if ( namelen == 0 ) {
					continue;
				}

				/* 
				 * Check to see if the given qtree is in 
				 * this snapshot.
				 */
				if (!wafl_qtree_get_name(vol, 
					sn_stats->snaps[real_index].snapid, 
					tid, qtname, MAXNAMLEN+1)) {
					continue;
				}

				newname[15] = (oid) index;
				result = compare(name, *length, newname, 16);
				if ((exact && (result == 0)) || 
				    (!exact && (result < 0))) {
					done = 1;
					break;
				}
				index++;
			}

			/* Get out of the loop when we are done */
			if (done) {

				/* only make the call when necessary */
				switch (vp->magic) {

				case SLQQTREECONTENT:
				case SLQSOURCE:
				case SLQSOURCETIME:	
				    ss = &sn_stats->snaps[real_index];
				    if (!wafl_snap_list_one_qtree_info(vol, 
					ss,snapname, qtname, &fh, true,
					source, &contents, &tv_sec)) {
					wafl_volref_destroy(vref);
					    goto error;
				    }
				}

				/* We are done! */
				break;
			}
		}

skip_vol:
		wafl_volref_destroy(vref);
	}

	if ( (! vol) || (real_index >= sn_stats->snapcnt) ) {
		ERROR("var_slVEntry: real_index 1");
		goto error;
	}

	*length = 16;
	bcopy((char *) newname, (char *) name, (int) *length* sizeof(oid));

	blks_used = vol->wv_fsinfo.blks.used_by_plane0;

	tv_sec2 = sn_stats->snaps[real_index].atime.tv_sec;

	SAFE_FREE(sn_stats);

	*var_len = sizeof(int32_t);
	switch (vp->magic) {
	/* ------------------------------------------- */
	case  SLQINDEX:
	    long_return = index;
	    break;
	/* ------------------------------------------- */
	case SLQVOLUME:
	    long_return = volctr;
	    break;
	/* ------------------------------------------- */
	case SLQQTREE:
	    long_return = qtreectr;
	    break;
	/* ------------------------------------------- */
	case SLQSNAPSHOTNAME:
	    *var_len = namelen;
	    strlcpy(Name, snapname, sizeof(Name) );
	    cp = Name;
	    return (uint8_t *) cp;
        /* ------------------------------------------- */
        case SLQSNAPSHOTTIME:
	    long_return = tv_sec2;
	    break;
	/* ------------------------------------------- */
	case SLQQTREENAME:
	    *var_len = strlen(qtname);
	    strlcpy(Name, qtname, sizeof(Name) );	
	    cp = Name;	
	    return (uint8_t *) cp;
	/* ------------------------------------------- */
	case SLQQTREECONTENT:
	    long_return = contents;
	    break;
	/* ------------------------------------------- */
	case SLQSOURCE:
	    *var_len = strlen(source);
	    strlcpy(Name, source, sizeof(Name) );	
	    cp = Name;	
	    return (uint8_t *) cp; 	
	/* ------------------------------------------- */
	case SLQSOURCETIME:
	    long_return = tv_sec;
	    break;
	/* ------------------------------------------- */
	case SLQVOLUMENAME:
	    strcpy(Name, volname);
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	/* ------------------------------------------- */   
	default:
	    ERROR("var_slQEntry: magic 2");
	    return NULL;
	/* ------------------------------------------- */
	}

	return (uint8_t *) & long_return;

error:
	if (sn_stats != NULL) {
		sk_kmem_free(sn_stats);
	}
	return NULL;
}


/*
 *  For burt 280634 we need to stabilize qtree OID's. Use the
 *  volume's fsid as it's subidentifier within qtreeEntry.
 * 
 *  XXX: Yet to do: stabalize OID's everywhere.
 */

/*
 *  Return the volume with the the smallest FSID that is strictly 
 *  greater than the given FSID. Returns NULL if it cannot
 *  find any such volume. See wafl_volume_iterator for flags.
 */
static wafl_Volume *
find_next_vol_by_fsid(fsid_t fsid, int flags)
{
	void *cookie = NULL;
	wafl_Volume *next_vol = NULL;
	fsid_t next_fsid = UINT_MAX;

	/*
	 *  Look through all the volumes for the smallest fsid
	 *  greater than the parameter.
	 */
	wafl_Volume *vol = wafl_volume_iterator(&cookie, flags);
	while (vol) {
		if (fsid < vol->wv_fsid && vol->wv_fsid < next_fsid) {
			next_fsid = vol->wv_fsid;
			next_vol = vol;
		}
		vol = wafl_volume_iterator(&cookie, flags);
	}
	return next_vol;
}

/* format is .1.3.6.1.4.1.789.1.5.10.1.magic.volume.index */
uint8_t *
var_qtreeEntry(SNMP_FM_ARGS)
{
	oid             newname[SNMP_OID_MAX];
	int             result;
	static char     Name[MAX_VAL_LENGTH];
	char	       *cp;
	wafl_Volume    *vol = NULL;
	void           *cookie;
	int             index = 0;
	wafl_Volref	*vref;
	char            qtname[MAXNAMLEN + 1];
	int32_t         oplock_state = 0;
	oid		volno;
	const int vol_flags = WIT_MOUNTED | WIT_HOST | WIT_FS;
#define TID (index - 1)

	ASSERT(sizeof(oid) == sizeof(fsid_t));

	if (fm_takingover() || fm_givingback()) {
		return NULL;
	}

	qtname[0] = '\0';

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	if (*length >= 13 && name[12] != 0) {
		volno = name[12];
	} else {
		volno = name[12] = 1;
	}

	if (*length >= 14) {
		index = name[13];
	} else {
		index = name[13] = 0;
	}

	cookie = NULL;

	if (exact) {
		if (*length != 14) {
			index = 0;
		}
		goto EXACT;
	}

	/*
	 * Entering the getnext code. Start looking at current volume, but
	 * qtree after the current one.
	 */
	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
					sizeof(oid));

	index++;
	vol = find_next_vol_by_fsid(volno - 1, vol_flags);
	
	while (vol) {
		volno = vol->wv_fsid;

		/* Skip Primordial volumes */
		if (WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
		        goto NEXT_VOL;
		}

		vref = wafl_volref_create(vol, "var_qtreeEntry get qtree info");
		if (vref) {
			while (TID < QUOTA_TID_LIM &&
				!wafl_qtree_get_name(vol, 0, TID, qtname,
						 MAXNAMLEN+1)) {
				++index;
			}
			if (TID < QUOTA_TID_LIM) {
				/* Found a qtree. */
				break;
			}
			wafl_volref_destroy(vref);
		}
NEXT_VOL:
		vol = find_next_vol_by_fsid(volno, vol_flags);
		index = 1;
	}
	if (!vol) {
		/* No more qtrees. */
		return NULL;
	}

	newname[12] = volno;
	newname[13] = index;
	result = compare(name, *length, newname, 14);
	
	if (result >= 0) {
		return NULL;
	}

	*length = 14;
	bcopy((char *) newname, (char *) name, (int) *length * sizeof(oid));
	goto magic;

  EXACT:
	if (index == 0) {
		return NULL;
	}
	vol = wafl_find_volume_by_fsid(volno, WIT_FS);
	if (vol == NULL) {
		return NULL;
	}

	/* Skip Primordial volumes */
        if (WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
	        return NULL;
        }

	vref = wafl_volref_create(vol, "var_qtreeEntry get qtree info");
	if (vref == NULL) {
		return NULL;
	}
	if (TID >= QUOTA_TID_LIM ||
	    !wafl_qtree_get_name(vol, 0, TID, qtname, MAXNAMLEN+1)) {
		wafl_volref_destroy(vref);
		return NULL;
	}
magic:
	*var_len = sizeof(int32_t);	/* default length for INTEGER */

	switch (vp->magic) {
	/* ------------------------------------------- */	
        case QTREEINDEX:
		long_return = index;
		break;
        /* ------------------------------------------- */        
	case QTREEVOLUME:
		long_return = volno;
		break;
        /* ------------------------------------------- */
	case QTREEVOLUMENAME:
		strlcpy(Name, WVOL_NAME(vol),sizeof(Name));
		cp = Name;
		*var_len = strlen(cp);
		wafl_volref_destroy(vref);
		return (uint8_t *) cp;
        /* ------------------------------------------- */        
	case QTREEID:
		long_return = TID;
		break;
	/* ------------------------------------------- */
	case QTREENAME:
		*var_len = strlen(qtname);
		strlcpy(Name, qtname, sizeof(Name) );	
		cp = Name;	
		wafl_volref_destroy(vref);
		return (uint8_t *) cp;
        /* ------------------------------------------- */
	case QTREESTYLE:	
		long_return = wafl_qtree_get_security(vol, TID) + 1;
		break;
        /* ------------------------------------------- */
	case QTREESTATUS:
		long_return = 1;
		if (wafl_qtree_is_replica(vol, TID)) {
			if (wafl_qtree_is_snapvault(vol, TID)) {
				long_return = 3;
			} else {
				long_return = 2;
			}
		}
		break;
        /* ------------------------------------------- */
	case QTREEOPLOCK:
		oplock_state = wafl_qtree_get_oplock_state(vol, TID);
		if (oplock_state == WAFL_ENABLE_OPLOCKS) {
			long_return = 1;
		} else {
			long_return = 2;
		}
		break;
        /* ------------------------------------------- */
	case QTREEVSERVER:
	        if (WAFL_VOL_10_MODE(vol)) {
		        char printable_uuid[VVOL_UUID_STRING_CHARS];
			uuid_to_string_noalloc(
			        &(vol->wvvv_info->vvi_raid->
				        vvrd_owning_vserver_uuid),
				printable_uuid,
				sizeof(printable_uuid));
			snprintf(Name, MAX_VAL_LENGTH, "%s", printable_uuid);
		} else {
		        strncpy_safe(Name, "N/A", MAX_VAL_LENGTH);
		}
		cp = Name;
		*var_len = strlen(cp);
		wafl_volref_destroy(vref);
		return (uint8_t *) cp;
        /* ------------------------------------------- */
	default:
	    ERROR("var_qtreeEntry: magic 2");
	/* ------------------------------------------- */
	}
#undef TID
	wafl_volref_destroy(vref);
	return (uint8_t *) & long_return;
}	

/*
 *  Retrieve the aggr status string for one aggregate in the
 *  format that "aggr status -v" would use.
 *
 *  Put the string into <buf> and return a pointer to <buf>.
 */
static char *
snmp_get_aggr_status_string(char * buf, int sz, char * volName)
{
	aggr_status_t vol_status;
	const char * sep = "";
	int len;
	char * status;
	char * ptr;

	ASSERT(0 != buf);

	vol_status = aggrcmd_util_get_vol_status(volName, NULL);

	buf[0] = 0;
	ptr = buf;

	for ( ; ; ) {
		status = aggrcmd_util_get_status_string(&vol_status,
							false);
		if (0 == status) {
			break;
		}
		len = strlen(status);
		if (sz < (len+1+strlen(sep))) {
			if (3 < sz) {
				strcpy(ptr, "...");
			}
			break;
		}
		strcpy(ptr, sep);
		ptr += strlen(sep);
		sz -= strlen(sep);
		sep = ", ";
		strcpy(ptr, status);
		ptr += len;
		sz -= len;
	} 
	return buf;
}

/*
 *  Retrieve the volume status string for one volume in the
 *  format that "vol status -v" would use.
 *
 *  Put the string into <buf> and return a pointer to <buf>.
 */
static char *
snmp_get_vol_status_string(char * buf, int sz, vvol_info_t *vvinfo, char * volName)
{
	vvol_status_t vol_status;
	const char * sep = "";
	int len;
	char * status;
	char * ptr;

	ASSERT(0 != buf);

	vol_status = volcmd_util_get_vol_status(volName);

	if (vvinfo) { /* for flex vols, overwrite the aggr buftree format */
		switch (WAFL_BUFTREE_FORMAT(VVLABEL_BUFTREE_TYPE_VVI(vvinfo))) {
		case BUFTREE_FORMAT_HYBRID:
        	case BUFTREE_FORMAT_64:
			vol_status.buftree_fmt_64 = 1;
			vol_status.buftree_fmt_32 = 0;
			break;
		case BUFTREE_FORMAT_32:
                        vol_status.buftree_fmt_32 = 1;
                        vol_status.buftree_fmt_64 = 0;
			break;
		}
	}

	buf[0] = 0;
	ptr = buf;

	for ( ; ; ) {
		status = volcmd_util_get_status_string(&vol_status,
						       false);
		if (0 == status) {
			break;
		}
		len = strlen(status);
		if (sz < (len+1+strlen(sep))) {
			if (3 < sz) {
				strcpy(ptr, "...");
			}
			break;
		}
		strcpy(ptr, sep);
		ptr += strlen(sep);
		sz -= strlen(sep);
		sep = ", ";
		strcpy(ptr, status);
		ptr += len;
		sz -= len;
	} 
	return buf;
}

/*
 *  Retrieve the aggregate options string for one aggregate in the
 *  format that "aggr status -v" would use.
 *
 *  Put the string into <buf> and return a pointer to <buf>.
 */
static char *
snmp_get_aggr_options_string(char * buf, int sz, config_attr_obj_t * vol)
{
	int	ocookie = 0;
	int	olen;

	olen = aggrcmd_util_get_opt_list(vol, &ocookie, true, buf, sz);
	return buf;
}

/*
 *  Retrieve the volume options string for one volume in the
 *  format that "vol status -v" would use.
 *
 *  Put the string into <buf> and return a pointer to <buf>.
 */
static char *
snmp_get_vol_options_string(char              *buf,
			    int                sz,
			    config_attr_obj_t *cao, 
			    char              *aggrname,
			    char              *volname)
{
	int	          ocookie = 0;
	int	          olen;
	config_attr_obj_t vol;

	if (!cao) {
		/* Is a flexible volume
		 */
		if (!volcmd_util_blend_vvol_options(aggrname,
						    volname,
						    &vol)) {
			/* Got an error, return */
			strcpy(buf, "");
			return buf;	

		}
		cao = &vol;
	}
	olen = volcmd_util_get_opt_list(cao, &ocookie, true, 
					false, buf, sz);
	return buf;
}

static void
snmp_get_clone_snapshot(vvol_info_t *vvi, char *buf, uint32_t len)
{
	wafl_Volref *vref = NULL;

	buf[0] = '\0';

	if (vvi->vvi_raid->vvrd_flags & VVOL_FLAG_CLONE) {
		int namelen = 0;
		int snapid = wafl_get_clone_base_snapid(vvi->vvi_raid);
		wafl_Volume *cvol = wafl_find_volume_by_vvol_id(
				vvi->vvi_raid->vvrd_clone_parent,
				vvi->vvi_pvol);

		if (cvol != NULL) {
	                vref = wafl_volref_create(cvol, "snmp clone snapshot info");
       		         if (vref == NULL) {
				buf[0] = '\0';
				return;
			}

			namelen = wafl_get_snap_name(cvol, snapid,
				buf, len);

			wafl_volref_destroy(vref);
		}
	} 
}

/* format is .1.3.6.1.4.1.789.1.5.13.1.magic.volume */
uint8_t *
var_volMoveStatusEntry(SNMP_FM_ARGS) 
{
	int 			err;
	uint8_t *		rval = NULL;
	
	HEADER_SIMPLE_TABLE(10000);

	sk_Msg                  *msg = sk_my_msg();
	ndm_request_t 		req;

	memset(&req, 0, sizeof(ndm_request_t));
	
	req.is_snmp = 1;
	req.name_index = NAME_INDEX;
	msg->type = NDM_STATUS;		
	msg->data.p = &req;
	
	err = ndm_admin_send();
	if (err == NDM_ERROR_NDM_NOT_INITIALIZED) {
		ERROR("var_volMoveStatusEntry: err == NDM_ERROR_NDM_NOT_INITIALIZED");
		return NULL;
	}
	
	if(req.src_volname[0] == '\0') {
		return NULL;
	}
	switch (vp->magic) {
		case VOLMOVEINDEX :
			long_return = NAME_INDEX ;
			rval = (uint8_t *) &long_return;
			break;
		case VOLMOVESRCNAME :
			strlcpy(return_buf, req.src_volname, sizeof(return_buf));
	                *var_len = strlen(return_buf);
        	        rval = (uint8_t *) return_buf;
                	break;
			
		case VOLMOVEDSTAGGRNAME :
                        strlcpy(return_buf, req.dst_aggrname, sizeof(return_buf));
                	*var_len = strlen(return_buf);
      	        	rval = (uint8_t *) return_buf;
        	        break;

		case VOLMOVECOATTEMPTS :
			long_return = req.cutover_attempts;
			rval = (uint8_t *) &long_return;
			break;
		case VOLMOVECOTIME :
			long_return = req.cutover_window;
			rval = (uint8_t *) &long_return;
			break;
		case VOLMOVESTATE : 
                        strlcpy(return_buf, req.state, sizeof(return_buf));
       		        *var_len = strlen(return_buf);
                	rval = (uint8_t *) return_buf;
                	break;
		default :
			ERROR("var_volmoveEntry: magic");
			return NULL;
	}

	return rval;
}

/*
 * Check if we can return a volume in vol_varEntry. If this
 * function returns false, we were not able to get some of the
 * necessary information for this value of magic.
 *
 * vol_name and aggr_name must point to buffers of size name_size.
 * options must point to a buffer of size options_size.
 */
static bool
check_vol_for_var_volEntry(uint8_t magic,
			   vdb_info_t *vdb_info,
			   char *vol_name,
			   char *aggr_name,
			   int name_size,
			   char *options,
			   int options_size)
{
	int host;
	config_attr_obj_t *aggr;
	raid_config_iter_t *aggrIter;

	aggr = NULL;
	aggrIter = NULL;

	/*
	 * Volume name is only used by VOLNAME, VOLSTATUS, and VOLOPTIONS.
	 */
	if (magic == VOLNAME || magic == VOLSTATUS || magic == VOLOPTIONS) {
		ASSERT(vdb_info->v_valid & VDB_INFO_NAME);
		if (vdb_info->v_name.vn_namelen == 0) {
			ERROR("var_volEntry: unable to get volume name");
			return false;
		}

		if (!vdb_name_to_string(&vdb_info->v_name, vol_name,
					name_size)) {
			ASSERT(false);
		}
	}

	/*
	 * Aggregate name is only used by VOLAGGRNAME, VOLSTATUS, and
	 * VOLOPTIONS. For a tradvol, it's only used by VOLSTATUS,
	 * and is the same as vol_name.
	 */
	ASSERT(vdb_info->v_valid & VDB_INFO_TYPE);
	if (vdb_info->v_type == VDB_TYPE_FLEX &&
	    (magic == VOLAGGRNAME || magic == VOLOPTIONS ||
	     magic == VOLSTATUS)) {
		ASSERT(vdb_info->v_valid & VDB_INFO_AGGR);
		if (!vdb_is_null(vdb_info->v_aggr)) {
			if (vdb_lock(vdb_info->v_aggr, false)) {
				if (!vdb_get_name_string(vdb_info->v_aggr,
							 aggr_name,
							 name_size)) {
					ASSERT(false);
				}
				vdb_unlock(vdb_info->v_aggr);
			} else {
				/*
				 * Since we are in kahuna and have not blocked,
				 * the aggr should not have gone away.
				 */
				ERROR("var_volEntry: couldn't vdb_lock aggr");
				ASSERT(false);
				return false;
			}
		} else {
			ERROR("var_volEntry: couldn't get vdb handle of aggr");
			return false;
		}
	} else if (vdb_info->v_type == VDB_TYPE_TRAD && magic == VOLSTATUS) {
		/*
		 * For a tradvol, aggr_name is the same as vol_name.
		 * We already found vol_name above.
		 */
		strlcpy(aggr_name, vol_name, name_size);
	}

	/*
	 * For tradvols, we need to get a config_attr_obj_t for VOLOPTIONS.
	 */
	if (vdb_info->v_type == VDB_TYPE_TRAD && magic == VOLOPTIONS) {
		host = sk_gethost();

		if (!raid_config_iterator_create(&aggrIter, RAIDTYPE_VOL)) {
			ERROR("var_volEntry: couldn't create raid iterator");
			return false;
		}

		while ((aggr = raid_config_iterator_next(aggrIter)) != NULL) {
			if (!strcmp(aggr->cao_vol.cav_name, vol_name) &&
			    (host == aggr->cao_vol.cav_host)) {
				break;
			}
		}

		if (aggr == NULL) {
			ERROR("var_volEntry: didn't find tradvol config attrs");
			raid_config_iterator_destroy(aggrIter);
			return false;
		}
	}

	if (magic == VOLOPTIONS) {
		/*
		 * snmp_get_vol_options just returns its first argument.
		 */
		(void) snmp_get_vol_options_string(options,
						   options_size,
						   aggr,
						   aggr_name,
						   vol_name);
	}

	if (aggrIter != NULL) {
		raid_config_iterator_destroy(aggrIter);
	}

	return true;
}

/* format is .1.3.6.1.4.1.789.1.5.8.1.magic.volume */
uint8_t *
var_volEntry(SNMP_FM_ARGS)
{
        char     	        aggr_name[VDB_VOLNAME_MAX_LEN];
        char *          	cp;
        int             	index;
	bool			is_flex;
        static char     	Name[MAX_VAL_LENGTH];
        uint8_t *        	rval = NULL;
	vdb_handle_t            vdb;
	vdb_info_t              vdb_info;
	vdb_iter_t              vdb_cookie;
        char			vol_name[VDB_VOLNAME_MAX_LEN];
	wafl_Volume *	        vol = NULL;
	wafl_Volref *           vref = NULL;
	bool			vres;
	alock_outcome_t		outcome;
	alock_handle_t		al_handle;
	alock_op_t		al_op;
	bool			call_blocked;
	bool			got_admin_lock = false;

	ASSERT(sizeof(Name) >= sizeof(aggr_name));
	aggr_name[0] = '\0';		/* Burt545230: Lint 645 warning */
	vol_name[0] = '\0';

	HEADER_SIMPLE_TABLE(10000);

        /*
	 * The index of a volume is based on the order it is returned
	 * by the vdb iterator. We iterate until we reach the volume
	 * at NAME_INDEX. If for some reason we can't return
	 * information for that volume (and exact is false), we skip
	 * it and continue on to the next one. Then we update
	 * NAME_INDEX to match the index of the volume which was
	 * actually returned.
	 *
         * If this iterator changes, be sure to update
         * snmp_volume_cnt(), too.  That routine must use
         * the same iterator that this routine uses.
         */
	index = 1;
	for (vdb = vdb_iter_first(&vdb_cookie,
				  VDB_ITER_OWNER_HOST |
				  VDB_ITER_TYPE_FS |
				  VDB_ITER_OPT_LOCK);
	     !vdb_is_null(vdb);
	     vdb = vdb_iter_next(&vdb_cookie), index++) {

		if (index < NAME_INDEX) {
			/*
			 * The next call to vdb_iter_next or
			 * vdb_iter_done will unlock the entry.
			 */
			continue;
		}

		bzero(&vdb_info, sizeof(vdb_info));
		vdb_get_select(vdb,
			       VDB_INFO_NAME |
			       VDB_INFO_TYPE |
			       VDB_INFO_AGGR |
			       VDB_INFO_FSID |
			       VDB_INFO_UUID |
			       VDB_INFO_MSTATE |
			       VDB_INFO_SUBTYPE_CLONE |
			       VDB_INFO_CLONE_PARENT |
			       VDB_INFO_CLONE_PARENT_FLEXID |
			       VDB_INFO_VOLUME |
			       VDB_INFO_VVINFO,
			       &vdb_info);

		vref = vdb_volref_create(vdb, "snmp volTable");

		/*
		 * check_vol_for_var_volEntry can suspend, so we need
		 * to unlock the vdb entry here instead of waiting for
		 * the next call to vdb_iter_next or vdb_iter_done.
		 */
		vdb_iter_unlock(&vdb_cookie);

		got_admin_lock = false;
		if (vref == NULL) {
			(void) vvcal_op_to_alock_op(VVC_LOCK_STATUS, &al_op);
			outcome = alock_acquire(vdb,
						al_op,
						ALOCK_DONT_WAIT,
						&al_handle,
						&call_blocked,
						NULL);

			got_admin_lock = (outcome == ALOCK_OUTCOME_SUCCESS);
			if (!got_admin_lock) {
				/*
				 * We weren't able to take a volref or admin lock to
				 * prevent the volume from going away. Don't use the
				 * vol or vvinfo pointers as they might be stale
				 * after we suspend.
				 */
				vdb_info.v_vvinfo = NULL;
				vdb_info.v_volume = NULL;
			}
		}

		if (check_vol_for_var_volEntry(vp->magic,
					       &vdb_info,
					       vol_name,
					       aggr_name,
					       VDB_VOLNAME_MAX_LEN,
					       Name,
					       sizeof(Name))) {
			break;
		} else if (exact) {
			/*
			 * We were unable to load some information
			 * necessary for the volume at this index.
			 * For the case where exact is true (meaning
			 * we are doing SNMP get, rather than
			 * get-next), we return NULL instead of
			 * continuing on and returning the next
			 * volume.
			 */
			goto end;
		}

		if (vref != NULL) {
			vdb_volref_destroy(vref);
			vref = NULL;
		}
		if (got_admin_lock) {
			outcome = alock_release(vdb, &al_handle);
			ASSERT(outcome == ALOCK_OUTCOME_SUCCESS);
			got_admin_lock = false;
		}
        }

        if (vdb_is_null(vdb)) {
		/*
		 * This is the case where there are no more volumes to
		 * return. It is the only case where this function
		 * should return NULL, if exact is false. Returning
		 * NULL in other cases will cause all remaining
		 * volumes to be skipped, even if we could have
		 * returned information about them.
		 */
                ERROR("var_volEntry: no more volumes");
		goto end;
        }

	ASSERT(!exact || index == NAME_INDEX);
	NAME_INDEX = index;

	is_flex = (vdb_info.v_type == VDB_TYPE_FLEX);
	vol = vdb_info.v_volume;

        rval = (uint8_t *) & long_return;

	TESTPT("snmp", "var_volEntry", "Inject delay in var_volEntry");

	D(snmp, 105, ("snmp: var_volEntry: volume state is %s\n",
		      vdb_mstate_to_online_state_string(vdb_info.v_mstate)));

	switch (vp->magic) {
	/* ---------------------------------------------------- */
	case VOLINDEX:
		long_return = index;
		break;
	/* ---------------------------------------------------- */
	case VOLNAME:
		strlcpy(Name, vol_name, sizeof(Name));
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
	/* ---------------------------------------------------- */
	case VOLFSID:
		snprintf(Name, sizeof(Name), "%u", vdb_info.v_fsid);
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
	/* ---------------------------------------------------- */
	case VOLOWNINGHOST:
		/*
		 *  See the MIB for these values:
		 *	1	== this host
		 *	2 	== partner
		 * Post 7.0 behavior requires volumes to be reported
	 	 * as local.
		 */

		long_return = 1;
		break;
	/* ---------------------------------------------------- */
	case VOLSTATE: {
		ASSERT(vdb_info.v_valid & VDB_INFO_MSTATE);
		snprintf(Name, sizeof(Name), "%s", 
			 vdb_mstate_to_online_state_string(vdb_info.v_mstate));
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
	}
	/* ---------------------------------------------------- */
	case VOLSTATUS: {
		if (is_flex && !vdb_info.v_vvinfo) {
			ERROR("var_volEntry: vvinfo not valid");
			rval = "";
			goto end;
		}
		cp = snmp_get_vol_status_string(Name, MAX_VAL_LENGTH,
						vdb_info.v_vvinfo,
						aggr_name);
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
	}
	/* ---------------------------------------------------- */
	case VOLOPTIONS: {
		/*
		 * For the VOLOPTIONS case, check_vol_for_var_volEntry
		 * fills Name with the options string.
		 */
                *var_len = strlen(Name);
                rval = (uint8_t *) Name;
                break;
	}
	/* ---------------------------------------------------- */
	case VOLUUID: {
		char printable_uuid[VVOL_UUID_STRING_CHARS];

		uuid_to_string_noalloc(&vdb_info.v_uuid,
				printable_uuid,
				sizeof(printable_uuid));
		snprintf(Name, MAX_VAL_LENGTH, "%s",
				printable_uuid);
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
	}
        /* ---------------------------------------------------- */
        case VOLAGGRNAME: {
		if (is_flex) {
			strlcpy(Name, aggr_name, sizeof(Name));
		} else {
			strcpy(Name, "N/A");
		}
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;                   
                break;
        }
        /* ---------------------------------------------------- */
        case VOLTYPE: {
		if (is_flex) {
			long_return = 2;
		} else {
			long_return = 1;
		}
                break;
        }
        /* ---------------------------------------------------- */
        case VOLCLONE: {
		if (vdb_info.v_subtype_clone) {
			long_return = 2;
		} else {
			long_return = 1;
		}
                break;
        }
        /* ---------------------------------------------------- */
        case VOLCLONEOF: {
		if (vdb_info.v_subtype_clone && 
		    vdb_lock(vdb_info.v_clone_parent, false)) {
			vres = vdb_get_name_string(vdb_info.v_clone_parent,
						   Name, sizeof(Name));
			ASSERT(vres);
			vdb_unlock(vdb_info.v_clone_parent);
		} else {
			strcpy(Name, "");
		}
                cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        }
        /* ---------------------------------------------------- */
        case VOLCLONESNAP: {
		if (vdb_info.v_subtype_clone && vdb_info.v_vvinfo != NULL) {
			snmp_get_clone_snapshot(vdb_info.v_vvinfo, Name, 
						sizeof (Name));
		} else {
			strcpy(Name, "");
		}
                cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break; 
        }
	/* ---------------------------------------------------- */
	case VOLVSERVER:
		if (vdb_info.v_mode == VDB_MODE_10) {
			char printable_uuid[VVOL_UUID_STRING_CHARS];
			uuid_to_string_noalloc(&vdb_info.v_vsuuid,
					       printable_uuid, sizeof(printable_uuid));
			snprintf(Name, MAX_VAL_LENGTH, "%s", printable_uuid);
		} else {
			strcpy(Name, "N/A");
		}
		cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
		break;
	/* ---------------------------------------------------- */
	case VOLMSID:
		if (vdb_info.v_mode == VDB_MODE_10) {
			sprintf(Name, "0x%8x", vdb_info.v_msid);
		} else {
			strcpy(Name, "N/A");
		}
		cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
		break;
	/* ---------------------------------------------------- */
	case VOLDSID:
		if (vdb_info.v_mode == VDB_MODE_10) {
			sprintf(Name, "0x%8x", vdb_info.v_dsid);
		} else {
			strcpy(Name, "N/A");
		}
		cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
		break;
	/* ---------------------------------------------------- */
	case VOLSPACEGUARANTEEENABLED:
		long_return = 1 /*false*/;
		if (vol != NULL) {
			long_return = (WAFL_VOL_SPCRES_DISABLED(vol)?
				       1 /*false*/ : 2 /*true*/);
		}
		break;
	/* ---------------------------------------------------- */
	case VOLSPACEGUARANTEE:
		long_return = 0 /*none*/;
		if (vol != NULL) {
			switch (WAFL_VOL_SPCRES(vol)) {
			case VOL_SPCRES_FILE:
				long_return = 1 /*file*/;
				break;
			case VOL_SPCRES_NONE:
				long_return = 0 /*none*/;
				break;
			case VOL_SPCRES_VOLUME:
				long_return = 2 /*volume*/;
				break;
			case VOL_SPCRES_REPLICA:
			case VOL_SPCRES_PARTIAL:
			case VOL_SPCRES_UNUSED:
			case VOL_SPCRES_INVALID:
			default:
				break;
			} // switch
		}
		break;
	/* ---------------------------------------------------- */
	case VOLLANGUAGE:
		if (vol != NULL) {
			char		returnedlangName[VAL_LANG_BUFSIZE];
			FILER_LANG	volLang;
			char *		friendlyName;
			char		line[VAL_LANG_BUFSIZE];
			char *		oem;
			char *		nfs;
			(void) WaflCodetoLangName((FILER_LANG) vol->wv_fsinfo.language,
						  returnedlangName);
			volLang = ValidateLangName(returnedlangName, line, &oem, 
						   &nfs, &friendlyName);
			if (volLang == V_LANG_UNDEFINED) {
				strcpy(Name, "undefined");
			} else {
				strlcpy(Name, friendlyName, sizeof(Name));
			}
		} else {
			strcpy(Name, "Unknown");
		}
		cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
		break;
	/* ---------------------------------------------------- */
	case VOLLANGUAGECODE:
		if (vol != NULL) {
			char returnedlangName[VAL_LANG_BUFSIZE];
			(void) WaflCodetoLangName((FILER_LANG) vol->wv_fsinfo.language,
						  returnedlangName);
			strlcpy(Name, returnedlangName, sizeof(Name));
		} else {
			strcpy(Name, "Unknown");
		}
		cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
		break;
	/* ---------------------------------------------------- */
	case VOLCLONECHILDRENLIST:
		if ((vol != NULL) && (vol->wvvv_info != NULL) &&
		    wafl_vvol_has_clones(vol->wvvv_info)) {
			vvol_info_t *	vv_info = vol->wvvv_info;
			char *		buf = NULL;
			int		buflen = 0;
			int		zapi = 0;
			do {
				clone_get_buflen(zapi, vv_info, &buflen);
				clone_realloc_buf(&buf, buflen);
			} while (!clone_copy_names(zapi, vv_info, &buf, buflen));
			if (buflen < MAX_VAL_LENGTH) {
				strcpy(Name, buf);
			} else {
				strcpy(Name, "Unavailable");
			}
			clone_free_names(&buf);
		} else {
			strcpy(Name, "");
		}
		cp = Name;      
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
		break;
	/* ---------------------------------------------------- */
	case VOLJUNCTIONPATHACTIVE:
	case VOLJUNCTIONPATH:
	case VOLJUNCTIONPATHSOURCE:
		/*
		 * Junction information not available on D-blade.
		 */
		rval = NULL;
		break;
	/* ---------------------------------------------------- */
	case VOLROWINFO:
		/*
		 * SNMP is stateless.
		 * There is no way to know if the information
		 * sent earlier about this row was complete or not.
		 */
		rval = NULL;
		break;
	/* ---------------------------------------------------- */
	case VOLINSTANCEUUID: {
		char printable_uuid[VVOL_UUID_STRING_CHARS];

		if (is_flex && vdb_info.v_vvinfo != NULL) {
			uuid_to_string_noalloc(
			       &vdb_info.v_vvinfo->vvi_raid->vvrd_instance_id,
			       printable_uuid,
			       sizeof(printable_uuid));
			snprintf(Name, MAX_VAL_LENGTH, "%s", printable_uuid);
		} else {
			strcpy(Name, "N/A");
		}
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *) cp;
                break;
	}
	/* ---------------------------------------------------- */
	case VOLPROVENANCEUUID: {
		char printable_uuid[VVOL_UUID_STRING_CHARS];

		if (is_flex) {
			if (vol != NULL) {
				uuid_to_string_noalloc(
					       &vol->wv_volinfo.provenance_id,
					       printable_uuid,
					       sizeof(printable_uuid));
				snprintf(Name, MAX_VAL_LENGTH, "%s",
					 printable_uuid);
			} else {
				strcpy(Name, "Unknown");
			}
		} else {
			strcpy(Name, "N/A");
		}
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *) cp;
                break;
	}
	/* ----------------------------- */
	default:
		ERROR("var_volEntry: magic 2");
		rval = NULL;
		break;
	/* ---------------------------------------- */
	}

end:
	vdb_iter_done(&vdb_cookie);
	if (vref != NULL) {
		vdb_volref_destroy(vref);
	}
	if (got_admin_lock) {
		outcome = alock_release(vdb, &al_handle);
		ASSERT(outcome == ALOCK_OUTCOME_SUCCESS);
	}
	return rval;
}

SK_DOMAIN_IMPORT(raid_get_node_name_by_system_id, SK_REASON_MPSAFE);
/* format is .1.3.6.1.4.1.789.1.5.11.1.magic.aggr */
uint8_t *
var_aggrEntry(SNMP_FM_ARGS)
{
        int             index;
        static char     Name[MAX_VAL_LENGTH];
        char *          cp;
        config_attr_obj_t *     aggr;
        raid_config_iter_t *    aggrIter;
        uint8_t *        rval;
	wafl_Volume	* vol;
	int 		host = sk_gethost();

	HEADER_SIMPLE_TABLE(10000);

        if (!raid_config_iterator_create(&aggrIter, RAIDTYPE_VOL)) {
                ERROR("var_aggrEntry: index 1");
                return NULL;
        }

        /*
         *  If this iterator changes, be sure to update
         *  snmp_aggregate_cnt(), too.  That routine must use
         *  the same iterator that this routine uses.
         */
	index = 1;
        while ((aggr = raid_config_iterator_next(aggrIter)) != NULL) {

		/*
		 * Skip aggregates that do not belong to this host.
		 */
		if (aggr->cao_u.u_vol.cav_host != host) {
			continue;
		}
		if (index == NAME_INDEX) {
			break;
		}
		index ++;
        }

        if (aggr == NULL) {
                ERROR("var_aggrEntry: index 2");
                raid_config_iterator_destroy(aggrIter);
                return NULL;
        }
        rval = (uint8_t *) & long_return;
        switch (vp->magic) {
        /* ---------------------------------------------------- */
        case AGGRINDEX:
                long_return = index;
                break;
        /* ---------------------------------------------------- */
        case AGGRNAME:
                strcpy(Name, aggr->cao_vol.cav_name);
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        /* ---------------------------------------------------- */
        case AGGRFSID:
                snprintf(Name, MAX_VAL_LENGTH, "%u",
                                aggr->cao_vol.cav_fsid);
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        /* ---------------------------------------------------- */
        case AGGROWNINGHOST:
                /*
                 *  See the MIB for these values:
                 *      1       == this host
                 *      2       == partner
                 */
                long_return = (sk_gethost() == aggr->cao_vol.cav_host) ?
                                1 : 2;
                break;
        /* ---------------------------------------------------- */
        case AGGRSTATE: {
                snprintf(Name, MAX_VAL_LENGTH, "%s",
                                aggr->cao_vol.cav_state_name);
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        }
        /* ---------------------------------------------------- */
        case AGGRSTATUS:
                cp = snmp_get_aggr_status_string(Name, MAX_VAL_LENGTH,
                        aggr->cao_vol.cav_name);
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        /* ---------------------------------------------------- */
        case AGGROPTIONS: {
                cp = snmp_get_aggr_options_string(Name, MAX_VAL_LENGTH,
                        aggr);
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        }
        /* ---------------------------------------------------- */
        case AGGRUUID: {
		char printable_uuid[VVOL_UUID_STRING_CHARS];

		(void)uuid_to_string_noalloc(
			(const uuid_t *)&aggr->cao_vol.cav_uuid,
			printable_uuid, sizeof(printable_uuid));
		snprintf(Name, MAX_VAL_LENGTH, "%s",
			printable_uuid);
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        }
	case AGGRFLEXVOLLIST: {
		struct vvol_info_s *wvvaq;

		strcpy(Name, "");
		/* generate a space seperated list of all the flexible
		 * volumes.
		 */
		vol = wafl_find_volume_by_name(aggr->cao_vol.cav_name,
							WIT_BASE);
		if (!vol) {
			/* The aggregate is probably not online */
			snprintf(Name, MAX_VAL_LENGTH, "Unavailable");
		} else {
			wvvaq = TAILQ_FIRST(&vol->wvva_q);
			while (wvvaq) {
				snprintf(Name, MAX_VAL_LENGTH, "%s %s", Name, 
						wvvaq->vvi_fullname);
				wvvaq = TAILQ_NEXT(wvvaq, vvi_link);
			}
		}
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *) cp;			
		break;
	}
	case AGGRTYPE: {
		int wv_type;

		wv_type = wafl_find_voltype_by_name(aggr->cao_vol.cav_name,
				WIT_RAID);
		if (wv_type == WIT_BASE)
			long_return = 2;
		else
			long_return = 1;

		break;
	}
        case AGGRRAIDTYPE: {
                snprintf(Name, MAX_VAL_LENGTH, "%s", 
		      raidtree_type_to_str( aggr->cao_vol.cav_raidtree_type));
                cp = Name;
                *var_len = strlen(cp);
                rval = (uint8_t *) cp;
                break;
        }
        /* ---------------------------------------------------- */
	case AGGRHATYPE: {
		/*
		 * Please refer the MIB for these values
		 * 0 -- none
		 * 1 -- cfo
		 * 2 -- sfo
		 */
		if (aggr->cao_vol.cav_ha_policy == HA_POLICY_SFO) {
			long_return = 2;
		} else if (aggr->cao_vol.cav_ha_policy == HA_POLICY_CFO) {
			long_return = 1;
		} else {
			long_return = 0;
		}
		break;
	 }
        /* ---------------------------------------------------- */
	case AGGROWNERS: {
		raid_get_node_name_by_system_id(aggr->cao_vol.cav_owner_id,
						Name,
						MAX_VAL_LENGTH);
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *) cp;
               	break;
	 }
        /* ---------------------------------------------------- */
	case AGGRROWINFO: {
		/*
		 * This is a cluster-only field.
		 * see burt 379294
		 */
		rval = NULL;
		break;
	 }
        /* ----------------------------- */
        default:
                ERROR("var_aggrEntry: magic 2");
                rval = NULL;
                break;
        /* ---------------------------------------- */
        }
        raid_config_iterator_destroy(aggrIter);
        return rval;
}

uint64_t nfs_pclops( pclnt_nfs_Stats *pcl_sp )
{
	uint64_t total = 0;
	int index = 0;

	for ( ; index < (NFSV2_NPROCS+NFSV3_NPROCS) ; index++ ) {
	      total += pcl_sp->srvrpccnt[ index ];
	}

	return( total );
}

/* format is 1.3.6.1.4.1.789.1.3.1.3.1.1.magic.A.B.C.D
 * A.B.C.D is IP address.
 * IPADDR starts at offset (vp->namelen - 4).
 */
uint8_t *
_var_pclEntry(SNMP_FM_ARGS)
{
	pclnt_nfs_Stats *pcl_sp;
	int magic = vp->magic;

	/*
	 * fill in object part of name for current (less sizeof instance
	 * part)
	 */
	/* XXX
	   These is about per-client NFS stats, what we do about this is 
	   still TBD. 
	 */
	if ( VV_pclnt_stat_enable == false ) {
	    ERROR("var_pclEntry: VV_pclnt_stat_enable 1");
	    return( NULL );
	}

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	snmp_fillname(name, length, 0, 18);

	if ( exact ) {
	    uint32_t    ipaddr;
	    struct in6_addr 	ip6addr;

	    {
		uint8_t *cp = (uint8_t *)&ipaddr;
		oid    *op = &(name[14]);

		*cp++ = *op++;
		*cp++ = *op++;
		*cp++ = *op++;
		*cp   = *op  ;
	    }

	    INADDR_TO_IN6ADDR(ipaddr, ip6addr);
	    /* get stats for the given ip address */
	    SK_DOMAIN_REFERENCE(pclnt_find_entry, SK_DOMAIN_NETWORK);
	    pcl_sp = pclnt_find_entry(&ip6addr);

	    if ( pcl_sp == 0 ) {
		ERROR("var_pclEntry: pclnt_find_entry 2");
		return( NULL );
	    }
	}

	else {

	    pclnt_nfs_Stats *lowest_pcl_sp = NULL;

	    oid	lowest[  SNMP_OID_MAX ];
	    oid	current[ SNMP_OID_MAX ];

	    /* flag as initially unused */
	    lowest[0] = 0;

	    bcopy((char *) vp->name, (char *) current, (int) 14 *
							sizeof(oid));

	    SK_DOMAIN_REFERENCE(pclnt_getnext_stats, SK_DOMAIN_NETWORK);
	    for ( pcl_sp = pclnt_getnext_stats( 0 ) ; pcl_sp ;
	          pcl_sp = pclnt_getnext_stats( pcl_sp ) ) {

		{
		   oid    *op;
		   uint8_t *cp;
		   cp = (uint8_t *) & (pcl_sp->clnt_ipaddr.s6_addr32[3]);
		   op = &(current[14]);

		   *op++ = *cp++;
		   *op++ = *cp++;
		   *op++ = *cp++;
		   *op   = *cp  ;
		}

		if ( (compare(current, 18, name, *length) > 0)
			&&
		     ((lowest[0] == 0) ||
		      (compare(current, 18, lowest, 18) < 0))) {
			/*
			 * if new one is greater than input and
			 * closer to input than previous lowest, save
			 * this one as the "next" one.
			 */
			bcopy((char *) current, (char *) lowest,
				18 * sizeof(oid));
			lowest_pcl_sp = pcl_sp;
		}
	    }
	    if (lowest[0] == 0) {
		ERROR("var_pclEntry: var_pclEntry 3");
		return (NULL);
	    }

	    /* now reference selected oid and stats pointer */
	    bcopy((char *) lowest, (char *) name, 18 * sizeof(oid));

	    pcl_sp = lowest_pcl_sp;
	}

	if (pcl_sp == NULL) {
		ERROR("var_pclEntry: var_pclEntry pcl_sp == NULL");
		return (NULL);
	}

	*length = 18;
	*var_len = sizeof(int32_t);

	switch (vp->magic) {
	/* --------------------------------------------------- */
	case PCLIPADDR:
	    long_return = pcl_sp->clnt_ipaddr.s6_addr32[3];
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLRPCCALLS:
	    long_return = (int32_t)(pcl_sp->rpc_calls_co + pcl_sp->rpc_calls_cl);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLRPCBADCALLS:
	    long_return = (int32_t)(pcl_sp->rpc_badlen_co + pcl_sp->rpc_badhdr_co
				+ pcl_sp->rpc_badlen_cl + pcl_sp->rpc_badhdr_cl);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLRPCNULLRECVS:
	    long_return = (int32_t)(pcl_sp->rpc_badproc_co + pcl_sp->rpc_badproc_cl);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLRPCBADLENS:
	    long_return = (int32_t)(pcl_sp->rpc_badlen_co + pcl_sp->rpc_badlen_cl);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLRPCSERVXDRCALLS:
	    long_return = (int32_t)(pcl_sp->rpc_badhdr_co + pcl_sp->rpc_badhdr_cl);
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLNFSCALLS:
	    long_return = nfs_pclops( pcl_sp );
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLNFSSERVBADCALLS:
	    long_return = pcl_sp->srv_errs;
	    return (uint8_t *) & long_return;
	/* --------------------------------------------------- */
	case PCLPERCENT:
	{
	    uint64_t nfsops = get_deltaOps();
	    SK_DOMAIN_REFERENCE(get_deltaOps, SK_DOMAIN_NETWORK);

	    long_return = ( nfsops ? percent( nfs_pclops( pcl_sp ), nfsops ) : 0 );
	    return (uint8_t *) & long_return;
	}
	/* --------------------------------------------------- */
	default:
	    if ( (magic >= PCLNFSV2START) &&
	         (magic <= PCLNFSV3END  ) ) {
	      long_return = pcl_sp->srvrpccnt[ magic - PCLNFSV2START ];
	      return (uint8_t *) & long_return;
	    }
	    else if ( (magic >= PCLNFSV2PCSTART) &&
	              (magic <= PCLNFSV3PCEND  ) ) {

	      uint64_t pclops = nfs_pclops( pcl_sp );

	      long_return = ( pclops ?
		percent( (pcl_sp->srvrpccnt[ magic - PCLNFSV2PCSTART ]),
			 pclops ) : 0 );
	      return (uint8_t *) & long_return;
	    }
	    else if ( (magic > PCLNFSV3PCEND) &&
			(magic <= PCLNFSV2RDSZEND) ) {
		long_return = (int32_t)(pcl_sp->statreadv2.bucket[ magic - (PCLNFSV3PCEND+1) ]);
		return (uint8_t *) & long_return;    
	    }
	    else if ( (magic > PCLNFSV2RDSZEND) &&
			(magic <= PCLNFSV2WRSZEND) ) {	
		long_return = (int32_t)(pcl_sp->statwritev2.bucket[ magic - (PCLNFSV2RDSZEND+1) ]);
                return (uint8_t *) & long_return;
            }
	    else if ( (magic > PCLNFSV2WRSZEND) &&
                        (magic <= PCLNFSV3RDSZEND) ) {
                long_return = (int32_t)(pcl_sp->statreadv3.bucket[ magic - (PCLNFSV2WRSZEND+1) ]);
                return (uint8_t *) & long_return;
            }
	    else if ( (magic > PCLNFSV3RDSZEND) &&
                        (magic <= PCLNFSV3WRSZEND) ) {
                long_return = (int32_t)(pcl_sp->statwritev3.bucket[ magic - (PCLNFSV3RDSZEND+1) ]);
                return (uint8_t *) & long_return;
            }
	    else {
		ERROR("var_pclEntry: magic 4");
	    }
	/* --------------------------------------------------- */
	}
	return NULL;
}

uint8_t *
var_pclEntry(SNMP_FM_ARGS)
{
	DOMAIN_SWITCH_NEST(sk_domain_network, _var_pclEntry,
			   (vp, name, length, exact, var_len, write_method)); 
}

/* use var_raidVEntry instead */
/* format is .1.3.6.1.4.1.789.1.6.1.1.magic.disk */
uint8_t *
var_raidEntry(SNMP_FM_ARGS)
{ /*XXX-1*/
	raid_config_iter_t *volIter;
	raid_config_iter_t *plexIter;
	raid_config_iter_t *raidIter;
	raid_config_iter_t *diskIter;

	config_attr_obj_t *caVol;
	config_attr_obj_t *caPlex;
	config_attr_obj_t *caRaid;
	config_attr_obj_t *caDisk;
	config_attr_group_t cagKeepGroup;	/* On local stack. (Not a pointer) */
	config_attr_obj_t caoKeepDisk;		/* On local stack. (Not a pointer) */
	config_attr_group_t *cag = &cagKeepGroup;
	config_attr_obj_t *cao = &caoKeepDisk;
	config_attr_disk_t *cad = &(cao->cao_disk);

	uint8_t	*return_ptr = NULL;

	int index;
	int host = sk_gethost();

	HEADER_SIMPLE_TABLE(10000);

	bzero(&caoKeepDisk, sizeof(caoKeepDisk));
	bzero(&cagKeepGroup, sizeof(cagKeepGroup));

	/*
	 * walk the volumes 
	 */
	if (!raid_config_iterator_create(&volIter, RAIDTYPE_VOL)) {
		ERROR("var_raidEntry: volIter");
		return NULL; /* Volume iteration error! */
	}

	for (index = 1; (caVol = raid_config_iterator_next(volIter)) != NULL;) {

		/*
		 * Skip this volume if it isn't from the current host.
		 */
		if (caVol->cao_u.u_vol.cav_host != host) {
			continue;
		}

		/*
		 * Walking down into plexes and raidgroups
		 */
		if (!raid_config_iterator_create(&plexIter, RAIDTYPE_PLEX)) {
			raid_config_iterator_destroy(volIter);
			ERROR("var_raidEntry: plexIter");
			return NULL; /* Plex iteration error! */
		}

		/*
		 * walk all plexes (in the volume)
		 */
		while ((caPlex = raid_config_iterator_next(plexIter)) != NULL) {
			/*
			 * Skip if current volume not this plex's parent
			 */
			if (caPlex->cao_parent_obj_id != caVol->cao_id.cai_obj_id)
				continue;
#ifdef RAIDDEBUG
			dbg_printf( "DBG: Vol: %s  Plex: %s index: %d\n",
				    caVol->cao_vol.cav_name, caPlex->cao_plex.cap_name, index );
#endif
			/*
			 * create iterator for raid groups
			 */
			if (!raid_config_iterator_create(&raidIter, RAIDTYPE_GROUP)) {
				raid_config_iterator_destroy(volIter);
				raid_config_iterator_destroy(plexIter);
				ERROR("var_raidEntry: raidIter");
				return NULL;  /* RAID group iteration error! */
			}

			/*
			 * walk all raid groups (in the plex)
			 */
			while ((caRaid = raid_config_iterator_next(raidIter)) != NULL) {
				/*
				 * Skip if current plex not this group's parent
				 */
				if (caRaid->cao_parent_obj_id != caPlex->cao_id.cai_obj_id)
					continue;

#ifdef RAIDDEBUG
				dbg_printf( "DBG:     Raid Group: %s index: %d\n",
					    caRaid->cao_group.cag_name, index );
#endif
				/*
				 * create iterator for disks
				 */
				if (!raid_config_iterator_create(&diskIter, RAIDTYPE_DISK)) {
					raid_config_iterator_destroy(volIter);
					raid_config_iterator_destroy(plexIter);
					raid_config_iterator_destroy(raidIter);
					ERROR("var_raidEntry: diskIter");
					return NULL;  /* Disk iteration error! */
				}

				/*
				 * walk all disks (in the raid group)
				 */
				while ((caDisk = raid_config_iterator_next(diskIter)) != NULL) {
					/*
					 * Skip if current raid group not this disk's parent
					 */
					if (caDisk->cao_parent_obj_id != caRaid->cao_id.cai_obj_id)
						continue;

					if (index == NAME_INDEX) {
						/* copy relevant info and goto found */
						bcopy(caDisk, &caoKeepDisk, sizeof(caoKeepDisk));
						bcopy(&caRaid->cao_group, &cagKeepGroup, sizeof(cagKeepGroup));
						goto found;
					}
					index++;	/* Increment the disk count */
				}
				raid_config_iterator_destroy(diskIter);
			}
			raid_config_iterator_destroy(raidIter);
			/*
			 * IMPORTANT NOTE: For this MIB, we just do the first plex!
			 */
			break;
		}
		raid_config_iterator_destroy(plexIter);
	}
	raid_config_iterator_destroy(volIter);

	return NULL;  /* Didn't find a disk! */
  found:
	/* The only way we can get here is if the disk was found during iterations. */
	raid_config_iterator_destroy(diskIter);
	raid_config_iterator_destroy(raidIter);
	raid_config_iterator_destroy(plexIter);
	raid_config_iterator_destroy(volIter);

	/*
	 * Get value for OID requested
	 */
	switch (vp->magic) {

		case RAIDINDEX:
			long_return = index;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDDISKNAME:	/* DisplayString */
			snprintf(return_buf, sizeof(return_buf),
					 "%s disk %s", cad->cad_raid_type, cao->cao_raid_name); 
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDSTATUS:
			/*
			 * See MIB:
			 * active(1),
			 * reconstructionInProgress(2),
			 * parityReconstructionInProgress(3),
			 * parityVerificationInProgress(4),
			 * scrubbingInProgress(5),
			 * failed(6),
			 * addingSpare(7),
			 * spare(8),
			 * prefailed(9),
			 * offline(10)
			 */
			long_return = snmp_get_raid_disk_status(cad,cag);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDDISKID:
			long_return = snmp_get_raid_disk_diskid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDSCSIADAPTER:	/* DisplayString */
			strlcpy(return_buf, cad->cad_host_adapter[0], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDSCSIID:
			long_return = snmp_get_raid_disk_scsiid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDUSEDMB:
			long_return = (cao->cao_raid_size + DISK_NBLOCKS_RESERVED)/ RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDUSEDBLOCKS:
			long_return = (cao->cao_raid_size + DISK_NBLOCKS_RESERVED) *
					DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDTOTALMB:
			long_return = cad->cad_waflblks / RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDTOTALBLOCKS:
			long_return = cad->cad_waflblks * DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDCOMPLETIONPERCENT:
			long_return = snmp_get_raid_disk_completion_percent(cad, cag);
			return_ptr = (uint8_t *) & long_return;
			break;

		default:
			ERROR("var_raidEntry");
			*var_len = 0;
			return_ptr = NULL;
			break;
	}
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.6.2.1.magic.volume.raidgroup.disk */
uint8_t *
var_raidVEntry(SNMP_FM_ARGS)
{ /*XXX-2*/
	raid_config_iter_t *volIter;
	raid_config_iter_t *plexIter;
	raid_config_iter_t *raidIter;
	raid_config_iter_t *diskIter;

	config_attr_obj_t *caVol;
	config_attr_obj_t *caPlex;
	config_attr_obj_t *caRaid;
	config_attr_obj_t *caDisk;
	config_attr_vol_t cavKeepVol;		/* On local stack. (Not a pointer) */
	config_attr_plex_t capKeepPlex;		/* On local stack. (Not a pointer) */
	config_attr_group_t cagKeepGroup;	/* On local stack. (Not a pointer) */
	config_attr_obj_t caoKeepDisk;		/* On local stack. (Not a pointer) */
	config_attr_vol_t *cav = &cavKeepVol;
	config_attr_plex_t *cap = &capKeepPlex;
	config_attr_group_t *cag = &cagKeepGroup;
	config_attr_obj_t *cao = &caoKeepDisk;
	config_attr_disk_t *cad = &(cao->cao_disk);
	raidobj_id_t  vol_id = 0;
	raidobj_id_t  plex_id = 0;
	raidobj_id_t  group_id = 0;
	uint64_t counter64;
	uint8_t	*return_ptr = NULL;
	boolean_t done;
	boolean_t found;
	boolean_t found_oid_match;
	boolean_t match_first_oid;
	char carrier[STSB_SERIALNO+1] = "";

/* Change to fix burt236659: When a large instance ID of type unsigned int is 
 * copied to a variable of type integer, the data was turning to be -ve.
 * This used to enable match_first_oid wrongly. Thus GETNEXT request was
 * returning response to an OID which is lexicographically smaller than the request.
 * Changing the data type of variables which will take value from the index to
 * uint32_t solves the problem
 */
	uint32_t volumeIn;
	uint32_t volume;
	int plex = 0;
	int group = 0;
	uint32_t volgroupIn;
	uint32_t volgroup = 0;
	uint32_t indexIn;
	uint32_t index = 0;
	int host = sk_gethost();

	*var_len = 0;				/* default length for abort */

#define RAIDVENTRYOIDMINLEN		12
#define RAIDVENTRYOIDMAXLEN		15
#define RAIDVENTRYOIDMAGIC		11
#define RAIDVENTRYOIDVOL		(RAIDVENTRYOIDMAGIC + 1)
#define RAIDVENTRYOIDVOLGROUP	(RAIDVENTRYOIDMAGIC + 2)
#define RAIDVENTRYOIDDISK		(RAIDVENTRYOIDMAGIC + 3)
#ifdef	DEBUG
//#define	RAIDVDEBUG				DEBUG
#endif
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}


#ifdef RAIDVDEBUG
	dbg_printf( "\nDBG: START raidVEntry: *length %d  vp->namelen %d  vp->magic %d  exact %d\n",
				 *length, vp->namelen, vp->magic, exact );
#endif
	bcopy((char *) vp->name, (char *) name, (int) vp->namelen * sizeof(oid));

	/*
	 * Incoming volume, volgroup, and disk indexes.
	 * (if missing, default to 1) 
	 */
	volumeIn   = (*length < RAIDVENTRYOIDVOL+1)      ? 1 : name[RAIDVENTRYOIDVOL]; 
	volgroupIn = (*length < RAIDVENTRYOIDVOLGROUP+1) ? 1 : name[RAIDVENTRYOIDVOLGROUP]; 
	indexIn    = (*length < RAIDVENTRYOIDDISK+1)     ? 1 : name[RAIDVENTRYOIDDISK]; 
	
	/*
	 * If these were set to 0, then start at beginning.
	 */
	volumeIn   = (volumeIn   == 0)   ? 1 : volumeIn; 
	volgroupIn = (volgroupIn == 0)   ? 1 : volgroupIn; 
	
	/*
	 * For "get next", less than full length OID means return the first good one.
	 */
	match_first_oid = (*length < RAIDVENTRYOIDMAXLEN || indexIn < 1);
	
	bzero(&cavKeepVol, sizeof(cavKeepVol));
	bzero(&capKeepPlex, sizeof(capKeepPlex));
	bzero(&cagKeepGroup, sizeof(cagKeepGroup));
	bzero(&caoKeepDisk, sizeof(caoKeepDisk));
	*length = RAIDVENTRYOIDMAXLEN;
	*write_method = 0;

	/*
	 * walk the volumes 
	 */
	if (!raid_config_iterator_create(&volIter, RAIDTYPE_VOL)) {
		ERROR("var_raidVEntry: volIter");
		return NULL; /* Volume iteration error! */
	}

	volume = 0;
	done = false;
	found = false;
	found_oid_match = false;

	while (!done && (caVol = raid_config_iterator_next(volIter)) != NULL) {

		/*
		 * Skip this volume if it isn't from the current host.
		 */
		if (caVol->cao_u.u_vol.cav_host != host) {
			continue;
		}

		volume++;

#ifdef RAIDVDEBUG
	dbg_printf( "DBG: Vol: %s  done: %d  found: %d  exact: %d  v: %u  p: %d  vg: %u  index: %u\n",
				 caVol->cao_vol.cav_name, done, found, exact, volume, plex, volgroup, index );
#endif
		/*
		 * Skip to next volume if we haven't reached volume index yet.
		 */
		if (!found_oid_match & (volume < volumeIn)) {
			continue;
		}

		/*
		 * Walking down into plexes and raidgroups
		 */
		if (!raid_config_iterator_create(&plexIter, RAIDTYPE_PLEX)) {
			raid_config_iterator_destroy(volIter);
			ERROR("var_raidVEntry: plexIter");
			return NULL; /* Plex iteration error! */
		}

		/*
		 * walk all plexes (in the volume)
		 */
		plex = 0;		/* plexes are counted per volume */
		volgroup = 0;	/* raid groups are counted per volume */
		
		while (!done && (caPlex = raid_config_iterator_next(plexIter)) != NULL) {
			/*
			 * Skip if current volume not this plex's parent
			 */
			if (caPlex->cao_parent_obj_id != caVol->cao_id.cai_obj_id)
				continue;

			plex++;

#ifdef RAIDVDEBUG
	dbg_printf( "DBG:   Plex: %s  done: %d  found: %d  exact: %d  v: %u  p: %d  vg: %u  index: %u\n",
				 caPlex->cao_plex.cap_name, done, found, exact, volume, plex, volgroup, index );
#endif
			/*
			 * create iterator for raid groups
			 */
			if (!raid_config_iterator_create(&raidIter, RAIDTYPE_GROUP)) {
				raid_config_iterator_destroy(volIter);
				raid_config_iterator_destroy(plexIter);
				ERROR("var_raidVEntry: raidIter");
				return NULL;  /* RAIDV group iteration error! */
			}

			/*
			 * walk all raid groups (in the plex)
			 */
			group = 0;	/* count groups per plex, as well as per volume */
			
			while (!done && (caRaid = raid_config_iterator_next(raidIter)) != NULL) {
				/*
				 * Skip if current plex not this group's parent
				 */
				if (caRaid->cao_parent_obj_id != caPlex->cao_id.cai_obj_id)
					continue;

				volgroup++;
				group++;

#ifdef RAIDVDEBUG
	dbg_printf( "DBG:     Raid Group: %s  done: %d  found: %d  exact: %d  v: %u  p: %d  vg: %u  index: %u\n",
				 caRaid->cao_group.cag_name, done, found, exact, volume, plex, volgroup, index );
#endif
				/*
				 * Skip to next raid group if we haven't reached volgroup index yet.
				 */
				if (!found_oid_match & (volgroup < volgroupIn)) {
					continue;
				}
				/*
				 * create iterator for disks
				 */
				if (!raid_config_iterator_create(&diskIter, RAIDTYPE_DISK)) {
					raid_config_iterator_destroy(volIter);
					raid_config_iterator_destroy(plexIter);
					raid_config_iterator_destroy(raidIter);
					ERROR("var_raidVEntry: diskIter");
					return NULL;  /* Disk iteration error! */
				}

				/*
				 * walk all disks (in the raid group)
				 */
				index = 0; /* disks are counted per raid group */
				
				while (!done && (caDisk = raid_config_iterator_next(diskIter)) != NULL) {
					/*
					 * Skip if current raid group not this disk's parent
					 */
					if (caDisk->cao_parent_obj_id != caRaid->cao_id.cai_obj_id)
						continue;

					index++;	/* Increment the disk count for next iteration */

#ifdef RAIDVDEBUG
	dbg_printf( "DBG:          Disk:  %s - %s - '%s' (%d) exact: %d  v: %u  vIn: %u  p: %d  vg: %u  vgIn: %u  index: %u  indexIn: %u\n",
				 caDisk->cao_disk.cad_raid_name, caDisk->cao_disk.cad_name, caDisk->cao_disk.cad_phys_name,
				 caDisk->cao_fsm_state, exact, volume, volumeIn, plex, volgroup, volgroupIn, index, indexIn );
#endif
					/*
					 * Is this the "next" or "first" valid OID?
					 */
					if (!exact && (found_oid_match || match_first_oid)) {
						if (caDisk != NULL) {
							found = true;
							bcopy(&caVol->cao_vol, &cavKeepVol, sizeof(cavKeepVol));
							bcopy(&caPlex->cao_plex, &capKeepPlex, sizeof(capKeepPlex));
							bcopy(&caRaid->cao_group, &cagKeepGroup, sizeof(cagKeepGroup));
							bcopy(caDisk, &caoKeepDisk, sizeof(caoKeepDisk));
							vol_id   = caVol->cao_id.cai_obj_id;
							plex_id  = caPlex->cao_id.cai_obj_id;
							group_id = caRaid->cao_id.cai_obj_id;
#ifdef RAIDVDEBUG
	dbg_printf( "DBG:          Found %s: %s - %s disk %s    exact: %d  cag_scrub: %d  cag_reparity: %d\n",
				 exact ? "EXACT":"NEXT ", cad->cad_raid_name, cad->cad_raid_type, cao->cao_raid_name, exact, cag->cag_scrub, cag->cag_reparity );
#endif
						}
						done = true;
						break; /* This needs to break out of everything */
					}

					found_oid_match = ((volume == volumeIn)
										&& (volgroup == volgroupIn)
										&& (index == indexIn));

					/*
					 * Is this the "exact" valid OID we are looking for?
					 */
					if (exact && found_oid_match) {
						if (caDisk != NULL) {
							found = true;
							bcopy(&caVol->cao_vol, &cavKeepVol, sizeof(cavKeepVol));
							bcopy(&caPlex->cao_plex, &capKeepPlex, sizeof(capKeepPlex));
							bcopy(&caRaid->cao_group, &cagKeepGroup, sizeof(cagKeepGroup));
							bcopy(caDisk, &caoKeepDisk, sizeof(caoKeepDisk));
							vol_id   = caVol->cao_id.cai_obj_id;
							plex_id  = caPlex->cao_id.cai_obj_id;
							group_id = caRaid->cao_id.cai_obj_id;
#ifdef RAIDVDEBUG
	// dbg_printf( "DBG: %s\n", "cao" );
	// dbg_hexdump(cao, sizeof(caoKeepDisk));
	// dbg_printf( "DBG:          bcopy: sizeof(caoKeepDisk): %d  &caoKeepDisk: 0x%lx  cao: 0x%lx  cad: 0x%lx\n",
	//			 sizeof(caoKeepDisk), (long unsigned int)&caoKeepDisk, (long unsigned int)cao, (long unsigned int)cad );
#endif
#ifdef RAIDVDEBUG
	dbg_printf( "DBG:          Found %s: %s - %s disk %s    exact: %d  cag_scrub: %d  cag_reparity: %d\n",
				 exact ? "EXACT":"NEXT ", cad->cad_raid_name, cad->cad_raid_type, cao->cao_raid_name, exact, cag->cag_scrub, cag->cag_reparity );
#endif
						}
						done = true;
						break; /* This needs to break out of everything */
					}
				}
				raid_config_iterator_destroy(diskIter);
			}
			raid_config_iterator_destroy(raidIter);
		}
		raid_config_iterator_destroy(plexIter);
	}
	raid_config_iterator_destroy(volIter);

	/*
	 * Update name to point to next item (OID) 
	 */
	name[RAIDVENTRYOIDVOL]      = volume;
	name[RAIDVENTRYOIDVOLGROUP] = volgroup;
	name[RAIDVENTRYOIDDISK]     = index;

#ifdef RAIDVDEBUG
	dbg_printf( "DBG:          Update:  found: %d  exact: %d  v: %u  p: %d  g: %u  vg: %u  index: %u\n",
				 found, exact, name[RAIDVENTRYOIDVOL], plex, group,
				 name[RAIDVENTRYOIDVOLGROUP], name[RAIDVENTRYOIDDISK] );
#endif
	if (!found) {
		return NULL;  /* Didn't find a disk! */
	}
	
	*var_len = sizeof(int32_t);	/* default length for INTEGER */

	switch (vp->magic) {

	case RAIDVINDEX:
			long_return = index;
			return_ptr = (uint8_t *) & long_return;
			break;

	case RAIDVDISKNAME:	/* DisplayString */
			snprintf(return_buf, sizeof(return_buf),
				 "%s disk %s", cad->cad_raid_type, 
				 cao->cao_raid_name); 
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

    	case RAIDVSTATUS:
			/*
			 * See MIB:
			 * active(1),
			 * reconstructionInProgress(2),
			 * parityReconstructionInProgress(3),
			 * parityVerificationInProgress(4),
			 * scrubbingInProgress(5),
			 * failed(6),
			 * prefailed(9),
			 * offline(10)
			 */
			long_return = snmp_get_raid_disk_status(cad,cag);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVDISKID:
			long_return = snmp_get_raid_disk_diskid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVSCSIADAPTER:	/* DisplayString */
			strlcpy(return_buf, cad->cad_host_adapter[0], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case RAIDVSCSIID:
			long_return = snmp_get_raid_disk_scsiid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVUSEDMB:
			long_return = (cao->cao_raid_size + DISK_NBLOCKS_RESERVED)/ RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVUSEDBLOCKS:
			long_return = (cao->cao_raid_size + DISK_NBLOCKS_RESERVED)*
				DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVTOTALMB:
			long_return = cad->cad_waflblks / RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVTOTALBLOCKS:
			long_return = cad->cad_waflblks * DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVCOMPLETIONPERCENT:
			long_return = snmp_get_raid_disk_completion_percent(cad, cag);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVVOL:
			long_return = volume;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVGROUP:
			long_return = volgroup;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVDISKNUMBER:
			long_return = snmp_get_raid_disk_disks_in_group(group_id);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVGROUPNUMBER:
			long_return = snmp_get_raid_disk_groups_in_volume(vol_id);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVDISKPORT:
			long_return = snmp_get_raid_disk_diskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVSECONDARYDISKNAME:	/* DisplayString */
			strlcpy(return_buf, cad->cad_path_name[1], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVSECONDARYDISKPORT:
			long_return = snmp_get_raid_disk_secondarydiskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVSHELF:
			long_return = cad->cad_shelf;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVBAY:
			long_return = cad->cad_bay;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVPLEX:
			long_return = plex;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVPLEXGROUP:
			long_return = group;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVPLEXNUMBER:
			long_return = cav->cav_plex_count;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDVPLEXNAME:	/* DisplayString */
			strlcpy(return_buf, cap->cap_name, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
		
		case RAIDVSECTORSIZE:
			long_return = cad->cad_bps;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDVDISKSERIALNUMBER: /* DisplayString */
			strlcpy(return_buf, cad->cad_serialno, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKVENDOR: /* DisplayString */
			strlcpy(return_buf, cad->cad_vendor, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKMODEL: /* DisplayString */
			strlcpy(return_buf, cad->cad_model, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKFIRMWAREREVISION: /* DisplayString */
			strlcpy(return_buf, cad->cad_fw_revision, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKRPM: /* DisplayString */
			strlcpy(return_buf, 
				disk_rpm_string(cad->cad_rpm),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKTYPE: /* DisplayString */
			strlcpy(return_buf, 
				disk_type_string(cad->cad_type, "  ? "),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKPOOL: /* DisplayString */
			strlcpy(return_buf, 
				disk_pool_string(cad->cad_pool),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDVDISKCOPYDESTDISKNAME: /* DisplayString */
		{
			char sdc_target_disk_name[MAX_RAIDNAME_SIZE] = "-";

			/*
			 * Intentionally ignoring return value
			 * since we have same action for both cases.
			 */
			(void)snmp_get_sdc_target_disk_name_and_copy_percentage(
				cad,
				sdc_target_disk_name, 
				sizeof(sdc_target_disk_name),
				NULL);

			strlcpy(return_buf, sdc_target_disk_name, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
		}

		case RAIDVDISKUID: /* DisplayString */
			SK_DOMAIN_IMPORT(disk_unique_id_to_str, SK_REASON_MPSAFE);
			disk_unique_id_to_str(&cad->cad_uid, return_buf);
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDV64USEDBLOCKS:
			counter64 = (uint64_t)(cao->cao_raid_size + DISK_NBLOCKS_RESERVED) * 
						DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case RAIDV64TOTALBLOCKS:
			counter64 = (uint64_t)(cad->cad_waflblks) * 
						DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case RAIDVCARRIERID:
			if (cad->cad_multidisk_carrier) {
				strlcpy(carrier, cad->cad_carrier_serialno, sizeof(carrier));
			}
			strlcpy(return_buf, carrier, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		default:
			ERROR("var_raidVEntry");
			*var_len = 0;
			return_ptr = NULL;
			break;
	}
	
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.6.10.1.magic.volume.plex.raidgroup.disk */
uint8_t *
var_raidPEntry(SNMP_FM_ARGS)
{ /*XXX-3*/
	raid_config_iter_t *volIter;
	raid_config_iter_t *plexIter;
	raid_config_iter_t *raidIter;
	raid_config_iter_t *diskIter;

	config_attr_obj_t *caVol;
	config_attr_obj_t *caPlex;
	config_attr_obj_t *caRaid;
	config_attr_obj_t *caDisk;
	config_attr_vol_t cavKeepVol;		/* On local stack. (Not a pointer) */
	config_attr_plex_t capKeepPlex;		/* On local stack. (Not a pointer) */
	config_attr_group_t cagKeepGroup;	/* On local stack. (Not a pointer) */
	config_attr_obj_t caoKeepDisk;		/* On local stack. (Not a pointer) */
	config_attr_vol_t *cav = &cavKeepVol;
	config_attr_plex_t *cap = &capKeepPlex;
	config_attr_group_t *cag = &cagKeepGroup;
	config_attr_obj_t *cao = &caoKeepDisk;
	config_attr_disk_t *cad = &(cao->cao_disk);
	raidobj_id_t  vol_id = 0;
	raidobj_id_t  plex_id = 0;
	raidobj_id_t  group_id = 0;
	uint64_t counter64;
	uint8_t	*return_ptr = NULL;
	boolean_t done;
	boolean_t found;
	boolean_t found_oid_match;
	boolean_t match_first_oid;

	uint32_t volumeIn;
	uint32_t volume;
	uint32_t plexIn;
	uint32_t plex = 0;
	uint32_t groupIn;
	uint32_t group = 0;
	uint32_t indexIn;
	uint32_t index = 0;
	char carrier[STSB_SERIALNO+1] = "";
	int host = sk_gethost();

	*var_len = 0;				/* default length for abort */

#define RAIDPENTRYOIDMINLEN	12
#define RAIDPENTRYOIDMAXLEN		16
#define RAIDPENTRYOIDMAGIC		11
#define RAIDPENTRYOIDVOL		(RAIDPENTRYOIDMAGIC + 1)
#define RAIDPENTRYOIDPLEX		(RAIDPENTRYOIDMAGIC + 2)
#define RAIDPENTRYOIDGROUP		(RAIDPENTRYOIDMAGIC + 3)
#define RAIDPENTRYOIDDISK		(RAIDPENTRYOIDMAGIC + 4)
#ifdef	DEBUG
//#define	RAIDPDEBUG				DEBUG
#endif

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

#ifdef RAIDPDEBUG
	dbg_printf( "\nDBG: START raidPEntry: *length %d  vp->namelen %d  vp->magic %d  exact %d\n",
				 *length, vp->namelen, vp->magic, exact );
#endif

	bcopy((char *) vp->name, (char *) name, (int) vp->namelen * sizeof(oid));
	
	/*
	 * Incoming volume, group, and disk indexes.
	 * (if missing, default to 1) 
	 */
	volumeIn   = (*length < RAIDPENTRYOIDVOL+1)      ? 1 : name[RAIDPENTRYOIDVOL]; 
	plexIn     = (*length < RAIDPENTRYOIDPLEX+1)     ? 1 : name[RAIDPENTRYOIDPLEX]; 
	groupIn    = (*length < RAIDPENTRYOIDGROUP+1)    ? 1 : name[RAIDPENTRYOIDGROUP]; 
	indexIn    = (*length < RAIDPENTRYOIDDISK+1)     ? 1 : name[RAIDPENTRYOIDDISK]; 

	/*
	 * If these were set to 0, then start at beginning.
	 */
	volumeIn   = (volumeIn   == 0)   ? 1 : volumeIn;
	plexIn     = (plexIn     == 0)   ? 1 : plexIn;
	groupIn    = (groupIn    == 0)   ? 1 : groupIn;

	/*
	 * For "get next", less than full length OID means return the first good one.
	 */
	match_first_oid = (*length < RAIDPENTRYOIDMAXLEN || indexIn < 1);
	
	bzero(&cavKeepVol, sizeof(cavKeepVol));
	bzero(&capKeepPlex, sizeof(capKeepPlex));
	bzero(&cagKeepGroup, sizeof(cagKeepGroup));
	bzero(&caoKeepDisk, sizeof(caoKeepDisk));
	*length = RAIDPENTRYOIDMAXLEN;
	*write_method = 0;

	/*
	 * walk the volumes 
	 */
	if (!raid_config_iterator_create(&volIter, RAIDTYPE_VOL)) {
		ERROR("var_raidPEntry: volIter");
		return NULL; /* Volume iteration error! */
	}

	volume = 0;
	done = false;
	found = false;
	found_oid_match = false;

	while (!done && (caVol = raid_config_iterator_next(volIter)) != NULL) {
		/*
		 * Skip this volume if it isn't from the current host.
		 */
		if (caVol->cao_u.u_vol.cav_host != host) {
			continue;
		}

		volume++;

#ifdef RAIDPDEBUG
	dbg_printf( "DBG: Vol: %s  done: %d  found: %d  exact: %d  v: %u  p: %u  g: %u  index: %u\n",
				 caVol->cao_vol.cav_name, done, found, exact, volume, plex, group, index );
#endif
		/*
		 * Skip to next volume if we haven't reached volume index yet.
		 */
		if (!found_oid_match & (volume < volumeIn)) {
			continue;
		}

		/*
		 * Walking down into plexes and raidgroups
		 */
		if (!raid_config_iterator_create(&plexIter, RAIDTYPE_PLEX)) {
			raid_config_iterator_destroy(volIter);
			ERROR("var_raidPEntry: plexIter");
			return NULL; /* Plex iteration error! */
		}

		/*
		 * walk all plexes (in the volume)
		 */
		plex  = 0;	/* plexes are counted per volume */
		
		while (!done && (caPlex = raid_config_iterator_next(plexIter)) != NULL) {
			/*
			 * Skip if current volume not this plex's parent
			 */
			if (caPlex->cao_parent_obj_id != caVol->cao_id.cai_obj_id)
				continue;

			plex++;

#ifdef RAIDPDEBUG
	dbg_printf( "DBG:   Plex: %s  done: %d  found: %d  exact: %d  v: %u  p: %u  g: %u  index: %u\n",
				 caPlex->cao_plex.cap_name, done, found, exact, volume, plex, group, index );
#endif
			/*
			 * Skip to next plex if we haven't reached plex index yet.
			 */
			if (!found_oid_match & (plex < plexIn)) {
				continue;
			}
	
			/*
			 * create iterator for raid groups
			 */
			if (!raid_config_iterator_create(&raidIter, RAIDTYPE_GROUP)) {
				raid_config_iterator_destroy(volIter);
				raid_config_iterator_destroy(plexIter);
				ERROR("var_raidPEntry: raidIter");
				return NULL;  /* RAIDP group iteration error! */
			}

			/*
			 * walk all raid groups (in the plex)
			 */
			group = 0;	/* raid groups are counted per plex */
			
			while (!done && (caRaid = raid_config_iterator_next(raidIter)) != NULL) {
				/*
				 * Skip if current plex not this group's parent
				 */
				if (caRaid->cao_parent_obj_id != caPlex->cao_id.cai_obj_id)
					continue;

				group++;

#ifdef RAIDPDEBUG
	dbg_printf( "DBG:     Raid Group: %s  done: %d  found: %d  exact: %d  v: %u  p: %u  g: %u  index: %u\n",
				 caRaid->cao_group.cag_name, done, found, exact, volume, plex, group, index );
#endif
				/*
				 * Skip to next raid group if we haven't reached group index yet.
				 */
				if (!found_oid_match & (group < groupIn)) {
					continue;
				}
				/*
				 * create iterator for disks
				 */
				if (!raid_config_iterator_create(&diskIter, RAIDTYPE_DISK)) {
					raid_config_iterator_destroy(volIter);
					raid_config_iterator_destroy(plexIter);
					raid_config_iterator_destroy(raidIter);
					ERROR("var_raidPEntry: diskIter");
					return NULL;  /* Disk iteration error! */
				}

				/*
				 * walk all disks (in the raid group)
				 */
				index = 0; /* disks are counted per raid group */
				
				while (!done && (caDisk = raid_config_iterator_next(diskIter)) != NULL) {
					/*
					 * Skip if current raid group not this disk's parent
					 */
					if (caDisk->cao_parent_obj_id != caRaid->cao_id.cai_obj_id)
						continue;

					index++;	/* Increment the disk count for next iteration */

#ifdef RAIDPDEBUG
	dbg_printf( "DBG:          Disk:  %s - %s - '%s' (%d) exact: %d  v: %u  vIn: %u  p: %u  g: %u  gIn: %u  index: %u  indexIn: %u\n",
				 caDisk->cao_disk.cad_raid_name, caDisk->cao_disk.cad_name, caDisk->cao_disk.cad_phys_name,
				 caDisk->cao_fsm_state, exact, volume, volumeIn, plex, group, groupIn, index, indexIn );
#endif
					/*
					 * Is this the "next" or "first" valid OID?
					 */
					if (!exact && (found_oid_match || match_first_oid)) {
						if (caDisk != NULL) {
							found = true;
							bcopy(&caVol->cao_vol, &cavKeepVol, sizeof(cavKeepVol));
							bcopy(&caPlex->cao_plex, &capKeepPlex, sizeof(capKeepPlex));
							bcopy(&caRaid->cao_group, &cagKeepGroup, sizeof(cagKeepGroup));
							bcopy(caDisk, &caoKeepDisk, sizeof(caoKeepDisk));
							vol_id   = caVol->cao_id.cai_obj_id;
							plex_id  = caPlex->cao_id.cai_obj_id;
							group_id = caRaid->cao_id.cai_obj_id;
#ifdef RAIDPDEBUG
	dbg_printf( "DBG:          Found %s: %s - %s disk %s    exact: %d  cag_scrub: %d  cag_reparity: %d\n",
				 exact ? "EXACT":"NEXT ", cad->cad_raid_name, cad->cad_raid_type, cao->cao_raid_name, exact, cag->cag_scrub, cag->cag_reparity );
#endif
						}
						done = true;
						break; /* This needs to break out of everything */
					}

					found_oid_match = ((volume == volumeIn)
										&& (group == groupIn)
										&& (index == indexIn));

					/*
					 * Is this the "exact" valid OID we are looking for?
					 */
					if (exact && found_oid_match) {
						if (caDisk != NULL) {
							found = true;
							bcopy(&caVol->cao_vol, &cavKeepVol, sizeof(cavKeepVol));
							bcopy(&caPlex->cao_plex, &capKeepPlex, sizeof(capKeepPlex));
							bcopy(&caRaid->cao_group, &cagKeepGroup, sizeof(cagKeepGroup));
							bcopy(caDisk, &caoKeepDisk, sizeof(caoKeepDisk));
							vol_id   = caVol->cao_id.cai_obj_id;
							plex_id  = caPlex->cao_id.cai_obj_id;
							group_id = caRaid->cao_id.cai_obj_id;
#ifdef RAIDPDEBUG
	// dbg_printf( "DBG: %s\n", "cao" );
	// dbg_hexdump(cao, sizeof(caoKeepDisk));
	// dbg_printf( "DBG:          bcopy: sizeof(caoKeepDisk): %d  &caoKeepDisk: 0x%lx  cao: 0x%lx  cad: 0x%lx\n",
	//			 sizeof(caoKeepDisk), (long unsigned int)&caoKeepDisk, (long unsigned int)cao, (long unsigned int)cad );
#endif
#ifdef RAIDPDEBUG
	dbg_printf( "DBG:          Found %s: %s - %s disk %s    exact: %d  cag_scrub: %d  cag_reparity: %d\n",
				 exact ? "EXACT":"NEXT ", cad->cad_raid_name, cad->cad_raid_type, cao->cao_raid_name, exact, cag->cag_scrub, cag->cag_reparity );
#endif
						}
						done = true;
						break; /* This needs to break out of everything */
					}
				}
				raid_config_iterator_destroy(diskIter);
			}
			raid_config_iterator_destroy(raidIter);
		}
		raid_config_iterator_destroy(plexIter);
	}
	raid_config_iterator_destroy(volIter);

	/*
	 * Update name to point to next item (OID) 
	 */
	name[RAIDPENTRYOIDVOL]   = volume;
	name[RAIDPENTRYOIDPLEX]  = plex;
	name[RAIDPENTRYOIDGROUP] = group;
	name[RAIDPENTRYOIDDISK]  = index;

#ifdef RAIDPDEBUG
	dbg_printf( "DBG:          Update:  found: %d  exact: %d  v: %u  p: %u  g: %u  index: %u\n",
				 found, exact, name[RAIDPENTRYOIDVOL], name[RAIDPENTRYOIDPLEX],
				 name[RAIDPENTRYOIDGROUP], name[RAIDPENTRYOIDDISK] );
#endif
	if (!found) {
		return NULL;  /* Didn't find a disk! */
	}
	
	*var_len = sizeof(int32_t);	/* default length for INTEGER */

	switch (vp->magic) {

		case RAIDPINDEX:
			long_return = index;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPSTATUS:
			/*
			 * See MIB:
			 * active(1),
			 * reconstructionInProgress(2),
			 * parityReconstructionInProgress(3),
			 * parityVerificationInProgress(4),
			 * scrubbingInProgress(5),
			 * failed(6),
			 * prefailed(9),
			 * offline(10)
			 */
			long_return = snmp_get_raid_disk_status(cad,cag);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPVOL:
			long_return = volume;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPPLEX:
			long_return = plex;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPGROUP:
			long_return = group;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPPLEXNUMBER:
			long_return = cav->cav_plex_count;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPGROUPNUMBER:
			long_return = snmp_get_raid_disk_groups_in_plex(plex_id);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPDISKNUMBER:
			long_return = snmp_get_raid_disk_disks_in_group(group_id);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPPLEXNAME:	/* DisplayString */
			strlcpy(return_buf, cap->cap_name, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
		
		case RAIDPDISKNAME:	/* DisplayString */
			snprintf(return_buf, sizeof(return_buf),
					 "%s disk %s", cad->cad_raid_type, cao->cao_raid_name); 
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKPORT:
			long_return = snmp_get_raid_disk_diskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPSECONDARYDISKNAME:	/* DisplayString */
			strlcpy(return_buf, cad->cad_path_name[1], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPSECONDARYDISKPORT:
			long_return = snmp_get_raid_disk_secondarydiskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPSCSIADAPTER:	/* DisplayString */
			strlcpy(return_buf, cad->cad_host_adapter[0], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case RAIDPSCSIID:
			long_return = snmp_get_raid_disk_scsiid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPDISKID:
			long_return = snmp_get_raid_disk_diskid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPSHELF:
			long_return = cad->cad_shelf;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPBAY:
			long_return = cad->cad_bay;
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPSECTORSIZE:
			long_return = cad->cad_bps;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPUSEDMB:
			long_return = (cao->cao_raid_size + DISK_NBLOCKS_RESERVED)/ RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPUSEDBLOCKS:
			long_return = (cao->cao_raid_size + DISK_NBLOCKS_RESERVED)*
				DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPTOTALMB:
			long_return = cad->cad_waflblks / RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPTOTALBLOCKS:
			long_return = cad->cad_waflblks * DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case RAIDPCOMPLETIONPERCENT:
			long_return = snmp_get_raid_disk_completion_percent(cad, cag);
			return_ptr = (uint8_t *) & long_return;
			break;

		case RAIDPDISKSERIALNUMBER: /* DisplayString */
			strlcpy(return_buf, cad->cad_serialno, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKVENDOR: /* DisplayString */
			strlcpy(return_buf, cad->cad_vendor, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKMODEL: /* DisplayString */
			strlcpy(return_buf, cad->cad_model, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKFIRMWAREREVISION: /* DisplayString */
			strlcpy(return_buf, cad->cad_fw_revision, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKRPM: /* DisplayString */
			strlcpy(return_buf, 
				disk_rpm_string(cad->cad_rpm),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKTYPE: /* DisplayString */
			strlcpy(return_buf, 
				disk_type_string(cad->cad_type, "  ? "),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKPOOL: /* DisplayString */
			strlcpy(return_buf, 
				disk_pool_string(cad->cad_pool),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case RAIDPDISKCOPYDESTDISKNAME: /* DisplayString */
		{
			char sdc_target_disk_name[MAX_RAIDNAME_SIZE] = "-";

			/*
			 * Intentionally ignoring return value
			 * since we have same action for both cases.
			 */
			(void)snmp_get_sdc_target_disk_name_and_copy_percentage(
				cad,
				sdc_target_disk_name, 
				sizeof(sdc_target_disk_name),
				NULL);

			strlcpy(return_buf, sdc_target_disk_name, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
		}

		case RAIDP64USEDBLOCKS:
			counter64 = (uint64_t)(cao->cao_raid_size + DISK_NBLOCKS_RESERVED) * 
						DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case RAIDP64TOTALBLOCKS:
			counter64 = (uint64_t)(cad->cad_waflblks) * 
						DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case RAIDPCARRIERID:
			if (cad->cad_multidisk_carrier) {
				strlcpy(carrier, cad->cad_carrier_serialno, sizeof(carrier));
			}
			strlcpy(return_buf, carrier, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		default:
			ERROR("var_raidPEntry");
			*var_len = 0;
			return_ptr = NULL;
			break;
	}
	
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.6.3.1.magic.disk */
uint8_t *
var_spareEntry(SNMP_FM_ARGS)
{ /*XXX-4*/
	raid_config_iter_t *diskIter;

	config_attr_obj_t *caDisk;
	config_attr_obj_t caoKeepDisk;	/* On local stack. (Not a pointer) */
	config_attr_obj_t *cao = &caoKeepDisk;
	config_attr_disk_t *cad = &(cao->cao_disk);
	uint64_t counter64;
	uint8_t	*return_ptr = NULL;
	int index = 0;
	int host = sk_gethost();
	int raid_status;
	char carrier[STSB_SERIALNO+1] = "";

	*var_len = 0;				/* default length for abort */

	HEADER_SIMPLE_TABLE(10000);

	bzero(&caoKeepDisk, sizeof(caoKeepDisk));

	/*
	 * create iterator for disks
	 */
	if (!raid_config_iterator_create(&diskIter, RAIDTYPE_DISK)) {
		ERROR("var_spareEntry: diskIter");
		return NULL;  /* Disk iteration error! */
	}

	/*
	 * walk all disks
	 */
	index = 1;
	while ((caDisk = raid_config_iterator_next(diskIter)) != NULL) {
		
		/*
		 * Only look at spare disks.
		 */
		if (!caDisk->cao_disk.cad_spare) {
			continue;
		}
		/*
		 * Also need to ignore disks that don't belong to this host.
		 */
		if (caDisk->cao_disk.cad_host != host) {
			continue;
		}

		if (index == NAME_INDEX) {
			bcopy(caDisk, &caoKeepDisk, sizeof(caoKeepDisk));
			break;
		}
		index++;	/* Increment the disk count for next iteration */
	}
	raid_config_iterator_destroy(diskIter);

	if (caDisk == NULL) {
		return NULL;  /* Didn't find a disk! */
	}
	
	switch (vp->magic) {

		case SPAREINDEX:
			long_return = index;
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPAREDISKNAME:	/* DisplayString */
			snprintf(return_buf, sizeof(return_buf),
					 "%s disk %s", spare_str, cao->cao_raid_name); 
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

	    	case SPARESTATUS:
			/*
			 * See MIB:
			spare(1),
			addingspare(2),
			bypassed(3),
			unknown(4),
			offline(10)
			 */
			raid_status = snmp_get_raid_disk_status(cad,NULL);
			switch (raid_status) {
				case RAIDSTSPARE:
					if (snmp_get_raid_disk_bypassed(cad)) {
						long_return = 3;
					}
					else {
						long_return = 1;
					}
					break;
				case RAIDSTADDSPARE:
					long_return = 2;
					break;
				case RAIDSTOFFLINE:
					long_return = RAIDSTOFFLINE;
					break;
				default:
					long_return = 4;
					break;
			}
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPAREDISKID:
			long_return = snmp_get_raid_disk_diskid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case SPARESCSIADAPTER:	/* DisplayString */
			strlcpy(return_buf, cad->cad_host_adapter[0], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case SPARESCSIID:
			long_return = snmp_get_raid_disk_scsiid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case SPARETOTALMB:
			long_return = cad->cad_waflblks / RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case SPARETOTALBLOCKS:
			long_return = cad->cad_waflblks * DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case SPAREDISKPORT:
			long_return = snmp_get_raid_disk_diskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPARESECONDARYDISKNAME:	/* DisplayString */
			strlcpy(return_buf, cad->cad_path_name[1], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPARESECONDARYDISKPORT:
			long_return = snmp_get_raid_disk_secondarydiskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPARESHELF:
			long_return = cad->cad_shelf;
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPAREBAY:
			long_return = cad->cad_bay;
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPAREPOOL: /* DisplayString */
			long_return = snmp_get_raid_disk_pool(cao, return_buf, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case SPARESECTORSIZE:
			long_return = cad->cad_bps;
			return_ptr = (uint8_t *) & long_return;
			break;

		case SPAREDISKSERIALNUMBER: /* DisplayString */
			strlcpy(return_buf, cad->cad_serialno, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPAREDISKVENDOR: /* DisplayString */
			strlcpy(return_buf, cad->cad_vendor, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPAREDISKMODEL: /* DisplayString */
			strlcpy(return_buf, cad->cad_model, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPAREDISKFIRMWAREREVISION: /* DisplayString */
			strlcpy(return_buf, cad->cad_fw_revision, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPAREDISKRPM: /* DisplayString */
			strlcpy(return_buf, 
				disk_rpm_string(cad->cad_rpm),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPAREDISKTYPE: /* DisplayString */
			strlcpy(return_buf, 
				disk_type_string(cad->cad_type, "  ? "),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPAREDISKUID: /* DisplayString */
			SK_DOMAIN_IMPORT(disk_unique_id_to_str, SK_REASON_MPSAFE);
			disk_unique_id_to_str(&cad->cad_uid, return_buf);
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case SPARE64TOTALBLOCKS:
			counter64 = (uint64_t)(cad->cad_waflblks) * 
						DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case SPARECARRIERID:
			if (cad->cad_multidisk_carrier) {
				strlcpy(carrier, cad->cad_carrier_serialno, sizeof(carrier));
			}
			strlcpy(return_buf, carrier, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		default:
			ERROR("var_spareEntry");
			*var_len = 0;
			return_ptr = NULL;
			break;
	}
	
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.6.2.1.magic.disk */
uint8_t *
var_otherDiskEntry(SNMP_FM_ARGS)
{ /*XXX-5*/
	raid_config_iter_t *diskIter;
	raid_disk_iterator_t it;
	config_attr_obj_t *caDisk;
	config_attr_obj_t caoKeepDisk;	/* On local stack. (Not a pointer) */
	config_attr_obj_t *cao = &caoKeepDisk;
	config_attr_disk_t *cad = &(cao->cao_disk);
	uint64_t counter64;
	uint8_t	*return_ptr = NULL;
	int index = 0;
	char carrier[STSB_SERIALNO+1] = "";
	int host = sk_gethost();
	char disk_name[MAX_DISK_NAME];

//#define	OTHERDISKDEBUG				DEBUG

	HEADER_SIMPLE_TABLE(10000);

	bzero(&caoKeepDisk, sizeof(caoKeepDisk));

	/*
	 * create iterator for disks
	 */
	if (!raid_config_iterator_create(&diskIter, RAIDTYPE_DISK)) {
		ERROR("var_otherDiskEntry: diskIter");
		return NULL;  /* Disk iteration error! */
	}

	/*
	 * walk all disks
	 */
	index = 1;
	while ((caDisk = raid_config_iterator_next(diskIter)) != NULL) {
		
		/*
		 * Only look at broken disks.
		 */
		if (!caDisk->cao_disk.cad_broken) {
			continue;
		}
		/*
		 * Also need to ignore disks that don't belong to this host.
		 */
		if (caDisk->cao_disk.cad_host != host) {
			continue;
		}
		
		if (index == NAME_INDEX) {
			bcopy(caDisk, cao, sizeof(caoKeepDisk));
			break;
		}
		index ++;
	}

	raid_config_iterator_destroy(diskIter);

	/*
	 * Below code is valid only for online maintenance disks.
	 */
	if (caDisk == NULL) {
		raid_disk_iterator_init(&it);
		while (raid_disk_iterator_including_uninit(&it)) {

			/* Discard non-owned disks */
			if (!raid_owner_native(it.rdi_owner)) {
				continue;
			}

			if (!raid_disk_id_is_in_labelmaint(it.rdi_id)) {
				continue;
			}

			if (raid_disk_id_name(it.rdi_id, disk_name) != E_NO_ERROR) {
				continue;
			}
			if (!get_disk_attributes(disk_name, &caoKeepDisk, false)) {
				continue;
			}

			if (index == NAME_INDEX) {
				caDisk = &caoKeepDisk;
				break;
			}
			index++;
		}
	}

	if (caDisk == NULL) {
		return NULL;
	}

	switch (vp->magic) {

		case OTHERDISKINDEX:
			long_return = index;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKDISKNAME:	/* DisplayString */
			snprintf(return_buf, sizeof(return_buf),
				 "%s disk %s",
				 disk_failure_reason_string(cao->cao_disk.cad_outage_reason),
				 cao->cao_raid_name);
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

    	        case OTHERDISKSTATUS:
			/*
			 * See MIB:
			broken(1),
			bypassed(2),
			unknown(3)
			 */
			if (snmp_get_raid_disk_bypassed(cad)) {
				long_return = 2;
			}
			else {
				long_return = 1;
			}
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKDISKID:
			long_return = snmp_get_raid_disk_diskid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OTHERDISKSCSIADAPTER:	/* DisplayString */
			strlcpy(return_buf, cad->cad_host_adapter[0], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case OTHERDISKSCSIID:
			long_return = snmp_get_raid_disk_scsiid(cad);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OTHERDISKTOTALMB:
			long_return = cad->cad_waflblks / RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OTHERDISKTOTALBLOCKS:
			long_return = cad->cad_waflblks * DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OTHERDISKDISKPORT:
			long_return = snmp_get_raid_disk_diskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKSECONDARYDISKNAME:	/* DisplayString */
			strlcpy(return_buf, cad->cad_path_name[1], sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISKSECONDARYDISKPORT:
			long_return = snmp_get_raid_disk_secondarydiskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKSHELF:
			long_return = cad->cad_shelf;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKBAY:
			long_return = cad->cad_bay;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKPOOL: /* DisplayString */
			long_return = snmp_get_raid_disk_pool(cao, return_buf, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case OTHERDISKSECTORSIZE:
			long_return = cad->cad_bps;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OTHERDISKSERIALNUMBER: /* DisplayString */
			strlcpy(return_buf, cad->cad_serialno, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISKVENDOR: /* DisplayString */
			strlcpy(return_buf, cad->cad_vendor, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISKMODEL: /* DisplayString */
			strlcpy(return_buf, cad->cad_model, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISKFIRMWAREREVISION: /* DisplayString */
			strlcpy(return_buf, cad->cad_fw_revision, 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISKRPM: /* DisplayString */
			strlcpy(return_buf, 
				disk_rpm_string(cad->cad_rpm),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISKTYPE: /* DisplayString */
			strlcpy(return_buf, 
				disk_type_string(cad->cad_type, "  ? "),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OTHERDISK64TOTALBLOCKS:
			counter64 = (uint64_t)(cad->cad_waflblks) * 
				DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case OTHERDISKCARRIERID:
			if (cad->cad_multidisk_carrier) {
				strlcpy(carrier, cad->cad_carrier_serialno, sizeof(carrier));
			}
			strlcpy(return_buf, carrier, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		default:
			ERROR("var_otherDiskEntry");
			*var_len = 0;
			return_ptr = NULL;
			break;
	}
	
	return return_ptr;
}

long cifsGetSummaryStatisticValue(int index);
C_EXPORT_CIFS(cifsGetSummaryStatisticValue);
long
cifsGetSummaryStatisticValue(int index)
{
	int i;
	long result = 0;

	/*
	 * This is not a particularly efficient way of getting the value
	 * since we have to scan the entire list for each statistic
	 * value that we're interested in.  We should be computing the
	 * summary and caching the result on a per-SNMP request basis.
	 */
	/*
	 * The efficiency here was decreased somewhat further with this
	 * change for burt #28318. Previous code avoided array index
	 * calculations by co-indexing a pointer to the array containing
	 * the type and value data. With this change, the statistics
	 * storage is considered a private data structure & not accessible.
	 */
	for (i = 0; i < kSMBStatNumber; i++)
	{
		if (smbstatGetMajorType (i) == index)
		{
			result += smbstatGetValue (i);
		}
	}
	

	return result;
}

/* 
 * To trap on when this drops below a certain value, it needs to
 * start high, not at zero as it formerly did.   agy 990317.
 */
C_EXPORT_CIFS(secs_to_shutdown);
int secs_to_shutdown = 1 << 30;

C_EXPORT_CIFS(registerCifsDelay);
void
registerCifsDelay(uint32_t secs) 
{
        C_REFERENCE_CIFS(secs_to_shutdown);
	secs_to_shutdown = secs;
}

uint8_t *
var_admin_dafs(SNMP_FM_ARGS)
{
	return NULL;
}

uint8_t *
var_adminDafsNicEntry(SNMP_FM_ARGS)
{
	return NULL;
}

uint8_t *
var_admin_nfs(SNMP_FM_ARGS)
{
	HEADER_GENERIC;

	switch (vp->magic) {
	case ADMINNFSOP:
		long_return = 1;		/* XXX */
		return  (uint8_t *)&long_return;
	default:
		ERROR("var_admin_nfs");
	}

	return NULL;
}

C_EXPORT_SWITCH_DOMAIN(var_admin_cifs);
uint8_t *
var_admin_cifs(SNMP_FM_ARGS)
{
        uint8_t *        result = NULL;
        sk_domain_t     calling_domain;
        
        HEADER_GENERIC;

        calling_domain = C_DOMAIN_SWITCH_BEGIN(sk_domain_cifs);

	switch (vp->magic) {
	case ADMINCIFSOP:
		long_return = 1;		/* XXX */
		result = (uint8_t*)&long_return;
                break;
	case ADMINCIFSGETATTR:
	case ADMINCIFSREADS:
	case ADMINCIFSWRITES:
	case ADMINCIFSLOCKS:
	case ADMINCIFSOPENS:
	case ADMINCIFSDIRS:
	case ADMINCIFSOTHER:
		C_REFERENCE_CIFS(cifsGetSummaryStatisticValue);
		long_return = cifsGetSummaryStatisticValue(vp->magic - 1);
		result = (uint8_t*)&long_return;
		break;
	case ADMINCIFSSTATUS:
		if (SMBAccess(c_SMBStartStat) == SMB_SEEACTIVE) { 
			long_return = (SMB_IsStarted() ? SMB_ACTIVE : SMB_INACTIVE);
		} else {
			long_return = SMBAccess(c_SMBStartStat);
		}
		result = (uint8_t*)&long_return;
		break;
	case ADMINCIFSDELAY:
                C_REFERENCE_CIFS(secs_to_shutdown);
		long_return = secs_to_shutdown;
		result = (uint8_t*)&long_return;
		break;
	case ADMINCIFSDOMAINJOINED:
		if (fio_exist(SMB_MACHINE_CONFIG, false)) {
			long_return = 1;
		} else {
			long_return = 0;
		}
		result = (uint8_t*)&long_return;
		break;
	case ADMINCIFSDOMAIN:
		*var_len = strlen((char *)ParamAccess(c_WorkgroupName));
		result = (uint8_t *) ParamAccess(c_WorkgroupName);
		break;
	case ADMINCIFSFNAME:
		*var_len = strlen((char *)ParamAccess(c_HostName));
		result = (uint8_t *) ParamAccess(c_HostName);
		break;
	case ADMINCIFSNEEDPW:
		if (!VV_nis_enabled && !fio_exist("/etc/passwd", false)) {
			long_return = 1;
		} else {
			long_return = 0;
		}
		result = (uint8_t*)&long_return;
		break;
		
	default:
		ERROR("var_admin_cifs");
	}

        C_DOMAIN_SWITCH_END(calling_domain);
        return(result);
}


uint8_t *
var_admin_http(SNMP_FM_ARGS)
{
	HEADER_GENERIC;
	switch (vp->magic) {
	case ADMINHTTPOP:
		long_return = 1;	/* XXX */
		return (uint8_t*)&long_return;
	case ADMINHTTPREQS:
		long_return = HTTP_STAT_REQ(HTTP_STATS_TOTAL).accepts
				+ HTTP_STAT_REQ(HTTP_STATS_TOTAL).reuseConn;
		return (uint8_t*)&long_return;
	case ADMINHTTPREQERRS:
		long_return = HTTP_STAT_ERR(HTTP_STATS_TOTAL).requestErrors;
		return (uint8_t*)&long_return;
	case ADMINHTTPREQDISCS:
		long_return = HTTP_STAT_ERR(HTTP_STATS_TOTAL).requestDiscards;
		return (uint8_t*)&long_return;
	case ADMINHTTPRESPS:
		long_return = HTTP_STAT_REQ(HTTP_STATS_TOTAL).responses;
		return (uint8_t*)&long_return;
	case ADMINHTTPINBYTES:
		long_return = HTTP_STAT_REQ(HTTP_STATS_TOTAL).inBytes;
		return (uint8_t*)&long_return;
	case ADMINHTTPOUTBYTES:
		long_return = HTTP_STAT_REQ(HTTP_STATS_TOTAL).outBytes;
		return (uint8_t*)&long_return;
	case ADMINHTTPTIMEOUTS:
		long_return = HTTP_STAT_TIMEOUT(HTTP_STATS_TOTAL).pending
				+ HTTP_STAT_TIMEOUT(HTTP_STATS_TOTAL).active
				+ HTTP_STAT_TIMEOUT(HTTP_STATS_TOTAL).idle;
		return (uint8_t*)&long_return;
	default:
		ERROR("var_adminHttp");
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.6.magic.0 */
uint8_t *
var_raid(SNMP_FM_ARGS)
{
	HEADER_GENERIC;

	switch (vp->magic) {
	case RAIDPNUMBER:
	case RAIDVNUMBER:
		long_return = snmp_aggregate_cnt();
		return (uint8_t*)&long_return;

	case SPARENUMBER:
		if (!update_disk_counts(sk_gethost()))
			return NULL;
		long_return = counts[sk_gethost()].spareCount;
		return (uint8_t *) & long_return;

	case OTHERDISKNUMBER:
		if (!update_disk_counts(sk_gethost()))
			return NULL;
		long_return = counts[sk_gethost()].failedCount;
		return (uint8_t *) & long_return;

	case OUTOFDATEDISKCOUNT:
		long_return = snmp_get_out_of_date_disk_count();
		return (uint8_t *) & long_return;

	default:
		ERROR("var_raid");
	}

	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.3.1.3.magic */
uint8_t *
var_nfsPerClient(SNMP_FM_ARGS)
{
	HEADER_GENERIC;

	switch (vp->magic) {
	case PCLNUMBER:
		SK_DOMAIN_REFERENCE(pclnt_count, SK_REASON_SWITCH_DOMAIN);
		long_return = pclnt_count();
		return (uint8_t*)&long_return;
	default:
		ERROR("var_nfsPerClient");
	}

	return NULL;
}

/* dummy redirect functions below this point */

uint8_t *
var_tv2Percent(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv2CachedCalls(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v2CachedCalls(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv3CachedCalls(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v2Percent(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v3Percent(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv2Calls(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tnfsServ(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_nfsServ(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v2CachedPerCent(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv2CachedPerCent(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv3CachedPerCent(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v3CachedPerCent(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v3Calls(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v2Calls(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v3CachedCalls(SNMP_FM_ARGS)
{
	return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv3Calls(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv3Percent(SNMP_FM_ARGS)
{
	return var_tnfs(vp, name, length, exact, var_len, write_method);
}

void
var_gettrwstats(void)
{
	static uint32_t time = 0;		
	if (sk_msecs4 - time > 3000){
        	SK_DOMAIN_REFERENCE(get_rw_stats, SK_REASON_SWITCH_DOMAIN);
        	/*
         	 * Since we want rw stats since last boot, the flag is 
	 	 * set to TRUE, which copies stats since last boot into tpcs.
         	 */
        	get_rw_stats(&tpcs, true);
		time = sk_msecs4;
	}
}

void
var_getrwstats(void)
{
	static uint32_t time = 0;
	if (sk_msecs4 - time > 3000){
                SK_DOMAIN_REFERENCE(get_rw_stats, SK_REASON_SWITCH_DOMAIN);
        	/*
         	 * Since we want rw stats since they were last zeroed,
         	 * the flag is set to FALSE, which copies stats since
         	 * last zeroed into pcs.
         	 */
        	get_rw_stats(&pcs, false);
		time = sk_msecs4;
	}
}

uint8_t *
var_tv2ReadStats(SNMP_FM_ARGS)
{
        var_gettrwstats();
        return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v2ReadStats(SNMP_FM_ARGS)
{
	var_getrwstats();
        return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv2WriteStats(SNMP_FM_ARGS)
{
	var_gettrwstats();
        return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v2WriteStats(SNMP_FM_ARGS)
{
	var_getrwstats();
        return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv3ReadStats(SNMP_FM_ARGS)
{
	var_gettrwstats();
        return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v3ReadStats(SNMP_FM_ARGS)
{
	var_getrwstats();
        return var_nfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_tv3WriteStats(SNMP_FM_ARGS)
{
	var_gettrwstats();
        return var_tnfs(vp, name, length, exact, var_len, write_method);
}

uint8_t *
var_v3WriteStats(SNMP_FM_ARGS)
{
	var_getrwstats();
        return var_nfs(vp, name, length, exact, var_len, write_method);
}

/* format is .1.3.6.1.4.1.789.1.18.1.magic.0 */
STATIC uint8_t *
_var_nfsCacheOptions(SNMP_FM_ARGS)
{
	switch (vp->magic) {
	case NFSCACHEISLICENSED:
		long_return = is_service_licensed(LICENSE_FLEXCACHE_NFS) ? 2 : 1;
		return (uint8_t*)&long_return;
	case NFSCACHEISENABLED:
		long_return = snmp_pfsNfsIsEnabled() ? 2 : 1;
		return (uint8_t*)&long_return;
	default:
		ERROR("var_nfsCacheOptions");
	}

	return NULL;
}

uint8_t *
var_nfsCacheOptions(SNMP_FM_ARGS)
{
	HEADER_GENERIC;
	DOMAIN_SWITCH_NEST(sk_domain_kahuna, _var_nfsCacheOptions,
			   (vp,name,length,exact,var_len,write_method)); 
}

/* format is .1.3.6.1.4.1.789.1.18.2.magic.0 */
STATIC uint8_t *
_var_nfsCacheStats(SNMP_FM_ARGS)
{
	uint64_t counter64;

	ASSERT(sk_in_domain(sk_domain_network));

	switch (vp->magic) {

	case NFSCACHEBYTESFROMCLIENTS:
		long_return = (int32_t) snmp_pfsNfsBytesFromClients();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHBYTESFROMCLIENTS:
		counter64 = (uint64_t) snmp_pfsNfsBytesFromClients();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWBYTESFROMCLIENTS:
		counter64 = (uint64_t) snmp_pfsNfsBytesFromClients();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64BYTESFROMCLIENTS:
		counter64 = (uint64_t) snmp_pfsNfsBytesFromClients();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHEBYTESTOCLIENTS:
		long_return = (int32_t) snmp_pfsNfsBytesToClients();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHBYTESTOCLIENTS:
		counter64 = (uint64_t) snmp_pfsNfsBytesToClients();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWBYTESTOCLIENTS:
		counter64 = (uint64_t) snmp_pfsNfsBytesToClients();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64BYTESTOCLIENTS:
		counter64 = (uint64_t) snmp_pfsNfsBytesToClients();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHEBYTESFROMSERVERS:
		long_return = (int32_t) snmp_pfsNfsBytesFromServers();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHBYTESFROMSERVERS:
		counter64 = (uint64_t) snmp_pfsNfsBytesFromServers();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWBYTESFROMSERVERS:
		counter64 = (uint64_t) snmp_pfsNfsBytesFromServers();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64BYTESFROMSERVERS:
		counter64 = (uint64_t) snmp_pfsNfsBytesFromServers();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHEBYTESTOSERVERS:
		long_return = (int32_t) snmp_pfsNfsBytesToServers();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHBYTESTOSERVERS:
	        counter64 = (uint64_t) snmp_pfsNfsBytesToServers();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWBYTESTOSERVERS:
		counter64 = (uint64_t) snmp_pfsNfsBytesToServers();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64BYTESTOSERVERS:
		counter64 = (uint64_t) snmp_pfsNfsBytesToServers();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHETOTALREQUESTS:
		long_return = (int32_t) snmp_pfsNfsTotalRequests();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHTOTALREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsTotalRequests();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWTOTALREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsTotalRequests();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64TOTALREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsTotalRequests();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHEHITREQUESTS:
		long_return = (int32_t) snmp_pfsNfsHitRequests();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHHITREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsHitRequests();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWHITREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsHitRequests();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64HITREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsHitRequests();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHEMISSREQUESTS:
		long_return = (int32_t) snmp_pfsNfsMissRequests();
		return (uint8_t*)&long_return;
	case NFSCACHEHIGHMISSREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsMissRequests();
		long_return = HIGH32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHELOWMISSREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsMissRequests();
		long_return = LOW32(counter64);
		return (uint8_t*)&long_return;
	case NFSCACHE64MISSREQUESTS:
		counter64 = (uint64_t) snmp_pfsNfsMissRequests();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case NFSCACHEMISSCACHEABLEREQUESTS:
		long_return = snmp_pfsNfsMissCacheableRequests();
		return (uint8_t*)&long_return;
	case NFSCACHEMISSUNCACHEABLEREQUESTS:
		long_return = snmp_pfsNfsMissUnCacheableRequests();
		return (uint8_t*)&long_return;
	case NFSCACHEEJECTREQUESTS:
		long_return = snmp_pfsNfsEjectRequests();
		return (uint8_t*)&long_return;
	case NFSCACHEVERIFYREQUESTS:
		long_return = snmp_pfsNfsVerifyRequests();
		return (uint8_t*)&long_return;
	case NFSCACHERPCRECORDS:
		long_return = snmp_pfsNfsRpcRecords();
		return (uint8_t*)&long_return;
	case NFSCACHEBWSAVINGS:
		long_return = snmp_pfsNfsBWSavings();
		return (uint8_t*)&long_return;
	default:
		ERROR("var_nfsCacheStats");
	}

	return NULL;
}

uint8_t *
var_nfsCacheStats(SNMP_FM_ARGS)
{
	HEADER_GENERIC;
	DOMAIN_SWITCH_NEST(sk_domain_network, _var_nfsCacheStats,
			   (vp,name,length,exact,var_len,write_method)); 
}

uint8_t *
var_snapmirror(SNMP_FM_ARGS)
{
	return _var_mirrorvaultCommon(vp, name, length, exact, var_len, write_method, RPL_SNAPMIRROR);
}

uint8_t *
var_snapvault(SNMP_FM_ARGS)
{
	return _var_mirrorvaultCommon(vp, name, length, exact, var_len, write_method, RPL_SNAPVAULT);
}

/* handles 2 formats by using VAULT_MAGIC:
 * format is .1.3.6.1.4.1.789.1.9.magic.0
 * format is .1.3.6.1.4.1.789.1.19.magic.0
 */
uint8_t *
_var_mirrorvaultCommon(SNMP_FM_ARGS,
		       rpl_type       rtype    /* IN - snapvault or snapmirror */
)
{
	int magic = vp->magic;
	HEADER_GENERIC;

	if (rtype == RPL_SNAPVAULT) {
		magic =  VAULT_MAGIC(magic);

		if ((magic != VAULT_MAGIC (SVPRIMARYISLICENSED)) && 
		    (magic != VAULT_MAGIC (SVSECONDARYISLICENSED)) &&
		    (!sv_licensed(sk_gethost()))) {
			return NULL;
		}
	} else {
		if ((magic != SNAPMIRRORISLICENSED) && 
		    (!is_snapmirror_allowed())) {
			return NULL;
		}
	}

	switch (magic) {
	/* ----------------------------- */
	case SNAPMIRRORON:
                if (rpl_query_on()) {
                        long_return = 2;
                } else {
                        long_return = 1;
                }
                return (uint8_t *) & long_return;
	/* ----------------------------- */
	case VAULT_MAGIC (SVON):
		if (sv_is_on(sk_get_vfiler())) {
			long_return = 2;
		} else {
			long_return = 1;
		}
		return (uint8_t *) & long_return;
	/* ----------------------------- */
	case SNAPMIRRORISLICENSED:
		if (is_service_licensed(LICENSE_REPLICATE)) {
			long_return = 2;
		} else {
			long_return = 1;
		}
		return (uint8_t *) & long_return;
	/* ----------------------------- */
	case VAULT_MAGIC (SVPRIMARYISLICENSED):
		if (is_service_licensed(LICENSE_SNAPVAULT_CLIENT) ||
		    is_service_licensed(LICENSE_SNAPVAULT_DR)) {
			long_return = 2;
		} else {
			long_return = 1;
		}
		return (uint8_t *) & long_return;
	/* ----------------------------- */
	case VAULT_MAGIC (SVDRPRIMARYISLICENSED):
		if (is_service_licensed(LICENSE_SNAPVAULT_DR)) {
			long_return = 2;
		} else {
			long_return = 1;
		}
		return (uint8_t *) & long_return;
 	/* ----------------------------- */
	case VAULT_MAGIC (SVSECONDARYISLICENSED):
		if (is_service_licensed(LICENSE_SNAPVAULT_SERVER)) {
			long_return = 2;
		} else {
			long_return = 1;
		}
		return (uint8_t *) & long_return;
	/* ----------------------------- */
	case SNAPMIRRORACTIVERESTORECOUNT:
	case SNAPMIRRORACTIVEDSTNUMBER:
	case VAULT_MAGIC (SVSYSTEMACTIVEDSTNUMBER):	
		long_return = rpl_query_num_activeDstXfers(rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORSCHEDULEDRESTORECOUNT:
		long_return = rpl_query_num_destXfers(rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORBACKUPNUMBER:
	case SNAPMIRRORACTIVESRCNUMBER:
	case VAULT_MAGIC (SVSYSTEMACTIVESRCNUMBER):
		long_return = rpl_query_num_srcXfers(rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORBACKUPSUCCESSES:
		long_return = rpl_query_stats(RPL_STATS_BACKUPS, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORRESTORESUCCESSES:
		long_return = rpl_query_stats(RPL_STATS_RESTORES, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORBACKUPABORTS:
		long_return = rpl_query_stats(RPL_STATS_SRC_ABORTS, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORRESTORERESTARTABORTS:
		long_return = rpl_query_stats(RPL_STATS_DST_RESTART_ABORTS, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORRESTOREWAITABORTS:
		long_return = rpl_query_stats(RPL_STATS_DST_WAIT_ABORTS, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORWRITTENBYTES:
		long_return = rpl_query_stats(RPL_STATS_MBYTES_WRITTEN, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORREADBYTES:
		long_return = rpl_query_stats(RPL_STATS_MBYTES_READ, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORFILERTOTALSRCSUCCESSES:
	case VAULT_MAGIC (SVSYSTEMTOTALPRIMARYSUCCESSES):
		long_return = rpl_query_stats(RPL_STATS_SRC_SUCCESS, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORFILERTOTALDSTSUCCESSES:
	case VAULT_MAGIC (SVSYSTEMTOTALSECONDARYSUCCESSES):
		long_return = rpl_query_stats(RPL_STATS_DST_SUCCESS, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORFILERTOTALSRCFAILURES:
	case VAULT_MAGIC (SVSYSTEMTOTALPRIMARYFAILURES):
		long_return = rpl_query_stats(RPL_STATS_SRC_FAILURE, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORFILERTOTALDSTFAILURES:
	case VAULT_MAGIC (SVSYSTEMTOTALSECONDARYFAILURES):
		long_return = rpl_query_stats(RPL_STATS_DST_FAILURE, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	case SNAPMIRRORFILERTOTALDSTDEFERMENTS:
	case VAULT_MAGIC (SVSYSTEMTOTALSECONDARYDEFERMENTS):
		long_return = rpl_query_stats(RPL_STATS_DST_DEFER, rtype);
		return (uint8_t*) &long_return;
	/* ----------------------------- */
	default:
	    	ERROR("var_snapmirror or var_snapvault");
	    	break;
	}

	return( NULL );
}

char outbuf[NFS_MAXPATHLEN + ONTAP_MAXHOSTNAMELEN + 2];

uint8_t *
var_snapmirrorStatusEntry(SNMP_FM_ARGS) 
{
	return _var_mirrorvaultStatusEntryCommon(vp, name, length, exact, 
						 var_len, write_method, 
						 RPL_SNAPMIRROR);
}

uint8_t *
var_snapvaultStatusEntry(SNMP_FM_ARGS)
{
	return _var_mirrorvaultStatusEntryCommon(vp, name, length, exact, 
						 var_len, write_method, 
						 RPL_SNAPVAULT);
}	

/* handles 2 formats by using VAULT_MAGIC
 * format is .1.3.6.1.4.1.789.1.9.20.1.magic.index
 * format is .1.3.6.1.4.1.789.1.19.11.1.magic.index
 * snapmirror -> 1.9.20
 * snapvault -> 1.19.11
 */
uint8_t *
_var_mirrorvaultStatusEntryCommon(SNMP_FM_ARGS,
	rpl_type        rtype   /* IN - snapmirror or snapvault) */
)
{
	struct rpl_status	*info;

	int magic = vp->magic;

	if (magic < 1) {
		ERROR("var_snapmirrorStatusEntry or var_snapvaultStatusEntry: "
		      "magic 1");
		return (NULL);
	}

	if (rtype == RPL_SNAPVAULT) {
		magic = VAULT_MAGIC (magic);

		if (!sv_licensed(sk_gethost())) {
			return NULL;
		}
	} else {
		if (!is_snapmirror_allowed()) {
			return NULL;
		}
	}

	HEADER_SIMPLE_TABLE(10000);

	info = rpl_status_alloc_node(SKMA_SLEEP);
	/* look for the correct status node to return */
	if (rpl_snmp_get_stats(&NAME_INDEX, info, exact, rtype) == false) {
		rpl_status_free_node(info);	
		return NULL;
	}

	switch (magic) {
	/* ------------------------------------------- */
	case SNAPMIRRORINDEX:
	case VAULT_MAGIC (SVINDEX):
	    long_return = NAME_INDEX;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORSRC:
	case VAULT_MAGIC (SVSRC):
	    rpl_get_fullpath(info->src_filer, info->src_path, outbuf);
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORDST:
	case VAULT_MAGIC (SVDST):
	    rpl_get_fullpath(info->dst_filer, info->dst_path, outbuf);
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORSTATUS:
	case VAULT_MAGIC (SVSTATUS):
	    /* SlideRuler cpsync and fullsync has same status value to users */
	    if (info->status == RPL_STATUS_NVLOG)
		    info->status = RPL_STATUS_CPSYNC;
	    long_return = info->status + 1;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORSTATE:
	case VAULT_MAGIC (SVSTATE):
	    long_return = info->state + 1;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORLAG:
	case VAULT_MAGIC (SVLAG):
	    long_return = info->mirror_age_in_sec * 100;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTOTALSUCCESSES:
	case VAULT_MAGIC (SVTOTALSUCCESSES):
	    long_return = info->counters.total_success;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTOTALRESTARTSUCCESSES:
	case VAULT_MAGIC (SVTOTALRESTARTSUCCESSES):
	    long_return = info->snmpinfo.total_restart_success;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTOTALFAILURES:
	case VAULT_MAGIC (SVTOTALFAILURES):
	    long_return = info->counters.total_failure;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTOTALDEFERMENTS:
	case VAULT_MAGIC (SVTOTALDEFERMENTS):
	    long_return = info->counters.total_defer_cnt;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTOTALTRANSMBS:
	case VAULT_MAGIC (SVTOTALTRANSMBS):
	    long_return = info->snmpinfo.total_mb_trans;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTOTALTRANSTIMESECONDS:
	case VAULT_MAGIC (SVTOTALTRANSTIMESECONDS):
	    long_return = info->snmpinfo.total_trans_time;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORTHROTTLEVALUE:
	case VAULT_MAGIC (SVTHROTTLEVALUE):
	    long_return = info->snmpinfo.kbs;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
        /* ------------------------------------------- */  
	case VAULT_MAGIC (SVSRCSNAPSHOTTIME):    
   	    long_return = info->verbose.mirror_time_in_sec;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORMIRRORTIMESTAMP:
	    rpl_get_ctime_str(info->verbose.mirror_time_in_sec, outbuf);
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORBASESNAPSHOT:
	case VAULT_MAGIC (SVBASESNAPSHOT):
	    strcpy(outbuf, info->verbose.snapshot);
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORLASTTRANSTYPE:
	case VAULT_MAGIC (SVLASTTRANSTYPE):
	    strcpy(outbuf, info->verbose.last_trans_type);
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORLASTTRANSMBS:
	case VAULT_MAGIC (SVLASTTRANSMBS):
	    /* cast uint64_t to uint32_t still allows up to 4096TB transfer size */
	    long_return = (uint32_t)BLKS2MB(info->verbose.last_trans_size_in_blks);
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORLASTTRANSTIMESECONDS:
	case VAULT_MAGIC (SVLASTTRANSTIMESECONDS):
            long_return = info->verbose.last_trans_duration;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
	/* ------------------------------------------- */
	case SNAPMIRRORSCHEDULE:
	    rpl_get_sm_sched(info->dst_filer, info->dst_path, outbuf, sizeof(outbuf));
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORSCHEDULEDESC:
	    rpl_get_sm_sched_desc(info->dst_filer, info->dst_path, outbuf);
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
	/* ------------------------------------------- */
	case SNAPMIRRORARGUMENTS:    
	    rpl_get_sm_args(info->dst_filer, info->dst_path, outbuf, sizeof(outbuf));
	    *var_len = strlen(outbuf);
	    rpl_status_free_node(info);	
	    return (uint8_t *) outbuf;
        /* ------------------------------------------- */
	case SNAPMIRRORSYNCTOASYNC:    
	    long_return = info->counters.total_sync_end;
	    *var_len = sizeof(int32_t);
	    rpl_status_free_node(info);	
	    return (uint8_t *) & long_return;
        /* ------------------------------------------- */
	default:
	    ERROR("var_snapmirrorStatusEntry or var_snapvaultStatusEntry");
	    break;
	}

	rpl_status_free_node(info);	
	return NULL;
}

extern struct rpl_con_info *rpl_con_list;

/* format is .1.3.6.1.4.1.789.1.9.21.1.magic.index */
uint8_t *
var_snapmirrorConnEntry(SNMP_FM_ARGS)
{
         int             index;
	 uint8_t          *return_ptr = NULL;
	 struct rpl_con_info *rci;

	HEADER_SIMPLE_TABLE(10000);

        if (!is_snapmirror_allowed()) {
		return NULL;
	}

	index = 1;
        for (rci = rpl_con_list; rci != NULL; rci = rci->next)
        {
		if (index == NAME_INDEX) {
			break;
		}
		index++;
	}

	if (rci == NULL) {
                return NULL;
        }

	switch ( vp->magic ) {

	/* ------------------------------------------- */
	case SNAPMIRRORCONNINDEX:
		long_return = index;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */
	case SNAPMIRRORCONNNAME:
		strcpy(outbuf, rci->name);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */
	case SNAPMIRRORCONNTYPE:
		long_return = rci->isa_mode + 1;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */	
	case SNAPMIRRORCONNSRC1:
		strcpy(outbuf, rci->ips[0].src);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */	
	case SNAPMIRRORCONNDST1:
		strcpy(outbuf, rci->ips[0].dst);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */	
	case SNAPMIRRORCONNSRC2:
		strcpy(outbuf, rci->ips[1].src);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;
	/* ------------------------------------------- */	
	case SNAPMIRRORCONNDST2:
		strcpy(outbuf, rci->ips[1].dst);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;
	/* ------------------------------------------- */
	default:
		ERROR("var_snapmirrorConnEntry");
		*var_len = 0;
		return_ptr = NULL;
		break;
	}
	
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.19.13.1.magic.index */
uint8_t *
var_snapvaultSchedEntry(SNMP_FM_ARGS)
{
	 int             err;
	 uint8_t          *return_ptr = NULL;
	 int             sv_list_size, sv_list_index;
	 sv_target_element *sv_list;

        if (!sv_licensed(sk_gethost())) {
                return NULL;
        }

        if ((err = sv_get_target_status_list(&sv_list, &sv_list_size)) != 0) {
                D(snmp,1,("Low on memory. Can't check status right now."
                              " Try again later.\n"));
                return NULL;
        }
	if (sv_list_size == 0) {
		return NULL;
	}

	if (header_simple_table(vp, name, length, exact, var_len,
				 write_method, sv_list_size) == MATCH_FAILED){
		sk_kmem_free(sv_list);
		return NULL;
	}

	sv_list_index = NAME_INDEX - 1;

	switch ( vp->magic ) {

	/* ------------------------------------------- */
	case SVSCHEDINDEX:
		long_return = NAME_INDEX;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */
	case SVSCHEDVOLUME:
		strcpy(outbuf, sv_list[sv_list_index].volname);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */
	case SVSCHEDSNAPSHOT:
		strcpy(outbuf, sv_list[sv_list_index].snapname);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */	
	case SVSCHEDSTATUS:
		long_return = sv_list[sv_list_index].status + 1;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */	
	case SVSCHEDTYPE:
		long_return = sv_list[sv_list_index].type + 1;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */	
	case SVSCHEDSCHEDULE:
		strcpy(outbuf, sv_list[sv_list_index].schedstr);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */
	default:
		ERROR("var_snapvaultSchedEntry");
		*var_len = 0;
		return_ptr = NULL;
		break;
	}
	
	sk_kmem_free(sv_list);
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.19.12.1.magic.index */
uint8_t *
var_snapvaultHostEntry(SNMP_FM_ARGS)
{
         int             index;
	 uint8_t          *return_ptr = NULL;
	 int             rpl_list_size = 0;
	 rpl_host_stats *rpl_host_list = NULL;
	 rpl_host_stats *rpl_host = NULL;
	 rpl_type        rtype = RPL_SNAPVAULT;

        if (!sv_licensed(sk_gethost())) {
                return NULL;
        }

        if (rpl_get_host_stats_list(&rpl_host_list, &rpl_list_size, rtype) 
		== false) {
		rpl_free_host_list(rpl_host_list);
                return NULL;
        }

        if (rpl_list_size == 0) {
		rpl_free_host_list(rpl_host_list);
                return NULL;
        }

	if (header_simple_table(vp, name, length, exact, var_len,
				 write_method, rpl_list_size) == MATCH_FAILED){
		rpl_free_host_list(rpl_host_list);
		return NULL;
	}

	rpl_host = rpl_host_list;

        for ( index = 1; index <= rpl_list_size; index++)
        {
		if (index == NAME_INDEX) {
			break;
		}
		rpl_host = rpl_host->next;
	}

	if (index > rpl_list_size) {
		rpl_free_host_list(rpl_host_list);
		return NULL;
	}

	switch ( vp->magic ) {

	/* ------------------------------------------- */
	case SVHOSTINDEX:
		long_return = index;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */
	case SVHOSTNAME:
		strcpy(outbuf, rpl_host->hostname);
		*var_len = strlen(outbuf);
		return_ptr = (uint8_t *) outbuf;
		break;

	/* ------------------------------------------- */
	case SVHOSTTYPE:
		long_return = rpl_host->hosttype + 1;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */
	case SVHOSTTOTALSUCCESSES:
		long_return = rpl_host->totalSuccesses;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */	
	case SVHOSTTOTALFAILURES:
		long_return = rpl_host->totalFailures;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */	
	case SVHOSTTOTALDEFERMENTS:
		long_return = rpl_host->totalDeferments;
		return_ptr = (uint8_t *) &long_return;
		break;

	/* ------------------------------------------- */	
	default:
		ERROR("var_snapvaultHostEntry");
		*var_len = 0;
		return_ptr = NULL;
		break;
	}
	
	rpl_free_host_list(rpl_host_list);
	return return_ptr;
}

/* format is .1.3.6.1.4.1.789.1.10.magic.0 */
uint8_t *
var_ndmp(SNMP_FM_ARGS)
{
	char *args[] = { NULL, NULL };
	bool get_int = true;

	HEADER_GENERIC;

	switch ( vp->magic ) {
	/* ----------------------------- */
	case NDMPON:
		args[0] = "1";
		long_return = (VV_ndmpd_on ? 2 : 1);
		return (uint8_t *) & long_return;
		break;
	/* ----------------------------- */
	case NDMPSESSIONOPENED:
		args[0] = "2";
		break;
	/* ----------------------------- */
	case NDMPBACKUPACTIVE:
		args[0] = "3";
		break;
	/* ----------------------------- */
	case NDMPRESTOREACTIVE:
		args[0] = "4";
		break;
	/* ----------------------------- */
	case NDMPTAPEACTIVE:
		args[0] = "5";
		break;
	/* ----------------------------- */
	case NDMPBACKUPSUCCESSES:
		args[0] = "6";
		break;
	/* ----------------------------- */
	case NDMPRESTORESUCCESSES:
		args[0] = "7";
		break;
	/* ----------------------------- */
	case NDMPBACKUPFAILURES:
		args[0] = "8";
		break;
	/* ----------------------------- */
	case NDMPRESTOREFAILURES:
		args[0] = "9";
		break;
	/* ----------------------------- */
	case NDMPBACKUPFAILUREREASON:
		args[0] = "10";
		get_int = false;
		break;
	/* ----------------------------- */
	case NDMPRESTOREFAILUREREASON:
		args[0] = "11";
		get_int = false;
		break;
	/* ----------------------------- */
	default:
	    ERROR("var_ndmp");
	    return (NULL);
	}

	if (!ndmp_mhost_snmpget(args, (char *)return_buf, MAX_VAL_LENGTH)) {
		if (get_int) {
			ERROR("var_ndmp");
		} else {
			var_len = 0;
		}
		return (NULL);
	}

	if (get_int) {
		long_return = (uint8_t) atoi(return_buf);
		return (uint8_t *) & long_return;
	} else {
		*var_len = strlen(return_buf);
		return (uint8_t *) return_buf;
	}
}

/* format is .1.3.6.1.4.1.789.1.20.magic.0 */
uint8_t *
var_ftpd(SNMP_FM_ARGS)
{
	int result;
	
	HEADER_GENERIC;

	switch ( vp->magic ) 
	{
	case FTPDON:
		result = ftpd_IsServiceOn ();
		break;
	case FTPDCURRENTCONNS:
		result = ftpd_GetConnCount ();
		break;
	case FTPDMAXCONNS:
		result = ftpd_GetConnMax ();
		break;
	case FTPDTOTALCONNS:
		result = ftpd_GetConnTotal ();
		break;
	default:
	    ERROR("var_ftpd");
	    return (NULL);
	}
	
	long_return = result;
	return (uint8_t *) & long_return;
}


uint8_t *
var_dump(SNMP_FM_ARGS)
{
	bkprcv_SnmpVar var;

	HEADER_GENERIC;

	switch ( vp->magic ) {
	/* ----------------------------- */
	case DMPACTIVES:
		var = BKPRCV_ACTIVE;
		break;
	/* ----------------------------- */
	case DMPATTEMPTS:
		var = BKPRCV_ATTEMPTED;
		break;
	/* ----------------------------- */
	case DMPSUCCESSES:
		var = BKPRCV_SUCCEEDED;
		break;
	/* ----------------------------- */
	case DMPFAILURES:
		var = BKPRCV_FAILED;
		break;
	/* ----------------------------- */
	default:
		ERROR("var_dump");
		return NULL;
	}

	long_return = bkp_rcv_get_snmp_var(BKP_TYPE_LOGICAL, var);
	return (uint8_t *)&long_return;
}

/* format is .1.3.6.1.4.1.789.1.14.1.5.1.magic.index */
uint8_t *
var_dmpEntry(SNMP_FM_ARGS)
{
	dmp_SubtreeStat stats;

	HEADER_SIMPLE_TABLE(10000);

	if (dmp_snmp_get_stats_by_index(NAME_INDEX, &stats, exact) == false) {
		ERROR("var_dmpEntry");
		return NULL;
	}

	NAME_INDEX = stats.index;

	switch (vp->magic) {
	case DMPINDEX:
		long_return = stats.index;
		break;

	case DMPSTPATH:
		*var_len = strlen(stats.path);
		strlcpy(return_buf, stats.path, sizeof(return_buf));
		return return_buf;

	case DMPSTATTEMPTS:
		long_return = stats.attempts;
		break;

	case DMPSTSUCCESSES:
		long_return = stats.successes;
		break;

	case DMPSTFAILURES:
		long_return = stats.failures;
		break;

	case DMPTIME:
		long_return = stats.timestamp;
		break;
	
	case DMPSTATUS:
		long_return = stats.status;
		break;

	case DMPLEVEL:
		long_return = stats.level;
		break;

	case DMPNUMFILES:
		long_return = stats.files;
		break;

	case DMPDATAAMOUNT:
		long_return = stats.data_mb;
		break;

	case DMPSTARTTIME:
		long_return = stats.start_time;
		break;

	case DMPDURATION:
		long_return = stats.duration * 100;
		break;

	default:
		ERROR("var_dmpEntry");
		return NULL;
	}

	return (uint8_t *)&long_return;
}

/* format is .1.3.6.1.4.1.789.1.14.2.magic.0 */
uint8_t *
var_restore(SNMP_FM_ARGS)
{
	bkprcv_SnmpVar var;

	HEADER_GENERIC;
	switch ( vp->magic ) {
	/* ----------------------------- */
	case RSTACTIVES:
		var = BKPRCV_ACTIVE;
		break;
	/* ----------------------------- */
	case RSTATTEMPTS:
		var = BKPRCV_ATTEMPTED;
		break;
	/* ----------------------------- */
	case RSTSUCCESSES:
		var = BKPRCV_SUCCEEDED;
		break;
	/* ----------------------------- */
	case RSTFAILURES:
		var = BKPRCV_FAILED;
		break;
	/* ----------------------------- */
	default:
		ERROR("var_restore");
		return NULL;
	}

	long_return = bkp_rcv_get_snmp_var(RCV_TYPE_LOGICAL, var);
	return (uint8_t *)&long_return;
}

uint8_t *
var_unused (SNMP_FM_ARGS)
{
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.12.6.1.magic.Fabric.Switch.Port */
uint8_t *
var_portEntry(SNMP_FM_ARGS)
{
#if FABRIC_MANAGEMENT
	oid newname[SNMP_OID_MAX];
	void *cookie1;
	void *cookie2;
	void *cookie3;
	int r = 0;
	int result;
	int done = 0;
	int fabric_count;
	int switch_count = 0;
	int port_count = 0;
	fabric_t fab;
	static fabric_switch_t sw;
	static switch_port_t port;

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
					sizeof(oid));

	fabric_count = 0;
	cookie1 = NULL;
	SK_DOMAIN_REFERENCE(fabric_iterator, SK_REASON_SWITCH_DOMAIN);
	while ( !done && (r=fabric_iterator(&cookie1,&fab)) != 0 ) {
	    if ( r < 0 ) {
		done = 1;
		break;
	    }
	    fabric_count++;
	    newname[12] = (oid) fabric_count;
	    switch_count = 0;
	    cookie2 = NULL;
	    SK_DOMAIN_REFERENCE(fabric_switch_iterator, SK_REASON_SWITCH_DOMAIN);
	    while ( !done && (r=fabric_switch_iterator(&cookie2,&fab,&sw)) != 0 ) {
		if ( r < 0 ) {
			done = 1;
			break;
		}
		switch_count++;
		newname[13] = (oid) switch_count;
		port_count = 0;
		cookie3 = NULL;
		SK_DOMAIN_REFERENCE(switch_port_iterator, SK_REASON_SWITCH_DOMAIN);
		while ( !done && (r=switch_port_iterator(&cookie3,&sw,&port)) != 0 ) {
			if ( r < 0 ) {
				done = 1;
				break;
			}
			port_count++;

			newname[14] = (oid) port_count;
			result = compare(name, *length, newname, 15);
			if ((exact && (result == 0)) || (!exact && (result < 0))) {
				/* We found the one we want. */
				done = 1;
				break;
			}
		}
	    }
	}

	if ( r < 0 ) {
		/* An error of some sort */
		return NULL;
	}
	if ( r == 0 ) {
		/* We've reached the end of all fabric/port/switches */
		return NULL;
	}

	*length = 15;
	bcopy((char *)newname, (char *)name, (int)*length * sizeof(oid));
	*write_method = 0;
	*var_len = sizeof(int32_t);

	switch (vp->magic) {
	case PORTINDEX:			/* INTEGER */
		long_return = port_count;
		return (uint8_t *) & long_return;
	case PORTNAME: 			/* OCTET STRING (SIZE (8)) */
		*var_len = WWN_SIZE;
		return (uint8_t *) port.port_wwn.name;
	case PORTSWITCHNAME:		/* OCTET STRING (SIZE (8)) */
		*var_len = WWN_SIZE;
		return (uint8_t *) sw.element_wwn.name;
	case PORTNUMBER:		/* INTEGER */
		long_return = port.port_number;
		return (uint8_t *) & long_return;
	case PORTTYPE:			/* INTEGER */
		long_return = port.type;
		return (uint8_t *) & long_return;
	case PORTSTATE:			/* INTEGER */
		long_return = port.state;
		return (uint8_t *) & long_return;
	case PORTFABRICINDEX:		/* INTEGER */
		long_return = fabric_count;
		return (uint8_t *) & long_return;
	default:
		ERROR("var_portEntry");
	}
#endif
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.11.3.1.magic.fabric.switch */
uint8_t *
var_switchEntry(SNMP_FM_ARGS)
{
#if FABRIC_MANAGEMENT
	static char msg[ SNMP_GLOBAL_STATUS_MESSAGE_LEN ];
	oid newname[SNMP_OID_MAX];
	void *cookie1;
	void *cookie2;
	int done = 0;
	int r = 0;
	int result;
	int fabric_count;
	int switch_count = 0;
	fabric_t fab;
	static fabric_switch_t sw; /* static so we can return ptrs into it */
	switch_status_t status;
	switch_stats_t stats;
	int statusok;
	int statsok;

	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
					sizeof(oid));

	*write_method = 0;
	*var_len = sizeof(int32_t);

	fabric_count = 0;
	cookie1 = NULL;
	SK_DOMAIN_REFERENCE(fabric_iterator, SK_REASON_SWITCH_DOMAIN);
	while ( !done && (r=fabric_iterator(&cookie1,&fab)) != 0 ) {
	    if ( r < 0 ) {
		done = 1;
		break;
	    }
	    fabric_count++;
	    newname[12] = (oid) fabric_count;
	    switch_count = 0;
	    cookie2 = NULL;
	    SK_DOMAIN_REFERENCE(fabric_switch_iterator, SK_REASON_SWITCH_DOMAIN);
	    while ( !done && (r=fabric_switch_iterator(&cookie2,&fab,&sw)) != 0 ) {
		if ( r < 0 ) {
			done = 1;
			break;
		}
		switch_count++;
		newname[13] = (oid) switch_count;

		result = compare(name, *length, newname, 14);
		if ((exact && (result == 0)) || (!exact && (result < 0))) {
			/* We found the one we want. */
			done = 1;
			break;
		}
	    }
	}

	if ( r < 0 ) {
		/* An error of some sort */
		return NULL;
	}
	if ( r == 0 ) {
		/* We've reached the end of all switches */
		return NULL;
	}

	*length = 14;
	bcopy((char *)newname, (char *)name, (int)*length * sizeof(oid));
	*write_method = 0;
	*var_len = sizeof(int32_t);

	SK_DOMAIN_REFERENCE(fabric_switch_status, SK_REASON_SWITCH_DOMAIN);
	statusok = (fabric_switch_status(&sw,&status) == 0);
	SK_DOMAIN_REFERENCE(fabric_switch_stats, SK_REASON_SWITCH_DOMAIN);
	statsok = (fabric_switch_stats(&sw,&stats) == 0);

	switch (vp->magic) {
	case SWITCHINDEX:			/* INTEGER */
		long_return = switch_count;
		return (uint8_t *) & long_return;
	case SWITCHNAME:			/* OCTET STRING (SIZE (8)) */
		*var_len = WWN_SIZE;
		return (uint8_t *) sw.element_wwn.name;
	case SWITCHSYMBOLICNAME:		/* OCTET STRING (SIZE (0..255)) */
		*var_len = strlen(sw.logical_name);
		return (uint8_t *) sw.logical_name;
	case SWITCHTYPE:			/* INTEGER */
		long_return = sw.type;
		return (uint8_t *) & long_return;
	case SWITCHDOMAIN:			/* INTEGER */
		long_return = sw.domain;
		return (uint8_t *) & long_return;
	case SWITCHMANAGEMENTID:		/* INTEGER */
		long_return = sw.management_id;
		return (uint8_t *) & long_return;
	case SWITCHSTATUS:			/* INTEGER */
		if ( ! statusok )
			return NULL;
		long_return = status.state;
		return (uint8_t *) & long_return;
	case SWITCHSTATUSMESSAGE:		/* DisplayString */
		if ( ! statusok )
			return NULL;
		switch_status_message(&status,msg,sizeof(msg));
		*var_len = strlen(msg);
		return (uint8_t *) msg;
	case SWITCHLINKSPEED:			/* INTEGER */
		if ( ! statusok )
			return NULL;
		long_return = status.linkspeed;
		return (uint8_t *) & long_return;
	case SWITCHHIGHPACKETSPROCESSED:	/* COUNTER */
		if ( ! statsok )
			return NULL;
		long_return = HIGH32(stats.processed_frames);
		return (uint8_t *) & long_return;
	case SWITCHLOWPACKETSPROCESSED:		/* COUNTER */
		if ( ! statsok )
			return NULL;
		long_return = LOW32(stats.processed_frames);
		return (uint8_t *) & long_return;
	case SWITCH64PACKETSPROCESSED:	/* COUNTER */
		if ( ! statsok )
			return NULL;
		counter64_return.high = HIGH32(stats.processed_frames);
		counter64_return.low  = LOW32(stats.processed_frames);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case SWITCHHIGHPACKETSREJECTED:		/* COUNTER */
		if ( ! statsok )
			return NULL;
		long_return = HIGH32(stats.rejected_frames);
		return (uint8_t *) & long_return;
	case SWITCHLOWPACKETSREJECTED:		/* COUNTER */
		if ( ! statsok )
			return NULL;
		long_return = LOW32(stats.rejected_frames);
		return (uint8_t *) & long_return;
	case SWITCH64PACKETSREJECTED:		/* COUNTER */
		if ( ! statsok )
			return NULL;
		counter64_return.high = HIGH32(stats.rejected_frames);
		counter64_return.low  = LOW32(stats.rejected_frames);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case SWITCHFABRICINDEX:			/* INTEGER */
		long_return = fabric_count;
		return (uint8_t *) & long_return;
	default:
		ERROR("var_switchEntry");
	}
#endif
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.11.magic.0 */
uint8_t *
var_fabric(SNMP_FM_ARGS)
{
#if FABRIC_MANAGEMENT
	void *cookie1 = NULL;
	int fabric_count = 0;
	fabric_t fab;
	int r;

	HEADER_GENERIC;

	switch ( vp->magic ) {
	case FABRICINSTANCES:
		/*
		 * Count the number of fabrics.
		 */
		SK_DOMAIN_REFERENCE(fabric_iterator, SK_REASON_SWITCH_DOMAIN);
		while ( (r=fabric_iterator(&cookie1,&fab)) > 0 ) {
			fabric_count++;
		}
		if ( r < 0 ) {
			return NULL; /* An error of some sort */
		}
		long_return = fabric_count;
		return (uint8_t *) & long_return;
	default:
		ERROR("var_fabric");
		return NULL;
	}
#endif
	return NULL;
}

/* format is .1.3.6.1.4.1.789.1.11.2.1.magic.index */
uint8_t *
var_fabricEntry(SNMP_FM_ARGS)
{
#if FABRIC_MANAGEMENT
	static char msg[ SNMP_GLOBAL_STATUS_MESSAGE_LEN ];
	void *cookie1;
	int r = 0;
	int index;
	static fabric_t fab; 	/* static so we can return ptrs into it */
	fabric_status_t status;
	int statusok;

	HEADER_SIMPLE_TABLE(10000);

	cookie1 = NULL;
	SK_DOMAIN_REFERENCE(fabric_iterator, SK_REASON_SWITCH_DOMAIN);
	index = 1;
	while ((r = fabric_iterator(&cookie1,&fab)) != 0 ) {
		if (index == NAME_INDEX) {
			break;
		}
		index ++;
	}

	if ( r < 0 ) {
		/* An error of some sort */
		return NULL;
	}
	if ( r == 0 ) {
		/* We've reached the end of all fabrics */
		return NULL;
	}

	SK_DOMAIN_REFERENCE(fabric_status, SK_REASON_SWITCH_DOMAIN);
	statusok = (fabric_status(&fab,&status) == 0);

	switch (vp->magic) {
	case FABRICINDEX:		/* INTEGER */
		long_return = NAME_INDEX;
		return (uint8_t *) & long_return;
	case FABRICSTATUS:		/* INTEGER */
		if ( ! statusok )
			return NULL;
		long_return = status.state;
		return (uint8_t *) & long_return;
	case FABRICSTATUSMESSAGE:	/* DisplayString */
		if ( ! statusok )
			return NULL;
		fabric_status_message(&status,msg,sizeof(msg));
		*var_len = strlen(msg);
		return (uint8_t *) msg;
	case FABRICNAME:		/* OCTET STRING (SIZE (8)) */
		*var_len = WWN_SIZE;
		return (uint8_t *) fab.fabric_wwn.name;
	case FABRICOWNER:		/* INTEGER */
		long_return = fab.owner;
		return (uint8_t *) & long_return;
	default:
		ERROR("var_fabricEntry");
	}
	return NULL;
#else
	return NULL;
#endif
}

/* format is .1.3.6.1.4.1.789.1.6.11.1.magic.plex */
uint8_t *
var_plexEntry(SNMP_FM_ARGS)
{
	raid_config_iter_t *rci;
	config_attr_obj_t *cao;
	config_attr_obj_t caoKeep = {{0}};
	int index;
	static char plexName[MAX_RAIDNAME_SIZE];
	static char volName[MAX_RAIDNAME_SIZE];

	HEADER_SIMPLE_TABLE(10000);

	/*
	 * Create a plex iterator
	 */
	if (!raid_config_iterator_create(&rci, RAIDTYPE_PLEX)) {
		ERROR("var_plexEntry: rci");
		return NULL;
	}

	/*
	 * Walk the plexes 
	 */
	index = 1;
	while ((cao = raid_config_iterator_next(rci)) != NULL) {
		if (index == NAME_INDEX) {
			break;
		}
		index ++;
	}

	if (cao != NULL) {
		memcpy(&caoKeep,cao,sizeof(caoKeep));
	}

	raid_config_iterator_destroy(rci);

	if (cao == NULL) {
		return NULL; 
	}

	switch (vp->magic) { 
	case PLEXINDEX:				/* INTEGER */
		long_return = index; 
		return (uint8_t *) & long_return;

	case PLEXNAME:				/* DisplayString */
		/*
		 * Copy into static plexName and return that.  We assume
		 * this is ok since snmpd is single threaded. 
		 */
		strlcpy(
			plexName,
			caoKeep.cao_plex.cap_name,
			sizeof(plexName));
		*var_len = strlen(plexName);
		return (uint8_t *) plexName; 

	case PLEXVOLNAME:			/* DisplayString */

		/*
		 * Copy into static volName and return that.  We
		 * assume this is ok since snmpd is single threaded.
		 */
		volName[0] = '\0';
		strlcpy(
			volName,
			caoKeep.cao_tree,
			sizeof(volName));
		*var_len = strlen(volName);
		return (uint8_t *) volName;

	case PLEXSTATUS:			/* INTEGER */
		/*
		 * See the MIB
		 * 1 = offline
		 * 2 = resyncing
		 * 3 = online
		 */
		{ 
			int status = 1;

			if (caoKeep.cao_plex.cap_resyncing)
				status = 2;
			else if (caoKeep.cao_plex.cap_online)
				status = 3;

			long_return = status; 
			return (uint8_t *) & long_return;
		}

	case PLEXPERCENTRESYNCING:		/* INTEGER */
		if (caoKeep.cao_plex.cap_resyncing) {
			long_return = caoKeep.cao_plex.cap_resyncpct; 
		} else {
			long_return = 0;
		}

		if (long_return < 0) {
			long_return = 0;
		} else if (long_return > 100) {
			long_return = 100;
		}

		return (uint8_t *) & long_return;
	} 
	
	return NULL; 
}

static int
getVdiskNbr(void)
{
    void *cookie = 0;
    int count = 0;

    while(vdisk_iterator(&cookie))
	count++;
    return count;
}

/* format is .1.3.6.1.4.1.789.1.17.magic.0 */
uint8_t *
var_blocks(SNMP_FM_ARGS)
{
	uint64_t counter64, fcp_readbytes, fcp_writebytes, iscsi_writebytes, iscsi_readbytes;
	HEADER_GENERIC;

	SK_DOMAIN_REFERENCE(fcp_ic_stat, SK_REASON_SWITCH_DOMAIN);
	fcp_ic_stat((uint64_t *)&fcp_readbytes, (uint64_t *)&fcp_writebytes);

	SK_DOMAIN_REFERENCE(iscsi_ic_stat, SK_REASON_SWITCH_DOMAIN);
	iscsi_ic_stat((uint64_t *)&iscsi_readbytes, (uint64_t *)&iscsi_writebytes);
	
	switch (vp->magic) {
        case FCPISLICENSED:
                long_return = is_service_licensed(LICENSE_FCP) ? 2 : 1;
                return (uint8_t *) & long_return;
        case ISCSIISLICENSED:
                long_return = is_service_licensed(LICENSE_ISCSI) ? 2 : 1;
                return (uint8_t *) & long_return;

	case FCPLOWREADBYTES:
                long_return = LOW32(fcp_readbytes); 
                return (uint8_t *) & long_return;
	case FCPLOWWRITEBYTES:
                long_return = LOW32(fcp_writebytes);
                return (uint8_t *) & long_return;
	case FCPHIGHREADBYTES:
                long_return = HIGH32(fcp_readbytes);
                return (uint8_t *) & long_return;
	case FCPHIGHWRITEBYTES:
                long_return = HIGH32(fcp_writebytes);
                return (uint8_t *) & long_return;
	case FCP64READBYTES:
		counter64_return.high = HIGH32(fcp_readbytes);
		counter64_return.low  = LOW32(fcp_readbytes);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;
	case FCP64WRITEBYTES:
		counter64_return.high = HIGH32(fcp_writebytes);
		counter64_return.low  = LOW32(fcp_writebytes);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case ISCSILOWREADBYTES:
                long_return = LOW32(iscsi_readbytes);
                return (uint8_t *) & long_return;
	case ISCSILOWWRITEBYTES:
                long_return = LOW32(iscsi_writebytes);
                return (uint8_t *) & long_return;
	case ISCSIHIGHREADBYTES:
                long_return = HIGH32(iscsi_readbytes);
                return (uint8_t *) & long_return;
	case ISCSIHIGHWRITEBYTES:
                long_return = HIGH32(iscsi_writebytes);
                return (uint8_t *) & long_return;
	case ISCSI64READBYTES:
		counter64_return.high = HIGH32(iscsi_readbytes);
		counter64_return.low  = LOW32(iscsi_readbytes);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;
	case ISCSI64WRITEBYTES:
		counter64_return.high = HIGH32(iscsi_writebytes);
		counter64_return.low  = LOW32(iscsi_writebytes);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

	case ISCSIHIGHOPS:
                long_return = HIGH32(iscsi_getops());
                return (uint8_t *) & long_return;
	case FCPHIGHOPS:
                long_return = HIGH32(fcp_getops());
                return (uint8_t *) & long_return;
	case ISCSILOWOPS:
                long_return = LOW32(iscsi_getops());
                return (uint8_t *) & long_return;
	case FCPLOWOPS:
                long_return = LOW32(fcp_getops());
                return (uint8_t *) & long_return;
	case ISCSI64OPS:
		counter64 = (uint64_t)iscsi_getops();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;
	case FCP64OPS:
		counter64 = (uint64_t)fcp_getops();
		counter64_return.high = HIGH32(counter64);
		counter64_return.low  = LOW32(counter64);
		*var_len = sizeof(counter64_return);
		return (uint8_t *) & counter64_return;

        case FCPCFMODE:
		if (fm_cf_configuration()) {
			long_return = 8;
		} else {
			long_return = 256;
		}
		return (uint8_t*)&long_return;
        default:
		ERROR("var_system");
	}
	return NULL;
}
 
/* format is .1.3.6.1.4.1.789.1.17.15.magic.0 */
uint8_t *
var_lun(SNMP_FM_ARGS)
{
	HEADER_GENERIC;

	switch (vp->magic) {
	case LUNCOUNT:
		*var_len = sizeof(long_return);
		long_return = getVdiskNbr();
		return (uint8_t *) & long_return;

	default:
		ERROR("var_lun");
	}
	return NULL;
}
 
/* format is .1.3.6.1.4.1.789.1.17.15.2.1.magic.index */
/* This function is called once for every get or getnext snmp query. */
uint8_t *
var_lunEntry(SNMP_FM_ARGS)
{
    static char     Name[MAX_VAL_LENGTH];
    char           *cp;
    vdisk_t *vdisk;
    vdisk_attr_t *ap;
    char *path = NULL;
    char *vol_name = NULL;
    wafl_Volume *vol = NULL;
    wafl_File_handle  vdisk_fh;
    wafl_Volref *vref = NULL;
    uint32_t tid;
    uint64_t counter64;

    HEADER_SIMPLE_TABLE(VDISK_SNMP_MAX_INDEX);
    /* NAME_INDEX now contains the index we are looking for */

    if(exact == 1) { /* the query was snmpget */
	vdisk = vdisk_snmp_tree_find(NAME_INDEX);

    }
    else { /* the query was snmpgetnext */
	/*
	 * NAME_INDEX has already been incremented by one assuming everything
	 * is sequential.  We substract one so that our tree can find the next
	 * index.
	 */
	vdisk = vdisk_snmp_tree_find_next(NAME_INDEX - 1);
    }

    /* We did not find the oid we were looking for (exact or next) */
    if(vdisk == NULL) {
	return NULL;
    }

    /* Skip Primordial volumes */
    vdisk_fh = vdisk->vv_fh;
    vol = wafl_get_volume(&vdisk_fh);
    if (vol && WAFL_IS_PALOMA_VOL_PRIMORDIAL(vol)) {
        /* Valid vdisks cannot exist on Primordial volumes.
	 * So, panic in debug kernels if we encounter such 
	 * a situation.
	 */
        ASSERT(0);
	return NULL;
    }

    /* set with the index we actually found as the next one */
    NAME_INDEX = vdisk->snmp_index; 

    /* vdisk exists but is fenced because of "vol move" cutover */
    if (vdisk->vv_flags & VDISK_FLAG_LUN_FENCED) {
        return NULL;
    }

    switch (vp->magic)
    {
    case LUNINDEX:
	*var_len = sizeof(long_return);
	long_return = vdisk->snmp_index;
	return (uint8_t *) & long_return;
    case LUNNAME:
	if (vdisk->vv_flags & VDISK_FLAG_RESTOREFILE_IN_PROGRESS) {
		strlcpy(Name, "[restore in progress]", sizeof(Name));
	} else {
		path = vdisk_admin_get_path(vdisk);
		if (path != NULL) {
			strlcpy(Name, path, sizeof(Name));
			sk_kmem_free(path);
		} else {
			strlcpy(Name, "???", sizeof(Name));
		}
	}
	cp = Name;
	*var_len = strlen(cp);
	return (uint8_t *) cp;
    case LUNSIZELOW:
	*var_len = sizeof(long_return);
	long_return = LOW32(VDISK_SIZE(vdisk));
	return (uint8_t *) & long_return;
    case LUNSIZEHIGH:
	*var_len = sizeof(long_return);
	long_return = HIGH32(VDISK_SIZE(vdisk));
	return (uint8_t *) & long_return;
    case LUNSIZE64:
	   counter64 = VDISK_SIZE(vdisk);
	   counter64_return.high = HIGH32(counter64);
	   counter64_return.low  = LOW32(counter64);
	   *var_len = sizeof(counter64_return);
	   return (uint8_t *) & counter64_return;

    case LUNMAPPED:
	*var_len = sizeof(long_return);
        long_return = vdisk->vv_maps ? 2 : 1; /* convert to SNMP 1 == false */
	return (uint8_t *) & long_return;
    case LUNSERIALNUMBER:
	ap = vdisk_attribute_get(vdisk->vv_attrs, "serial");
	if (ap && ap->va_value)
	    strlcpy(Name, ap->va_value, sizeof(Name));
	else
	    Name[0] = '\0';
	cp = Name;
	*var_len = strlen(cp);
	return (uint8_t *) cp;
    case LUNCOMMENT:
	if (vdisk->vv_comment)
	    strlcpy(Name, vdisk->vv_comment, sizeof(Name));
	else
	    Name[0] = '\0';
	cp = Name;
	*var_len = strlen(cp);
	return (uint8_t *) cp;

	
    case LUNQTREENAME:
	if (vdisk->vv_flags & VDISK_FLAG_RESTOREFILE_IN_PROGRESS) {
		strlcpy(Name, "[restore in progress]", sizeof(Name));
	} else {
		vdisk_fh = vdisk->vv_fh;
		if (fhzero(vdisk_fh)) 
			return NULL;
		vol = wafl_get_volume(&vdisk_fh);
		if (vol == NULL) {
			return NULL;
		}	
		vref = wafl_volref_create(vol, "var_lunEntry LUNQTREENAME");
		if (vref == NULL){
			return NULL;
		}
		tid = wafl_quota_get_qtree_id(&vdisk_fh);
		if (!vol || 
		    tid >= QUOTA_TID_LIM ||
		    !wafl_qtree_get_name(vol,
			    vdisk_fh.snapid,
			    tid,
			    Name,
			    MAX_VAL_LENGTH))
		    return NULL;
		if (strcmp(Name, ".") == 0)
		{
			/* root volume, just give vol name */
			vol_name = WVOL_NAME(vol);
			if (vol_name) 
			{
				strlcpy(Name, vol_name, sizeof(Name));
			} else {
				return NULL;
			}
		}
	}
	
	cp = Name;
	*var_len = strlen(cp);
	if(vref != NULL) {
		wafl_volref_destroy(vref);
	}
	return (uint8_t *) cp;

    case LUNHIGHOPS:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.o_ops[VDISK_STATS_CURRENT] +
			     vdisk->vv_stats.r_ops[VDISK_STATS_CURRENT] +
			     vdisk->vv_stats.w_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWOPS:
	*var_len = sizeof(long_return);
	long_return = LOW32 (vdisk->vv_stats.o_ops[VDISK_STATS_CURRENT] +
			     vdisk->vv_stats.r_ops[VDISK_STATS_CURRENT] +
			     vdisk->vv_stats.w_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64OPS:
	counter64 = vdisk->vv_stats.o_ops[VDISK_STATS_CURRENT] +
		vdisk->vv_stats.r_ops[VDISK_STATS_CURRENT] +
		vdisk->vv_stats.w_ops[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNHIGHREADOPS:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.r_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWREADOPS:
	*var_len = sizeof(long_return);
	long_return = LOW32 (vdisk->vv_stats.r_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64READOPS:
	counter64 = vdisk->vv_stats.r_ops[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNHIGHWRITEOPS:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.w_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWWRITEOPS:
	*var_len = sizeof(long_return);
	long_return = LOW32 (vdisk->vv_stats.w_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64WRITEOPS:
	counter64 = vdisk->vv_stats.w_ops[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNHIGHOTHEROPS:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.o_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWOTHEROPS:
	*var_len = sizeof(long_return);
	long_return = LOW32 (vdisk->vv_stats.o_ops[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64OTHEROPS:
	counter64 = vdisk->vv_stats.o_ops[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNSTATSRESETTIME:
	*var_len = sizeof(long_return);
	long_return = ontap_time() - vdisk->vv_stats.last_zeroed;
	return (uint8_t *) & long_return;
	
    case LUNHIGHREADBYTES:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.r_bytes[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWREADBYTES:
	*var_len = sizeof(long_return);
	long_return = LOW32(vdisk->vv_stats.r_bytes[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64READBYTES:
	counter64 = vdisk->vv_stats.r_bytes[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNHIGHWRITEBYTES:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.w_bytes[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWWRITEBYTES:
	*var_len = sizeof(long_return);
	long_return = LOW32(vdisk->vv_stats.w_bytes[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64WRITEBYTES:
	counter64 = vdisk->vv_stats.w_bytes[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNHIGHERRORS:
	*var_len = sizeof(long_return);
	long_return = HIGH32(vdisk->vv_stats.errors[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUNLOWERRORS:
	*var_len = sizeof(long_return);
	long_return = LOW32(vdisk->vv_stats.errors[VDISK_STATS_CURRENT]);
	return (uint8_t *) & long_return;
    case LUN64ERRORS:
	counter64 = vdisk->vv_stats.errors[VDISK_STATS_CURRENT];
	counter64_return.high = HIGH32(counter64);
	counter64_return.low  = LOW32(counter64);
	*var_len = sizeof(counter64_return);
	return (uint8_t *) & counter64_return;

    case LUNONLINE:
	*var_len = sizeof(long_return);
	long_return = vdisk->vv_enabled ? 2 : 1;    /* I hate SNMP oldBool */
	return (uint8_t *) & long_return;
    case LUNSNAPSTATUS:
	*var_len = sizeof(long_return);
	if (vdisk->vv_flags & VDISK_FLAG_RESTOREFILE_IN_PROGRESS) 
		long_return = 1;
	else
		long_return = vdisk_file_can_snapshot(vdisk) ? 2 : 1;    /* I hate SNMP oldBool */
	return (uint8_t *) & long_return;
    case LUNSHARESTATUS:
	*var_len = sizeof(long_return);
	if ((vdisk->vv_flags &  (VDISK_FLAG_SHARE_READ)) &&
	    (vdisk->vv_flags & (VDISK_FLAG_SHARE_WRITE)))
	    long_return = 4;
	else if (vdisk->vv_flags & (VDISK_FLAG_SHARE_WRITE))
	    long_return = 3;
	else if (vdisk->vv_flags & (VDISK_FLAG_SHARE_READ))
	    long_return = 2;
	else
	    long_return = 1;
	return (uint8_t *) & long_return;
    case LUNSPACERESERVED:
    {
	vdisk_lun_info_t *lun_info;
	path = vdisk_admin_get_path(vdisk);
	vdisk_admin_request_t req;
	sk_Msg *msg = sk_my_msg();

	if (!path) {
		return NULL;
	}
	
	memset(&req, 0, sizeof(req));
	msg->type = VDISK_GET_INFO;
        msg->data.p = &req;
	req.vr_vdisk_name = (char *) path;
	req.vr_admin_flags |= VDISK_VR_ADMIN_FLAGS_SET_VFILER;

	if (vdisk_admin_send() != 0) {
		sk_kmem_free(path);
		return NULL;
	}

	sk_kmem_free(path);

	if (req.vr_result.vr_lun_info == NULL) {
		return NULL;
	}
	lun_info = req.vr_result.vr_lun_info;
	if (lun_info->vr_space_reservation_enabled) {	
	    long_return = 2; 
	} else {
	    long_return = 1; 
	}
	sk_kmem_free(lun_info);
	return (uint8_t *) & long_return;
    }
    case LUNALIGNMENT:
    {
        path = vdisk_admin_get_path(vdisk);
	vdisk_admin_request_t req;
	sk_Msg *msg = sk_my_msg();

	if (!path) {
		return NULL;
	}
	memset(&req, 0, sizeof(req));
	msg->type = VDISK_GET_LUN_ALIGNMENT;
        msg->data.p = &req;
	req.vr_vdisk_name = (char *) path;
	req.vr_admin_flags |= VDISK_VR_ADMIN_FLAGS_SET_VFILER;

	if (vdisk_admin_send() != 0) {
		sk_kmem_free(path);
		return NULL;
	}

	sk_kmem_free(path);
	if(req.vr_result.vr_lun_alignment == 0) {
		return NULL;
	} else if (req.vr_result.vr_lun_alignment == VDISK_LUN_ALIGNED) {
		strlcpy(Name, VDISK_LUN_ALIGN_STR_ALIGNED , strlen(VDISK_LUN_ALIGN_STR_ALIGNED) + 1);
	} else if (req.vr_result.vr_lun_alignment == VDISK_LUN_MISALIGNED) {
		strlcpy(Name, VDISK_LUN_ALIGN_STR_MISALIGNED , strlen(VDISK_LUN_ALIGN_STR_MISALIGNED) + 1);
	} else if (req.vr_result.vr_lun_alignment == VDISK_LUN_ALIGNMENT_PARTIAL) {
		strlcpy(Name, VDISK_LUN_ALIGN_STR_PARTIAL  , strlen(VDISK_LUN_ALIGN_STR_PARTIAL) + 1);
	} else if (req.vr_result.vr_lun_alignment == VDISK_LUN_ALIGNMENT_INDETERMINATE) {
		strlcpy(Name, VDISK_LUN_ALIGN_STR_INDETERMINATE , strlen(VDISK_LUN_ALIGN_STR_INDETERMINATE) + 1);
	}

	cp = Name;
	*var_len = strlen(cp);
	return (uint8_t *) cp;
    }

    

    default:
	ERROR("var_system");
    }
    return NULL;
}

/* format is .1.3.6.1.4.1.789.1.17.15.3.1.magic.vdisk.initgroup */
uint8_t *
var_lunMapEntry(SNMP_FM_ARGS)
{

	oid				newname[SNMP_OID_MAX];
	int result;
    int vdisk_num, vdisk_ctr, grp_ctr = 0;
    void *vdisk_cookie = 0;
    void *lunmap_cookie = 0;
    vdisk_t *vdisk = 0;
    const char * groupname = 0;
    char *path = NULL;
    int done = 0;
    char *cp;
    static char Name[MAX_VAL_LENGTH];

   /*
    * length == 15
    * magic == 13 (oid[12])
    * vdisk == 14 (oid[13])
    * initgroup == 15 (oid[14])
    */

    if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
	    HEADER_SIMPLE_TABLE(10000);
    }
    
    bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
				    sizeof(oid));
    if (*length >= 14) {
        vdisk_num = name[13];
    } else {
        vdisk_num = name[13] = 1;
    }

    
    /* first iterate my way up to matching the vdisk number, if i 
     * have been given a vdisk number thats too high, i return null
     */
    for (vdisk_ctr=1; ((!done) && (vdisk_ctr <= vdisk_num)); vdisk_ctr++) 
    {
	vdisk_exported_iterator(&vdisk_cookie);
	if (vdisk_cookie == NULL) return NULL;
	/* if the vdisk number isn't there yet i continue */
	if (vdisk_ctr < vdisk_num) continue;
	vdisk = (vdisk_t*) vdisk_cookie;

	newname[13] = (oid)vdisk_ctr;


	/* now i iterate up through the init group numbers, if asked
	 * for one that doesn't exist (due not being exported i 
	 * give up and try either the next vdisk, or return null */
	lunmap_cookie = 0;
	for (grp_ctr = 0; 
	    (!done && 
	     (groupname = vdisk_lunmap_iterator(vdisk, &lunmap_cookie)));
	    )
	{
	    grp_ctr++;
	    newname[14] = (oid) grp_ctr; 

	    result = compare(name, *length, newname, 15);

	    done = ((exact && result == 0) || 
		    (!exact && result < 0));
	}
	if ((!done) && (!exact)) 
	{
	    vdisk_num++;
	    name[14] = 0;
	}
    }

    *length = 15;
    bcopy((char *) newname, (char *) name, (int) *length * sizeof(oid));
    *write_method = 0;
    *var_len = sizeof(int32_t);

    /* stupid off by 1 issue... */
    vdisk_ctr--;	

    if (!done) return NULL;
    if (grp_ctr < 1) return NULL;

    vdisk = (vdisk_t*) vdisk_cookie;

    ASSERT(groupname);
    ASSERT(vdisk);

    switch (vp->magic)
    {
	case LUNMAPLUNINDEX:
	    long_return = vdisk_ctr;
	    return (uint8_t*)&long_return;
	case LUNMAPINITIATORGROUPINDEX:
	    long_return = grp_ctr;
	    return (uint8_t*)&long_return;
	case LUNMAPLUNNAME:
	    if (vdisk->vv_flags & VDISK_FLAG_RESTOREFILE_IN_PROGRESS) {
		strlcpy(Name, "[restore in progress]", sizeof(Name));
	    } else {
		    path = vdisk_admin_get_path(vdisk);
		    if (path != NULL) {
			    strlcpy(Name, path, sizeof(Name));
			    sk_kmem_free(path);
		    } else {
			    strlcpy(Name, "???", sizeof(Name));
		    }
	    }
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case LUNMAPINITIATORGROUPNAME:
	    strlcpy(Name, groupname, sizeof(Name));
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case LUNMAPLOGICALUNITNUMBER:
	    long_return = vdisk_lunmap_get_virtual(vdisk, groupname);
	    if (long_return != -1)
		return (uint8_t*)&long_return;
	    else
		return NULL;
        default:
	    ERROR("var_system");
    }
		
	    
    return NULL;
}

SK_DOMAIN_IMPORT(scsi_tgt_iterator_initgrp, SK_REASON_MPSAFE);

/* format is .1.3.6.1.4.1.789.1.17.16.1.1.magic.group_num */
uint8_t *
var_initiatorGroupEntry(SNMP_FM_ARGS)
{
	int		index=0;
	void		*cookie;
	void		*cookie1;
	igroup_t	*init_grp = NULL;
	vfiler		*vfp = NULL;
	char 		*cp;
	static char     Name[MAX_VAL_LENGTH];
	sk_domain_t	*old_domain = NULL;
	uint8_t		*rval = NULL;
	int		already_switched_back = 0;
	
	cookie = NULL;

	HEADER_SIMPLE_TABLE(10000);

	old_domain = sk_domain_switch_begin(sk_domain_target);		
	/* until we switch back, every return (or error return path)
	 * should switch back to old_domain before returning any value 
	 */ 
	index = 1;
	cookie1 = NULL;	
	
	/*
	 * How this SNMP routine works?
	 * For an snmpwalk initiated on initiator groups, the
	 * var_initiatorGroupEntry(..) is called for every magic number that
	 * follows after 789.1.17.16.1(i.e a snmpget is performed for every
	 * magic number after the specified OID(eg. 789.1.17.16.1). In this
	 * routine, the magic number correspond to a category(e.g
	 * INITIATORGROUPNAME::>Initiator group name). The output would look
	 * like(say we had one Igroup in vfiler0 and vfiler1 each)
	 *	
	 *SNMPv2-SMI::enterprises.789.1.17.16.1.1.1.1 = INTEGER: 1
	 *SNMPv2-SMI::enterprises.789.1.17.16.1.1.1.1 = INTEGER: 2
	 *SNMPv2-SMI::enterprises.789.1.17.16.1.1.2.1 = STRING:	"vfiler0_igroup1"
	 *SNMPv2-SMI::enterprises.789.1.17.16.1.1.2.1 = STRING:	"vfiler1_igroup1"
	 *....
	 *........ and on
	 *
	 * As the first two lines correspond to INITIATORGROUPINDEX and the 
	 * next two are INITIATORGROUPNAME.
	 */

	 /*
	 * We iterate through the vfiler list(HH_vfiler_list) through the
	 * vfiler iterator. For every vfiler, we iterate through the initiator
	 * groups.
	 */
	while((vfp = vfiler_iterator(&cookie1, VFILER_ITER_ACTIVE)) != NULL) {
		SK_DOMAIN_REFERENCE(scsitarget_initgroup_iterator_vfiler, SK_DOMAIN_TARGET);
		while ((init_grp = scsitarget_initgroup_iterator_vfiler(vfp, &cookie)) != NULL) {
			if (index == NAME_INDEX) {
				break;
	  		}
    			index ++;
	 	}
		/* 
		 * When we complete printing the Initiator group for a specific
		 * magic number, we check whether we have more vfilers to 
		 * iterate through. In that case, we see the initiator group 
		 * iterator cookie to NULL(as we would starting a new iteration 
		 * of initiator groups belonging to different vfiler.
		 */
		if(init_grp == NULL) {
			cookie = NULL;
		}
		else {
		    	/*
			 * Done with iterating and printing the initiator
			 * groups for a specific magic number. Switch from
			 * target domain to the old domain.
			 */
			break;
		}
	}

	if(init_grp == NULL && vfp == NULL) {
		rval = NULL;
		goto switch_back_and_return;
	}

	switch (vp->magic)
	{
	    case INITIATORGROUPINDEX:
		long_return = index;
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    case INITIATORGROUPNAME:
		strlcpy(Name, init_grp->group_name, sizeof(Name));
		sk_domain_switch_end(old_domain);
		already_switched_back = 1;
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *)cp;
		goto switch_back_and_return;

	    case INITIATORGROUPTYPE:
		long_return = init_grp->flags & INIT_GRP_FCP ? 1 : 2;
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    case INITIATORGROUPOS:
		long_return = init_grp->os_type + 1; /* can't use zero */
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    case INITIATORGROUPTHROTTLERESERVE:
		long_return = init_grp->throttle ?
			init_grp->throttle->reserve_percentage :
			0;
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    case INITIATORGROUPTHROTTLEBORROW:
		long_return = init_grp->throttle ?
			(init_grp->throttle->flags & SCSITGT_THROTTLE_BORROW) ? 2 : 1 :
			1;
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    case INITIATORGROUPUSEPARTNER:
		/* can't use zero */
		long_return = scsitarget_initgroup_use_partner(init_grp) + 1; 
		rval = (uint8_t *)(&long_return);
		goto switch_back_and_return;

	    case INITIATORGROUPUSEALUA:
		{
		/* can't use zero */
		long_return = IGROUP_USES_ALUA(init_grp) ? 2 : 1; 
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;
		}

	    default:
		ERROR("var_system");
	}

switch_back_and_return:
	if (!already_switched_back)
		sk_domain_switch_end(old_domain);
	return rval;
}

/* format is .1.3.6.1.4.1.789.1.17.16.3.1.magic.index */
uint8_t *
var_initiatorListEntry(SNMP_FM_ARGS)
{
    int		index=0;
    int		virtualport = 0;
    void        *cookie;
    tha_initiator_t *initiator;
    tha_initiator_t initiator_copy;
    char *cp;
    static char     Name[MAX_VAL_LENGTH];
    sk_domain_t *old_domain;

    HEADER_SIMPLE_TABLE(10000);

    cookie = NULL;
    old_domain = sk_domain_switch_begin(sk_domain_target);		
    index = 1;
    SK_DOMAIN_REFERENCE(scsi_tgt_iterator_initiator, SK_REASON_SWITCH_DOMAIN);
    while  ((initiator = scsi_tgt_iterator_initiator(&cookie)) != NULL)
    {
	/* 
	 * If the initiator has logged out, continue and get the next one in 
	 * the list. Be careful not to increment index for initiators that
	 * aren't counted.
	 */
	if (initiator->flags & THA_INIT_FLAG_LOGGED_OUT) {
		continue;
	}

	if (index == NAME_INDEX) {
		break;
	}
	index ++;
    }
    if (initiator == NULL) {
    	    sk_domain_switch_end(old_domain);		
	    return NULL;
    }
    bcopy((void*)initiator, (void*)&initiator_copy, sizeof(tha_initiator_t));
    sk_domain_switch_end(old_domain);		
    
    initiator = &initiator_copy;

    switch (vp->magic)
    {
	case INITIATORLISTENTRYINDEX:
	    long_return = index;
	    return (uint8_t*)&long_return;
	case TARGETADAPTERNAME:
	    if ((virtualport = THA_INIT_GET_VP(initiator->key)) != 0) {
		    snprintf(Name, MAX_VAL_LENGTH, "%s_%d",scsi_tgt_get_target_name(
			     THA_INIT_GET_THA_INDEX(initiator->key)), 
			     virtualport);
	    } else {	
		    strlcpy(Name, scsi_tgt_get_target_name(
			    THA_INIT_GET_THA_INDEX(initiator->key)), 
			    sizeof(Name));
	    }
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case CONNECTEDINITIATORTYPE:
	    long_return = scsi_tgt_get_target_type
				(THA_INIT_GET_THA_INDEX(initiator->key));
	    return (uint8_t*)&long_return;
	case CONNECTEDINITIATORNODENAME:
	    switch (scsi_tgt_get_target_type
				(THA_INIT_GET_THA_INDEX(initiator->key)))
	    {
		case TADT_IF_FCP:
                    /* fall through */ 
                case TADT_IF_VTIC:
		    wwn_to_string(&initiator->nodename, Name);
		    break;
		case TADT_IF_ISCSI:
		    strlcpy(Name, initiator->iscsi_nodename, sizeof(Name));
		    break;
	    }
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case CONNECTEDINITIATORPORTNAME:
	    switch (scsi_tgt_get_target_type
				(THA_INIT_GET_THA_INDEX(initiator->key)))
	    {
		case TADT_IF_FCP:
                    /* fall through */ 
                case TADT_IF_VTIC:
		    wwn_to_string(&initiator->portname, Name);
		    break;
		case TADT_IF_ISCSI:
		    strlcpy(Name, "", sizeof(Name));
		    break;
	    }
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case CONNECTEDINITIATORISID:
	    switch (scsi_tgt_get_target_type
				(THA_INIT_GET_THA_INDEX(initiator->key)))
	    {
		case TADT_IF_FCP:
                    /* fall through */ 
                case TADT_IF_VTIC:
		    strlcpy(Name, "", sizeof(Name));
		    break;
		case TADT_IF_ISCSI:
			snprintf(Name, MAX_VAL_LENGTH, 
				"%02x:%02x:%02x:%02x:%02x:%02x", 
				initiator->iscsi_isid[0],
				initiator->iscsi_isid[1],
				initiator->iscsi_isid[2],
				initiator->iscsi_isid[3],
				initiator->iscsi_isid[4],
				initiator->iscsi_isid[5]);
		    break;
	    }
	    cp = Name;
	    *var_len = strlen(cp);
	    return (uint8_t *) cp;
	case CONNECTEDINITIATORPORTALGROUP:
	    switch (scsi_tgt_get_target_type
				(THA_INIT_GET_THA_INDEX(initiator->key)))
	    {
		case TADT_IF_FCP:
                    /* fall through */ 
                case TADT_IF_VTIC:
		    long_return = 0;
		    return (uint8_t*)&long_return;
		case TADT_IF_ISCSI:
		    long_return = initiator->iscsi_tpgtag;
		    return (uint8_t*)&long_return;
	    }
	    /* fall through */
	default:
	    ERROR("var_system");
    }
    return NULL;		
}

/* format is .1.3.6.1.4.1.789.1.17.16.2.magic.group_num.index */
uint8_t *
var_initiatorGroupMemberEntry(SNMP_FM_ARGS)
{
	oid             newname[SNMP_OID_MAX];
	int		index=0;
	int             result;
	int             done = 0;
	void           *cookie;
	void           *cookie1 = NULL;
	vfiler         *vfp = NULL;
	int		group_num, group_ctr=1, len;
	igroup_t       *init_grp = NULL;
	static char initiator_name[MAX_VAL_LENGTH];
	sk_domain_t    *old_domain;
	uint8_t 	       *rval = NULL;
	
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
					sizeof(oid));

	if (*length >= 14) {
		group_num = name[13];
	} else {
		group_num = name[13] = 1;
	}

	cookie = NULL;
	old_domain = sk_domain_switch_begin(sk_domain_target);		
	/* until we switch back, every return (or error return path)
	 * should switch back to old_domain before returning any value 
	 */ 
	while ((vfp = vfiler_iterator(&cookie1, VFILER_ITER_ACTIVE)) != NULL) {
		SK_DOMAIN_REFERENCE(scsitarget_initgroup_iterator, SK_DOMAIN_TARGET);
		for ( ; ((!done) && (group_ctr<=group_num)); group_ctr++) {
			init_grp = scsitarget_initgroup_iterator_vfiler(vfp, &cookie);
			if (!init_grp) {
				/*
				 * Iterate the next vfiler if we are done with current.
				 */
				cookie = NULL;
				break;
			}
			if (group_ctr < group_num) {
				continue;
			}
			newname[13] = (oid) group_ctr;
			for (index = 0; !done && index < init_grp->num_nodenames;) {
				index++;
				newname[14] = (oid) index;
				result = compare(name, *length, 
					newname, 15);
				done = ((exact && result == 0) || 
					(!exact && result < 0));
			}
			if ((!done) && (!exact)) {
				group_num++;
				name[14] = 0;
			}
		}
	}


	if ((vfp == NULL && init_grp == NULL) ||
		(!done || index < 1)){
		rval = NULL;
		goto switch_back_and_return;
	}

	*length = 15;
	bcopy((char *) newname, (char *) name, (int) *length * sizeof(oid));
	*write_method = 0;
	*var_len = sizeof(int32_t);

	switch (vp->magic)
	{
	    case INITIATORGROUPMEMBERINDEX:
		long_return = group_num;
		rval = (uint8_t *)&long_return;
		break;
	    case INITIATORGROUPMEMBERNAMEINDEX:
		long_return = index;
		rval = (uint8_t *)&long_return;
		break;
	    case INITIATORNAME:
		ASSERT((index-1) < init_grp->num_nodenames);
		if (init_grp->flags & INIT_GRP_FCP)
		{
		    sprintf(initiator_name, "WWN[");
		    wwn_to_string(init_grp->u.fcp_nodenames[(index-1)], 
			    &initiator_name[4]);
		    len = strlen(initiator_name);
		    if (len > MAX_VAL_LENGTH - 2)
			len = MAX_VAL_LENGTH - 2;
		    initiator_name[len] = ']';
		    initiator_name[len+1] = '\0';
		}
		else
		{
		    strlcpy(initiator_name, 
			    init_grp->u.iscsi_nodenames[index-1],
			    sizeof(initiator_name));
		    initiator_name[MAX_VAL_LENGTH-1] = '\0';
		}
		*var_len = strlen(initiator_name);
		rval = (uint8_t *)initiator_name;
		break;
	    default:
		ERROR("var_system");
	}

switch_back_and_return:
    	sk_domain_switch_end(old_domain);
    	return rval;
}

/* format is .1.3.6.1.4.1.789.1.17.19.1.1.magic.index */
uint8_t *
var_psetEntry(SNMP_FM_ARGS)
{
	int				index=0;
	void           	*cookie;
	scsitgt_pset_t	*port_set;
	char 			*cp;
	static char     Name[MAX_VAL_LENGTH];
	sk_domain_t     *old_domain;
	uint8_t		*rval = NULL;

	HEADER_SIMPLE_TABLE(10000)

	cookie = NULL;

	old_domain = sk_domain_switch_begin(sk_domain_target);		
	/* until we switch back, every return (or error return path)
	 * should switch back to old_domain before returning any value 
	 */ 
	index = 1;
	SK_DOMAIN_REFERENCE(scsitarget_portset_iterator, SK_DOMAIN_TARGET);
	while ((port_set = scsitarget_portset_iterator(&cookie)) != NULL) {
		if (index == NAME_INDEX) {
			break;
		}
		index ++;
	}
	if (port_set == NULL) {
		rval = NULL;
		goto switch_back_and_return;
	}

	/* Get the requested specific port set info (magic) */
	switch (vp->magic)
	{
	    case PSETINDEX:
		long_return = index;
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    case PSETNAME:
		strlcpy(Name, port_set->sps_name, sizeof(Name));
		cp = Name;
		*var_len = strlen(cp);
		rval = (uint8_t *)cp;
		goto switch_back_and_return;

	    case PSETTYPE:
		long_return = port_set->sps_flags & PORT_SET_FCP ? 1 : 2;
		rval = (uint8_t *)&long_return;
		goto switch_back_and_return;

	    default:
		ERROR("var_system");
	}

switch_back_and_return:		
	sk_domain_switch_end(old_domain);
	return rval;
}

/* format is .1.3.6.1.4.1.789.1.17.19.2.1.magic.pset_num.port_num */
uint8_t *
var_psetMemberEntry(SNMP_FM_ARGS)
{
	oid				newname[SNMP_OID_MAX];
	int				index = 0;
	int				result;
	int				done = 0;
	void			*cookie;
	int				pset_num, pset_ctr, len;
	scsitgt_pset_t	*port_set = NULL;
	static char		port_name[MAX_VAL_LENGTH];
	sk_domain_t 	*old_domain;
	uint8_t		*rval = NULL;
	
	if (compare(vp->name, vp->namelen, name, vp->namelen) != 0) {
		HEADER_SIMPLE_TABLE(10000);
	}

	bcopy((char *) vp->name, (char *) newname, (int) vp->namelen *
					sizeof(oid));

	if (*length >= 15) {
		pset_num = name[13];
	}
	else
		newname[13] = pset_num = 1;

	cookie = NULL;

	old_domain = sk_domain_switch_begin(sk_domain_target);		
	/* until we switch back, every return (or error return path)
	 * should switch back to old_domain before returning any value 
	 */ 
	for (pset_ctr = 1; ((!done) && (pset_ctr <= pset_num)); pset_ctr++) 
	{

		SK_DOMAIN_REFERENCE(scsitarget_portset_iterator, SK_DOMAIN_TARGET);
		port_set = scsitarget_portset_iterator(&cookie);
		if (!port_set) {
			rval = NULL;
			goto switch_back_and_return;
		}
		if (pset_ctr < pset_num) {
			continue;
		}

		newname[13] = (oid) pset_ctr;
		for (index = 0; !done && index < port_set->sps_total;) 
		{
			index++;
			newname[14] = (oid) index;
			result = compare(name, *length, 
				 newname, 15);
			done = ((exact && result == 0) || 
				(!exact && result < 0));
		}
		if ((!done) && (!exact)) 
		{
			pset_num++;
			name[14] = 0;
		}
	}

	if (!done || index < 1) 
	{
		rval = NULL;
		goto switch_back_and_return;
	}

	ASSERT(port_set);

	*length = 15;
	bcopy((char *) newname, (char *) name, (int) *length * sizeof(oid));
	*write_method = 0;
	*var_len = sizeof(int32_t);

	switch (vp->magic)
	{
		case PSETMEMBERINDEX:
			long_return = pset_num;
			rval = (uint8_t *)&long_return;
			goto switch_back_and_return;

		case PSETMEMBERNAMEINDEX:
			long_return = index;
			rval = (uint8_t *)&long_return;
			goto switch_back_and_return;

		case PSETPORTNAME:
			ASSERT((index-1) < port_set->sps_total);

			/* XXX - until I get port mappings, use dummy - CJC */
			strlcpy(port_name, "dummy:4a", sizeof(port_name));
			len = strlen(port_name);
			*var_len = strlen(port_name);
			rval = (uint8_t *)port_name;
			goto switch_back_and_return;

		default:
			ERROR("var_system");
	}

switch_back_and_return:
	sk_domain_switch_end(old_domain);
	return rval;
}

/* format is .1.3.6.1.4.1.789.1.17.17.1.1.magic.index */
uint8_t *
var_fcpTargetTableEntry(SNMP_FM_ARGS)
{
    int		index=0;
    tadt_snmp_cookie_t cookie;
    tadapter_snmp_info info;
    char *cp;
    static char     Name[MAX_VAL_LENGTH];
    int ret;

    HEADER_SIMPLE_TABLE(10000);

    cookie.tadt = 0;

    index = 1;
    SK_DOMAIN_REFERENCE(tadt_snmp_iterator, SK_REASON_SWITCH_DOMAIN);    
    while ((ret = tadt_snmp_iterator((void**)&cookie, &info)) != 0) {
	if (index == NAME_INDEX) {
		break;
	}
	index ++;
    }
    if (ret == 0) {
	    return NULL;
    }

    switch (vp->magic)
    {
	case FCPTARGETTABLEINDEX:
		long_return = index;
	    	return (uint8_t*)&long_return;
	    
	case FCPTARGETNAME:
	    	strlcpy(Name, info.name, sizeof(Name));
		cp = Name;
		*var_len = strlen(cp);
		return (uint8_t *) cp;

	case FCPTARGETNN:
		wwn_to_string(&info.u.f.fc_nodename, Name);
		cp = Name;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
	case FCPTARGETPN:
		wwn_to_string(&info.u.f.fc_portname, Name);
		cp = Name;
		*var_len = strlen(cp);
		return (uint8_t *) cp;
		
	case FCPTARGETSPEED:
		long_return = info.u.f.fc_link_rate;
		return (uint8_t*)&long_return;

	case FCPTARGETSTATUS:
		long_return = info.status;
		return (uint8_t*)&long_return;
	
	case FCPTARGETTOPOLOGY:
		long_return = info.u.f.topology;
		return (uint8_t*)&long_return;
	
	case FCPTARGETSTANDBY:
		long_return = 1; /* obsolete */
		return (uint8_t*)&long_return;
	
        case FCPTARGETTYPE:
		long_return = 1; /* obsolete */
		return (uint8_t*)&long_return;
    	default:
		ERROR("var_system");
    }
    return NULL;
}

/* format is .1.3.6.1.4.1.789.1.6.13.1.magic.disk */
uint8_t *
var_outOfDateDiskEntry(SNMP_FM_ARGS)
{
	config_attr_obj_t caoKeepDisk;	/* On local stack. (Not a pointer) */
	config_attr_obj_t *cao = &caoKeepDisk;
	config_attr_disk_t *cad = &(cao->cao_disk);

	raid_config_iter_t *dm_ci = NULL;
	config_attr_obj_t *dm = NULL;
	raid_config_iter_t *pool_ci = NULL;
	config_attr_obj_t *pool = NULL;
	raid_config_iter_t *disk_ci = NULL;
	config_attr_obj_t *disk = NULL;
	int host = sk_gethost();
	uint64_t counter64;
	uint8_t	*return_ptr = NULL;
	boolean_t found = false;
	boolean_t found_oid_match = false;
	boolean_t match_first_oid;
	char carrier[STSB_SERIALNO+1] = "";

	int magic;
	uint32_t indexIn;
	uint32_t index = 0;

	*var_len = 0;				/* default length for abort */

#define OUTOFDATEDISKENTRYOIDMINLEN		12
#define OUTOFDATEDISKENTRYOIDMAXLEN		13
#define OUTOFDATEDISKENTRYOIDMAGIC		11
#define OUTOFDATEDISKENTRYOIDDISK		(OUTOFDATEDISKENTRYOIDMAGIC+1)
//#define	OUTOFDATEDISKDEBUG				DEBUG

	HEADER_SIMPLE_TABLE(10000);

#ifdef OUTOFDATEDISKDEBUG
	dbg_printf( "\nDBG: START outOfDateDiskEntry: *length %d  "
			"vp->namelen %d  vp->magic %d  exact %d\n",
			 *length, vp->namelen, vp->magic, exact );
#endif

	/*
	 * Incoming disk index. if missing, default to 1 
	 */
	indexIn    = (*length < OUTOFDATEDISKENTRYOIDDISK+1) ? 1 : 
					name[OUTOFDATEDISKENTRYOIDDISK]; 
	
	/*
	 * For "get next", less than full length OID means return the first 
         * good one.
	 */
	match_first_oid = (*length < OUTOFDATEDISKENTRYOIDMAXLEN || 
								indexIn < 1);
	
	bzero(&caoKeepDisk, sizeof(caoKeepDisk));
	*length = OUTOFDATEDISKENTRYOIDMAXLEN;
	*write_method = 0;

	magic = name[OUTOFDATEDISKENTRYOIDMAGIC];
	
	if (!raid_config_iterator_create(&dm_ci, RAIDTYPE_DMGR)) {
		EMS_snmp_raid_iterator_failure(); 
		return 0; 
	}
	index = 0; /* count disks */

	while (!found && (dm = raid_config_iterator_next(dm_ci)) != NULL) {
		if (dm->cao_dmgr.cadm_type != CADMS_SPARE)
			continue;
		if (dm->cao_dmgr.cadm_host != host)
			continue;
		if (dm->cao_dmgr.cadm_ndisks <= 0)
			continue; 
		if (dm->cao_dmgr.cadm_vol_id < 0) 
			continue;
			
		/* 
		 * Get the attributes associated with all children of 
		 * the disk manager object.
		 */ 
		raid_config_child_iterator_create(&pool_ci, dm, 
							RAIDTYPE_INVALID);

		while (!found && (pool = raid_config_iterator_next(pool_ci))
								 != NULL) {
			/*
         		 * Get the attributes associated with all 
			 * child disk objects
         		 */ 
			raid_config_child_iterator_create(&disk_ci, 
						pool, RAIDTYPE_INVALID);

			while (!found && (disk = raid_config_iterator_next(
							disk_ci)) != NULL) {
				if ((disk->cao_fsm_state != DISK_STATE_LIMBO )
					|| (disk->cao_disk.cad_host != host)) {
					continue;
				}

				index++;
				found_oid_match = (index == indexIn);

				/*
		 		 * Is this the "next" or "first" valid OID?
		 		 */
				if (!exact && (found_oid_match || 
							match_first_oid)) {
					found = true;
				}


				if (exact && found_oid_match) {
					found = true;
				}
				if (found) {
					bcopy(disk, &caoKeepDisk, 
							sizeof(caoKeepDisk));
					break; 
				}
			}
			raid_config_iterator_destroy(disk_ci);
		}
		raid_config_iterator_destroy(pool_ci);
	}
	raid_config_iterator_destroy(dm_ci);

	/*
	 * Update name to point to next item (OID) 
	 */
	name[OUTOFDATEDISKENTRYOIDDISK]     = index;

	if (!found) {
		return NULL; 
	}
	*var_len = sizeof(int32_t);

	switch (magic) {
		case OUTOFDATEDISKINDEX:
			long_return = index;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OUTOFDATEDISKDISKNAME:	/* DisplayString */
			snprintf(return_buf, sizeof(return_buf),
				 "out-of-date disk %s", cao->cao_raid_name); 
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OUTOFDATEDISKDISKID:
			long_return = cad->cad_id;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OUTOFDATEDISKSCSIADAPTER:	/* DisplayString */
			strlcpy(return_buf, cad->cad_host_adapter[0], 
							sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case OUTOFDATEDISKSCSIID:
			long_return = cad->cad_device_address;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OUTOFDATEDISKTOTALMB:
			long_return = cad->cad_waflblks / RAID_BLKS_PER_MB;
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OUTOFDATEDISKTOTALBLOCKS:
			long_return = cad->cad_waflblks * 
					DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			return_ptr = (uint8_t *) & long_return;
			break;
	
		case OUTOFDATEDISKDISKPORT:
			long_return = snmp_get_raid_disk_diskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case OUTOFDATEDISKSECONDARYDISKNAME:	/* DisplayString */
			strlcpy(return_buf, cad->cad_path_name[1], 
						sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OUTOFDATEDISKSECONDARYDISKPORT:
			long_return = snmp_get_raid_disk_secondarydiskport(cad);
			return_ptr = (uint8_t *) & long_return;
			break;

		case OUTOFDATEDISKSHELF:
			long_return = cad->cad_shelf;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OUTOFDATEDISKBAY:
			long_return = cad->cad_bay;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OUTOFDATEDISKPOOL: /* DisplayString */
			strlcpy(return_buf, cad->cad_pool_name, 
						sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case OUTOFDATEDISKSECTORSIZE:
			long_return = cad->cad_bps;
			return_ptr = (uint8_t *) & long_return;
			break;

		case OUTOFDATEDISKSERIALNUMBER: /* Display String */
			strlcpy(return_buf, cad->cad_serialno, 
						sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OUTOFDATEDISKVENDOR: /* Display String */
			strlcpy(return_buf, cad->cad_vendor, 
						sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case OUTOFDATEDISKMODEL: /* Display String */
			strlcpy(return_buf, cad->cad_model, 
						sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OUTOFDATEDISKFIRMWAREREVISION: /* Display String */
			strlcpy(return_buf, cad->cad_fw_revision, 
						sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OUTOFDATEDISKRPM: /* DisplayString */
			strlcpy(return_buf, 
				disk_rpm_string(cad->cad_rpm),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		case OUTOFDATEDISKTYPE: /* DisplayString */
			strlcpy(return_buf, 
				disk_type_string(cad->cad_type, "  ? "),  
				sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;

		case OUTOFDATEDISK64TOTALBLOCKS:
			counter64 = (uint64_t)(cad->cad_waflblks) * 
					DISK_SECTORS_PER_RAID_BLOCK(cad->cad_bps);
			counter64_return.high = HIGH32(counter64);
			counter64_return.low  = LOW32(counter64);
			*var_len = sizeof(counter64_return);
			return (uint8_t *)&counter64_return;

		case OUTOFDATEDISKCARRIERID:
			if (cad->cad_multidisk_carrier) {
				strlcpy(carrier, cad->cad_carrier_serialno, sizeof(carrier));
			}
			strlcpy(return_buf, carrier, sizeof(return_buf));
			*var_len = strlen(return_buf);
			return_ptr = return_buf;
			break;
	
		default:
			dbg_printf("out of date disk default: error\n");
			ERROR("var_outOfDiskEntry");
			*var_len = 0;
			return_ptr = NULL;
			break;
	}
	
	return return_ptr;
}



static int
snmp_get_out_of_date_disk_count(void)
{
	raid_config_iter_t *dm_ci = NULL;
	config_attr_obj_t *dm = NULL;

	raid_config_iter_t *pool_ci = NULL;
	config_attr_obj_t *pool = NULL;

	raid_config_iter_t *disk_ci = NULL;
	config_attr_obj_t *disk = NULL;
	int host = sk_gethost();
	int count = 0;

	if (!raid_config_iterator_create(&dm_ci, RAIDTYPE_DMGR)) {
		EMS_snmp_raid_iterator_failure(); 
		return 0; 
	}

	while ((dm = raid_config_iterator_next(dm_ci)) != NULL) {
		if (dm->cao_dmgr.cadm_type != CADMS_SPARE)
			continue;
		if (dm->cao_dmgr.cadm_host != host)
			continue;
		if (dm->cao_dmgr.cadm_ndisks <= 0)
			continue; 
		if (dm->cao_dmgr.cadm_vol_id < 0) 
			continue;
			
		/* 
		 * Get the attributes associated with all children of 
		 * the disk manager object.
		 */ 
		raid_config_child_iterator_create(&pool_ci, dm, 
							RAIDTYPE_INVALID);

		while ((pool = raid_config_iterator_next(pool_ci)) != NULL) {
			/*
         		 * Get the attributes associated with all 
			 * child disk objects
         		 */ 
			raid_config_child_iterator_create(&disk_ci, 
						pool, RAIDTYPE_INVALID);

			while ((disk = raid_config_iterator_next(
							disk_ci)) != NULL) {
				if (disk->cao_fsm_state == DISK_STATE_LIMBO) {
					count++;
				}
			} 
			raid_config_iterator_destroy(disk_ci);
		} 
		raid_config_iterator_destroy(pool_ci);
	}
	raid_config_iterator_destroy(dm_ci);
	return count;
}

/* format is .1.3.6.1.4.1.789.1.21.1.magic.0 */
uint8_t *
var_enclosure(SNMP_FM_ARGS)
{
	
	HEADER_GENERIC;

	switch (vp->magic) {
	
	case ENCLNUMBER:
		if(!dsa_sesv2_init_done()) {
			SK_DOMAIN_IMPORT(ses_number_of_monitored_shelves, SK_REASON_MPSAFE);
			long_return = ses_get_number_of_monitored_shelves();
		} else {
			long_return = dsa_api_get_number_of_monitored_shelves();
		}
		return (uint8_t*)&long_return;

	default:
		ERROR("var_system");
		*var_len = 0;
	}

	return NULL;
}



/* format is .1.3.6.1.4.1.789.1.21.1.2.1.magic.shelf */
uint8_t *
var_enclEntry(SNMP_FM_ARGS)
{
	uint8_t	   *ret_addr = NULL;
	uint32_t   num_shelves = 0;
		
	if (!dsa_sesv2_init_done()) { /* SESV1*/
		
		num_shelves = ses_get_number_of_monitored_shelves();
		if (num_shelves == 0) {
			return NULL;
		}
		
		HEADER_SIMPLE_TABLE(num_shelves);
		
		SK_DOMAIN_REFERENCE(doenclEntry, SK_REASON_SWITCH_DOMAIN);
		ret_addr = doenclEntry(vp->magic, NAME_INDEX, &long_return,
			return_buf, MAX_VAL_LENGTH);
	} else { /* SESV2 */
				
		num_shelves = dsa_api_get_number_of_monitored_shelves();
		if (num_shelves == 0) {
			
			return NULL;
		}
		
		HEADER_SIMPLE_TABLE(num_shelves);
		
		ret_addr = dsa_doenclEntry(vp->magic, NAME_INDEX, &long_return,
			return_buf, MAX_VAL_LENGTH, num_shelves);
		
		
	}

	/* see ../driver/raid/enclosure_snmp.c */
	/* Adjust length to that of the return destination; 0 if NULL */
	*var_len = (ret_addr == return_buf) ?
		strlen(return_buf) : (ret_addr == NULL) ? 0:
		sizeof(long_return);
	return ret_addr;
}

uint8_t * var_nodeEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_vserverEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_nodeStatEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_clusterLicenseEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_clusterIdentity(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_netportEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_netportIfGrpEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_logicalInterfaceEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_fcpTargetPortTableEntry (SNMP_FM_ARGS)
{                                          
        return NULL;
}
uint8_t * var_fcpTargetLifTableEntry (SNMP_FM_ARGS)
{                                          
        return NULL;
}
uint8_t * var_qosWorkloadEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_haEntry(SNMP_FM_ARGS)
{
	return NULL;
}	
uint8_t * var_qosReadaheadSettingsEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_netOptsv6Table(SNMP_FM_ARGS)
{
        return NULL;
}
uint8_t * var_qosPolicyGroupEntry(SNMP_FM_ARGS)
{
		return NULL;
}
uint8_t * var_netOptsSwitchlessCluster(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_cDOTCpuEntry(SNMP_FM_ARGS)
{
	return NULL;
}
uint8_t * var_cDOTCpEntry(SNMP_FM_ARGS)
{
        return NULL;
}
uint8_t * var_snapmirrorRelStatusEntry(SNMP_FM_ARGS)
{
	return NULL;
}
